/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ElementwiseDiffusionIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDiffusionIcosahedralShellMap::computeInverseDiagonalOperatorValues_P2ElementwiseDiffusionIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const real_t tmp_blending_op_5 = rayVertex_1 - refVertex_1;
       const real_t tmp_blending_op_6 = -rayVertex_0;
       const real_t tmp_blending_op_7 = -forVertex_0 - tmp_blending_op_6;
       const real_t tmp_blending_op_8 = rayVertex_2 - thrVertex_2;
       const real_t tmp_blending_op_9 = tmp_blending_op_7*tmp_blending_op_8;
       const real_t tmp_blending_op_10 = rayVertex_2 - refVertex_2;
       const real_t tmp_blending_op_11 = rayVertex_1 - thrVertex_1;
       const real_t tmp_blending_op_12 = tmp_blending_op_11*tmp_blending_op_7;
       const real_t tmp_blending_op_13 = -rayVertex_1;
       const real_t tmp_blending_op_14 = -forVertex_1 - tmp_blending_op_13;
       const real_t tmp_blending_op_15 = rayVertex_0 - thrVertex_0;
       const real_t tmp_blending_op_16 = rayVertex_0 - refVertex_0;
       const real_t tmp_blending_op_17 = -rayVertex_2;
       const real_t tmp_blending_op_18 = -forVertex_2 - tmp_blending_op_17;
       const real_t tmp_blending_op_19 = tmp_blending_op_14*tmp_blending_op_8;
       const real_t tmp_blending_op_20 = tmp_blending_op_15*tmp_blending_op_18;
       const real_t tmp_blending_op_21 = -tmp_blending_op_10*tmp_blending_op_12 + tmp_blending_op_10*tmp_blending_op_14*tmp_blending_op_15 + tmp_blending_op_11*tmp_blending_op_16*tmp_blending_op_18 - tmp_blending_op_16*tmp_blending_op_19 - tmp_blending_op_20*tmp_blending_op_5 + tmp_blending_op_5*tmp_blending_op_9;
       const real_t tmp_blending_op_22 = radRayVertex*tmp_blending_op_21;
       const real_t tmp_blending_op_23 = radRayVertex - radRefVertex;
       const real_t tmp_blending_op_40 = tmp_blending_op_23*(-tmp_blending_op_12 + tmp_blending_op_14*tmp_blending_op_15);
       const real_t tmp_blending_op_41 = 1.0 / (tmp_blending_op_21)*1.0;
       const real_t tmp_blending_op_43 = tmp_blending_op_15*tmp_blending_op_18 - tmp_blending_op_9;
       const real_t tmp_blending_op_47 = tmp_blending_op_11*tmp_blending_op_18 - tmp_blending_op_19;
       const real_t tmp_blending_op_51 = -tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_blending_op_53 = tmp_blending_op_23*tmp_blending_op_47;
       const real_t tmp_blending_op_74 = tmp_blending_op_23*tmp_blending_op_43;
       const real_t tmp_kernel_op_0 = 1.0;
       const real_t tmp_kernel_op_1 = 1.0;
       const real_t tmp_kernel_op_2 = 1.0;
       const real_t tmp_kernel_op_3 = tmp_kernel_op_1 + tmp_kernel_op_2;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_0 + tmp_kernel_op_3 - 3.0;
       const real_t tmp_kernel_op_5 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_6 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_7 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_4;
       const real_t tmp_kernel_op_9 = 2.0;
       const real_t tmp_kernel_op_10 = 0.66666666666666663;
       const real_t tmp_kernel_op_11 = 0.66666666666666663;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_10 + tmp_kernel_op_11;
       const real_t tmp_kernel_op_13 = tmp_kernel_op_12 + tmp_kernel_op_9 - 3.0;
       const real_t tmp_kernel_op_14 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_13;
       const real_t tmp_kernel_op_15 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_13;
       const real_t tmp_kernel_op_16 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_13 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_13;
       const real_t tmp_kernel_op_18 = 0.66666666666666663;
       const real_t tmp_kernel_op_19 = 0.66666666666666663;
       const real_t tmp_kernel_op_20 = 2.0;
       const real_t tmp_kernel_op_21 = tmp_kernel_op_19 + tmp_kernel_op_20;
       const real_t tmp_kernel_op_22 = tmp_kernel_op_18 + tmp_kernel_op_21 - 3.0;
       const real_t tmp_kernel_op_23 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_24 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_25 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_22 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_22;
       const real_t tmp_kernel_op_27 = 0.66666666666666663;
       const real_t tmp_kernel_op_28 = 2.0;
       const real_t tmp_kernel_op_29 = 0.66666666666666663;
       const real_t tmp_kernel_op_30 = tmp_kernel_op_28 + tmp_kernel_op_29;
       const real_t tmp_kernel_op_31 = tmp_kernel_op_27 + tmp_kernel_op_30 - 3.0;
       const real_t tmp_kernel_op_32 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_33 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_34 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_31 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_31;
       const real_t tmp_kernel_op_36 = 0.66666666666666663;
       const real_t tmp_kernel_op_37 = 0.66666666666666663;
       const real_t tmp_kernel_op_38 = 0.66666666666666663;
       const real_t tmp_kernel_op_39 = tmp_kernel_op_37 + tmp_kernel_op_38;
       const real_t tmp_kernel_op_40 = tmp_kernel_op_36 + tmp_kernel_op_39 - 3.0;
       const real_t tmp_kernel_op_41 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_40;
       const real_t tmp_kernel_op_42 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_40;
       const real_t tmp_kernel_op_43 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_40 + jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_40;
       const real_t tmp_kernel_op_45 = tmp_kernel_op_1 - 1.0;
       const real_t tmp_kernel_op_46 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_45;
       const real_t tmp_kernel_op_47 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_45;
       const real_t tmp_kernel_op_48 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_45;
       const real_t tmp_kernel_op_49 = tmp_kernel_op_10 - 1.0;
       const real_t tmp_kernel_op_50 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_49;
       const real_t tmp_kernel_op_51 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_49;
       const real_t tmp_kernel_op_52 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_49;
       const real_t tmp_kernel_op_53 = tmp_kernel_op_19 - 1.0;
       const real_t tmp_kernel_op_54 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_53;
       const real_t tmp_kernel_op_55 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_53;
       const real_t tmp_kernel_op_56 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_53;
       const real_t tmp_kernel_op_57 = tmp_kernel_op_28 - 1.0;
       const real_t tmp_kernel_op_58 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_57;
       const real_t tmp_kernel_op_59 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_57;
       const real_t tmp_kernel_op_60 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_57;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_37 - 1.0;
       const real_t tmp_kernel_op_62 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_61;
       const real_t tmp_kernel_op_63 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_61;
       const real_t tmp_kernel_op_64 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_61;
       const real_t tmp_kernel_op_65 = tmp_kernel_op_2 - 1.0;
       const real_t tmp_kernel_op_66 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_65;
       const real_t tmp_kernel_op_67 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_65;
       const real_t tmp_kernel_op_68 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_65;
       const real_t tmp_kernel_op_69 = tmp_kernel_op_11 - 1.0;
       const real_t tmp_kernel_op_70 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_69;
       const real_t tmp_kernel_op_71 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_69;
       const real_t tmp_kernel_op_72 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_69;
       const real_t tmp_kernel_op_73 = tmp_kernel_op_20 - 1.0;
       const real_t tmp_kernel_op_74 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_73;
       const real_t tmp_kernel_op_75 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_73;
       const real_t tmp_kernel_op_76 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_73;
       const real_t tmp_kernel_op_77 = tmp_kernel_op_29 - 1.0;
       const real_t tmp_kernel_op_78 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77;
       const real_t tmp_kernel_op_79 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77;
       const real_t tmp_kernel_op_80 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77;
       const real_t tmp_kernel_op_81 = tmp_kernel_op_38 - 1.0;
       const real_t tmp_kernel_op_82 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_81;
       const real_t tmp_kernel_op_83 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_81;
       const real_t tmp_kernel_op_84 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_81;
       const real_t tmp_kernel_op_85 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_86 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_85;
       const real_t tmp_kernel_op_87 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_85;
       const real_t tmp_kernel_op_88 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_85;
       const real_t tmp_kernel_op_89 = tmp_kernel_op_9 - 1.0;
       const real_t tmp_kernel_op_90 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_91 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_92 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_89;
       const real_t tmp_kernel_op_93 = tmp_kernel_op_18 - 1.0;
       const real_t tmp_kernel_op_94 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_93;
       const real_t tmp_kernel_op_95 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_93;
       const real_t tmp_kernel_op_96 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_93;
       const real_t tmp_kernel_op_97 = tmp_kernel_op_27 - 1.0;
       const real_t tmp_kernel_op_98 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_97;
       const real_t tmp_kernel_op_99 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_97;
       const real_t tmp_kernel_op_100 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_97;
       const real_t tmp_kernel_op_101 = tmp_kernel_op_36 - 1.0;
       const real_t tmp_kernel_op_102 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_101;
       const real_t tmp_kernel_op_103 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_101;
       const real_t tmp_kernel_op_104 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_101;
       const real_t tmp_kernel_op_105 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_106 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_107 = tmp_kernel_op_105 + tmp_kernel_op_106;
       const real_t tmp_kernel_op_108 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_109 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_110 = tmp_kernel_op_108 + tmp_kernel_op_109;
       const real_t tmp_kernel_op_111 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_112 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_113 = tmp_kernel_op_111 + tmp_kernel_op_112;
       const real_t tmp_kernel_op_114 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_115 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_116 = tmp_kernel_op_114 + tmp_kernel_op_115;
       const real_t tmp_kernel_op_117 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_118 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_119 = tmp_kernel_op_117 + tmp_kernel_op_118;
       const real_t tmp_kernel_op_120 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_121 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_122 = tmp_kernel_op_120 + tmp_kernel_op_121;
       const real_t tmp_kernel_op_123 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_124 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_125 = tmp_kernel_op_123 + tmp_kernel_op_124;
       const real_t tmp_kernel_op_126 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_127 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_128 = tmp_kernel_op_126 + tmp_kernel_op_127;
       const real_t tmp_kernel_op_129 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_130 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_131 = tmp_kernel_op_129 + tmp_kernel_op_130;
       const real_t tmp_kernel_op_132 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_133 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_134 = tmp_kernel_op_132 + tmp_kernel_op_133;
       const real_t tmp_kernel_op_135 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_136 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_137 = tmp_kernel_op_135 + tmp_kernel_op_136;
       const real_t tmp_kernel_op_138 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_139 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_140 = tmp_kernel_op_138 + tmp_kernel_op_139;
       const real_t tmp_kernel_op_141 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_142 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_143 = tmp_kernel_op_141 + tmp_kernel_op_142;
       const real_t tmp_kernel_op_144 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_145 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_146 = tmp_kernel_op_144 + tmp_kernel_op_145;
       const real_t tmp_kernel_op_147 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_148 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_149 = tmp_kernel_op_147 + tmp_kernel_op_148;
       const real_t tmp_kernel_op_150 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_151 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_152 = tmp_kernel_op_150 + tmp_kernel_op_151;
       const real_t tmp_kernel_op_153 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_154 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_155 = tmp_kernel_op_153 + tmp_kernel_op_154;
       const real_t tmp_kernel_op_156 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_0;
       const real_t tmp_kernel_op_157 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_158 = tmp_kernel_op_156 + tmp_kernel_op_157;
       const real_t tmp_kernel_op_159 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_160 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_161 = tmp_kernel_op_159 + tmp_kernel_op_160;
       const real_t tmp_kernel_op_162 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_163 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_164 = tmp_kernel_op_162 + tmp_kernel_op_163;
       const real_t tmp_kernel_op_165 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_9;
       const real_t tmp_kernel_op_166 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_167 = tmp_kernel_op_165 + tmp_kernel_op_166;
       const real_t tmp_kernel_op_168 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_169 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_170 = tmp_kernel_op_168 + tmp_kernel_op_169;
       const real_t tmp_kernel_op_171 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_172 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_173 = tmp_kernel_op_171 + tmp_kernel_op_172;
       const real_t tmp_kernel_op_174 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_18;
       const real_t tmp_kernel_op_175 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_176 = tmp_kernel_op_174 + tmp_kernel_op_175;
       const real_t tmp_kernel_op_177 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_178 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_179 = tmp_kernel_op_177 + tmp_kernel_op_178;
       const real_t tmp_kernel_op_180 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_181 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_182 = tmp_kernel_op_180 + tmp_kernel_op_181;
       const real_t tmp_kernel_op_183 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_27;
       const real_t tmp_kernel_op_184 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_185 = tmp_kernel_op_183 + tmp_kernel_op_184;
       const real_t tmp_kernel_op_186 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_187 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_188 = tmp_kernel_op_186 + tmp_kernel_op_187;
       const real_t tmp_kernel_op_189 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_190 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_191 = tmp_kernel_op_189 + tmp_kernel_op_190;
       const real_t tmp_kernel_op_192 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_36;
       const real_t tmp_kernel_op_193 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_194 = tmp_kernel_op_192 + tmp_kernel_op_193;
       const real_t tmp_kernel_op_195 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_196 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_197 = tmp_kernel_op_195 + tmp_kernel_op_196;
       const real_t tmp_kernel_op_198 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_199 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_200 = tmp_kernel_op_198 + tmp_kernel_op_199;
       const real_t tmp_kernel_op_201 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_2;
       const real_t tmp_kernel_op_202 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_1;
       const real_t tmp_kernel_op_203 = tmp_kernel_op_201 + tmp_kernel_op_202;
       const real_t tmp_kernel_op_204 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_205 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_206 = tmp_kernel_op_204 + tmp_kernel_op_205;
       const real_t tmp_kernel_op_207 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_208 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_209 = tmp_kernel_op_207 + tmp_kernel_op_208;
       const real_t tmp_kernel_op_210 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_11;
       const real_t tmp_kernel_op_211 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_10;
       const real_t tmp_kernel_op_212 = tmp_kernel_op_210 + tmp_kernel_op_211;
       const real_t tmp_kernel_op_213 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_214 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_215 = tmp_kernel_op_213 + tmp_kernel_op_214;
       const real_t tmp_kernel_op_216 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_217 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_218 = tmp_kernel_op_216 + tmp_kernel_op_217;
       const real_t tmp_kernel_op_219 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_20;
       const real_t tmp_kernel_op_220 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_19;
       const real_t tmp_kernel_op_221 = tmp_kernel_op_219 + tmp_kernel_op_220;
       const real_t tmp_kernel_op_222 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_223 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_224 = tmp_kernel_op_222 + tmp_kernel_op_223;
       const real_t tmp_kernel_op_225 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_226 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_227 = tmp_kernel_op_225 + tmp_kernel_op_226;
       const real_t tmp_kernel_op_228 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_29;
       const real_t tmp_kernel_op_229 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_28;
       const real_t tmp_kernel_op_230 = tmp_kernel_op_228 + tmp_kernel_op_229;
       const real_t tmp_kernel_op_231 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_232 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_233 = tmp_kernel_op_231 + tmp_kernel_op_232;
       const real_t tmp_kernel_op_234 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_235 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_236 = tmp_kernel_op_234 + tmp_kernel_op_235;
       const real_t tmp_kernel_op_237 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_38;
       const real_t tmp_kernel_op_238 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_37;
       const real_t tmp_kernel_op_239 = tmp_kernel_op_237 + tmp_kernel_op_238;
       const real_t tmp_kernel_op_240 = -tmp_kernel_op_3 + 2.0;
       const real_t tmp_kernel_op_241 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_240 - tmp_kernel_op_105 - tmp_kernel_op_150;
       const real_t tmp_kernel_op_242 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_240 - tmp_kernel_op_108 - tmp_kernel_op_153;
       const real_t tmp_kernel_op_243 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_240 - tmp_kernel_op_111 - tmp_kernel_op_156;
       const real_t tmp_kernel_op_244 = -tmp_kernel_op_12;
       const real_t tmp_kernel_op_245 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_244 - tmp_kernel_op_114 - tmp_kernel_op_159;
       const real_t tmp_kernel_op_246 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_244 - tmp_kernel_op_117 - tmp_kernel_op_162;
       const real_t tmp_kernel_op_247 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_244 - tmp_kernel_op_120 - tmp_kernel_op_165;
       const real_t tmp_kernel_op_248 = -tmp_kernel_op_21 + 2.666666666666667;
       const real_t tmp_kernel_op_249 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_248 - tmp_kernel_op_123 - tmp_kernel_op_168;
       const real_t tmp_kernel_op_250 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_248 - tmp_kernel_op_126 - tmp_kernel_op_171;
       const real_t tmp_kernel_op_251 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_248 - tmp_kernel_op_129 - tmp_kernel_op_174;
       const real_t tmp_kernel_op_252 = -tmp_kernel_op_30 + 2.666666666666667;
       const real_t tmp_kernel_op_253 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_252 - tmp_kernel_op_132 - tmp_kernel_op_177;
       const real_t tmp_kernel_op_254 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_252 - tmp_kernel_op_135 - tmp_kernel_op_180;
       const real_t tmp_kernel_op_255 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_252 - tmp_kernel_op_138 - tmp_kernel_op_183;
       const real_t tmp_kernel_op_256 = -tmp_kernel_op_39 + 2.666666666666667;
       const real_t tmp_kernel_op_257 = jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_256 - tmp_kernel_op_141 - tmp_kernel_op_186;
       const real_t tmp_kernel_op_258 = jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_256 - tmp_kernel_op_144 - tmp_kernel_op_189;
       const real_t tmp_kernel_op_259 = jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_256 - tmp_kernel_op_147 - tmp_kernel_op_192;
       const real_t tmp_kernel_op_260 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_261 = -tmp_kernel_op_1 - tmp_kernel_op_260 - 2.0;
       const real_t tmp_kernel_op_262 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_261 - tmp_kernel_op_106 - tmp_kernel_op_195;
       const real_t tmp_kernel_op_263 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_261 - tmp_kernel_op_109 - tmp_kernel_op_198;
       const real_t tmp_kernel_op_264 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_261 - tmp_kernel_op_112 - tmp_kernel_op_201;
       const real_t tmp_kernel_op_265 = tmp_kernel_op_9 - 4.0;
       const real_t tmp_kernel_op_266 = -tmp_kernel_op_10 - tmp_kernel_op_265 - 1.3333333333333333;
       const real_t tmp_kernel_op_267 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_266 - tmp_kernel_op_115 - tmp_kernel_op_204;
       const real_t tmp_kernel_op_268 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_266 - tmp_kernel_op_118 - tmp_kernel_op_207;
       const real_t tmp_kernel_op_269 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_266 - tmp_kernel_op_121 - tmp_kernel_op_210;
       const real_t tmp_kernel_op_270 = tmp_kernel_op_18 - 4.0;
       const real_t tmp_kernel_op_271 = -tmp_kernel_op_19 - tmp_kernel_op_270 - 4.0;
       const real_t tmp_kernel_op_272 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_271 - tmp_kernel_op_124 - tmp_kernel_op_213;
       const real_t tmp_kernel_op_273 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_271 - tmp_kernel_op_127 - tmp_kernel_op_216;
       const real_t tmp_kernel_op_274 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_271 - tmp_kernel_op_130 - tmp_kernel_op_219;
       const real_t tmp_kernel_op_275 = tmp_kernel_op_27 - 4.0;
       const real_t tmp_kernel_op_276 = -tmp_kernel_op_275 - tmp_kernel_op_28 - 1.3333333333333333;
       const real_t tmp_kernel_op_277 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_276 - tmp_kernel_op_133 - tmp_kernel_op_222;
       const real_t tmp_kernel_op_278 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_276 - tmp_kernel_op_136 - tmp_kernel_op_225;
       const real_t tmp_kernel_op_279 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_276 - tmp_kernel_op_139 - tmp_kernel_op_228;
       const real_t tmp_kernel_op_280 = tmp_kernel_op_36 - 4.0;
       const real_t tmp_kernel_op_281 = -tmp_kernel_op_280 - tmp_kernel_op_37 - 1.3333333333333333;
       const real_t tmp_kernel_op_282 = jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_281 - tmp_kernel_op_142 - tmp_kernel_op_231;
       const real_t tmp_kernel_op_283 = jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_281 - tmp_kernel_op_145 - tmp_kernel_op_234;
       const real_t tmp_kernel_op_284 = jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_281 - tmp_kernel_op_148 - tmp_kernel_op_237;
       const real_t tmp_kernel_op_285 = -tmp_kernel_op_2 - tmp_kernel_op_260 - 2.0;
       const real_t tmp_kernel_op_286 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_285 - tmp_kernel_op_151 - tmp_kernel_op_196;
       const real_t tmp_kernel_op_287 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_285 - tmp_kernel_op_154 - tmp_kernel_op_199;
       const real_t tmp_kernel_op_288 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_285 - tmp_kernel_op_157 - tmp_kernel_op_202;
       const real_t tmp_kernel_op_289 = -tmp_kernel_op_11 - tmp_kernel_op_265 - 1.3333333333333333;
       const real_t tmp_kernel_op_290 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_289 - tmp_kernel_op_160 - tmp_kernel_op_205;
       const real_t tmp_kernel_op_291 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_289 - tmp_kernel_op_163 - tmp_kernel_op_208;
       const real_t tmp_kernel_op_292 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_289 - tmp_kernel_op_166 - tmp_kernel_op_211;
       const real_t tmp_kernel_op_293 = -tmp_kernel_op_20 - tmp_kernel_op_270 - 1.3333333333333333;
       const real_t tmp_kernel_op_294 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_293 - tmp_kernel_op_169 - tmp_kernel_op_214;
       const real_t tmp_kernel_op_295 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_293 - tmp_kernel_op_172 - tmp_kernel_op_217;
       const real_t tmp_kernel_op_296 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_293 - tmp_kernel_op_175 - tmp_kernel_op_220;
       const real_t tmp_kernel_op_297 = -tmp_kernel_op_275 - tmp_kernel_op_29 - 4.0;
       const real_t tmp_kernel_op_298 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_297 - tmp_kernel_op_178 - tmp_kernel_op_223;
       const real_t tmp_kernel_op_299 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_297 - tmp_kernel_op_181 - tmp_kernel_op_226;
       const real_t tmp_kernel_op_300 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_297 - tmp_kernel_op_184 - tmp_kernel_op_229;
       const real_t tmp_kernel_op_301 = -tmp_kernel_op_280 - tmp_kernel_op_38 - 1.3333333333333333;
       const real_t tmp_kernel_op_302 = jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_301 - tmp_kernel_op_187 - tmp_kernel_op_232;
       const real_t tmp_kernel_op_303 = jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_301 - tmp_kernel_op_190 - tmp_kernel_op_235;
       const real_t tmp_kernel_op_304 = jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_301 - tmp_kernel_op_193 - tmp_kernel_op_238;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33,tmp_kernel_op_33))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))))))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60,tmp_kernel_op_60))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62,tmp_kernel_op_62)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63,tmp_kernel_op_63))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64,tmp_kernel_op_64)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71,tmp_kernel_op_71))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72,tmp_kernel_op_72))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84,tmp_kernel_op_84)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100,tmp_kernel_op_100)),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99,tmp_kernel_op_99)))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102,tmp_kernel_op_102)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103,tmp_kernel_op_103))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104,tmp_kernel_op_104))))))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86,tmp_kernel_op_86)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87,tmp_kernel_op_87))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88,tmp_kernel_op_88))))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90,tmp_kernel_op_90)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91,tmp_kernel_op_91))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92,tmp_kernel_op_92))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94,tmp_kernel_op_94)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95,tmp_kernel_op_95))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96,tmp_kernel_op_96)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107,tmp_kernel_op_107)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116,tmp_kernel_op_116)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122,tmp_kernel_op_122))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125,tmp_kernel_op_125)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128,tmp_kernel_op_128))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131,tmp_kernel_op_131))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137,tmp_kernel_op_137))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140,tmp_kernel_op_140))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143,tmp_kernel_op_143)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146,tmp_kernel_op_146))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149,tmp_kernel_op_149)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152,tmp_kernel_op_152)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155,tmp_kernel_op_155))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158,tmp_kernel_op_158)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161,tmp_kernel_op_161)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170,tmp_kernel_op_170)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176,tmp_kernel_op_176))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179,tmp_kernel_op_179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182,tmp_kernel_op_182))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185,tmp_kernel_op_185))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191,tmp_kernel_op_191))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194,tmp_kernel_op_194)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197,tmp_kernel_op_197)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200,tmp_kernel_op_200))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203,tmp_kernel_op_203)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206,tmp_kernel_op_206)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209,tmp_kernel_op_209))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212,tmp_kernel_op_212))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215,tmp_kernel_op_215)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218,tmp_kernel_op_218))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221,tmp_kernel_op_221))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224,tmp_kernel_op_224)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227,tmp_kernel_op_227))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230,tmp_kernel_op_230))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233,tmp_kernel_op_233)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236,tmp_kernel_op_236))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239,tmp_kernel_op_239)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241,tmp_kernel_op_241)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242,tmp_kernel_op_242))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243,tmp_kernel_op_243)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245,tmp_kernel_op_245)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246,tmp_kernel_op_246))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247,tmp_kernel_op_247))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249,tmp_kernel_op_249)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250,tmp_kernel_op_250))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251,tmp_kernel_op_251))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253,tmp_kernel_op_253)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254,tmp_kernel_op_254))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255,tmp_kernel_op_255))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257,tmp_kernel_op_257)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258,tmp_kernel_op_258))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259,tmp_kernel_op_259)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262,tmp_kernel_op_262)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263,tmp_kernel_op_263))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264,tmp_kernel_op_264)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267,tmp_kernel_op_267)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268,tmp_kernel_op_268))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269,tmp_kernel_op_269))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272,tmp_kernel_op_272)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273,tmp_kernel_op_273))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274,tmp_kernel_op_274))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277,tmp_kernel_op_277)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278,tmp_kernel_op_278))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279,tmp_kernel_op_279))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282,tmp_kernel_op_282)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283,tmp_kernel_op_283))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284,tmp_kernel_op_284)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286,tmp_kernel_op_286)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287,tmp_kernel_op_287))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288,tmp_kernel_op_288)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290,tmp_kernel_op_290)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291,tmp_kernel_op_291))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292,tmp_kernel_op_292))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294,tmp_kernel_op_294)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295,tmp_kernel_op_295))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296,tmp_kernel_op_296))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298,tmp_kernel_op_298)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299,tmp_kernel_op_299))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300,tmp_kernel_op_300))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302,tmp_kernel_op_302)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303,tmp_kernel_op_303))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304,tmp_kernel_op_304)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_WHITE_UP*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_14 + jac_blending_inv_1_0_q_1*tmp_kernel_op_15 + jac_blending_inv_2_0_q_1*tmp_kernel_op_16)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_14 + jac_blending_inv_1_0_q_1*tmp_kernel_op_15 + jac_blending_inv_2_0_q_1*tmp_kernel_op_16)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_14 + jac_blending_inv_1_1_q_1*tmp_kernel_op_15 + jac_blending_inv_2_1_q_1*tmp_kernel_op_16)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_14 + jac_blending_inv_1_1_q_1*tmp_kernel_op_15 + jac_blending_inv_2_1_q_1*tmp_kernel_op_16)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_14 + jac_blending_inv_1_2_q_1*tmp_kernel_op_15 + jac_blending_inv_2_2_q_1*tmp_kernel_op_16)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_14 + jac_blending_inv_1_2_q_1*tmp_kernel_op_15 + jac_blending_inv_2_2_q_1*tmp_kernel_op_16))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_23 + jac_blending_inv_1_0_q_2*tmp_kernel_op_24 + jac_blending_inv_2_0_q_2*tmp_kernel_op_25)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_23 + jac_blending_inv_1_0_q_2*tmp_kernel_op_24 + jac_blending_inv_2_0_q_2*tmp_kernel_op_25)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_23 + jac_blending_inv_1_1_q_2*tmp_kernel_op_24 + jac_blending_inv_2_1_q_2*tmp_kernel_op_25)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_23 + jac_blending_inv_1_1_q_2*tmp_kernel_op_24 + jac_blending_inv_2_1_q_2*tmp_kernel_op_25)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_23 + jac_blending_inv_1_2_q_2*tmp_kernel_op_24 + jac_blending_inv_2_2_q_2*tmp_kernel_op_25)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_23 + jac_blending_inv_1_2_q_2*tmp_kernel_op_24 + jac_blending_inv_2_2_q_2*tmp_kernel_op_25))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_32 + jac_blending_inv_1_0_q_3*tmp_kernel_op_33 + jac_blending_inv_2_0_q_3*tmp_kernel_op_34)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_32 + jac_blending_inv_1_0_q_3*tmp_kernel_op_33 + jac_blending_inv_2_0_q_3*tmp_kernel_op_34)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_32 + jac_blending_inv_1_1_q_3*tmp_kernel_op_33 + jac_blending_inv_2_1_q_3*tmp_kernel_op_34)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_32 + jac_blending_inv_1_1_q_3*tmp_kernel_op_33 + jac_blending_inv_2_1_q_3*tmp_kernel_op_34)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_32 + jac_blending_inv_1_2_q_3*tmp_kernel_op_33 + jac_blending_inv_2_2_q_3*tmp_kernel_op_34)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_32 + jac_blending_inv_1_2_q_3*tmp_kernel_op_33 + jac_blending_inv_2_2_q_3*tmp_kernel_op_34))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_41 + jac_blending_inv_1_0_q_4*tmp_kernel_op_42 + jac_blending_inv_2_0_q_4*tmp_kernel_op_43)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_41 + jac_blending_inv_1_0_q_4*tmp_kernel_op_42 + jac_blending_inv_2_0_q_4*tmp_kernel_op_43)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_41 + jac_blending_inv_1_1_q_4*tmp_kernel_op_42 + jac_blending_inv_2_1_q_4*tmp_kernel_op_43)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_41 + jac_blending_inv_1_1_q_4*tmp_kernel_op_42 + jac_blending_inv_2_1_q_4*tmp_kernel_op_43)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_41 + jac_blending_inv_1_2_q_4*tmp_kernel_op_42 + jac_blending_inv_2_2_q_4*tmp_kernel_op_43)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_41 + jac_blending_inv_1_2_q_4*tmp_kernel_op_42 + jac_blending_inv_2_2_q_4*tmp_kernel_op_43))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_5 + jac_blending_inv_1_0_q_0*tmp_kernel_op_6 + jac_blending_inv_2_0_q_0*tmp_kernel_op_7)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_5 + jac_blending_inv_1_0_q_0*tmp_kernel_op_6 + jac_blending_inv_2_0_q_0*tmp_kernel_op_7)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_5 + jac_blending_inv_1_1_q_0*tmp_kernel_op_6 + jac_blending_inv_2_1_q_0*tmp_kernel_op_7)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_5 + jac_blending_inv_1_1_q_0*tmp_kernel_op_6 + jac_blending_inv_2_1_q_0*tmp_kernel_op_7)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_5 + jac_blending_inv_1_2_q_0*tmp_kernel_op_6 + jac_blending_inv_2_2_q_0*tmp_kernel_op_7)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_5 + jac_blending_inv_1_2_q_0*tmp_kernel_op_6 + jac_blending_inv_2_2_q_0*tmp_kernel_op_7)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_50 + jac_blending_inv_1_0_q_1*tmp_kernel_op_51 + jac_blending_inv_2_0_q_1*tmp_kernel_op_52)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_50 + jac_blending_inv_1_0_q_1*tmp_kernel_op_51 + jac_blending_inv_2_0_q_1*tmp_kernel_op_52)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_50 + jac_blending_inv_1_1_q_1*tmp_kernel_op_51 + jac_blending_inv_2_1_q_1*tmp_kernel_op_52)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_50 + jac_blending_inv_1_1_q_1*tmp_kernel_op_51 + jac_blending_inv_2_1_q_1*tmp_kernel_op_52)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_50 + jac_blending_inv_1_2_q_1*tmp_kernel_op_51 + jac_blending_inv_2_2_q_1*tmp_kernel_op_52)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_50 + jac_blending_inv_1_2_q_1*tmp_kernel_op_51 + jac_blending_inv_2_2_q_1*tmp_kernel_op_52))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_54 + jac_blending_inv_1_0_q_2*tmp_kernel_op_55 + jac_blending_inv_2_0_q_2*tmp_kernel_op_56)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_54 + jac_blending_inv_1_0_q_2*tmp_kernel_op_55 + jac_blending_inv_2_0_q_2*tmp_kernel_op_56)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_54 + jac_blending_inv_1_1_q_2*tmp_kernel_op_55 + jac_blending_inv_2_1_q_2*tmp_kernel_op_56)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_54 + jac_blending_inv_1_1_q_2*tmp_kernel_op_55 + jac_blending_inv_2_1_q_2*tmp_kernel_op_56)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_54 + jac_blending_inv_1_2_q_2*tmp_kernel_op_55 + jac_blending_inv_2_2_q_2*tmp_kernel_op_56)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_54 + jac_blending_inv_1_2_q_2*tmp_kernel_op_55 + jac_blending_inv_2_2_q_2*tmp_kernel_op_56))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_58 + jac_blending_inv_1_0_q_3*tmp_kernel_op_59 + jac_blending_inv_2_0_q_3*tmp_kernel_op_60)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_58 + jac_blending_inv_1_0_q_3*tmp_kernel_op_59 + jac_blending_inv_2_0_q_3*tmp_kernel_op_60)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_58 + jac_blending_inv_1_1_q_3*tmp_kernel_op_59 + jac_blending_inv_2_1_q_3*tmp_kernel_op_60)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_58 + jac_blending_inv_1_1_q_3*tmp_kernel_op_59 + jac_blending_inv_2_1_q_3*tmp_kernel_op_60)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_58 + jac_blending_inv_1_2_q_3*tmp_kernel_op_59 + jac_blending_inv_2_2_q_3*tmp_kernel_op_60)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_58 + jac_blending_inv_1_2_q_3*tmp_kernel_op_59 + jac_blending_inv_2_2_q_3*tmp_kernel_op_60))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_62 + jac_blending_inv_1_0_q_4*tmp_kernel_op_63 + jac_blending_inv_2_0_q_4*tmp_kernel_op_64)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_62 + jac_blending_inv_1_0_q_4*tmp_kernel_op_63 + jac_blending_inv_2_0_q_4*tmp_kernel_op_64)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_62 + jac_blending_inv_1_1_q_4*tmp_kernel_op_63 + jac_blending_inv_2_1_q_4*tmp_kernel_op_64)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_62 + jac_blending_inv_1_1_q_4*tmp_kernel_op_63 + jac_blending_inv_2_1_q_4*tmp_kernel_op_64)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_62 + jac_blending_inv_1_2_q_4*tmp_kernel_op_63 + jac_blending_inv_2_2_q_4*tmp_kernel_op_64)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_62 + jac_blending_inv_1_2_q_4*tmp_kernel_op_63 + jac_blending_inv_2_2_q_4*tmp_kernel_op_64))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_46 + jac_blending_inv_1_0_q_0*tmp_kernel_op_47 + jac_blending_inv_2_0_q_0*tmp_kernel_op_48)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_46 + jac_blending_inv_1_0_q_0*tmp_kernel_op_47 + jac_blending_inv_2_0_q_0*tmp_kernel_op_48)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_46 + jac_blending_inv_1_1_q_0*tmp_kernel_op_47 + jac_blending_inv_2_1_q_0*tmp_kernel_op_48)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_46 + jac_blending_inv_1_1_q_0*tmp_kernel_op_47 + jac_blending_inv_2_1_q_0*tmp_kernel_op_48)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_46 + jac_blending_inv_1_2_q_0*tmp_kernel_op_47 + jac_blending_inv_2_2_q_0*tmp_kernel_op_48)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_46 + jac_blending_inv_1_2_q_0*tmp_kernel_op_47 + jac_blending_inv_2_2_q_0*tmp_kernel_op_48)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_70 + jac_blending_inv_1_0_q_1*tmp_kernel_op_71 + jac_blending_inv_2_0_q_1*tmp_kernel_op_72)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_70 + jac_blending_inv_1_0_q_1*tmp_kernel_op_71 + jac_blending_inv_2_0_q_1*tmp_kernel_op_72)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_70 + jac_blending_inv_1_1_q_1*tmp_kernel_op_71 + jac_blending_inv_2_1_q_1*tmp_kernel_op_72)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_70 + jac_blending_inv_1_1_q_1*tmp_kernel_op_71 + jac_blending_inv_2_1_q_1*tmp_kernel_op_72)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_70 + jac_blending_inv_1_2_q_1*tmp_kernel_op_71 + jac_blending_inv_2_2_q_1*tmp_kernel_op_72)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_70 + jac_blending_inv_1_2_q_1*tmp_kernel_op_71 + jac_blending_inv_2_2_q_1*tmp_kernel_op_72))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_74 + jac_blending_inv_1_0_q_2*tmp_kernel_op_75 + jac_blending_inv_2_0_q_2*tmp_kernel_op_76)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_74 + jac_blending_inv_1_0_q_2*tmp_kernel_op_75 + jac_blending_inv_2_0_q_2*tmp_kernel_op_76)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_74 + jac_blending_inv_1_1_q_2*tmp_kernel_op_75 + jac_blending_inv_2_1_q_2*tmp_kernel_op_76)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_74 + jac_blending_inv_1_1_q_2*tmp_kernel_op_75 + jac_blending_inv_2_1_q_2*tmp_kernel_op_76)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_74 + jac_blending_inv_1_2_q_2*tmp_kernel_op_75 + jac_blending_inv_2_2_q_2*tmp_kernel_op_76)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_74 + jac_blending_inv_1_2_q_2*tmp_kernel_op_75 + jac_blending_inv_2_2_q_2*tmp_kernel_op_76))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_78 + jac_blending_inv_1_0_q_3*tmp_kernel_op_79 + jac_blending_inv_2_0_q_3*tmp_kernel_op_80)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_78 + jac_blending_inv_1_0_q_3*tmp_kernel_op_79 + jac_blending_inv_2_0_q_3*tmp_kernel_op_80)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_78 + jac_blending_inv_1_1_q_3*tmp_kernel_op_79 + jac_blending_inv_2_1_q_3*tmp_kernel_op_80)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_78 + jac_blending_inv_1_1_q_3*tmp_kernel_op_79 + jac_blending_inv_2_1_q_3*tmp_kernel_op_80)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_78 + jac_blending_inv_1_2_q_3*tmp_kernel_op_79 + jac_blending_inv_2_2_q_3*tmp_kernel_op_80)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_78 + jac_blending_inv_1_2_q_3*tmp_kernel_op_79 + jac_blending_inv_2_2_q_3*tmp_kernel_op_80))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_82 + jac_blending_inv_1_0_q_4*tmp_kernel_op_83 + jac_blending_inv_2_0_q_4*tmp_kernel_op_84)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_82 + jac_blending_inv_1_0_q_4*tmp_kernel_op_83 + jac_blending_inv_2_0_q_4*tmp_kernel_op_84)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_82 + jac_blending_inv_1_1_q_4*tmp_kernel_op_83 + jac_blending_inv_2_1_q_4*tmp_kernel_op_84)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_82 + jac_blending_inv_1_1_q_4*tmp_kernel_op_83 + jac_blending_inv_2_1_q_4*tmp_kernel_op_84)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_82 + jac_blending_inv_1_2_q_4*tmp_kernel_op_83 + jac_blending_inv_2_2_q_4*tmp_kernel_op_84)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_82 + jac_blending_inv_1_2_q_4*tmp_kernel_op_83 + jac_blending_inv_2_2_q_4*tmp_kernel_op_84))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_66 + jac_blending_inv_1_0_q_0*tmp_kernel_op_67 + jac_blending_inv_2_0_q_0*tmp_kernel_op_68)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_66 + jac_blending_inv_1_0_q_0*tmp_kernel_op_67 + jac_blending_inv_2_0_q_0*tmp_kernel_op_68)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_66 + jac_blending_inv_1_1_q_0*tmp_kernel_op_67 + jac_blending_inv_2_1_q_0*tmp_kernel_op_68)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_66 + jac_blending_inv_1_1_q_0*tmp_kernel_op_67 + jac_blending_inv_2_1_q_0*tmp_kernel_op_68)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_66 + jac_blending_inv_1_2_q_0*tmp_kernel_op_67 + jac_blending_inv_2_2_q_0*tmp_kernel_op_68)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_66 + jac_blending_inv_1_2_q_0*tmp_kernel_op_67 + jac_blending_inv_2_2_q_0*tmp_kernel_op_68)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_90 + jac_blending_inv_1_0_q_1*tmp_kernel_op_91 + jac_blending_inv_2_0_q_1*tmp_kernel_op_92)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_90 + jac_blending_inv_1_0_q_1*tmp_kernel_op_91 + jac_blending_inv_2_0_q_1*tmp_kernel_op_92)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_90 + jac_blending_inv_1_1_q_1*tmp_kernel_op_91 + jac_blending_inv_2_1_q_1*tmp_kernel_op_92)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_90 + jac_blending_inv_1_1_q_1*tmp_kernel_op_91 + jac_blending_inv_2_1_q_1*tmp_kernel_op_92)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_90 + jac_blending_inv_1_2_q_1*tmp_kernel_op_91 + jac_blending_inv_2_2_q_1*tmp_kernel_op_92)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_90 + jac_blending_inv_1_2_q_1*tmp_kernel_op_91 + jac_blending_inv_2_2_q_1*tmp_kernel_op_92))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_94 + jac_blending_inv_1_0_q_2*tmp_kernel_op_95 + jac_blending_inv_2_0_q_2*tmp_kernel_op_96)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_94 + jac_blending_inv_1_0_q_2*tmp_kernel_op_95 + jac_blending_inv_2_0_q_2*tmp_kernel_op_96)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_94 + jac_blending_inv_1_1_q_2*tmp_kernel_op_95 + jac_blending_inv_2_1_q_2*tmp_kernel_op_96)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_94 + jac_blending_inv_1_1_q_2*tmp_kernel_op_95 + jac_blending_inv_2_1_q_2*tmp_kernel_op_96)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_94 + jac_blending_inv_1_2_q_2*tmp_kernel_op_95 + jac_blending_inv_2_2_q_2*tmp_kernel_op_96)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_94 + jac_blending_inv_1_2_q_2*tmp_kernel_op_95 + jac_blending_inv_2_2_q_2*tmp_kernel_op_96))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_98 + jac_blending_inv_1_0_q_3*tmp_kernel_op_99 + jac_blending_inv_2_0_q_3*tmp_kernel_op_100)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_98 + jac_blending_inv_1_0_q_3*tmp_kernel_op_99 + jac_blending_inv_2_0_q_3*tmp_kernel_op_100)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_98 + jac_blending_inv_1_1_q_3*tmp_kernel_op_99 + jac_blending_inv_2_1_q_3*tmp_kernel_op_100)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_98 + jac_blending_inv_1_1_q_3*tmp_kernel_op_99 + jac_blending_inv_2_1_q_3*tmp_kernel_op_100)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_98 + jac_blending_inv_1_2_q_3*tmp_kernel_op_99 + jac_blending_inv_2_2_q_3*tmp_kernel_op_100)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_98 + jac_blending_inv_1_2_q_3*tmp_kernel_op_99 + jac_blending_inv_2_2_q_3*tmp_kernel_op_100))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_102 + jac_blending_inv_1_0_q_4*tmp_kernel_op_103 + jac_blending_inv_2_0_q_4*tmp_kernel_op_104)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_102 + jac_blending_inv_1_0_q_4*tmp_kernel_op_103 + jac_blending_inv_2_0_q_4*tmp_kernel_op_104)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_102 + jac_blending_inv_1_1_q_4*tmp_kernel_op_103 + jac_blending_inv_2_1_q_4*tmp_kernel_op_104)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_102 + jac_blending_inv_1_1_q_4*tmp_kernel_op_103 + jac_blending_inv_2_1_q_4*tmp_kernel_op_104)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_102 + jac_blending_inv_1_2_q_4*tmp_kernel_op_103 + jac_blending_inv_2_2_q_4*tmp_kernel_op_104)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_102 + jac_blending_inv_1_2_q_4*tmp_kernel_op_103 + jac_blending_inv_2_2_q_4*tmp_kernel_op_104))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_86 + jac_blending_inv_1_0_q_0*tmp_kernel_op_87 + jac_blending_inv_2_0_q_0*tmp_kernel_op_88)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_86 + jac_blending_inv_1_0_q_0*tmp_kernel_op_87 + jac_blending_inv_2_0_q_0*tmp_kernel_op_88)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_86 + jac_blending_inv_1_1_q_0*tmp_kernel_op_87 + jac_blending_inv_2_1_q_0*tmp_kernel_op_88)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_86 + jac_blending_inv_1_1_q_0*tmp_kernel_op_87 + jac_blending_inv_2_1_q_0*tmp_kernel_op_88)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_86 + jac_blending_inv_1_2_q_0*tmp_kernel_op_87 + jac_blending_inv_2_2_q_0*tmp_kernel_op_88)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_86 + jac_blending_inv_1_2_q_0*tmp_kernel_op_87 + jac_blending_inv_2_2_q_0*tmp_kernel_op_88)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_116 + jac_blending_inv_1_0_q_1*tmp_kernel_op_119 + jac_blending_inv_2_0_q_1*tmp_kernel_op_122)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_116 + jac_blending_inv_1_0_q_1*tmp_kernel_op_119 + jac_blending_inv_2_0_q_1*tmp_kernel_op_122)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_1_q_1*tmp_kernel_op_119 + jac_blending_inv_2_1_q_1*tmp_kernel_op_122)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_116 + jac_blending_inv_1_1_q_1*tmp_kernel_op_119 + jac_blending_inv_2_1_q_1*tmp_kernel_op_122)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_119 + jac_blending_inv_2_2_q_1*tmp_kernel_op_122)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_116 + jac_blending_inv_1_2_q_1*tmp_kernel_op_119 + jac_blending_inv_2_2_q_1*tmp_kernel_op_122))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_125 + jac_blending_inv_1_0_q_2*tmp_kernel_op_128 + jac_blending_inv_2_0_q_2*tmp_kernel_op_131)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_125 + jac_blending_inv_1_0_q_2*tmp_kernel_op_128 + jac_blending_inv_2_0_q_2*tmp_kernel_op_131)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_125 + jac_blending_inv_1_1_q_2*tmp_kernel_op_128 + jac_blending_inv_2_1_q_2*tmp_kernel_op_131)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_125 + jac_blending_inv_1_1_q_2*tmp_kernel_op_128 + jac_blending_inv_2_1_q_2*tmp_kernel_op_131)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_125 + jac_blending_inv_1_2_q_2*tmp_kernel_op_128 + jac_blending_inv_2_2_q_2*tmp_kernel_op_131)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_125 + jac_blending_inv_1_2_q_2*tmp_kernel_op_128 + jac_blending_inv_2_2_q_2*tmp_kernel_op_131))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_134 + jac_blending_inv_1_0_q_3*tmp_kernel_op_137 + jac_blending_inv_2_0_q_3*tmp_kernel_op_140)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_134 + jac_blending_inv_1_0_q_3*tmp_kernel_op_137 + jac_blending_inv_2_0_q_3*tmp_kernel_op_140)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_134 + jac_blending_inv_1_1_q_3*tmp_kernel_op_137 + jac_blending_inv_2_1_q_3*tmp_kernel_op_140)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_134 + jac_blending_inv_1_1_q_3*tmp_kernel_op_137 + jac_blending_inv_2_1_q_3*tmp_kernel_op_140)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_134 + jac_blending_inv_1_2_q_3*tmp_kernel_op_137 + jac_blending_inv_2_2_q_3*tmp_kernel_op_140)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_134 + jac_blending_inv_1_2_q_3*tmp_kernel_op_137 + jac_blending_inv_2_2_q_3*tmp_kernel_op_140))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_143 + jac_blending_inv_1_0_q_4*tmp_kernel_op_146 + jac_blending_inv_2_0_q_4*tmp_kernel_op_149)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_143 + jac_blending_inv_1_0_q_4*tmp_kernel_op_146 + jac_blending_inv_2_0_q_4*tmp_kernel_op_149)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_143 + jac_blending_inv_1_1_q_4*tmp_kernel_op_146 + jac_blending_inv_2_1_q_4*tmp_kernel_op_149)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_143 + jac_blending_inv_1_1_q_4*tmp_kernel_op_146 + jac_blending_inv_2_1_q_4*tmp_kernel_op_149)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_143 + jac_blending_inv_1_2_q_4*tmp_kernel_op_146 + jac_blending_inv_2_2_q_4*tmp_kernel_op_149)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_143 + jac_blending_inv_1_2_q_4*tmp_kernel_op_146 + jac_blending_inv_2_2_q_4*tmp_kernel_op_149))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_107 + jac_blending_inv_1_0_q_0*tmp_kernel_op_110 + jac_blending_inv_2_0_q_0*tmp_kernel_op_113)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_107 + jac_blending_inv_1_0_q_0*tmp_kernel_op_110 + jac_blending_inv_2_0_q_0*tmp_kernel_op_113)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_107 + jac_blending_inv_1_1_q_0*tmp_kernel_op_110 + jac_blending_inv_2_1_q_0*tmp_kernel_op_113)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_107 + jac_blending_inv_1_1_q_0*tmp_kernel_op_110 + jac_blending_inv_2_1_q_0*tmp_kernel_op_113)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_107 + jac_blending_inv_1_2_q_0*tmp_kernel_op_110 + jac_blending_inv_2_2_q_0*tmp_kernel_op_113)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_107 + jac_blending_inv_1_2_q_0*tmp_kernel_op_110 + jac_blending_inv_2_2_q_0*tmp_kernel_op_113)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_161 + jac_blending_inv_1_0_q_1*tmp_kernel_op_164 + jac_blending_inv_2_0_q_1*tmp_kernel_op_167)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_161 + jac_blending_inv_1_0_q_1*tmp_kernel_op_164 + jac_blending_inv_2_0_q_1*tmp_kernel_op_167)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_161 + jac_blending_inv_1_1_q_1*tmp_kernel_op_164 + jac_blending_inv_2_1_q_1*tmp_kernel_op_167)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_161 + jac_blending_inv_1_1_q_1*tmp_kernel_op_164 + jac_blending_inv_2_1_q_1*tmp_kernel_op_167)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_161 + jac_blending_inv_1_2_q_1*tmp_kernel_op_164 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_161 + jac_blending_inv_1_2_q_1*tmp_kernel_op_164 + jac_blending_inv_2_2_q_1*tmp_kernel_op_167))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_170 + jac_blending_inv_1_0_q_2*tmp_kernel_op_173 + jac_blending_inv_2_0_q_2*tmp_kernel_op_176)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_170 + jac_blending_inv_1_0_q_2*tmp_kernel_op_173 + jac_blending_inv_2_0_q_2*tmp_kernel_op_176)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_170 + jac_blending_inv_1_1_q_2*tmp_kernel_op_173 + jac_blending_inv_2_1_q_2*tmp_kernel_op_176)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_170 + jac_blending_inv_1_1_q_2*tmp_kernel_op_173 + jac_blending_inv_2_1_q_2*tmp_kernel_op_176)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_170 + jac_blending_inv_1_2_q_2*tmp_kernel_op_173 + jac_blending_inv_2_2_q_2*tmp_kernel_op_176)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_170 + jac_blending_inv_1_2_q_2*tmp_kernel_op_173 + jac_blending_inv_2_2_q_2*tmp_kernel_op_176))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_179 + jac_blending_inv_1_0_q_3*tmp_kernel_op_182 + jac_blending_inv_2_0_q_3*tmp_kernel_op_185)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_179 + jac_blending_inv_1_0_q_3*tmp_kernel_op_182 + jac_blending_inv_2_0_q_3*tmp_kernel_op_185)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_179 + jac_blending_inv_1_1_q_3*tmp_kernel_op_182 + jac_blending_inv_2_1_q_3*tmp_kernel_op_185)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_179 + jac_blending_inv_1_1_q_3*tmp_kernel_op_182 + jac_blending_inv_2_1_q_3*tmp_kernel_op_185)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_179 + jac_blending_inv_1_2_q_3*tmp_kernel_op_182 + jac_blending_inv_2_2_q_3*tmp_kernel_op_185)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_179 + jac_blending_inv_1_2_q_3*tmp_kernel_op_182 + jac_blending_inv_2_2_q_3*tmp_kernel_op_185))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_188 + jac_blending_inv_1_0_q_4*tmp_kernel_op_191 + jac_blending_inv_2_0_q_4*tmp_kernel_op_194)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_188 + jac_blending_inv_1_0_q_4*tmp_kernel_op_191 + jac_blending_inv_2_0_q_4*tmp_kernel_op_194)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_188 + jac_blending_inv_1_1_q_4*tmp_kernel_op_191 + jac_blending_inv_2_1_q_4*tmp_kernel_op_194)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_188 + jac_blending_inv_1_1_q_4*tmp_kernel_op_191 + jac_blending_inv_2_1_q_4*tmp_kernel_op_194)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_188 + jac_blending_inv_1_2_q_4*tmp_kernel_op_191 + jac_blending_inv_2_2_q_4*tmp_kernel_op_194)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_188 + jac_blending_inv_1_2_q_4*tmp_kernel_op_191 + jac_blending_inv_2_2_q_4*tmp_kernel_op_194))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_152 + jac_blending_inv_1_0_q_0*tmp_kernel_op_155 + jac_blending_inv_2_0_q_0*tmp_kernel_op_158)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_152 + jac_blending_inv_1_0_q_0*tmp_kernel_op_155 + jac_blending_inv_2_0_q_0*tmp_kernel_op_158)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_152 + jac_blending_inv_1_1_q_0*tmp_kernel_op_155 + jac_blending_inv_2_1_q_0*tmp_kernel_op_158)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_152 + jac_blending_inv_1_1_q_0*tmp_kernel_op_155 + jac_blending_inv_2_1_q_0*tmp_kernel_op_158)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_152 + jac_blending_inv_1_2_q_0*tmp_kernel_op_155 + jac_blending_inv_2_2_q_0*tmp_kernel_op_158)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_152 + jac_blending_inv_1_2_q_0*tmp_kernel_op_155 + jac_blending_inv_2_2_q_0*tmp_kernel_op_158)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_206 + jac_blending_inv_1_0_q_1*tmp_kernel_op_209 + jac_blending_inv_2_0_q_1*tmp_kernel_op_212)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_206 + jac_blending_inv_1_0_q_1*tmp_kernel_op_209 + jac_blending_inv_2_0_q_1*tmp_kernel_op_212)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_206 + jac_blending_inv_1_1_q_1*tmp_kernel_op_209 + jac_blending_inv_2_1_q_1*tmp_kernel_op_212)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_206 + jac_blending_inv_1_1_q_1*tmp_kernel_op_209 + jac_blending_inv_2_1_q_1*tmp_kernel_op_212)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_206 + jac_blending_inv_1_2_q_1*tmp_kernel_op_209 + jac_blending_inv_2_2_q_1*tmp_kernel_op_212)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_206 + jac_blending_inv_1_2_q_1*tmp_kernel_op_209 + jac_blending_inv_2_2_q_1*tmp_kernel_op_212))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_215 + jac_blending_inv_1_0_q_2*tmp_kernel_op_218 + jac_blending_inv_2_0_q_2*tmp_kernel_op_221)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_215 + jac_blending_inv_1_0_q_2*tmp_kernel_op_218 + jac_blending_inv_2_0_q_2*tmp_kernel_op_221)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_1_q_2*tmp_kernel_op_218 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_215 + jac_blending_inv_1_1_q_2*tmp_kernel_op_218 + jac_blending_inv_2_1_q_2*tmp_kernel_op_221)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_218 + jac_blending_inv_2_2_q_2*tmp_kernel_op_221)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_215 + jac_blending_inv_1_2_q_2*tmp_kernel_op_218 + jac_blending_inv_2_2_q_2*tmp_kernel_op_221))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_224 + jac_blending_inv_1_0_q_3*tmp_kernel_op_227 + jac_blending_inv_2_0_q_3*tmp_kernel_op_230)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_224 + jac_blending_inv_1_0_q_3*tmp_kernel_op_227 + jac_blending_inv_2_0_q_3*tmp_kernel_op_230)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_224 + jac_blending_inv_1_1_q_3*tmp_kernel_op_227 + jac_blending_inv_2_1_q_3*tmp_kernel_op_230)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_224 + jac_blending_inv_1_1_q_3*tmp_kernel_op_227 + jac_blending_inv_2_1_q_3*tmp_kernel_op_230)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_224 + jac_blending_inv_1_2_q_3*tmp_kernel_op_227 + jac_blending_inv_2_2_q_3*tmp_kernel_op_230)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_224 + jac_blending_inv_1_2_q_3*tmp_kernel_op_227 + jac_blending_inv_2_2_q_3*tmp_kernel_op_230))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_233 + jac_blending_inv_1_0_q_4*tmp_kernel_op_236 + jac_blending_inv_2_0_q_4*tmp_kernel_op_239)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_233 + jac_blending_inv_1_0_q_4*tmp_kernel_op_236 + jac_blending_inv_2_0_q_4*tmp_kernel_op_239)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_233 + jac_blending_inv_1_1_q_4*tmp_kernel_op_236 + jac_blending_inv_2_1_q_4*tmp_kernel_op_239)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_233 + jac_blending_inv_1_1_q_4*tmp_kernel_op_236 + jac_blending_inv_2_1_q_4*tmp_kernel_op_239)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_233 + jac_blending_inv_1_2_q_4*tmp_kernel_op_236 + jac_blending_inv_2_2_q_4*tmp_kernel_op_239)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_233 + jac_blending_inv_1_2_q_4*tmp_kernel_op_236 + jac_blending_inv_2_2_q_4*tmp_kernel_op_239))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_197 + jac_blending_inv_1_0_q_0*tmp_kernel_op_200 + jac_blending_inv_2_0_q_0*tmp_kernel_op_203)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_197 + jac_blending_inv_1_0_q_0*tmp_kernel_op_200 + jac_blending_inv_2_0_q_0*tmp_kernel_op_203)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_197 + jac_blending_inv_1_1_q_0*tmp_kernel_op_200 + jac_blending_inv_2_1_q_0*tmp_kernel_op_203)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_197 + jac_blending_inv_1_1_q_0*tmp_kernel_op_200 + jac_blending_inv_2_1_q_0*tmp_kernel_op_203)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_197 + jac_blending_inv_1_2_q_0*tmp_kernel_op_200 + jac_blending_inv_2_2_q_0*tmp_kernel_op_203)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_197 + jac_blending_inv_1_2_q_0*tmp_kernel_op_200 + jac_blending_inv_2_2_q_0*tmp_kernel_op_203)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_245 + jac_blending_inv_1_0_q_1*tmp_kernel_op_246 + jac_blending_inv_2_0_q_1*tmp_kernel_op_247)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_245 + jac_blending_inv_1_0_q_1*tmp_kernel_op_246 + jac_blending_inv_2_0_q_1*tmp_kernel_op_247)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_245 + jac_blending_inv_1_1_q_1*tmp_kernel_op_246 + jac_blending_inv_2_1_q_1*tmp_kernel_op_247)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_245 + jac_blending_inv_1_1_q_1*tmp_kernel_op_246 + jac_blending_inv_2_1_q_1*tmp_kernel_op_247)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_245 + jac_blending_inv_1_2_q_1*tmp_kernel_op_246 + jac_blending_inv_2_2_q_1*tmp_kernel_op_247)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_245 + jac_blending_inv_1_2_q_1*tmp_kernel_op_246 + jac_blending_inv_2_2_q_1*tmp_kernel_op_247))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_249 + jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_0_q_2*tmp_kernel_op_251)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_249 + jac_blending_inv_1_0_q_2*tmp_kernel_op_250 + jac_blending_inv_2_0_q_2*tmp_kernel_op_251)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_249 + jac_blending_inv_1_1_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_249 + jac_blending_inv_1_1_q_2*tmp_kernel_op_250 + jac_blending_inv_2_1_q_2*tmp_kernel_op_251)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_249 + jac_blending_inv_1_2_q_2*tmp_kernel_op_250 + jac_blending_inv_2_2_q_2*tmp_kernel_op_251)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_249 + jac_blending_inv_1_2_q_2*tmp_kernel_op_250 + jac_blending_inv_2_2_q_2*tmp_kernel_op_251))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_253 + jac_blending_inv_1_0_q_3*tmp_kernel_op_254 + jac_blending_inv_2_0_q_3*tmp_kernel_op_255)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_253 + jac_blending_inv_1_0_q_3*tmp_kernel_op_254 + jac_blending_inv_2_0_q_3*tmp_kernel_op_255)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_253 + jac_blending_inv_1_1_q_3*tmp_kernel_op_254 + jac_blending_inv_2_1_q_3*tmp_kernel_op_255)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_253 + jac_blending_inv_1_1_q_3*tmp_kernel_op_254 + jac_blending_inv_2_1_q_3*tmp_kernel_op_255)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_253 + jac_blending_inv_1_2_q_3*tmp_kernel_op_254 + jac_blending_inv_2_2_q_3*tmp_kernel_op_255)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_253 + jac_blending_inv_1_2_q_3*tmp_kernel_op_254 + jac_blending_inv_2_2_q_3*tmp_kernel_op_255))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_257 + jac_blending_inv_1_0_q_4*tmp_kernel_op_258 + jac_blending_inv_2_0_q_4*tmp_kernel_op_259)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_257 + jac_blending_inv_1_0_q_4*tmp_kernel_op_258 + jac_blending_inv_2_0_q_4*tmp_kernel_op_259)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_257 + jac_blending_inv_1_1_q_4*tmp_kernel_op_258 + jac_blending_inv_2_1_q_4*tmp_kernel_op_259)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_257 + jac_blending_inv_1_1_q_4*tmp_kernel_op_258 + jac_blending_inv_2_1_q_4*tmp_kernel_op_259)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_257 + jac_blending_inv_1_2_q_4*tmp_kernel_op_258 + jac_blending_inv_2_2_q_4*tmp_kernel_op_259)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_257 + jac_blending_inv_1_2_q_4*tmp_kernel_op_258 + jac_blending_inv_2_2_q_4*tmp_kernel_op_259))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_241 + jac_blending_inv_1_0_q_0*tmp_kernel_op_242 + jac_blending_inv_2_0_q_0*tmp_kernel_op_243)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_241 + jac_blending_inv_1_0_q_0*tmp_kernel_op_242 + jac_blending_inv_2_0_q_0*tmp_kernel_op_243)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_241 + jac_blending_inv_1_1_q_0*tmp_kernel_op_242 + jac_blending_inv_2_1_q_0*tmp_kernel_op_243)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_241 + jac_blending_inv_1_1_q_0*tmp_kernel_op_242 + jac_blending_inv_2_1_q_0*tmp_kernel_op_243)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_241 + jac_blending_inv_1_2_q_0*tmp_kernel_op_242 + jac_blending_inv_2_2_q_0*tmp_kernel_op_243)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_241 + jac_blending_inv_1_2_q_0*tmp_kernel_op_242 + jac_blending_inv_2_2_q_0*tmp_kernel_op_243)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_267 + jac_blending_inv_1_0_q_1*tmp_kernel_op_268 + jac_blending_inv_2_0_q_1*tmp_kernel_op_269)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_267 + jac_blending_inv_1_0_q_1*tmp_kernel_op_268 + jac_blending_inv_2_0_q_1*tmp_kernel_op_269)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_267 + jac_blending_inv_1_1_q_1*tmp_kernel_op_268 + jac_blending_inv_2_1_q_1*tmp_kernel_op_269)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_267 + jac_blending_inv_1_1_q_1*tmp_kernel_op_268 + jac_blending_inv_2_1_q_1*tmp_kernel_op_269)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_267 + jac_blending_inv_1_2_q_1*tmp_kernel_op_268 + jac_blending_inv_2_2_q_1*tmp_kernel_op_269)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_267 + jac_blending_inv_1_2_q_1*tmp_kernel_op_268 + jac_blending_inv_2_2_q_1*tmp_kernel_op_269))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_272 + jac_blending_inv_1_0_q_2*tmp_kernel_op_273 + jac_blending_inv_2_0_q_2*tmp_kernel_op_274)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_272 + jac_blending_inv_1_0_q_2*tmp_kernel_op_273 + jac_blending_inv_2_0_q_2*tmp_kernel_op_274)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_272 + jac_blending_inv_1_1_q_2*tmp_kernel_op_273 + jac_blending_inv_2_1_q_2*tmp_kernel_op_274)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_272 + jac_blending_inv_1_1_q_2*tmp_kernel_op_273 + jac_blending_inv_2_1_q_2*tmp_kernel_op_274)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_272 + jac_blending_inv_1_2_q_2*tmp_kernel_op_273 + jac_blending_inv_2_2_q_2*tmp_kernel_op_274)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_272 + jac_blending_inv_1_2_q_2*tmp_kernel_op_273 + jac_blending_inv_2_2_q_2*tmp_kernel_op_274))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_277 + jac_blending_inv_1_0_q_3*tmp_kernel_op_278 + jac_blending_inv_2_0_q_3*tmp_kernel_op_279)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_277 + jac_blending_inv_1_0_q_3*tmp_kernel_op_278 + jac_blending_inv_2_0_q_3*tmp_kernel_op_279)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_277 + jac_blending_inv_1_1_q_3*tmp_kernel_op_278 + jac_blending_inv_2_1_q_3*tmp_kernel_op_279)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_277 + jac_blending_inv_1_1_q_3*tmp_kernel_op_278 + jac_blending_inv_2_1_q_3*tmp_kernel_op_279)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_277 + jac_blending_inv_1_2_q_3*tmp_kernel_op_278 + jac_blending_inv_2_2_q_3*tmp_kernel_op_279)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_277 + jac_blending_inv_1_2_q_3*tmp_kernel_op_278 + jac_blending_inv_2_2_q_3*tmp_kernel_op_279))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_282 + jac_blending_inv_1_0_q_4*tmp_kernel_op_283 + jac_blending_inv_2_0_q_4*tmp_kernel_op_284)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_282 + jac_blending_inv_1_0_q_4*tmp_kernel_op_283 + jac_blending_inv_2_0_q_4*tmp_kernel_op_284)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_282 + jac_blending_inv_1_1_q_4*tmp_kernel_op_283 + jac_blending_inv_2_1_q_4*tmp_kernel_op_284)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_282 + jac_blending_inv_1_1_q_4*tmp_kernel_op_283 + jac_blending_inv_2_1_q_4*tmp_kernel_op_284)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_282 + jac_blending_inv_1_2_q_4*tmp_kernel_op_283 + jac_blending_inv_2_2_q_4*tmp_kernel_op_284)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_282 + jac_blending_inv_1_2_q_4*tmp_kernel_op_283 + jac_blending_inv_2_2_q_4*tmp_kernel_op_284))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_262 + jac_blending_inv_1_0_q_0*tmp_kernel_op_263 + jac_blending_inv_2_0_q_0*tmp_kernel_op_264)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_262 + jac_blending_inv_1_0_q_0*tmp_kernel_op_263 + jac_blending_inv_2_0_q_0*tmp_kernel_op_264)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_262 + jac_blending_inv_1_1_q_0*tmp_kernel_op_263 + jac_blending_inv_2_1_q_0*tmp_kernel_op_264)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_262 + jac_blending_inv_1_1_q_0*tmp_kernel_op_263 + jac_blending_inv_2_1_q_0*tmp_kernel_op_264)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_262 + jac_blending_inv_1_2_q_0*tmp_kernel_op_263 + jac_blending_inv_2_2_q_0*tmp_kernel_op_264)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_262 + jac_blending_inv_1_2_q_0*tmp_kernel_op_263 + jac_blending_inv_2_2_q_0*tmp_kernel_op_264)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_kernel_op_290 + jac_blending_inv_1_0_q_1*tmp_kernel_op_291 + jac_blending_inv_2_0_q_1*tmp_kernel_op_292)*(jac_blending_inv_0_0_q_1*tmp_kernel_op_290 + jac_blending_inv_1_0_q_1*tmp_kernel_op_291 + jac_blending_inv_2_0_q_1*tmp_kernel_op_292)) + ((jac_blending_inv_0_1_q_1*tmp_kernel_op_290 + jac_blending_inv_1_1_q_1*tmp_kernel_op_291 + jac_blending_inv_2_1_q_1*tmp_kernel_op_292)*(jac_blending_inv_0_1_q_1*tmp_kernel_op_290 + jac_blending_inv_1_1_q_1*tmp_kernel_op_291 + jac_blending_inv_2_1_q_1*tmp_kernel_op_292)) + ((jac_blending_inv_0_2_q_1*tmp_kernel_op_290 + jac_blending_inv_1_2_q_1*tmp_kernel_op_291 + jac_blending_inv_2_2_q_1*tmp_kernel_op_292)*(jac_blending_inv_0_2_q_1*tmp_kernel_op_290 + jac_blending_inv_1_2_q_1*tmp_kernel_op_291 + jac_blending_inv_2_2_q_1*tmp_kernel_op_292))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_kernel_op_294 + jac_blending_inv_1_0_q_2*tmp_kernel_op_295 + jac_blending_inv_2_0_q_2*tmp_kernel_op_296)*(jac_blending_inv_0_0_q_2*tmp_kernel_op_294 + jac_blending_inv_1_0_q_2*tmp_kernel_op_295 + jac_blending_inv_2_0_q_2*tmp_kernel_op_296)) + ((jac_blending_inv_0_1_q_2*tmp_kernel_op_294 + jac_blending_inv_1_1_q_2*tmp_kernel_op_295 + jac_blending_inv_2_1_q_2*tmp_kernel_op_296)*(jac_blending_inv_0_1_q_2*tmp_kernel_op_294 + jac_blending_inv_1_1_q_2*tmp_kernel_op_295 + jac_blending_inv_2_1_q_2*tmp_kernel_op_296)) + ((jac_blending_inv_0_2_q_2*tmp_kernel_op_294 + jac_blending_inv_1_2_q_2*tmp_kernel_op_295 + jac_blending_inv_2_2_q_2*tmp_kernel_op_296)*(jac_blending_inv_0_2_q_2*tmp_kernel_op_294 + jac_blending_inv_1_2_q_2*tmp_kernel_op_295 + jac_blending_inv_2_2_q_2*tmp_kernel_op_296))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_kernel_op_298 + jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_0_q_3*tmp_kernel_op_300)*(jac_blending_inv_0_0_q_3*tmp_kernel_op_298 + jac_blending_inv_1_0_q_3*tmp_kernel_op_299 + jac_blending_inv_2_0_q_3*tmp_kernel_op_300)) + ((jac_blending_inv_0_1_q_3*tmp_kernel_op_298 + jac_blending_inv_1_1_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300)*(jac_blending_inv_0_1_q_3*tmp_kernel_op_298 + jac_blending_inv_1_1_q_3*tmp_kernel_op_299 + jac_blending_inv_2_1_q_3*tmp_kernel_op_300)) + ((jac_blending_inv_0_2_q_3*tmp_kernel_op_298 + jac_blending_inv_1_2_q_3*tmp_kernel_op_299 + jac_blending_inv_2_2_q_3*tmp_kernel_op_300)*(jac_blending_inv_0_2_q_3*tmp_kernel_op_298 + jac_blending_inv_1_2_q_3*tmp_kernel_op_299 + jac_blending_inv_2_2_q_3*tmp_kernel_op_300))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_kernel_op_302 + jac_blending_inv_1_0_q_4*tmp_kernel_op_303 + jac_blending_inv_2_0_q_4*tmp_kernel_op_304)*(jac_blending_inv_0_0_q_4*tmp_kernel_op_302 + jac_blending_inv_1_0_q_4*tmp_kernel_op_303 + jac_blending_inv_2_0_q_4*tmp_kernel_op_304)) + ((jac_blending_inv_0_1_q_4*tmp_kernel_op_302 + jac_blending_inv_1_1_q_4*tmp_kernel_op_303 + jac_blending_inv_2_1_q_4*tmp_kernel_op_304)*(jac_blending_inv_0_1_q_4*tmp_kernel_op_302 + jac_blending_inv_1_1_q_4*tmp_kernel_op_303 + jac_blending_inv_2_1_q_4*tmp_kernel_op_304)) + ((jac_blending_inv_0_2_q_4*tmp_kernel_op_302 + jac_blending_inv_1_2_q_4*tmp_kernel_op_303 + jac_blending_inv_2_2_q_4*tmp_kernel_op_304)*(jac_blending_inv_0_2_q_4*tmp_kernel_op_302 + jac_blending_inv_1_2_q_4*tmp_kernel_op_303 + jac_blending_inv_2_2_q_4*tmp_kernel_op_304))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_kernel_op_286 + jac_blending_inv_1_0_q_0*tmp_kernel_op_287 + jac_blending_inv_2_0_q_0*tmp_kernel_op_288)*(jac_blending_inv_0_0_q_0*tmp_kernel_op_286 + jac_blending_inv_1_0_q_0*tmp_kernel_op_287 + jac_blending_inv_2_0_q_0*tmp_kernel_op_288)) + ((jac_blending_inv_0_1_q_0*tmp_kernel_op_286 + jac_blending_inv_1_1_q_0*tmp_kernel_op_287 + jac_blending_inv_2_1_q_0*tmp_kernel_op_288)*(jac_blending_inv_0_1_q_0*tmp_kernel_op_286 + jac_blending_inv_1_1_q_0*tmp_kernel_op_287 + jac_blending_inv_2_1_q_0*tmp_kernel_op_288)) + ((jac_blending_inv_0_2_q_0*tmp_kernel_op_286 + jac_blending_inv_1_2_q_0*tmp_kernel_op_287 + jac_blending_inv_2_2_q_0*tmp_kernel_op_288)*(jac_blending_inv_0_2_q_0*tmp_kernel_op_286 + jac_blending_inv_1_2_q_0*tmp_kernel_op_287 + jac_blending_inv_2_2_q_0*tmp_kernel_op_288)));
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const real_t tmp_moved_constant_0 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_1 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_2 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_3 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_4 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_5 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_6 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_7 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_8 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_9 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_10 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_11 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_12 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_13 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_14 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_15 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_16 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_17 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_18 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_19 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_20 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_21 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_22 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_23 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_24 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_25 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_26 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_27 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_28 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_29 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_30 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_31 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_32 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_33 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_34 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_35 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_36 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_37 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_38 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_39 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_40 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_41 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_42 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_43 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_44 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_45 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_46 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_47 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_48 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_49 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_50 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_51 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_52 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_53 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_54 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_55 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_56 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_57 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_58 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_59 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_60 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_61 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_62 = tmp_moved_constant_60 + tmp_moved_constant_61;
       const real_t tmp_moved_constant_63 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_64 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_65 = tmp_moved_constant_63 + tmp_moved_constant_64;
       const real_t tmp_moved_constant_66 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_67 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_68 = tmp_moved_constant_66 + tmp_moved_constant_67;
       const real_t tmp_moved_constant_69 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_70 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_71 = tmp_moved_constant_69 + tmp_moved_constant_70;
       const real_t tmp_moved_constant_72 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_73 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_74 = tmp_moved_constant_72 + tmp_moved_constant_73;
       const real_t tmp_moved_constant_75 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_76 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_77 = tmp_moved_constant_75 + tmp_moved_constant_76;
       const real_t tmp_moved_constant_78 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_79 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_80 = tmp_moved_constant_78 + tmp_moved_constant_79;
       const real_t tmp_moved_constant_81 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_82 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_83 = tmp_moved_constant_81 + tmp_moved_constant_82;
       const real_t tmp_moved_constant_84 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_85 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_86 = tmp_moved_constant_84 + tmp_moved_constant_85;
       const real_t tmp_moved_constant_87 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_88 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_89 = tmp_moved_constant_87 + tmp_moved_constant_88;
       const real_t tmp_moved_constant_90 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_91 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_92 = tmp_moved_constant_90 + tmp_moved_constant_91;
       const real_t tmp_moved_constant_93 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_94 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_95 = tmp_moved_constant_93 + tmp_moved_constant_94;
       const real_t tmp_moved_constant_96 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_97 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_98 = tmp_moved_constant_96 + tmp_moved_constant_97;
       const real_t tmp_moved_constant_99 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_100 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_101 = tmp_moved_constant_100 + tmp_moved_constant_99;
       const real_t tmp_moved_constant_102 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_103 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_104 = tmp_moved_constant_102 + tmp_moved_constant_103;
       const real_t tmp_moved_constant_105 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_106 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_107 = tmp_moved_constant_105 + tmp_moved_constant_106;
       const real_t tmp_moved_constant_108 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_109 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_110 = tmp_moved_constant_108 + tmp_moved_constant_109;
       const real_t tmp_moved_constant_111 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_112 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_113 = tmp_moved_constant_111 + tmp_moved_constant_112;
       const real_t tmp_moved_constant_114 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_115 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_116 = tmp_moved_constant_114 + tmp_moved_constant_115;
       const real_t tmp_moved_constant_117 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_118 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_119 = tmp_moved_constant_117 + tmp_moved_constant_118;
       const real_t tmp_moved_constant_120 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_121 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_122 = tmp_moved_constant_120 + tmp_moved_constant_121;
       const real_t tmp_moved_constant_123 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_124 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_125 = tmp_moved_constant_123 + tmp_moved_constant_124;
       const real_t tmp_moved_constant_126 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_127 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_128 = tmp_moved_constant_126 + tmp_moved_constant_127;
       const real_t tmp_moved_constant_129 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_130 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_131 = tmp_moved_constant_129 + tmp_moved_constant_130;
       const real_t tmp_moved_constant_132 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_133 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_134 = tmp_moved_constant_132 + tmp_moved_constant_133;
       const real_t tmp_moved_constant_135 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_136 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_137 = tmp_moved_constant_135 + tmp_moved_constant_136;
       const real_t tmp_moved_constant_138 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_139 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_140 = tmp_moved_constant_138 + tmp_moved_constant_139;
       const real_t tmp_moved_constant_141 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_142 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_143 = tmp_moved_constant_141 + tmp_moved_constant_142;
       const real_t tmp_moved_constant_144 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_145 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_146 = tmp_moved_constant_144 + tmp_moved_constant_145;
       const real_t tmp_moved_constant_147 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_148 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_149 = tmp_moved_constant_147 + tmp_moved_constant_148;
       const real_t tmp_moved_constant_150 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_151 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_152 = tmp_moved_constant_150 + tmp_moved_constant_151;
       const real_t tmp_moved_constant_153 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_154 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_155 = tmp_moved_constant_153 + tmp_moved_constant_154;
       const real_t tmp_moved_constant_156 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_157 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_158 = tmp_moved_constant_156 + tmp_moved_constant_157;
       const real_t tmp_moved_constant_159 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_160 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_161 = tmp_moved_constant_159 + tmp_moved_constant_160;
       const real_t tmp_moved_constant_162 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_163 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_164 = tmp_moved_constant_162 + tmp_moved_constant_163;
       const real_t tmp_moved_constant_165 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_166 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_167 = tmp_moved_constant_165 + tmp_moved_constant_166;
       const real_t tmp_moved_constant_168 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_169 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_170 = tmp_moved_constant_168 + tmp_moved_constant_169;
       const real_t tmp_moved_constant_171 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_172 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_173 = tmp_moved_constant_171 + tmp_moved_constant_172;
       const real_t tmp_moved_constant_174 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_175 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_176 = tmp_moved_constant_174 + tmp_moved_constant_175;
       const real_t tmp_moved_constant_177 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_178 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_179 = tmp_moved_constant_177 + tmp_moved_constant_178;
       const real_t tmp_moved_constant_180 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_181 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_182 = tmp_moved_constant_180 + tmp_moved_constant_181;
       const real_t tmp_moved_constant_183 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_184 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_185 = tmp_moved_constant_183 + tmp_moved_constant_184;
       const real_t tmp_moved_constant_186 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_187 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_188 = tmp_moved_constant_186 + tmp_moved_constant_187;
       const real_t tmp_moved_constant_189 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_190 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_191 = tmp_moved_constant_189 + tmp_moved_constant_190;
       const real_t tmp_moved_constant_192 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_193 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_194 = tmp_moved_constant_192 + tmp_moved_constant_193;
       const real_t tmp_moved_constant_195 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_105 - tmp_moved_constant_60;
       const real_t tmp_moved_constant_196 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_108 - tmp_moved_constant_63;
       const real_t tmp_moved_constant_197 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_111 - tmp_moved_constant_66;
       const real_t tmp_moved_constant_198 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_114 - tmp_moved_constant_69;
       const real_t tmp_moved_constant_199 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_117 - tmp_moved_constant_72;
       const real_t tmp_moved_constant_200 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_120 - tmp_moved_constant_75;
       const real_t tmp_moved_constant_201 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_123 - tmp_moved_constant_78;
       const real_t tmp_moved_constant_202 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_126 - tmp_moved_constant_81;
       const real_t tmp_moved_constant_203 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_129 - tmp_moved_constant_84;
       const real_t tmp_moved_constant_204 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_132 - tmp_moved_constant_87;
       const real_t tmp_moved_constant_205 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_135 - tmp_moved_constant_90;
       const real_t tmp_moved_constant_206 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_138 - tmp_moved_constant_93;
       const real_t tmp_moved_constant_207 = jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_141 - tmp_moved_constant_96;
       const real_t tmp_moved_constant_208 = jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_144 - tmp_moved_constant_99;
       const real_t tmp_moved_constant_209 = jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_102 - tmp_moved_constant_147;
       const real_t tmp_moved_constant_210 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_150 - tmp_moved_constant_61;
       const real_t tmp_moved_constant_211 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_153 - tmp_moved_constant_64;
       const real_t tmp_moved_constant_212 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_156 - tmp_moved_constant_67;
       const real_t tmp_moved_constant_213 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_159 - tmp_moved_constant_70;
       const real_t tmp_moved_constant_214 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_162 - tmp_moved_constant_73;
       const real_t tmp_moved_constant_215 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_165 - tmp_moved_constant_76;
       const real_t tmp_moved_constant_216 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_168 - tmp_moved_constant_79;
       const real_t tmp_moved_constant_217 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_171 - tmp_moved_constant_82;
       const real_t tmp_moved_constant_218 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_174 - tmp_moved_constant_85;
       const real_t tmp_moved_constant_219 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_177 - tmp_moved_constant_88;
       const real_t tmp_moved_constant_220 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_180 - tmp_moved_constant_91;
       const real_t tmp_moved_constant_221 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_183 - tmp_moved_constant_94;
       const real_t tmp_moved_constant_222 = jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_186 - tmp_moved_constant_97;
       const real_t tmp_moved_constant_223 = jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_100 - tmp_moved_constant_189;
       const real_t tmp_moved_constant_224 = jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_103 - tmp_moved_constant_192;
       const real_t tmp_moved_constant_225 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_106 - tmp_moved_constant_151;
       const real_t tmp_moved_constant_226 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_109 - tmp_moved_constant_154;
       const real_t tmp_moved_constant_227 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_112 - tmp_moved_constant_157;
       const real_t tmp_moved_constant_228 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_115 - tmp_moved_constant_160;
       const real_t tmp_moved_constant_229 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_118 - tmp_moved_constant_163;
       const real_t tmp_moved_constant_230 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_121 - tmp_moved_constant_166;
       const real_t tmp_moved_constant_231 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_124 - tmp_moved_constant_169;
       const real_t tmp_moved_constant_232 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_127 - tmp_moved_constant_172;
       const real_t tmp_moved_constant_233 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_130 - tmp_moved_constant_175;
       const real_t tmp_moved_constant_234 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_133 - tmp_moved_constant_178;
       const real_t tmp_moved_constant_235 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_136 - tmp_moved_constant_181;
       const real_t tmp_moved_constant_236 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_139 - tmp_moved_constant_184;
       const real_t tmp_moved_constant_237 = jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_142 - tmp_moved_constant_187;
       const real_t tmp_moved_constant_238 = jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_145 - tmp_moved_constant_190;
       const real_t tmp_moved_constant_239 = jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_148 - tmp_moved_constant_193;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0,tmp_moved_constant_0)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1,tmp_moved_constant_1))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2,tmp_moved_constant_2)))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10,tmp_moved_constant_10)),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11,tmp_moved_constant_11))),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9,tmp_moved_constant_9))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12,tmp_moved_constant_12)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13,tmp_moved_constant_13))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14,tmp_moved_constant_14))))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3,tmp_moved_constant_3)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4,tmp_moved_constant_4))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5,tmp_moved_constant_5))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6,tmp_moved_constant_6)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7,tmp_moved_constant_7))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8,tmp_moved_constant_8)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15,tmp_moved_constant_15)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16,tmp_moved_constant_16))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17,tmp_moved_constant_17)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18,tmp_moved_constant_18)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19,tmp_moved_constant_19))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20,tmp_moved_constant_20))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21,tmp_moved_constant_21)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22,tmp_moved_constant_22))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23,tmp_moved_constant_23))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24,tmp_moved_constant_24)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25,tmp_moved_constant_25))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26,tmp_moved_constant_26))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27,tmp_moved_constant_27)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28,tmp_moved_constant_28))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29,tmp_moved_constant_29)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30,tmp_moved_constant_30)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31,tmp_moved_constant_31))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32,tmp_moved_constant_32)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33,tmp_moved_constant_33)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34,tmp_moved_constant_34))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35,tmp_moved_constant_35))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36,tmp_moved_constant_36)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37,tmp_moved_constant_37))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38,tmp_moved_constant_38))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39,tmp_moved_constant_39)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40,tmp_moved_constant_40))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41,tmp_moved_constant_41))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42,tmp_moved_constant_42)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43,tmp_moved_constant_43))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44,tmp_moved_constant_44)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45,tmp_moved_constant_45)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46,tmp_moved_constant_46))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47,tmp_moved_constant_47)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48,tmp_moved_constant_48)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49,tmp_moved_constant_49))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50,tmp_moved_constant_50))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51,tmp_moved_constant_51)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52,tmp_moved_constant_52))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53,tmp_moved_constant_53))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54,tmp_moved_constant_54)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55,tmp_moved_constant_55))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56,tmp_moved_constant_56))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57,tmp_moved_constant_57)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58,tmp_moved_constant_58))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59,tmp_moved_constant_59)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101,tmp_moved_constant_101)),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104,tmp_moved_constant_104))),_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98,tmp_moved_constant_98)))))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62,tmp_moved_constant_62)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65,tmp_moved_constant_65))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68,tmp_moved_constant_68))))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71,tmp_moved_constant_71)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74,tmp_moved_constant_74))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77,tmp_moved_constant_77))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80,tmp_moved_constant_80)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83,tmp_moved_constant_83))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86,tmp_moved_constant_86))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89,tmp_moved_constant_89)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92,tmp_moved_constant_92))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95,tmp_moved_constant_95)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107,tmp_moved_constant_107)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110,tmp_moved_constant_110))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113,tmp_moved_constant_113)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116,tmp_moved_constant_116)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119,tmp_moved_constant_119))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122,tmp_moved_constant_122))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125,tmp_moved_constant_125)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128,tmp_moved_constant_128))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131,tmp_moved_constant_131))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134,tmp_moved_constant_134)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137,tmp_moved_constant_137))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140,tmp_moved_constant_140))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143,tmp_moved_constant_143)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146,tmp_moved_constant_146))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149,tmp_moved_constant_149)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152,tmp_moved_constant_152)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155,tmp_moved_constant_155))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158,tmp_moved_constant_158)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161,tmp_moved_constant_161)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164,tmp_moved_constant_164))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167,tmp_moved_constant_167))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170,tmp_moved_constant_170)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173,tmp_moved_constant_173))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176,tmp_moved_constant_176))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179,tmp_moved_constant_179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182,tmp_moved_constant_182))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185,tmp_moved_constant_185))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188,tmp_moved_constant_188)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191,tmp_moved_constant_191))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194,tmp_moved_constant_194)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195,tmp_moved_constant_195)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196,tmp_moved_constant_196))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197,tmp_moved_constant_197)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198,tmp_moved_constant_198)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199,tmp_moved_constant_199))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200,tmp_moved_constant_200))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201,tmp_moved_constant_201)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202,tmp_moved_constant_202))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203,tmp_moved_constant_203))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204,tmp_moved_constant_204)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205,tmp_moved_constant_205))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206,tmp_moved_constant_206))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207,tmp_moved_constant_207)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208,tmp_moved_constant_208))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209,tmp_moved_constant_209)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210,tmp_moved_constant_210)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211,tmp_moved_constant_211))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212,tmp_moved_constant_212)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213,tmp_moved_constant_213)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214,tmp_moved_constant_214))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215,tmp_moved_constant_215))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216,tmp_moved_constant_216)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217,tmp_moved_constant_217))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218,tmp_moved_constant_218))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219,tmp_moved_constant_219)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220,tmp_moved_constant_220))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221,tmp_moved_constant_221))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222,tmp_moved_constant_222)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223,tmp_moved_constant_223))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224,tmp_moved_constant_224)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225,tmp_moved_constant_225)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226,tmp_moved_constant_226))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227,tmp_moved_constant_227)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228,tmp_moved_constant_228)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229,tmp_moved_constant_229))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230,tmp_moved_constant_230))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231,tmp_moved_constant_231)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232,tmp_moved_constant_232))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233,tmp_moved_constant_233))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234,tmp_moved_constant_234)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235,tmp_moved_constant_235))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236,tmp_moved_constant_236))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237,tmp_moved_constant_237)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238,tmp_moved_constant_238))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239,tmp_moved_constant_239)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_WHITE_DOWN*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_3 + jac_blending_inv_1_0_q_1*tmp_moved_constant_4 + jac_blending_inv_2_0_q_1*tmp_moved_constant_5)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_3 + jac_blending_inv_1_0_q_1*tmp_moved_constant_4 + jac_blending_inv_2_0_q_1*tmp_moved_constant_5)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_3 + jac_blending_inv_1_1_q_1*tmp_moved_constant_4 + jac_blending_inv_2_1_q_1*tmp_moved_constant_5)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_3 + jac_blending_inv_1_1_q_1*tmp_moved_constant_4 + jac_blending_inv_2_1_q_1*tmp_moved_constant_5)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_3 + jac_blending_inv_1_2_q_1*tmp_moved_constant_4 + jac_blending_inv_2_2_q_1*tmp_moved_constant_5)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_3 + jac_blending_inv_1_2_q_1*tmp_moved_constant_4 + jac_blending_inv_2_2_q_1*tmp_moved_constant_5))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_6 + jac_blending_inv_1_0_q_2*tmp_moved_constant_7 + jac_blending_inv_2_0_q_2*tmp_moved_constant_8)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_6 + jac_blending_inv_1_0_q_2*tmp_moved_constant_7 + jac_blending_inv_2_0_q_2*tmp_moved_constant_8)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_6 + jac_blending_inv_1_1_q_2*tmp_moved_constant_7 + jac_blending_inv_2_1_q_2*tmp_moved_constant_8)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_6 + jac_blending_inv_1_1_q_2*tmp_moved_constant_7 + jac_blending_inv_2_1_q_2*tmp_moved_constant_8)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_6 + jac_blending_inv_1_2_q_2*tmp_moved_constant_7 + jac_blending_inv_2_2_q_2*tmp_moved_constant_8)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_6 + jac_blending_inv_1_2_q_2*tmp_moved_constant_7 + jac_blending_inv_2_2_q_2*tmp_moved_constant_8))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_9 + jac_blending_inv_1_0_q_3*tmp_moved_constant_10 + jac_blending_inv_2_0_q_3*tmp_moved_constant_11)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_9 + jac_blending_inv_1_0_q_3*tmp_moved_constant_10 + jac_blending_inv_2_0_q_3*tmp_moved_constant_11)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_9 + jac_blending_inv_1_1_q_3*tmp_moved_constant_10 + jac_blending_inv_2_1_q_3*tmp_moved_constant_11)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_9 + jac_blending_inv_1_1_q_3*tmp_moved_constant_10 + jac_blending_inv_2_1_q_3*tmp_moved_constant_11)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_9 + jac_blending_inv_1_2_q_3*tmp_moved_constant_10 + jac_blending_inv_2_2_q_3*tmp_moved_constant_11)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_9 + jac_blending_inv_1_2_q_3*tmp_moved_constant_10 + jac_blending_inv_2_2_q_3*tmp_moved_constant_11))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_12 + jac_blending_inv_1_0_q_4*tmp_moved_constant_13 + jac_blending_inv_2_0_q_4*tmp_moved_constant_14)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_12 + jac_blending_inv_1_0_q_4*tmp_moved_constant_13 + jac_blending_inv_2_0_q_4*tmp_moved_constant_14)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_12 + jac_blending_inv_1_1_q_4*tmp_moved_constant_13 + jac_blending_inv_2_1_q_4*tmp_moved_constant_14)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_12 + jac_blending_inv_1_1_q_4*tmp_moved_constant_13 + jac_blending_inv_2_1_q_4*tmp_moved_constant_14)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_12 + jac_blending_inv_1_2_q_4*tmp_moved_constant_13 + jac_blending_inv_2_2_q_4*tmp_moved_constant_14)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_12 + jac_blending_inv_1_2_q_4*tmp_moved_constant_13 + jac_blending_inv_2_2_q_4*tmp_moved_constant_14))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_0 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1 + jac_blending_inv_2_0_q_0*tmp_moved_constant_2)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_0 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1 + jac_blending_inv_2_0_q_0*tmp_moved_constant_2)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_0 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1 + jac_blending_inv_2_1_q_0*tmp_moved_constant_2)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_0 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1 + jac_blending_inv_2_1_q_0*tmp_moved_constant_2)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_0 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1 + jac_blending_inv_2_2_q_0*tmp_moved_constant_2)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_0 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1 + jac_blending_inv_2_2_q_0*tmp_moved_constant_2)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_18 + jac_blending_inv_1_0_q_1*tmp_moved_constant_19 + jac_blending_inv_2_0_q_1*tmp_moved_constant_20)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_18 + jac_blending_inv_1_0_q_1*tmp_moved_constant_19 + jac_blending_inv_2_0_q_1*tmp_moved_constant_20)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_18 + jac_blending_inv_1_1_q_1*tmp_moved_constant_19 + jac_blending_inv_2_1_q_1*tmp_moved_constant_20)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_18 + jac_blending_inv_1_1_q_1*tmp_moved_constant_19 + jac_blending_inv_2_1_q_1*tmp_moved_constant_20)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_18 + jac_blending_inv_1_2_q_1*tmp_moved_constant_19 + jac_blending_inv_2_2_q_1*tmp_moved_constant_20)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_18 + jac_blending_inv_1_2_q_1*tmp_moved_constant_19 + jac_blending_inv_2_2_q_1*tmp_moved_constant_20))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_21 + jac_blending_inv_1_0_q_2*tmp_moved_constant_22 + jac_blending_inv_2_0_q_2*tmp_moved_constant_23)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_21 + jac_blending_inv_1_0_q_2*tmp_moved_constant_22 + jac_blending_inv_2_0_q_2*tmp_moved_constant_23)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_21 + jac_blending_inv_1_1_q_2*tmp_moved_constant_22 + jac_blending_inv_2_1_q_2*tmp_moved_constant_23)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_21 + jac_blending_inv_1_1_q_2*tmp_moved_constant_22 + jac_blending_inv_2_1_q_2*tmp_moved_constant_23)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_21 + jac_blending_inv_1_2_q_2*tmp_moved_constant_22 + jac_blending_inv_2_2_q_2*tmp_moved_constant_23)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_21 + jac_blending_inv_1_2_q_2*tmp_moved_constant_22 + jac_blending_inv_2_2_q_2*tmp_moved_constant_23))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_24 + jac_blending_inv_1_0_q_3*tmp_moved_constant_25 + jac_blending_inv_2_0_q_3*tmp_moved_constant_26)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_24 + jac_blending_inv_1_0_q_3*tmp_moved_constant_25 + jac_blending_inv_2_0_q_3*tmp_moved_constant_26)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_24 + jac_blending_inv_1_1_q_3*tmp_moved_constant_25 + jac_blending_inv_2_1_q_3*tmp_moved_constant_26)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_24 + jac_blending_inv_1_1_q_3*tmp_moved_constant_25 + jac_blending_inv_2_1_q_3*tmp_moved_constant_26)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_24 + jac_blending_inv_1_2_q_3*tmp_moved_constant_25 + jac_blending_inv_2_2_q_3*tmp_moved_constant_26)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_24 + jac_blending_inv_1_2_q_3*tmp_moved_constant_25 + jac_blending_inv_2_2_q_3*tmp_moved_constant_26))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_27 + jac_blending_inv_1_0_q_4*tmp_moved_constant_28 + jac_blending_inv_2_0_q_4*tmp_moved_constant_29)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_27 + jac_blending_inv_1_0_q_4*tmp_moved_constant_28 + jac_blending_inv_2_0_q_4*tmp_moved_constant_29)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_27 + jac_blending_inv_1_1_q_4*tmp_moved_constant_28 + jac_blending_inv_2_1_q_4*tmp_moved_constant_29)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_27 + jac_blending_inv_1_1_q_4*tmp_moved_constant_28 + jac_blending_inv_2_1_q_4*tmp_moved_constant_29)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_27 + jac_blending_inv_1_2_q_4*tmp_moved_constant_28 + jac_blending_inv_2_2_q_4*tmp_moved_constant_29)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_27 + jac_blending_inv_1_2_q_4*tmp_moved_constant_28 + jac_blending_inv_2_2_q_4*tmp_moved_constant_29))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_15 + jac_blending_inv_1_0_q_0*tmp_moved_constant_16 + jac_blending_inv_2_0_q_0*tmp_moved_constant_17)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_15 + jac_blending_inv_1_0_q_0*tmp_moved_constant_16 + jac_blending_inv_2_0_q_0*tmp_moved_constant_17)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_15 + jac_blending_inv_1_1_q_0*tmp_moved_constant_16 + jac_blending_inv_2_1_q_0*tmp_moved_constant_17)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_15 + jac_blending_inv_1_1_q_0*tmp_moved_constant_16 + jac_blending_inv_2_1_q_0*tmp_moved_constant_17)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_15 + jac_blending_inv_1_2_q_0*tmp_moved_constant_16 + jac_blending_inv_2_2_q_0*tmp_moved_constant_17)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_15 + jac_blending_inv_1_2_q_0*tmp_moved_constant_16 + jac_blending_inv_2_2_q_0*tmp_moved_constant_17)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_33 + jac_blending_inv_1_0_q_1*tmp_moved_constant_34 + jac_blending_inv_2_0_q_1*tmp_moved_constant_35)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_33 + jac_blending_inv_1_0_q_1*tmp_moved_constant_34 + jac_blending_inv_2_0_q_1*tmp_moved_constant_35)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_33 + jac_blending_inv_1_1_q_1*tmp_moved_constant_34 + jac_blending_inv_2_1_q_1*tmp_moved_constant_35)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_33 + jac_blending_inv_1_1_q_1*tmp_moved_constant_34 + jac_blending_inv_2_1_q_1*tmp_moved_constant_35)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_33 + jac_blending_inv_1_2_q_1*tmp_moved_constant_34 + jac_blending_inv_2_2_q_1*tmp_moved_constant_35)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_33 + jac_blending_inv_1_2_q_1*tmp_moved_constant_34 + jac_blending_inv_2_2_q_1*tmp_moved_constant_35))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_36 + jac_blending_inv_1_0_q_2*tmp_moved_constant_37 + jac_blending_inv_2_0_q_2*tmp_moved_constant_38)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_36 + jac_blending_inv_1_0_q_2*tmp_moved_constant_37 + jac_blending_inv_2_0_q_2*tmp_moved_constant_38)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_36 + jac_blending_inv_1_1_q_2*tmp_moved_constant_37 + jac_blending_inv_2_1_q_2*tmp_moved_constant_38)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_36 + jac_blending_inv_1_1_q_2*tmp_moved_constant_37 + jac_blending_inv_2_1_q_2*tmp_moved_constant_38)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_36 + jac_blending_inv_1_2_q_2*tmp_moved_constant_37 + jac_blending_inv_2_2_q_2*tmp_moved_constant_38)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_36 + jac_blending_inv_1_2_q_2*tmp_moved_constant_37 + jac_blending_inv_2_2_q_2*tmp_moved_constant_38))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_39 + jac_blending_inv_1_0_q_3*tmp_moved_constant_40 + jac_blending_inv_2_0_q_3*tmp_moved_constant_41)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_39 + jac_blending_inv_1_0_q_3*tmp_moved_constant_40 + jac_blending_inv_2_0_q_3*tmp_moved_constant_41)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_39 + jac_blending_inv_1_1_q_3*tmp_moved_constant_40 + jac_blending_inv_2_1_q_3*tmp_moved_constant_41)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_39 + jac_blending_inv_1_1_q_3*tmp_moved_constant_40 + jac_blending_inv_2_1_q_3*tmp_moved_constant_41)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_39 + jac_blending_inv_1_2_q_3*tmp_moved_constant_40 + jac_blending_inv_2_2_q_3*tmp_moved_constant_41)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_39 + jac_blending_inv_1_2_q_3*tmp_moved_constant_40 + jac_blending_inv_2_2_q_3*tmp_moved_constant_41))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_42 + jac_blending_inv_1_0_q_4*tmp_moved_constant_43 + jac_blending_inv_2_0_q_4*tmp_moved_constant_44)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_42 + jac_blending_inv_1_0_q_4*tmp_moved_constant_43 + jac_blending_inv_2_0_q_4*tmp_moved_constant_44)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_42 + jac_blending_inv_1_1_q_4*tmp_moved_constant_43 + jac_blending_inv_2_1_q_4*tmp_moved_constant_44)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_42 + jac_blending_inv_1_1_q_4*tmp_moved_constant_43 + jac_blending_inv_2_1_q_4*tmp_moved_constant_44)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_42 + jac_blending_inv_1_2_q_4*tmp_moved_constant_43 + jac_blending_inv_2_2_q_4*tmp_moved_constant_44)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_42 + jac_blending_inv_1_2_q_4*tmp_moved_constant_43 + jac_blending_inv_2_2_q_4*tmp_moved_constant_44))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_30 + jac_blending_inv_1_0_q_0*tmp_moved_constant_31 + jac_blending_inv_2_0_q_0*tmp_moved_constant_32)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_30 + jac_blending_inv_1_0_q_0*tmp_moved_constant_31 + jac_blending_inv_2_0_q_0*tmp_moved_constant_32)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_30 + jac_blending_inv_1_1_q_0*tmp_moved_constant_31 + jac_blending_inv_2_1_q_0*tmp_moved_constant_32)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_30 + jac_blending_inv_1_1_q_0*tmp_moved_constant_31 + jac_blending_inv_2_1_q_0*tmp_moved_constant_32)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_30 + jac_blending_inv_1_2_q_0*tmp_moved_constant_31 + jac_blending_inv_2_2_q_0*tmp_moved_constant_32)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_30 + jac_blending_inv_1_2_q_0*tmp_moved_constant_31 + jac_blending_inv_2_2_q_0*tmp_moved_constant_32)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_48 + jac_blending_inv_1_0_q_1*tmp_moved_constant_49 + jac_blending_inv_2_0_q_1*tmp_moved_constant_50)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_48 + jac_blending_inv_1_0_q_1*tmp_moved_constant_49 + jac_blending_inv_2_0_q_1*tmp_moved_constant_50)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_48 + jac_blending_inv_1_1_q_1*tmp_moved_constant_49 + jac_blending_inv_2_1_q_1*tmp_moved_constant_50)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_48 + jac_blending_inv_1_1_q_1*tmp_moved_constant_49 + jac_blending_inv_2_1_q_1*tmp_moved_constant_50)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_48 + jac_blending_inv_1_2_q_1*tmp_moved_constant_49 + jac_blending_inv_2_2_q_1*tmp_moved_constant_50)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_48 + jac_blending_inv_1_2_q_1*tmp_moved_constant_49 + jac_blending_inv_2_2_q_1*tmp_moved_constant_50))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_51 + jac_blending_inv_1_0_q_2*tmp_moved_constant_52 + jac_blending_inv_2_0_q_2*tmp_moved_constant_53)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_51 + jac_blending_inv_1_0_q_2*tmp_moved_constant_52 + jac_blending_inv_2_0_q_2*tmp_moved_constant_53)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_51 + jac_blending_inv_1_1_q_2*tmp_moved_constant_52 + jac_blending_inv_2_1_q_2*tmp_moved_constant_53)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_51 + jac_blending_inv_1_1_q_2*tmp_moved_constant_52 + jac_blending_inv_2_1_q_2*tmp_moved_constant_53)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_51 + jac_blending_inv_1_2_q_2*tmp_moved_constant_52 + jac_blending_inv_2_2_q_2*tmp_moved_constant_53)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_51 + jac_blending_inv_1_2_q_2*tmp_moved_constant_52 + jac_blending_inv_2_2_q_2*tmp_moved_constant_53))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_54 + jac_blending_inv_1_0_q_3*tmp_moved_constant_55 + jac_blending_inv_2_0_q_3*tmp_moved_constant_56)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_54 + jac_blending_inv_1_0_q_3*tmp_moved_constant_55 + jac_blending_inv_2_0_q_3*tmp_moved_constant_56)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_54 + jac_blending_inv_1_1_q_3*tmp_moved_constant_55 + jac_blending_inv_2_1_q_3*tmp_moved_constant_56)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_54 + jac_blending_inv_1_1_q_3*tmp_moved_constant_55 + jac_blending_inv_2_1_q_3*tmp_moved_constant_56)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_54 + jac_blending_inv_1_2_q_3*tmp_moved_constant_55 + jac_blending_inv_2_2_q_3*tmp_moved_constant_56)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_54 + jac_blending_inv_1_2_q_3*tmp_moved_constant_55 + jac_blending_inv_2_2_q_3*tmp_moved_constant_56))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_57 + jac_blending_inv_1_0_q_4*tmp_moved_constant_58 + jac_blending_inv_2_0_q_4*tmp_moved_constant_59)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_57 + jac_blending_inv_1_0_q_4*tmp_moved_constant_58 + jac_blending_inv_2_0_q_4*tmp_moved_constant_59)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_57 + jac_blending_inv_1_1_q_4*tmp_moved_constant_58 + jac_blending_inv_2_1_q_4*tmp_moved_constant_59)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_57 + jac_blending_inv_1_1_q_4*tmp_moved_constant_58 + jac_blending_inv_2_1_q_4*tmp_moved_constant_59)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_57 + jac_blending_inv_1_2_q_4*tmp_moved_constant_58 + jac_blending_inv_2_2_q_4*tmp_moved_constant_59)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_57 + jac_blending_inv_1_2_q_4*tmp_moved_constant_58 + jac_blending_inv_2_2_q_4*tmp_moved_constant_59))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_45 + jac_blending_inv_1_0_q_0*tmp_moved_constant_46 + jac_blending_inv_2_0_q_0*tmp_moved_constant_47)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_45 + jac_blending_inv_1_0_q_0*tmp_moved_constant_46 + jac_blending_inv_2_0_q_0*tmp_moved_constant_47)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_45 + jac_blending_inv_1_1_q_0*tmp_moved_constant_46 + jac_blending_inv_2_1_q_0*tmp_moved_constant_47)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_45 + jac_blending_inv_1_1_q_0*tmp_moved_constant_46 + jac_blending_inv_2_1_q_0*tmp_moved_constant_47)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_45 + jac_blending_inv_1_2_q_0*tmp_moved_constant_46 + jac_blending_inv_2_2_q_0*tmp_moved_constant_47)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_45 + jac_blending_inv_1_2_q_0*tmp_moved_constant_46 + jac_blending_inv_2_2_q_0*tmp_moved_constant_47)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_71 + jac_blending_inv_1_0_q_1*tmp_moved_constant_74 + jac_blending_inv_2_0_q_1*tmp_moved_constant_77)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_71 + jac_blending_inv_1_0_q_1*tmp_moved_constant_74 + jac_blending_inv_2_0_q_1*tmp_moved_constant_77)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_71 + jac_blending_inv_1_1_q_1*tmp_moved_constant_74 + jac_blending_inv_2_1_q_1*tmp_moved_constant_77)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_71 + jac_blending_inv_1_1_q_1*tmp_moved_constant_74 + jac_blending_inv_2_1_q_1*tmp_moved_constant_77)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_71 + jac_blending_inv_1_2_q_1*tmp_moved_constant_74 + jac_blending_inv_2_2_q_1*tmp_moved_constant_77)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_71 + jac_blending_inv_1_2_q_1*tmp_moved_constant_74 + jac_blending_inv_2_2_q_1*tmp_moved_constant_77))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_80 + jac_blending_inv_1_0_q_2*tmp_moved_constant_83 + jac_blending_inv_2_0_q_2*tmp_moved_constant_86)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_80 + jac_blending_inv_1_0_q_2*tmp_moved_constant_83 + jac_blending_inv_2_0_q_2*tmp_moved_constant_86)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_80 + jac_blending_inv_1_1_q_2*tmp_moved_constant_83 + jac_blending_inv_2_1_q_2*tmp_moved_constant_86)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_80 + jac_blending_inv_1_1_q_2*tmp_moved_constant_83 + jac_blending_inv_2_1_q_2*tmp_moved_constant_86)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_80 + jac_blending_inv_1_2_q_2*tmp_moved_constant_83 + jac_blending_inv_2_2_q_2*tmp_moved_constant_86)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_80 + jac_blending_inv_1_2_q_2*tmp_moved_constant_83 + jac_blending_inv_2_2_q_2*tmp_moved_constant_86))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_89 + jac_blending_inv_1_0_q_3*tmp_moved_constant_92 + jac_blending_inv_2_0_q_3*tmp_moved_constant_95)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_89 + jac_blending_inv_1_0_q_3*tmp_moved_constant_92 + jac_blending_inv_2_0_q_3*tmp_moved_constant_95)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_89 + jac_blending_inv_1_1_q_3*tmp_moved_constant_92 + jac_blending_inv_2_1_q_3*tmp_moved_constant_95)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_89 + jac_blending_inv_1_1_q_3*tmp_moved_constant_92 + jac_blending_inv_2_1_q_3*tmp_moved_constant_95)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_89 + jac_blending_inv_1_2_q_3*tmp_moved_constant_92 + jac_blending_inv_2_2_q_3*tmp_moved_constant_95)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_89 + jac_blending_inv_1_2_q_3*tmp_moved_constant_92 + jac_blending_inv_2_2_q_3*tmp_moved_constant_95))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_98 + jac_blending_inv_1_0_q_4*tmp_moved_constant_101 + jac_blending_inv_2_0_q_4*tmp_moved_constant_104)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_98 + jac_blending_inv_1_0_q_4*tmp_moved_constant_101 + jac_blending_inv_2_0_q_4*tmp_moved_constant_104)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_98 + jac_blending_inv_1_1_q_4*tmp_moved_constant_101 + jac_blending_inv_2_1_q_4*tmp_moved_constant_104)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_98 + jac_blending_inv_1_1_q_4*tmp_moved_constant_101 + jac_blending_inv_2_1_q_4*tmp_moved_constant_104)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_98 + jac_blending_inv_1_2_q_4*tmp_moved_constant_101 + jac_blending_inv_2_2_q_4*tmp_moved_constant_104)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_98 + jac_blending_inv_1_2_q_4*tmp_moved_constant_101 + jac_blending_inv_2_2_q_4*tmp_moved_constant_104))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_62 + jac_blending_inv_1_0_q_0*tmp_moved_constant_65 + jac_blending_inv_2_0_q_0*tmp_moved_constant_68)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_62 + jac_blending_inv_1_0_q_0*tmp_moved_constant_65 + jac_blending_inv_2_0_q_0*tmp_moved_constant_68)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_62 + jac_blending_inv_1_1_q_0*tmp_moved_constant_65 + jac_blending_inv_2_1_q_0*tmp_moved_constant_68)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_62 + jac_blending_inv_1_1_q_0*tmp_moved_constant_65 + jac_blending_inv_2_1_q_0*tmp_moved_constant_68)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_62 + jac_blending_inv_1_2_q_0*tmp_moved_constant_65 + jac_blending_inv_2_2_q_0*tmp_moved_constant_68)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_62 + jac_blending_inv_1_2_q_0*tmp_moved_constant_65 + jac_blending_inv_2_2_q_0*tmp_moved_constant_68)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_116 + jac_blending_inv_1_0_q_1*tmp_moved_constant_119 + jac_blending_inv_2_0_q_1*tmp_moved_constant_122)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_116 + jac_blending_inv_1_0_q_1*tmp_moved_constant_119 + jac_blending_inv_2_0_q_1*tmp_moved_constant_122)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_116 + jac_blending_inv_1_1_q_1*tmp_moved_constant_119 + jac_blending_inv_2_1_q_1*tmp_moved_constant_122)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_116 + jac_blending_inv_1_1_q_1*tmp_moved_constant_119 + jac_blending_inv_2_1_q_1*tmp_moved_constant_122)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_116 + jac_blending_inv_1_2_q_1*tmp_moved_constant_119 + jac_blending_inv_2_2_q_1*tmp_moved_constant_122)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_116 + jac_blending_inv_1_2_q_1*tmp_moved_constant_119 + jac_blending_inv_2_2_q_1*tmp_moved_constant_122))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_125 + jac_blending_inv_1_0_q_2*tmp_moved_constant_128 + jac_blending_inv_2_0_q_2*tmp_moved_constant_131)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_125 + jac_blending_inv_1_0_q_2*tmp_moved_constant_128 + jac_blending_inv_2_0_q_2*tmp_moved_constant_131)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_125 + jac_blending_inv_1_1_q_2*tmp_moved_constant_128 + jac_blending_inv_2_1_q_2*tmp_moved_constant_131)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_125 + jac_blending_inv_1_1_q_2*tmp_moved_constant_128 + jac_blending_inv_2_1_q_2*tmp_moved_constant_131)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_125 + jac_blending_inv_1_2_q_2*tmp_moved_constant_128 + jac_blending_inv_2_2_q_2*tmp_moved_constant_131)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_125 + jac_blending_inv_1_2_q_2*tmp_moved_constant_128 + jac_blending_inv_2_2_q_2*tmp_moved_constant_131))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_134 + jac_blending_inv_1_0_q_3*tmp_moved_constant_137 + jac_blending_inv_2_0_q_3*tmp_moved_constant_140)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_134 + jac_blending_inv_1_0_q_3*tmp_moved_constant_137 + jac_blending_inv_2_0_q_3*tmp_moved_constant_140)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_134 + jac_blending_inv_1_1_q_3*tmp_moved_constant_137 + jac_blending_inv_2_1_q_3*tmp_moved_constant_140)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_134 + jac_blending_inv_1_1_q_3*tmp_moved_constant_137 + jac_blending_inv_2_1_q_3*tmp_moved_constant_140)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_134 + jac_blending_inv_1_2_q_3*tmp_moved_constant_137 + jac_blending_inv_2_2_q_3*tmp_moved_constant_140)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_134 + jac_blending_inv_1_2_q_3*tmp_moved_constant_137 + jac_blending_inv_2_2_q_3*tmp_moved_constant_140))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_143 + jac_blending_inv_1_0_q_4*tmp_moved_constant_146 + jac_blending_inv_2_0_q_4*tmp_moved_constant_149)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_143 + jac_blending_inv_1_0_q_4*tmp_moved_constant_146 + jac_blending_inv_2_0_q_4*tmp_moved_constant_149)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_143 + jac_blending_inv_1_1_q_4*tmp_moved_constant_146 + jac_blending_inv_2_1_q_4*tmp_moved_constant_149)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_143 + jac_blending_inv_1_1_q_4*tmp_moved_constant_146 + jac_blending_inv_2_1_q_4*tmp_moved_constant_149)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_143 + jac_blending_inv_1_2_q_4*tmp_moved_constant_146 + jac_blending_inv_2_2_q_4*tmp_moved_constant_149)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_143 + jac_blending_inv_1_2_q_4*tmp_moved_constant_146 + jac_blending_inv_2_2_q_4*tmp_moved_constant_149))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_107 + jac_blending_inv_1_0_q_0*tmp_moved_constant_110 + jac_blending_inv_2_0_q_0*tmp_moved_constant_113)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_107 + jac_blending_inv_1_0_q_0*tmp_moved_constant_110 + jac_blending_inv_2_0_q_0*tmp_moved_constant_113)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_107 + jac_blending_inv_1_1_q_0*tmp_moved_constant_110 + jac_blending_inv_2_1_q_0*tmp_moved_constant_113)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_107 + jac_blending_inv_1_1_q_0*tmp_moved_constant_110 + jac_blending_inv_2_1_q_0*tmp_moved_constant_113)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_107 + jac_blending_inv_1_2_q_0*tmp_moved_constant_110 + jac_blending_inv_2_2_q_0*tmp_moved_constant_113)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_107 + jac_blending_inv_1_2_q_0*tmp_moved_constant_110 + jac_blending_inv_2_2_q_0*tmp_moved_constant_113)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_161 + jac_blending_inv_1_0_q_1*tmp_moved_constant_164 + jac_blending_inv_2_0_q_1*tmp_moved_constant_167)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_161 + jac_blending_inv_1_0_q_1*tmp_moved_constant_164 + jac_blending_inv_2_0_q_1*tmp_moved_constant_167)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_161 + jac_blending_inv_1_1_q_1*tmp_moved_constant_164 + jac_blending_inv_2_1_q_1*tmp_moved_constant_167)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_161 + jac_blending_inv_1_1_q_1*tmp_moved_constant_164 + jac_blending_inv_2_1_q_1*tmp_moved_constant_167)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_161 + jac_blending_inv_1_2_q_1*tmp_moved_constant_164 + jac_blending_inv_2_2_q_1*tmp_moved_constant_167)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_161 + jac_blending_inv_1_2_q_1*tmp_moved_constant_164 + jac_blending_inv_2_2_q_1*tmp_moved_constant_167))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_170 + jac_blending_inv_1_0_q_2*tmp_moved_constant_173 + jac_blending_inv_2_0_q_2*tmp_moved_constant_176)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_170 + jac_blending_inv_1_0_q_2*tmp_moved_constant_173 + jac_blending_inv_2_0_q_2*tmp_moved_constant_176)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_170 + jac_blending_inv_1_1_q_2*tmp_moved_constant_173 + jac_blending_inv_2_1_q_2*tmp_moved_constant_176)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_170 + jac_blending_inv_1_1_q_2*tmp_moved_constant_173 + jac_blending_inv_2_1_q_2*tmp_moved_constant_176)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_170 + jac_blending_inv_1_2_q_2*tmp_moved_constant_173 + jac_blending_inv_2_2_q_2*tmp_moved_constant_176)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_170 + jac_blending_inv_1_2_q_2*tmp_moved_constant_173 + jac_blending_inv_2_2_q_2*tmp_moved_constant_176))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_182 + jac_blending_inv_2_0_q_3*tmp_moved_constant_185)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_182 + jac_blending_inv_2_0_q_3*tmp_moved_constant_185)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_182 + jac_blending_inv_2_1_q_3*tmp_moved_constant_185)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_182 + jac_blending_inv_2_1_q_3*tmp_moved_constant_185)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_182 + jac_blending_inv_2_2_q_3*tmp_moved_constant_185)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_182 + jac_blending_inv_2_2_q_3*tmp_moved_constant_185))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_188 + jac_blending_inv_1_0_q_4*tmp_moved_constant_191 + jac_blending_inv_2_0_q_4*tmp_moved_constant_194)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_188 + jac_blending_inv_1_0_q_4*tmp_moved_constant_191 + jac_blending_inv_2_0_q_4*tmp_moved_constant_194)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_188 + jac_blending_inv_1_1_q_4*tmp_moved_constant_191 + jac_blending_inv_2_1_q_4*tmp_moved_constant_194)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_188 + jac_blending_inv_1_1_q_4*tmp_moved_constant_191 + jac_blending_inv_2_1_q_4*tmp_moved_constant_194)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_188 + jac_blending_inv_1_2_q_4*tmp_moved_constant_191 + jac_blending_inv_2_2_q_4*tmp_moved_constant_194)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_188 + jac_blending_inv_1_2_q_4*tmp_moved_constant_191 + jac_blending_inv_2_2_q_4*tmp_moved_constant_194))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_152 + jac_blending_inv_1_0_q_0*tmp_moved_constant_155 + jac_blending_inv_2_0_q_0*tmp_moved_constant_158)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_152 + jac_blending_inv_1_0_q_0*tmp_moved_constant_155 + jac_blending_inv_2_0_q_0*tmp_moved_constant_158)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_152 + jac_blending_inv_1_1_q_0*tmp_moved_constant_155 + jac_blending_inv_2_1_q_0*tmp_moved_constant_158)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_152 + jac_blending_inv_1_1_q_0*tmp_moved_constant_155 + jac_blending_inv_2_1_q_0*tmp_moved_constant_158)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_152 + jac_blending_inv_1_2_q_0*tmp_moved_constant_155 + jac_blending_inv_2_2_q_0*tmp_moved_constant_158)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_152 + jac_blending_inv_1_2_q_0*tmp_moved_constant_155 + jac_blending_inv_2_2_q_0*tmp_moved_constant_158)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_198 + jac_blending_inv_1_0_q_1*tmp_moved_constant_199 + jac_blending_inv_2_0_q_1*tmp_moved_constant_200)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_198 + jac_blending_inv_1_0_q_1*tmp_moved_constant_199 + jac_blending_inv_2_0_q_1*tmp_moved_constant_200)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_198 + jac_blending_inv_1_1_q_1*tmp_moved_constant_199 + jac_blending_inv_2_1_q_1*tmp_moved_constant_200)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_198 + jac_blending_inv_1_1_q_1*tmp_moved_constant_199 + jac_blending_inv_2_1_q_1*tmp_moved_constant_200)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_198 + jac_blending_inv_1_2_q_1*tmp_moved_constant_199 + jac_blending_inv_2_2_q_1*tmp_moved_constant_200)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_198 + jac_blending_inv_1_2_q_1*tmp_moved_constant_199 + jac_blending_inv_2_2_q_1*tmp_moved_constant_200))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_201 + jac_blending_inv_1_0_q_2*tmp_moved_constant_202 + jac_blending_inv_2_0_q_2*tmp_moved_constant_203)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_201 + jac_blending_inv_1_0_q_2*tmp_moved_constant_202 + jac_blending_inv_2_0_q_2*tmp_moved_constant_203)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_201 + jac_blending_inv_1_1_q_2*tmp_moved_constant_202 + jac_blending_inv_2_1_q_2*tmp_moved_constant_203)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_201 + jac_blending_inv_1_1_q_2*tmp_moved_constant_202 + jac_blending_inv_2_1_q_2*tmp_moved_constant_203)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_201 + jac_blending_inv_1_2_q_2*tmp_moved_constant_202 + jac_blending_inv_2_2_q_2*tmp_moved_constant_203)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_201 + jac_blending_inv_1_2_q_2*tmp_moved_constant_202 + jac_blending_inv_2_2_q_2*tmp_moved_constant_203))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_204 + jac_blending_inv_1_0_q_3*tmp_moved_constant_205 + jac_blending_inv_2_0_q_3*tmp_moved_constant_206)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_204 + jac_blending_inv_1_0_q_3*tmp_moved_constant_205 + jac_blending_inv_2_0_q_3*tmp_moved_constant_206)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_204 + jac_blending_inv_1_1_q_3*tmp_moved_constant_205 + jac_blending_inv_2_1_q_3*tmp_moved_constant_206)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_204 + jac_blending_inv_1_1_q_3*tmp_moved_constant_205 + jac_blending_inv_2_1_q_3*tmp_moved_constant_206)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_204 + jac_blending_inv_1_2_q_3*tmp_moved_constant_205 + jac_blending_inv_2_2_q_3*tmp_moved_constant_206)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_204 + jac_blending_inv_1_2_q_3*tmp_moved_constant_205 + jac_blending_inv_2_2_q_3*tmp_moved_constant_206))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_207 + jac_blending_inv_1_0_q_4*tmp_moved_constant_208 + jac_blending_inv_2_0_q_4*tmp_moved_constant_209)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_207 + jac_blending_inv_1_0_q_4*tmp_moved_constant_208 + jac_blending_inv_2_0_q_4*tmp_moved_constant_209)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_207 + jac_blending_inv_1_1_q_4*tmp_moved_constant_208 + jac_blending_inv_2_1_q_4*tmp_moved_constant_209)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_207 + jac_blending_inv_1_1_q_4*tmp_moved_constant_208 + jac_blending_inv_2_1_q_4*tmp_moved_constant_209)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_207 + jac_blending_inv_1_2_q_4*tmp_moved_constant_208 + jac_blending_inv_2_2_q_4*tmp_moved_constant_209)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_207 + jac_blending_inv_1_2_q_4*tmp_moved_constant_208 + jac_blending_inv_2_2_q_4*tmp_moved_constant_209))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_195 + jac_blending_inv_1_0_q_0*tmp_moved_constant_196 + jac_blending_inv_2_0_q_0*tmp_moved_constant_197)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_195 + jac_blending_inv_1_0_q_0*tmp_moved_constant_196 + jac_blending_inv_2_0_q_0*tmp_moved_constant_197)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_195 + jac_blending_inv_1_1_q_0*tmp_moved_constant_196 + jac_blending_inv_2_1_q_0*tmp_moved_constant_197)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_195 + jac_blending_inv_1_1_q_0*tmp_moved_constant_196 + jac_blending_inv_2_1_q_0*tmp_moved_constant_197)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_195 + jac_blending_inv_1_2_q_0*tmp_moved_constant_196 + jac_blending_inv_2_2_q_0*tmp_moved_constant_197)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_195 + jac_blending_inv_1_2_q_0*tmp_moved_constant_196 + jac_blending_inv_2_2_q_0*tmp_moved_constant_197)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_213 + jac_blending_inv_1_0_q_1*tmp_moved_constant_214 + jac_blending_inv_2_0_q_1*tmp_moved_constant_215)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_213 + jac_blending_inv_1_0_q_1*tmp_moved_constant_214 + jac_blending_inv_2_0_q_1*tmp_moved_constant_215)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_213 + jac_blending_inv_1_1_q_1*tmp_moved_constant_214 + jac_blending_inv_2_1_q_1*tmp_moved_constant_215)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_213 + jac_blending_inv_1_1_q_1*tmp_moved_constant_214 + jac_blending_inv_2_1_q_1*tmp_moved_constant_215)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_213 + jac_blending_inv_1_2_q_1*tmp_moved_constant_214 + jac_blending_inv_2_2_q_1*tmp_moved_constant_215)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_213 + jac_blending_inv_1_2_q_1*tmp_moved_constant_214 + jac_blending_inv_2_2_q_1*tmp_moved_constant_215))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_216 + jac_blending_inv_1_0_q_2*tmp_moved_constant_217 + jac_blending_inv_2_0_q_2*tmp_moved_constant_218)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_216 + jac_blending_inv_1_0_q_2*tmp_moved_constant_217 + jac_blending_inv_2_0_q_2*tmp_moved_constant_218)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_216 + jac_blending_inv_1_1_q_2*tmp_moved_constant_217 + jac_blending_inv_2_1_q_2*tmp_moved_constant_218)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_216 + jac_blending_inv_1_1_q_2*tmp_moved_constant_217 + jac_blending_inv_2_1_q_2*tmp_moved_constant_218)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_216 + jac_blending_inv_1_2_q_2*tmp_moved_constant_217 + jac_blending_inv_2_2_q_2*tmp_moved_constant_218)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_216 + jac_blending_inv_1_2_q_2*tmp_moved_constant_217 + jac_blending_inv_2_2_q_2*tmp_moved_constant_218))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_219 + jac_blending_inv_1_0_q_3*tmp_moved_constant_220 + jac_blending_inv_2_0_q_3*tmp_moved_constant_221)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_219 + jac_blending_inv_1_0_q_3*tmp_moved_constant_220 + jac_blending_inv_2_0_q_3*tmp_moved_constant_221)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_219 + jac_blending_inv_1_1_q_3*tmp_moved_constant_220 + jac_blending_inv_2_1_q_3*tmp_moved_constant_221)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_219 + jac_blending_inv_1_1_q_3*tmp_moved_constant_220 + jac_blending_inv_2_1_q_3*tmp_moved_constant_221)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_219 + jac_blending_inv_1_2_q_3*tmp_moved_constant_220 + jac_blending_inv_2_2_q_3*tmp_moved_constant_221)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_219 + jac_blending_inv_1_2_q_3*tmp_moved_constant_220 + jac_blending_inv_2_2_q_3*tmp_moved_constant_221))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_222 + jac_blending_inv_1_0_q_4*tmp_moved_constant_223 + jac_blending_inv_2_0_q_4*tmp_moved_constant_224)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_222 + jac_blending_inv_1_0_q_4*tmp_moved_constant_223 + jac_blending_inv_2_0_q_4*tmp_moved_constant_224)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_222 + jac_blending_inv_1_1_q_4*tmp_moved_constant_223 + jac_blending_inv_2_1_q_4*tmp_moved_constant_224)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_222 + jac_blending_inv_1_1_q_4*tmp_moved_constant_223 + jac_blending_inv_2_1_q_4*tmp_moved_constant_224)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_222 + jac_blending_inv_1_2_q_4*tmp_moved_constant_223 + jac_blending_inv_2_2_q_4*tmp_moved_constant_224)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_222 + jac_blending_inv_1_2_q_4*tmp_moved_constant_223 + jac_blending_inv_2_2_q_4*tmp_moved_constant_224))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_210 + jac_blending_inv_1_0_q_0*tmp_moved_constant_211 + jac_blending_inv_2_0_q_0*tmp_moved_constant_212)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_210 + jac_blending_inv_1_0_q_0*tmp_moved_constant_211 + jac_blending_inv_2_0_q_0*tmp_moved_constant_212)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_210 + jac_blending_inv_1_1_q_0*tmp_moved_constant_211 + jac_blending_inv_2_1_q_0*tmp_moved_constant_212)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_210 + jac_blending_inv_1_1_q_0*tmp_moved_constant_211 + jac_blending_inv_2_1_q_0*tmp_moved_constant_212)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_210 + jac_blending_inv_1_2_q_0*tmp_moved_constant_211 + jac_blending_inv_2_2_q_0*tmp_moved_constant_212)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_210 + jac_blending_inv_1_2_q_0*tmp_moved_constant_211 + jac_blending_inv_2_2_q_0*tmp_moved_constant_212)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_228 + jac_blending_inv_1_0_q_1*tmp_moved_constant_229 + jac_blending_inv_2_0_q_1*tmp_moved_constant_230)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_228 + jac_blending_inv_1_0_q_1*tmp_moved_constant_229 + jac_blending_inv_2_0_q_1*tmp_moved_constant_230)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_228 + jac_blending_inv_1_1_q_1*tmp_moved_constant_229 + jac_blending_inv_2_1_q_1*tmp_moved_constant_230)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_228 + jac_blending_inv_1_1_q_1*tmp_moved_constant_229 + jac_blending_inv_2_1_q_1*tmp_moved_constant_230)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_228 + jac_blending_inv_1_2_q_1*tmp_moved_constant_229 + jac_blending_inv_2_2_q_1*tmp_moved_constant_230)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_228 + jac_blending_inv_1_2_q_1*tmp_moved_constant_229 + jac_blending_inv_2_2_q_1*tmp_moved_constant_230))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_231 + jac_blending_inv_1_0_q_2*tmp_moved_constant_232 + jac_blending_inv_2_0_q_2*tmp_moved_constant_233)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_231 + jac_blending_inv_1_0_q_2*tmp_moved_constant_232 + jac_blending_inv_2_0_q_2*tmp_moved_constant_233)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_231 + jac_blending_inv_1_1_q_2*tmp_moved_constant_232 + jac_blending_inv_2_1_q_2*tmp_moved_constant_233)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_231 + jac_blending_inv_1_1_q_2*tmp_moved_constant_232 + jac_blending_inv_2_1_q_2*tmp_moved_constant_233)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_231 + jac_blending_inv_1_2_q_2*tmp_moved_constant_232 + jac_blending_inv_2_2_q_2*tmp_moved_constant_233)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_231 + jac_blending_inv_1_2_q_2*tmp_moved_constant_232 + jac_blending_inv_2_2_q_2*tmp_moved_constant_233))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_234 + jac_blending_inv_1_0_q_3*tmp_moved_constant_235 + jac_blending_inv_2_0_q_3*tmp_moved_constant_236)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_234 + jac_blending_inv_1_0_q_3*tmp_moved_constant_235 + jac_blending_inv_2_0_q_3*tmp_moved_constant_236)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_234 + jac_blending_inv_1_1_q_3*tmp_moved_constant_235 + jac_blending_inv_2_1_q_3*tmp_moved_constant_236)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_234 + jac_blending_inv_1_1_q_3*tmp_moved_constant_235 + jac_blending_inv_2_1_q_3*tmp_moved_constant_236)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_234 + jac_blending_inv_1_2_q_3*tmp_moved_constant_235 + jac_blending_inv_2_2_q_3*tmp_moved_constant_236)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_234 + jac_blending_inv_1_2_q_3*tmp_moved_constant_235 + jac_blending_inv_2_2_q_3*tmp_moved_constant_236))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_237 + jac_blending_inv_1_0_q_4*tmp_moved_constant_238 + jac_blending_inv_2_0_q_4*tmp_moved_constant_239)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_237 + jac_blending_inv_1_0_q_4*tmp_moved_constant_238 + jac_blending_inv_2_0_q_4*tmp_moved_constant_239)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_237 + jac_blending_inv_1_1_q_4*tmp_moved_constant_238 + jac_blending_inv_2_1_q_4*tmp_moved_constant_239)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_237 + jac_blending_inv_1_1_q_4*tmp_moved_constant_238 + jac_blending_inv_2_1_q_4*tmp_moved_constant_239)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_237 + jac_blending_inv_1_2_q_4*tmp_moved_constant_238 + jac_blending_inv_2_2_q_4*tmp_moved_constant_239)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_237 + jac_blending_inv_1_2_q_4*tmp_moved_constant_238 + jac_blending_inv_2_2_q_4*tmp_moved_constant_239))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_225 + jac_blending_inv_1_0_q_0*tmp_moved_constant_226 + jac_blending_inv_2_0_q_0*tmp_moved_constant_227)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_225 + jac_blending_inv_1_0_q_0*tmp_moved_constant_226 + jac_blending_inv_2_0_q_0*tmp_moved_constant_227)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_225 + jac_blending_inv_1_1_q_0*tmp_moved_constant_226 + jac_blending_inv_2_1_q_0*tmp_moved_constant_227)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_225 + jac_blending_inv_1_1_q_0*tmp_moved_constant_226 + jac_blending_inv_2_1_q_0*tmp_moved_constant_227)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_225 + jac_blending_inv_1_2_q_0*tmp_moved_constant_226 + jac_blending_inv_2_2_q_0*tmp_moved_constant_227)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_225 + jac_blending_inv_1_2_q_0*tmp_moved_constant_226 + jac_blending_inv_2_2_q_0*tmp_moved_constant_227)));
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const real_t tmp_moved_constant_240 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_241 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_242 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_243 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_244 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_245 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_13 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_246 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_247 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_248 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_22 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_249 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_250 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_251 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_31 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_252 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_253 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_254 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_40 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_255 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_256 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_257 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_258 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_259 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_260 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_261 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_262 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_263 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_264 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_265 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_266 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_267 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_268 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_269 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_270 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_271 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_272 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_273 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_274 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_275 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_276 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_277 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_278 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_279 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_280 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_281 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_282 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_283 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_284 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_285 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_286 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_287 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_288 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_289 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_290 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_291 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_292 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_293 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_294 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_295 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_296 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_297 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_298 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_299 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_300 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_301 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_302 = tmp_moved_constant_300 + tmp_moved_constant_301;
       const real_t tmp_moved_constant_303 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_304 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_305 = tmp_moved_constant_303 + tmp_moved_constant_304;
       const real_t tmp_moved_constant_306 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_307 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_308 = tmp_moved_constant_306 + tmp_moved_constant_307;
       const real_t tmp_moved_constant_309 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_310 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_311 = tmp_moved_constant_309 + tmp_moved_constant_310;
       const real_t tmp_moved_constant_312 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_313 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_314 = tmp_moved_constant_312 + tmp_moved_constant_313;
       const real_t tmp_moved_constant_315 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_316 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_317 = tmp_moved_constant_315 + tmp_moved_constant_316;
       const real_t tmp_moved_constant_318 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_319 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_320 = tmp_moved_constant_318 + tmp_moved_constant_319;
       const real_t tmp_moved_constant_321 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_322 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_323 = tmp_moved_constant_321 + tmp_moved_constant_322;
       const real_t tmp_moved_constant_324 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_325 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_326 = tmp_moved_constant_324 + tmp_moved_constant_325;
       const real_t tmp_moved_constant_327 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_328 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_329 = tmp_moved_constant_327 + tmp_moved_constant_328;
       const real_t tmp_moved_constant_330 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_331 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_332 = tmp_moved_constant_330 + tmp_moved_constant_331;
       const real_t tmp_moved_constant_333 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_334 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_335 = tmp_moved_constant_333 + tmp_moved_constant_334;
       const real_t tmp_moved_constant_336 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_337 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_338 = tmp_moved_constant_336 + tmp_moved_constant_337;
       const real_t tmp_moved_constant_339 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_340 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_341 = tmp_moved_constant_339 + tmp_moved_constant_340;
       const real_t tmp_moved_constant_342 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_343 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_344 = tmp_moved_constant_342 + tmp_moved_constant_343;
       const real_t tmp_moved_constant_345 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_346 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_347 = tmp_moved_constant_345 + tmp_moved_constant_346;
       const real_t tmp_moved_constant_348 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_349 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_350 = tmp_moved_constant_348 + tmp_moved_constant_349;
       const real_t tmp_moved_constant_351 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_352 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_353 = tmp_moved_constant_351 + tmp_moved_constant_352;
       const real_t tmp_moved_constant_354 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_355 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_356 = tmp_moved_constant_354 + tmp_moved_constant_355;
       const real_t tmp_moved_constant_357 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_358 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_359 = tmp_moved_constant_357 + tmp_moved_constant_358;
       const real_t tmp_moved_constant_360 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_361 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_362 = tmp_moved_constant_360 + tmp_moved_constant_361;
       const real_t tmp_moved_constant_363 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_364 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_365 = tmp_moved_constant_363 + tmp_moved_constant_364;
       const real_t tmp_moved_constant_366 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_367 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_368 = tmp_moved_constant_366 + tmp_moved_constant_367;
       const real_t tmp_moved_constant_369 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_370 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_371 = tmp_moved_constant_369 + tmp_moved_constant_370;
       const real_t tmp_moved_constant_372 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_373 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_374 = tmp_moved_constant_372 + tmp_moved_constant_373;
       const real_t tmp_moved_constant_375 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_376 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_377 = tmp_moved_constant_375 + tmp_moved_constant_376;
       const real_t tmp_moved_constant_378 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_379 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_380 = tmp_moved_constant_378 + tmp_moved_constant_379;
       const real_t tmp_moved_constant_381 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_382 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_383 = tmp_moved_constant_381 + tmp_moved_constant_382;
       const real_t tmp_moved_constant_384 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_385 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_386 = tmp_moved_constant_384 + tmp_moved_constant_385;
       const real_t tmp_moved_constant_387 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_388 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_389 = tmp_moved_constant_387 + tmp_moved_constant_388;
       const real_t tmp_moved_constant_390 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_391 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_392 = tmp_moved_constant_390 + tmp_moved_constant_391;
       const real_t tmp_moved_constant_393 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_394 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_395 = tmp_moved_constant_393 + tmp_moved_constant_394;
       const real_t tmp_moved_constant_396 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_397 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_398 = tmp_moved_constant_396 + tmp_moved_constant_397;
       const real_t tmp_moved_constant_399 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_400 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_401 = tmp_moved_constant_399 + tmp_moved_constant_400;
       const real_t tmp_moved_constant_402 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_403 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_404 = tmp_moved_constant_402 + tmp_moved_constant_403;
       const real_t tmp_moved_constant_405 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_406 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_407 = tmp_moved_constant_405 + tmp_moved_constant_406;
       const real_t tmp_moved_constant_408 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_409 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_410 = tmp_moved_constant_408 + tmp_moved_constant_409;
       const real_t tmp_moved_constant_411 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_412 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_413 = tmp_moved_constant_411 + tmp_moved_constant_412;
       const real_t tmp_moved_constant_414 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_415 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_416 = tmp_moved_constant_414 + tmp_moved_constant_415;
       const real_t tmp_moved_constant_417 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_418 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_419 = tmp_moved_constant_417 + tmp_moved_constant_418;
       const real_t tmp_moved_constant_420 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_421 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_422 = tmp_moved_constant_420 + tmp_moved_constant_421;
       const real_t tmp_moved_constant_423 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_424 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_425 = tmp_moved_constant_423 + tmp_moved_constant_424;
       const real_t tmp_moved_constant_426 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_427 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_428 = tmp_moved_constant_426 + tmp_moved_constant_427;
       const real_t tmp_moved_constant_429 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_430 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_431 = tmp_moved_constant_429 + tmp_moved_constant_430;
       const real_t tmp_moved_constant_432 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_433 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_434 = tmp_moved_constant_432 + tmp_moved_constant_433;
       const real_t tmp_moved_constant_435 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_240 - tmp_moved_constant_300 - tmp_moved_constant_345;
       const real_t tmp_moved_constant_436 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_240 - tmp_moved_constant_303 - tmp_moved_constant_348;
       const real_t tmp_moved_constant_437 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_240 - tmp_moved_constant_306 - tmp_moved_constant_351;
       const real_t tmp_moved_constant_438 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_244 - tmp_moved_constant_309 - tmp_moved_constant_354;
       const real_t tmp_moved_constant_439 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_244 - tmp_moved_constant_312 - tmp_moved_constant_357;
       const real_t tmp_moved_constant_440 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_244 - tmp_moved_constant_315 - tmp_moved_constant_360;
       const real_t tmp_moved_constant_441 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_248 - tmp_moved_constant_318 - tmp_moved_constant_363;
       const real_t tmp_moved_constant_442 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_248 - tmp_moved_constant_321 - tmp_moved_constant_366;
       const real_t tmp_moved_constant_443 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_248 - tmp_moved_constant_324 - tmp_moved_constant_369;
       const real_t tmp_moved_constant_444 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_252 - tmp_moved_constant_327 - tmp_moved_constant_372;
       const real_t tmp_moved_constant_445 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_252 - tmp_moved_constant_330 - tmp_moved_constant_375;
       const real_t tmp_moved_constant_446 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_252 - tmp_moved_constant_333 - tmp_moved_constant_378;
       const real_t tmp_moved_constant_447 = jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_256 - tmp_moved_constant_336 - tmp_moved_constant_381;
       const real_t tmp_moved_constant_448 = jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_256 - tmp_moved_constant_339 - tmp_moved_constant_384;
       const real_t tmp_moved_constant_449 = jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_256 - tmp_moved_constant_342 - tmp_moved_constant_387;
       const real_t tmp_moved_constant_450 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_261 - tmp_moved_constant_301 - tmp_moved_constant_390;
       const real_t tmp_moved_constant_451 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_261 - tmp_moved_constant_304 - tmp_moved_constant_393;
       const real_t tmp_moved_constant_452 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_261 - tmp_moved_constant_307 - tmp_moved_constant_396;
       const real_t tmp_moved_constant_453 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_266 - tmp_moved_constant_310 - tmp_moved_constant_399;
       const real_t tmp_moved_constant_454 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_266 - tmp_moved_constant_313 - tmp_moved_constant_402;
       const real_t tmp_moved_constant_455 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_266 - tmp_moved_constant_316 - tmp_moved_constant_405;
       const real_t tmp_moved_constant_456 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_271 - tmp_moved_constant_319 - tmp_moved_constant_408;
       const real_t tmp_moved_constant_457 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_271 - tmp_moved_constant_322 - tmp_moved_constant_411;
       const real_t tmp_moved_constant_458 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_271 - tmp_moved_constant_325 - tmp_moved_constant_414;
       const real_t tmp_moved_constant_459 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_276 - tmp_moved_constant_328 - tmp_moved_constant_417;
       const real_t tmp_moved_constant_460 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_276 - tmp_moved_constant_331 - tmp_moved_constant_420;
       const real_t tmp_moved_constant_461 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_276 - tmp_moved_constant_334 - tmp_moved_constant_423;
       const real_t tmp_moved_constant_462 = jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_281 - tmp_moved_constant_337 - tmp_moved_constant_426;
       const real_t tmp_moved_constant_463 = jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_281 - tmp_moved_constant_340 - tmp_moved_constant_429;
       const real_t tmp_moved_constant_464 = jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_281 - tmp_moved_constant_343 - tmp_moved_constant_432;
       const real_t tmp_moved_constant_465 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_285 - tmp_moved_constant_346 - tmp_moved_constant_391;
       const real_t tmp_moved_constant_466 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_285 - tmp_moved_constant_349 - tmp_moved_constant_394;
       const real_t tmp_moved_constant_467 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_285 - tmp_moved_constant_352 - tmp_moved_constant_397;
       const real_t tmp_moved_constant_468 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_289 - tmp_moved_constant_355 - tmp_moved_constant_400;
       const real_t tmp_moved_constant_469 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_289 - tmp_moved_constant_358 - tmp_moved_constant_403;
       const real_t tmp_moved_constant_470 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_289 - tmp_moved_constant_361 - tmp_moved_constant_406;
       const real_t tmp_moved_constant_471 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_293 - tmp_moved_constant_364 - tmp_moved_constant_409;
       const real_t tmp_moved_constant_472 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_293 - tmp_moved_constant_367 - tmp_moved_constant_412;
       const real_t tmp_moved_constant_473 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_293 - tmp_moved_constant_370 - tmp_moved_constant_415;
       const real_t tmp_moved_constant_474 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_297 - tmp_moved_constant_373 - tmp_moved_constant_418;
       const real_t tmp_moved_constant_475 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_297 - tmp_moved_constant_376 - tmp_moved_constant_421;
       const real_t tmp_moved_constant_476 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_297 - tmp_moved_constant_379 - tmp_moved_constant_424;
       const real_t tmp_moved_constant_477 = jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_301 - tmp_moved_constant_382 - tmp_moved_constant_427;
       const real_t tmp_moved_constant_478 = jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_301 - tmp_moved_constant_385 - tmp_moved_constant_430;
       const real_t tmp_moved_constant_479 = jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_301 - tmp_moved_constant_388 - tmp_moved_constant_433;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240,tmp_moved_constant_240)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241,tmp_moved_constant_241))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242,tmp_moved_constant_242)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243,tmp_moved_constant_243)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244,tmp_moved_constant_244))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245,tmp_moved_constant_245))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246,tmp_moved_constant_246)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247,tmp_moved_constant_247))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248,tmp_moved_constant_248))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249,tmp_moved_constant_249)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250,tmp_moved_constant_250))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251,tmp_moved_constant_251))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252,tmp_moved_constant_252)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253,tmp_moved_constant_253))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254,tmp_moved_constant_254)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255,tmp_moved_constant_255)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256,tmp_moved_constant_256))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257,tmp_moved_constant_257)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258,tmp_moved_constant_258)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259,tmp_moved_constant_259))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260,tmp_moved_constant_260))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261,tmp_moved_constant_261)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262,tmp_moved_constant_262))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263,tmp_moved_constant_263))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264,tmp_moved_constant_264)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265,tmp_moved_constant_265))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266,tmp_moved_constant_266))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267,tmp_moved_constant_267)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268,tmp_moved_constant_268))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269,tmp_moved_constant_269)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270,tmp_moved_constant_270)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271,tmp_moved_constant_271))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272,tmp_moved_constant_272)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273,tmp_moved_constant_273)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274,tmp_moved_constant_274))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275,tmp_moved_constant_275))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276,tmp_moved_constant_276)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277,tmp_moved_constant_277))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278,tmp_moved_constant_278))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279,tmp_moved_constant_279)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280,tmp_moved_constant_280))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281,tmp_moved_constant_281))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282,tmp_moved_constant_282)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283,tmp_moved_constant_283))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284,tmp_moved_constant_284)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285,tmp_moved_constant_285)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286,tmp_moved_constant_286))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287,tmp_moved_constant_287)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288,tmp_moved_constant_288)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289,tmp_moved_constant_289))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290,tmp_moved_constant_290))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291,tmp_moved_constant_291)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292,tmp_moved_constant_292))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293,tmp_moved_constant_293))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294,tmp_moved_constant_294)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295,tmp_moved_constant_295))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296,tmp_moved_constant_296))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297,tmp_moved_constant_297)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298,tmp_moved_constant_298))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299,tmp_moved_constant_299)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302,tmp_moved_constant_302)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305,tmp_moved_constant_305))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308,tmp_moved_constant_308)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311,tmp_moved_constant_311)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314,tmp_moved_constant_314))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317,tmp_moved_constant_317))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320,tmp_moved_constant_320)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323,tmp_moved_constant_323))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326,tmp_moved_constant_326))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329,tmp_moved_constant_329)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332,tmp_moved_constant_332))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335,tmp_moved_constant_335))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338,tmp_moved_constant_338)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341,tmp_moved_constant_341))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344,tmp_moved_constant_344)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347,tmp_moved_constant_347)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350,tmp_moved_constant_350))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353,tmp_moved_constant_353)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356,tmp_moved_constant_356)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359,tmp_moved_constant_359))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362,tmp_moved_constant_362))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365,tmp_moved_constant_365)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368,tmp_moved_constant_368))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371,tmp_moved_constant_371))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374,tmp_moved_constant_374)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377,tmp_moved_constant_377))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380,tmp_moved_constant_380))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383,tmp_moved_constant_383)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386,tmp_moved_constant_386))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389,tmp_moved_constant_389)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392,tmp_moved_constant_392)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395,tmp_moved_constant_395))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398,tmp_moved_constant_398)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401,tmp_moved_constant_401)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404,tmp_moved_constant_404))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407,tmp_moved_constant_407))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410,tmp_moved_constant_410)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413,tmp_moved_constant_413))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416,tmp_moved_constant_416))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419,tmp_moved_constant_419)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422,tmp_moved_constant_422))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425,tmp_moved_constant_425))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428,tmp_moved_constant_428)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431,tmp_moved_constant_431))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434,tmp_moved_constant_434)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435,tmp_moved_constant_435)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436,tmp_moved_constant_436))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437,tmp_moved_constant_437)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438,tmp_moved_constant_438)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439,tmp_moved_constant_439))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440,tmp_moved_constant_440))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441,tmp_moved_constant_441)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442,tmp_moved_constant_442))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443,tmp_moved_constant_443))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444,tmp_moved_constant_444)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445,tmp_moved_constant_445))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446,tmp_moved_constant_446))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447,tmp_moved_constant_447)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448,tmp_moved_constant_448))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449,tmp_moved_constant_449)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450,tmp_moved_constant_450)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451,tmp_moved_constant_451))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452,tmp_moved_constant_452)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453,tmp_moved_constant_453)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454,tmp_moved_constant_454))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455,tmp_moved_constant_455))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456,tmp_moved_constant_456)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457,tmp_moved_constant_457))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458,tmp_moved_constant_458))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459,tmp_moved_constant_459)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460,tmp_moved_constant_460))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461,tmp_moved_constant_461))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462,tmp_moved_constant_462)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463,tmp_moved_constant_463))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464,tmp_moved_constant_464)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465,tmp_moved_constant_465)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466,tmp_moved_constant_466))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467,tmp_moved_constant_467)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468,tmp_moved_constant_468)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469,tmp_moved_constant_469))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470,tmp_moved_constant_470))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471,tmp_moved_constant_471)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472,tmp_moved_constant_472))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473,tmp_moved_constant_473))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474,tmp_moved_constant_474)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475,tmp_moved_constant_475))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476,tmp_moved_constant_476))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477,tmp_moved_constant_477)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478,tmp_moved_constant_478))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479,tmp_moved_constant_479)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_BLUE_UP*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_243 + jac_blending_inv_1_0_q_1*tmp_moved_constant_244 + jac_blending_inv_2_0_q_1*tmp_moved_constant_245)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_243 + jac_blending_inv_1_0_q_1*tmp_moved_constant_244 + jac_blending_inv_2_0_q_1*tmp_moved_constant_245)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_243 + jac_blending_inv_1_1_q_1*tmp_moved_constant_244 + jac_blending_inv_2_1_q_1*tmp_moved_constant_245)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_243 + jac_blending_inv_1_1_q_1*tmp_moved_constant_244 + jac_blending_inv_2_1_q_1*tmp_moved_constant_245)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_243 + jac_blending_inv_1_2_q_1*tmp_moved_constant_244 + jac_blending_inv_2_2_q_1*tmp_moved_constant_245)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_243 + jac_blending_inv_1_2_q_1*tmp_moved_constant_244 + jac_blending_inv_2_2_q_1*tmp_moved_constant_245))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_246 + jac_blending_inv_1_0_q_2*tmp_moved_constant_247 + jac_blending_inv_2_0_q_2*tmp_moved_constant_248)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_246 + jac_blending_inv_1_0_q_2*tmp_moved_constant_247 + jac_blending_inv_2_0_q_2*tmp_moved_constant_248)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_246 + jac_blending_inv_1_1_q_2*tmp_moved_constant_247 + jac_blending_inv_2_1_q_2*tmp_moved_constant_248)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_246 + jac_blending_inv_1_1_q_2*tmp_moved_constant_247 + jac_blending_inv_2_1_q_2*tmp_moved_constant_248)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_246 + jac_blending_inv_1_2_q_2*tmp_moved_constant_247 + jac_blending_inv_2_2_q_2*tmp_moved_constant_248)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_246 + jac_blending_inv_1_2_q_2*tmp_moved_constant_247 + jac_blending_inv_2_2_q_2*tmp_moved_constant_248))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_249 + jac_blending_inv_1_0_q_3*tmp_moved_constant_250 + jac_blending_inv_2_0_q_3*tmp_moved_constant_251)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_249 + jac_blending_inv_1_0_q_3*tmp_moved_constant_250 + jac_blending_inv_2_0_q_3*tmp_moved_constant_251)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_249 + jac_blending_inv_1_1_q_3*tmp_moved_constant_250 + jac_blending_inv_2_1_q_3*tmp_moved_constant_251)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_249 + jac_blending_inv_1_1_q_3*tmp_moved_constant_250 + jac_blending_inv_2_1_q_3*tmp_moved_constant_251)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_249 + jac_blending_inv_1_2_q_3*tmp_moved_constant_250 + jac_blending_inv_2_2_q_3*tmp_moved_constant_251)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_249 + jac_blending_inv_1_2_q_3*tmp_moved_constant_250 + jac_blending_inv_2_2_q_3*tmp_moved_constant_251))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_252 + jac_blending_inv_1_0_q_4*tmp_moved_constant_253 + jac_blending_inv_2_0_q_4*tmp_moved_constant_254)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_252 + jac_blending_inv_1_0_q_4*tmp_moved_constant_253 + jac_blending_inv_2_0_q_4*tmp_moved_constant_254)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_252 + jac_blending_inv_1_1_q_4*tmp_moved_constant_253 + jac_blending_inv_2_1_q_4*tmp_moved_constant_254)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_252 + jac_blending_inv_1_1_q_4*tmp_moved_constant_253 + jac_blending_inv_2_1_q_4*tmp_moved_constant_254)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_252 + jac_blending_inv_1_2_q_4*tmp_moved_constant_253 + jac_blending_inv_2_2_q_4*tmp_moved_constant_254)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_252 + jac_blending_inv_1_2_q_4*tmp_moved_constant_253 + jac_blending_inv_2_2_q_4*tmp_moved_constant_254))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_240 + jac_blending_inv_1_0_q_0*tmp_moved_constant_241 + jac_blending_inv_2_0_q_0*tmp_moved_constant_242)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_240 + jac_blending_inv_1_0_q_0*tmp_moved_constant_241 + jac_blending_inv_2_0_q_0*tmp_moved_constant_242)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_240 + jac_blending_inv_1_1_q_0*tmp_moved_constant_241 + jac_blending_inv_2_1_q_0*tmp_moved_constant_242)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_240 + jac_blending_inv_1_1_q_0*tmp_moved_constant_241 + jac_blending_inv_2_1_q_0*tmp_moved_constant_242)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_240 + jac_blending_inv_1_2_q_0*tmp_moved_constant_241 + jac_blending_inv_2_2_q_0*tmp_moved_constant_242)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_240 + jac_blending_inv_1_2_q_0*tmp_moved_constant_241 + jac_blending_inv_2_2_q_0*tmp_moved_constant_242)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_258 + jac_blending_inv_1_0_q_1*tmp_moved_constant_259 + jac_blending_inv_2_0_q_1*tmp_moved_constant_260)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_258 + jac_blending_inv_1_0_q_1*tmp_moved_constant_259 + jac_blending_inv_2_0_q_1*tmp_moved_constant_260)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_258 + jac_blending_inv_1_1_q_1*tmp_moved_constant_259 + jac_blending_inv_2_1_q_1*tmp_moved_constant_260)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_258 + jac_blending_inv_1_1_q_1*tmp_moved_constant_259 + jac_blending_inv_2_1_q_1*tmp_moved_constant_260)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_258 + jac_blending_inv_1_2_q_1*tmp_moved_constant_259 + jac_blending_inv_2_2_q_1*tmp_moved_constant_260)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_258 + jac_blending_inv_1_2_q_1*tmp_moved_constant_259 + jac_blending_inv_2_2_q_1*tmp_moved_constant_260))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_261 + jac_blending_inv_1_0_q_2*tmp_moved_constant_262 + jac_blending_inv_2_0_q_2*tmp_moved_constant_263)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_261 + jac_blending_inv_1_0_q_2*tmp_moved_constant_262 + jac_blending_inv_2_0_q_2*tmp_moved_constant_263)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_261 + jac_blending_inv_1_1_q_2*tmp_moved_constant_262 + jac_blending_inv_2_1_q_2*tmp_moved_constant_263)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_261 + jac_blending_inv_1_1_q_2*tmp_moved_constant_262 + jac_blending_inv_2_1_q_2*tmp_moved_constant_263)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_261 + jac_blending_inv_1_2_q_2*tmp_moved_constant_262 + jac_blending_inv_2_2_q_2*tmp_moved_constant_263)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_261 + jac_blending_inv_1_2_q_2*tmp_moved_constant_262 + jac_blending_inv_2_2_q_2*tmp_moved_constant_263))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_264 + jac_blending_inv_1_0_q_3*tmp_moved_constant_265 + jac_blending_inv_2_0_q_3*tmp_moved_constant_266)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_264 + jac_blending_inv_1_0_q_3*tmp_moved_constant_265 + jac_blending_inv_2_0_q_3*tmp_moved_constant_266)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_264 + jac_blending_inv_1_1_q_3*tmp_moved_constant_265 + jac_blending_inv_2_1_q_3*tmp_moved_constant_266)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_264 + jac_blending_inv_1_1_q_3*tmp_moved_constant_265 + jac_blending_inv_2_1_q_3*tmp_moved_constant_266)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_264 + jac_blending_inv_1_2_q_3*tmp_moved_constant_265 + jac_blending_inv_2_2_q_3*tmp_moved_constant_266)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_264 + jac_blending_inv_1_2_q_3*tmp_moved_constant_265 + jac_blending_inv_2_2_q_3*tmp_moved_constant_266))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_267 + jac_blending_inv_1_0_q_4*tmp_moved_constant_268 + jac_blending_inv_2_0_q_4*tmp_moved_constant_269)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_267 + jac_blending_inv_1_0_q_4*tmp_moved_constant_268 + jac_blending_inv_2_0_q_4*tmp_moved_constant_269)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_267 + jac_blending_inv_1_1_q_4*tmp_moved_constant_268 + jac_blending_inv_2_1_q_4*tmp_moved_constant_269)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_267 + jac_blending_inv_1_1_q_4*tmp_moved_constant_268 + jac_blending_inv_2_1_q_4*tmp_moved_constant_269)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_267 + jac_blending_inv_1_2_q_4*tmp_moved_constant_268 + jac_blending_inv_2_2_q_4*tmp_moved_constant_269)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_267 + jac_blending_inv_1_2_q_4*tmp_moved_constant_268 + jac_blending_inv_2_2_q_4*tmp_moved_constant_269))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_255 + jac_blending_inv_1_0_q_0*tmp_moved_constant_256 + jac_blending_inv_2_0_q_0*tmp_moved_constant_257)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_255 + jac_blending_inv_1_0_q_0*tmp_moved_constant_256 + jac_blending_inv_2_0_q_0*tmp_moved_constant_257)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_255 + jac_blending_inv_1_1_q_0*tmp_moved_constant_256 + jac_blending_inv_2_1_q_0*tmp_moved_constant_257)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_255 + jac_blending_inv_1_1_q_0*tmp_moved_constant_256 + jac_blending_inv_2_1_q_0*tmp_moved_constant_257)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_255 + jac_blending_inv_1_2_q_0*tmp_moved_constant_256 + jac_blending_inv_2_2_q_0*tmp_moved_constant_257)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_255 + jac_blending_inv_1_2_q_0*tmp_moved_constant_256 + jac_blending_inv_2_2_q_0*tmp_moved_constant_257)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_273 + jac_blending_inv_1_0_q_1*tmp_moved_constant_274 + jac_blending_inv_2_0_q_1*tmp_moved_constant_275)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_273 + jac_blending_inv_1_0_q_1*tmp_moved_constant_274 + jac_blending_inv_2_0_q_1*tmp_moved_constant_275)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_273 + jac_blending_inv_1_1_q_1*tmp_moved_constant_274 + jac_blending_inv_2_1_q_1*tmp_moved_constant_275)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_273 + jac_blending_inv_1_1_q_1*tmp_moved_constant_274 + jac_blending_inv_2_1_q_1*tmp_moved_constant_275)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_273 + jac_blending_inv_1_2_q_1*tmp_moved_constant_274 + jac_blending_inv_2_2_q_1*tmp_moved_constant_275)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_273 + jac_blending_inv_1_2_q_1*tmp_moved_constant_274 + jac_blending_inv_2_2_q_1*tmp_moved_constant_275))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_276 + jac_blending_inv_1_0_q_2*tmp_moved_constant_277 + jac_blending_inv_2_0_q_2*tmp_moved_constant_278)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_276 + jac_blending_inv_1_0_q_2*tmp_moved_constant_277 + jac_blending_inv_2_0_q_2*tmp_moved_constant_278)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_276 + jac_blending_inv_1_1_q_2*tmp_moved_constant_277 + jac_blending_inv_2_1_q_2*tmp_moved_constant_278)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_276 + jac_blending_inv_1_1_q_2*tmp_moved_constant_277 + jac_blending_inv_2_1_q_2*tmp_moved_constant_278)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_276 + jac_blending_inv_1_2_q_2*tmp_moved_constant_277 + jac_blending_inv_2_2_q_2*tmp_moved_constant_278)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_276 + jac_blending_inv_1_2_q_2*tmp_moved_constant_277 + jac_blending_inv_2_2_q_2*tmp_moved_constant_278))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_279 + jac_blending_inv_1_0_q_3*tmp_moved_constant_280 + jac_blending_inv_2_0_q_3*tmp_moved_constant_281)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_279 + jac_blending_inv_1_0_q_3*tmp_moved_constant_280 + jac_blending_inv_2_0_q_3*tmp_moved_constant_281)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_279 + jac_blending_inv_1_1_q_3*tmp_moved_constant_280 + jac_blending_inv_2_1_q_3*tmp_moved_constant_281)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_279 + jac_blending_inv_1_1_q_3*tmp_moved_constant_280 + jac_blending_inv_2_1_q_3*tmp_moved_constant_281)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_279 + jac_blending_inv_1_2_q_3*tmp_moved_constant_280 + jac_blending_inv_2_2_q_3*tmp_moved_constant_281)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_279 + jac_blending_inv_1_2_q_3*tmp_moved_constant_280 + jac_blending_inv_2_2_q_3*tmp_moved_constant_281))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_282 + jac_blending_inv_1_0_q_4*tmp_moved_constant_283 + jac_blending_inv_2_0_q_4*tmp_moved_constant_284)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_282 + jac_blending_inv_1_0_q_4*tmp_moved_constant_283 + jac_blending_inv_2_0_q_4*tmp_moved_constant_284)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_282 + jac_blending_inv_1_1_q_4*tmp_moved_constant_283 + jac_blending_inv_2_1_q_4*tmp_moved_constant_284)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_282 + jac_blending_inv_1_1_q_4*tmp_moved_constant_283 + jac_blending_inv_2_1_q_4*tmp_moved_constant_284)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_282 + jac_blending_inv_1_2_q_4*tmp_moved_constant_283 + jac_blending_inv_2_2_q_4*tmp_moved_constant_284)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_282 + jac_blending_inv_1_2_q_4*tmp_moved_constant_283 + jac_blending_inv_2_2_q_4*tmp_moved_constant_284))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_270 + jac_blending_inv_1_0_q_0*tmp_moved_constant_271 + jac_blending_inv_2_0_q_0*tmp_moved_constant_272)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_270 + jac_blending_inv_1_0_q_0*tmp_moved_constant_271 + jac_blending_inv_2_0_q_0*tmp_moved_constant_272)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_270 + jac_blending_inv_1_1_q_0*tmp_moved_constant_271 + jac_blending_inv_2_1_q_0*tmp_moved_constant_272)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_270 + jac_blending_inv_1_1_q_0*tmp_moved_constant_271 + jac_blending_inv_2_1_q_0*tmp_moved_constant_272)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_270 + jac_blending_inv_1_2_q_0*tmp_moved_constant_271 + jac_blending_inv_2_2_q_0*tmp_moved_constant_272)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_270 + jac_blending_inv_1_2_q_0*tmp_moved_constant_271 + jac_blending_inv_2_2_q_0*tmp_moved_constant_272)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_288 + jac_blending_inv_1_0_q_1*tmp_moved_constant_289 + jac_blending_inv_2_0_q_1*tmp_moved_constant_290)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_288 + jac_blending_inv_1_0_q_1*tmp_moved_constant_289 + jac_blending_inv_2_0_q_1*tmp_moved_constant_290)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_288 + jac_blending_inv_1_1_q_1*tmp_moved_constant_289 + jac_blending_inv_2_1_q_1*tmp_moved_constant_290)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_288 + jac_blending_inv_1_1_q_1*tmp_moved_constant_289 + jac_blending_inv_2_1_q_1*tmp_moved_constant_290)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_288 + jac_blending_inv_1_2_q_1*tmp_moved_constant_289 + jac_blending_inv_2_2_q_1*tmp_moved_constant_290)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_288 + jac_blending_inv_1_2_q_1*tmp_moved_constant_289 + jac_blending_inv_2_2_q_1*tmp_moved_constant_290))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_291 + jac_blending_inv_1_0_q_2*tmp_moved_constant_292 + jac_blending_inv_2_0_q_2*tmp_moved_constant_293)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_291 + jac_blending_inv_1_0_q_2*tmp_moved_constant_292 + jac_blending_inv_2_0_q_2*tmp_moved_constant_293)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_291 + jac_blending_inv_1_1_q_2*tmp_moved_constant_292 + jac_blending_inv_2_1_q_2*tmp_moved_constant_293)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_291 + jac_blending_inv_1_1_q_2*tmp_moved_constant_292 + jac_blending_inv_2_1_q_2*tmp_moved_constant_293)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_291 + jac_blending_inv_1_2_q_2*tmp_moved_constant_292 + jac_blending_inv_2_2_q_2*tmp_moved_constant_293)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_291 + jac_blending_inv_1_2_q_2*tmp_moved_constant_292 + jac_blending_inv_2_2_q_2*tmp_moved_constant_293))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_294 + jac_blending_inv_1_0_q_3*tmp_moved_constant_295 + jac_blending_inv_2_0_q_3*tmp_moved_constant_296)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_294 + jac_blending_inv_1_0_q_3*tmp_moved_constant_295 + jac_blending_inv_2_0_q_3*tmp_moved_constant_296)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_294 + jac_blending_inv_1_1_q_3*tmp_moved_constant_295 + jac_blending_inv_2_1_q_3*tmp_moved_constant_296)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_294 + jac_blending_inv_1_1_q_3*tmp_moved_constant_295 + jac_blending_inv_2_1_q_3*tmp_moved_constant_296)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_294 + jac_blending_inv_1_2_q_3*tmp_moved_constant_295 + jac_blending_inv_2_2_q_3*tmp_moved_constant_296)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_294 + jac_blending_inv_1_2_q_3*tmp_moved_constant_295 + jac_blending_inv_2_2_q_3*tmp_moved_constant_296))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_297 + jac_blending_inv_1_0_q_4*tmp_moved_constant_298 + jac_blending_inv_2_0_q_4*tmp_moved_constant_299)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_297 + jac_blending_inv_1_0_q_4*tmp_moved_constant_298 + jac_blending_inv_2_0_q_4*tmp_moved_constant_299)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_297 + jac_blending_inv_1_1_q_4*tmp_moved_constant_298 + jac_blending_inv_2_1_q_4*tmp_moved_constant_299)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_297 + jac_blending_inv_1_1_q_4*tmp_moved_constant_298 + jac_blending_inv_2_1_q_4*tmp_moved_constant_299)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_297 + jac_blending_inv_1_2_q_4*tmp_moved_constant_298 + jac_blending_inv_2_2_q_4*tmp_moved_constant_299)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_297 + jac_blending_inv_1_2_q_4*tmp_moved_constant_298 + jac_blending_inv_2_2_q_4*tmp_moved_constant_299))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_285 + jac_blending_inv_1_0_q_0*tmp_moved_constant_286 + jac_blending_inv_2_0_q_0*tmp_moved_constant_287)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_285 + jac_blending_inv_1_0_q_0*tmp_moved_constant_286 + jac_blending_inv_2_0_q_0*tmp_moved_constant_287)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_285 + jac_blending_inv_1_1_q_0*tmp_moved_constant_286 + jac_blending_inv_2_1_q_0*tmp_moved_constant_287)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_285 + jac_blending_inv_1_1_q_0*tmp_moved_constant_286 + jac_blending_inv_2_1_q_0*tmp_moved_constant_287)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_285 + jac_blending_inv_1_2_q_0*tmp_moved_constant_286 + jac_blending_inv_2_2_q_0*tmp_moved_constant_287)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_285 + jac_blending_inv_1_2_q_0*tmp_moved_constant_286 + jac_blending_inv_2_2_q_0*tmp_moved_constant_287)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_311 + jac_blending_inv_1_0_q_1*tmp_moved_constant_314 + jac_blending_inv_2_0_q_1*tmp_moved_constant_317)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_311 + jac_blending_inv_1_0_q_1*tmp_moved_constant_314 + jac_blending_inv_2_0_q_1*tmp_moved_constant_317)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_311 + jac_blending_inv_1_1_q_1*tmp_moved_constant_314 + jac_blending_inv_2_1_q_1*tmp_moved_constant_317)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_311 + jac_blending_inv_1_1_q_1*tmp_moved_constant_314 + jac_blending_inv_2_1_q_1*tmp_moved_constant_317)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_311 + jac_blending_inv_1_2_q_1*tmp_moved_constant_314 + jac_blending_inv_2_2_q_1*tmp_moved_constant_317)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_311 + jac_blending_inv_1_2_q_1*tmp_moved_constant_314 + jac_blending_inv_2_2_q_1*tmp_moved_constant_317))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_320 + jac_blending_inv_1_0_q_2*tmp_moved_constant_323 + jac_blending_inv_2_0_q_2*tmp_moved_constant_326)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_320 + jac_blending_inv_1_0_q_2*tmp_moved_constant_323 + jac_blending_inv_2_0_q_2*tmp_moved_constant_326)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_320 + jac_blending_inv_1_1_q_2*tmp_moved_constant_323 + jac_blending_inv_2_1_q_2*tmp_moved_constant_326)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_320 + jac_blending_inv_1_1_q_2*tmp_moved_constant_323 + jac_blending_inv_2_1_q_2*tmp_moved_constant_326)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_320 + jac_blending_inv_1_2_q_2*tmp_moved_constant_323 + jac_blending_inv_2_2_q_2*tmp_moved_constant_326)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_320 + jac_blending_inv_1_2_q_2*tmp_moved_constant_323 + jac_blending_inv_2_2_q_2*tmp_moved_constant_326))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_329 + jac_blending_inv_1_0_q_3*tmp_moved_constant_332 + jac_blending_inv_2_0_q_3*tmp_moved_constant_335)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_329 + jac_blending_inv_1_0_q_3*tmp_moved_constant_332 + jac_blending_inv_2_0_q_3*tmp_moved_constant_335)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_329 + jac_blending_inv_1_1_q_3*tmp_moved_constant_332 + jac_blending_inv_2_1_q_3*tmp_moved_constant_335)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_329 + jac_blending_inv_1_1_q_3*tmp_moved_constant_332 + jac_blending_inv_2_1_q_3*tmp_moved_constant_335)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_329 + jac_blending_inv_1_2_q_3*tmp_moved_constant_332 + jac_blending_inv_2_2_q_3*tmp_moved_constant_335)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_329 + jac_blending_inv_1_2_q_3*tmp_moved_constant_332 + jac_blending_inv_2_2_q_3*tmp_moved_constant_335))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_338 + jac_blending_inv_1_0_q_4*tmp_moved_constant_341 + jac_blending_inv_2_0_q_4*tmp_moved_constant_344)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_338 + jac_blending_inv_1_0_q_4*tmp_moved_constant_341 + jac_blending_inv_2_0_q_4*tmp_moved_constant_344)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_338 + jac_blending_inv_1_1_q_4*tmp_moved_constant_341 + jac_blending_inv_2_1_q_4*tmp_moved_constant_344)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_338 + jac_blending_inv_1_1_q_4*tmp_moved_constant_341 + jac_blending_inv_2_1_q_4*tmp_moved_constant_344)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_338 + jac_blending_inv_1_2_q_4*tmp_moved_constant_341 + jac_blending_inv_2_2_q_4*tmp_moved_constant_344)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_338 + jac_blending_inv_1_2_q_4*tmp_moved_constant_341 + jac_blending_inv_2_2_q_4*tmp_moved_constant_344))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_302 + jac_blending_inv_1_0_q_0*tmp_moved_constant_305 + jac_blending_inv_2_0_q_0*tmp_moved_constant_308)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_302 + jac_blending_inv_1_0_q_0*tmp_moved_constant_305 + jac_blending_inv_2_0_q_0*tmp_moved_constant_308)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_302 + jac_blending_inv_1_1_q_0*tmp_moved_constant_305 + jac_blending_inv_2_1_q_0*tmp_moved_constant_308)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_302 + jac_blending_inv_1_1_q_0*tmp_moved_constant_305 + jac_blending_inv_2_1_q_0*tmp_moved_constant_308)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_302 + jac_blending_inv_1_2_q_0*tmp_moved_constant_305 + jac_blending_inv_2_2_q_0*tmp_moved_constant_308)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_302 + jac_blending_inv_1_2_q_0*tmp_moved_constant_305 + jac_blending_inv_2_2_q_0*tmp_moved_constant_308)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_356 + jac_blending_inv_1_0_q_1*tmp_moved_constant_359 + jac_blending_inv_2_0_q_1*tmp_moved_constant_362)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_356 + jac_blending_inv_1_0_q_1*tmp_moved_constant_359 + jac_blending_inv_2_0_q_1*tmp_moved_constant_362)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_356 + jac_blending_inv_1_1_q_1*tmp_moved_constant_359 + jac_blending_inv_2_1_q_1*tmp_moved_constant_362)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_356 + jac_blending_inv_1_1_q_1*tmp_moved_constant_359 + jac_blending_inv_2_1_q_1*tmp_moved_constant_362)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_356 + jac_blending_inv_1_2_q_1*tmp_moved_constant_359 + jac_blending_inv_2_2_q_1*tmp_moved_constant_362)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_356 + jac_blending_inv_1_2_q_1*tmp_moved_constant_359 + jac_blending_inv_2_2_q_1*tmp_moved_constant_362))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_365 + jac_blending_inv_1_0_q_2*tmp_moved_constant_368 + jac_blending_inv_2_0_q_2*tmp_moved_constant_371)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_365 + jac_blending_inv_1_0_q_2*tmp_moved_constant_368 + jac_blending_inv_2_0_q_2*tmp_moved_constant_371)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_365 + jac_blending_inv_1_1_q_2*tmp_moved_constant_368 + jac_blending_inv_2_1_q_2*tmp_moved_constant_371)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_365 + jac_blending_inv_1_1_q_2*tmp_moved_constant_368 + jac_blending_inv_2_1_q_2*tmp_moved_constant_371)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_365 + jac_blending_inv_1_2_q_2*tmp_moved_constant_368 + jac_blending_inv_2_2_q_2*tmp_moved_constant_371)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_365 + jac_blending_inv_1_2_q_2*tmp_moved_constant_368 + jac_blending_inv_2_2_q_2*tmp_moved_constant_371))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_374 + jac_blending_inv_1_0_q_3*tmp_moved_constant_377 + jac_blending_inv_2_0_q_3*tmp_moved_constant_380)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_374 + jac_blending_inv_1_0_q_3*tmp_moved_constant_377 + jac_blending_inv_2_0_q_3*tmp_moved_constant_380)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_374 + jac_blending_inv_1_1_q_3*tmp_moved_constant_377 + jac_blending_inv_2_1_q_3*tmp_moved_constant_380)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_374 + jac_blending_inv_1_1_q_3*tmp_moved_constant_377 + jac_blending_inv_2_1_q_3*tmp_moved_constant_380)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_374 + jac_blending_inv_1_2_q_3*tmp_moved_constant_377 + jac_blending_inv_2_2_q_3*tmp_moved_constant_380)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_374 + jac_blending_inv_1_2_q_3*tmp_moved_constant_377 + jac_blending_inv_2_2_q_3*tmp_moved_constant_380))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_383 + jac_blending_inv_1_0_q_4*tmp_moved_constant_386 + jac_blending_inv_2_0_q_4*tmp_moved_constant_389)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_383 + jac_blending_inv_1_0_q_4*tmp_moved_constant_386 + jac_blending_inv_2_0_q_4*tmp_moved_constant_389)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_383 + jac_blending_inv_1_1_q_4*tmp_moved_constant_386 + jac_blending_inv_2_1_q_4*tmp_moved_constant_389)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_383 + jac_blending_inv_1_1_q_4*tmp_moved_constant_386 + jac_blending_inv_2_1_q_4*tmp_moved_constant_389)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_383 + jac_blending_inv_1_2_q_4*tmp_moved_constant_386 + jac_blending_inv_2_2_q_4*tmp_moved_constant_389)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_383 + jac_blending_inv_1_2_q_4*tmp_moved_constant_386 + jac_blending_inv_2_2_q_4*tmp_moved_constant_389))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_347 + jac_blending_inv_1_0_q_0*tmp_moved_constant_350 + jac_blending_inv_2_0_q_0*tmp_moved_constant_353)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_347 + jac_blending_inv_1_0_q_0*tmp_moved_constant_350 + jac_blending_inv_2_0_q_0*tmp_moved_constant_353)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_347 + jac_blending_inv_1_1_q_0*tmp_moved_constant_350 + jac_blending_inv_2_1_q_0*tmp_moved_constant_353)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_347 + jac_blending_inv_1_1_q_0*tmp_moved_constant_350 + jac_blending_inv_2_1_q_0*tmp_moved_constant_353)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_347 + jac_blending_inv_1_2_q_0*tmp_moved_constant_350 + jac_blending_inv_2_2_q_0*tmp_moved_constant_353)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_347 + jac_blending_inv_1_2_q_0*tmp_moved_constant_350 + jac_blending_inv_2_2_q_0*tmp_moved_constant_353)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_401 + jac_blending_inv_1_0_q_1*tmp_moved_constant_404 + jac_blending_inv_2_0_q_1*tmp_moved_constant_407)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_401 + jac_blending_inv_1_0_q_1*tmp_moved_constant_404 + jac_blending_inv_2_0_q_1*tmp_moved_constant_407)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_401 + jac_blending_inv_1_1_q_1*tmp_moved_constant_404 + jac_blending_inv_2_1_q_1*tmp_moved_constant_407)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_401 + jac_blending_inv_1_1_q_1*tmp_moved_constant_404 + jac_blending_inv_2_1_q_1*tmp_moved_constant_407)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_401 + jac_blending_inv_1_2_q_1*tmp_moved_constant_404 + jac_blending_inv_2_2_q_1*tmp_moved_constant_407)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_401 + jac_blending_inv_1_2_q_1*tmp_moved_constant_404 + jac_blending_inv_2_2_q_1*tmp_moved_constant_407))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_413 + jac_blending_inv_2_0_q_2*tmp_moved_constant_416)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_410 + jac_blending_inv_1_0_q_2*tmp_moved_constant_413 + jac_blending_inv_2_0_q_2*tmp_moved_constant_416)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_413 + jac_blending_inv_2_1_q_2*tmp_moved_constant_416)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_410 + jac_blending_inv_1_1_q_2*tmp_moved_constant_413 + jac_blending_inv_2_1_q_2*tmp_moved_constant_416)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_413 + jac_blending_inv_2_2_q_2*tmp_moved_constant_416)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_410 + jac_blending_inv_1_2_q_2*tmp_moved_constant_413 + jac_blending_inv_2_2_q_2*tmp_moved_constant_416))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_419 + jac_blending_inv_1_0_q_3*tmp_moved_constant_422 + jac_blending_inv_2_0_q_3*tmp_moved_constant_425)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_419 + jac_blending_inv_1_0_q_3*tmp_moved_constant_422 + jac_blending_inv_2_0_q_3*tmp_moved_constant_425)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_419 + jac_blending_inv_1_1_q_3*tmp_moved_constant_422 + jac_blending_inv_2_1_q_3*tmp_moved_constant_425)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_419 + jac_blending_inv_1_1_q_3*tmp_moved_constant_422 + jac_blending_inv_2_1_q_3*tmp_moved_constant_425)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_419 + jac_blending_inv_1_2_q_3*tmp_moved_constant_422 + jac_blending_inv_2_2_q_3*tmp_moved_constant_425)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_419 + jac_blending_inv_1_2_q_3*tmp_moved_constant_422 + jac_blending_inv_2_2_q_3*tmp_moved_constant_425))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_428 + jac_blending_inv_1_0_q_4*tmp_moved_constant_431 + jac_blending_inv_2_0_q_4*tmp_moved_constant_434)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_428 + jac_blending_inv_1_0_q_4*tmp_moved_constant_431 + jac_blending_inv_2_0_q_4*tmp_moved_constant_434)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_428 + jac_blending_inv_1_1_q_4*tmp_moved_constant_431 + jac_blending_inv_2_1_q_4*tmp_moved_constant_434)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_428 + jac_blending_inv_1_1_q_4*tmp_moved_constant_431 + jac_blending_inv_2_1_q_4*tmp_moved_constant_434)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_428 + jac_blending_inv_1_2_q_4*tmp_moved_constant_431 + jac_blending_inv_2_2_q_4*tmp_moved_constant_434)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_428 + jac_blending_inv_1_2_q_4*tmp_moved_constant_431 + jac_blending_inv_2_2_q_4*tmp_moved_constant_434))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_392 + jac_blending_inv_1_0_q_0*tmp_moved_constant_395 + jac_blending_inv_2_0_q_0*tmp_moved_constant_398)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_392 + jac_blending_inv_1_0_q_0*tmp_moved_constant_395 + jac_blending_inv_2_0_q_0*tmp_moved_constant_398)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_392 + jac_blending_inv_1_1_q_0*tmp_moved_constant_395 + jac_blending_inv_2_1_q_0*tmp_moved_constant_398)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_392 + jac_blending_inv_1_1_q_0*tmp_moved_constant_395 + jac_blending_inv_2_1_q_0*tmp_moved_constant_398)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_392 + jac_blending_inv_1_2_q_0*tmp_moved_constant_395 + jac_blending_inv_2_2_q_0*tmp_moved_constant_398)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_392 + jac_blending_inv_1_2_q_0*tmp_moved_constant_395 + jac_blending_inv_2_2_q_0*tmp_moved_constant_398)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_438 + jac_blending_inv_1_0_q_1*tmp_moved_constant_439 + jac_blending_inv_2_0_q_1*tmp_moved_constant_440)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_438 + jac_blending_inv_1_0_q_1*tmp_moved_constant_439 + jac_blending_inv_2_0_q_1*tmp_moved_constant_440)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_438 + jac_blending_inv_1_1_q_1*tmp_moved_constant_439 + jac_blending_inv_2_1_q_1*tmp_moved_constant_440)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_438 + jac_blending_inv_1_1_q_1*tmp_moved_constant_439 + jac_blending_inv_2_1_q_1*tmp_moved_constant_440)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_438 + jac_blending_inv_1_2_q_1*tmp_moved_constant_439 + jac_blending_inv_2_2_q_1*tmp_moved_constant_440)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_438 + jac_blending_inv_1_2_q_1*tmp_moved_constant_439 + jac_blending_inv_2_2_q_1*tmp_moved_constant_440))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_441 + jac_blending_inv_1_0_q_2*tmp_moved_constant_442 + jac_blending_inv_2_0_q_2*tmp_moved_constant_443)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_441 + jac_blending_inv_1_0_q_2*tmp_moved_constant_442 + jac_blending_inv_2_0_q_2*tmp_moved_constant_443)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_441 + jac_blending_inv_1_1_q_2*tmp_moved_constant_442 + jac_blending_inv_2_1_q_2*tmp_moved_constant_443)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_441 + jac_blending_inv_1_1_q_2*tmp_moved_constant_442 + jac_blending_inv_2_1_q_2*tmp_moved_constant_443)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_441 + jac_blending_inv_1_2_q_2*tmp_moved_constant_442 + jac_blending_inv_2_2_q_2*tmp_moved_constant_443)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_441 + jac_blending_inv_1_2_q_2*tmp_moved_constant_442 + jac_blending_inv_2_2_q_2*tmp_moved_constant_443))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_444 + jac_blending_inv_1_0_q_3*tmp_moved_constant_445 + jac_blending_inv_2_0_q_3*tmp_moved_constant_446)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_444 + jac_blending_inv_1_0_q_3*tmp_moved_constant_445 + jac_blending_inv_2_0_q_3*tmp_moved_constant_446)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_444 + jac_blending_inv_1_1_q_3*tmp_moved_constant_445 + jac_blending_inv_2_1_q_3*tmp_moved_constant_446)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_444 + jac_blending_inv_1_1_q_3*tmp_moved_constant_445 + jac_blending_inv_2_1_q_3*tmp_moved_constant_446)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_444 + jac_blending_inv_1_2_q_3*tmp_moved_constant_445 + jac_blending_inv_2_2_q_3*tmp_moved_constant_446)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_444 + jac_blending_inv_1_2_q_3*tmp_moved_constant_445 + jac_blending_inv_2_2_q_3*tmp_moved_constant_446))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_447 + jac_blending_inv_1_0_q_4*tmp_moved_constant_448 + jac_blending_inv_2_0_q_4*tmp_moved_constant_449)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_447 + jac_blending_inv_1_0_q_4*tmp_moved_constant_448 + jac_blending_inv_2_0_q_4*tmp_moved_constant_449)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_447 + jac_blending_inv_1_1_q_4*tmp_moved_constant_448 + jac_blending_inv_2_1_q_4*tmp_moved_constant_449)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_447 + jac_blending_inv_1_1_q_4*tmp_moved_constant_448 + jac_blending_inv_2_1_q_4*tmp_moved_constant_449)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_447 + jac_blending_inv_1_2_q_4*tmp_moved_constant_448 + jac_blending_inv_2_2_q_4*tmp_moved_constant_449)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_447 + jac_blending_inv_1_2_q_4*tmp_moved_constant_448 + jac_blending_inv_2_2_q_4*tmp_moved_constant_449))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_435 + jac_blending_inv_1_0_q_0*tmp_moved_constant_436 + jac_blending_inv_2_0_q_0*tmp_moved_constant_437)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_435 + jac_blending_inv_1_0_q_0*tmp_moved_constant_436 + jac_blending_inv_2_0_q_0*tmp_moved_constant_437)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_435 + jac_blending_inv_1_1_q_0*tmp_moved_constant_436 + jac_blending_inv_2_1_q_0*tmp_moved_constant_437)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_435 + jac_blending_inv_1_1_q_0*tmp_moved_constant_436 + jac_blending_inv_2_1_q_0*tmp_moved_constant_437)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_435 + jac_blending_inv_1_2_q_0*tmp_moved_constant_436 + jac_blending_inv_2_2_q_0*tmp_moved_constant_437)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_435 + jac_blending_inv_1_2_q_0*tmp_moved_constant_436 + jac_blending_inv_2_2_q_0*tmp_moved_constant_437)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_453 + jac_blending_inv_1_0_q_1*tmp_moved_constant_454 + jac_blending_inv_2_0_q_1*tmp_moved_constant_455)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_453 + jac_blending_inv_1_0_q_1*tmp_moved_constant_454 + jac_blending_inv_2_0_q_1*tmp_moved_constant_455)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_453 + jac_blending_inv_1_1_q_1*tmp_moved_constant_454 + jac_blending_inv_2_1_q_1*tmp_moved_constant_455)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_453 + jac_blending_inv_1_1_q_1*tmp_moved_constant_454 + jac_blending_inv_2_1_q_1*tmp_moved_constant_455)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_453 + jac_blending_inv_1_2_q_1*tmp_moved_constant_454 + jac_blending_inv_2_2_q_1*tmp_moved_constant_455)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_453 + jac_blending_inv_1_2_q_1*tmp_moved_constant_454 + jac_blending_inv_2_2_q_1*tmp_moved_constant_455))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_456 + jac_blending_inv_1_0_q_2*tmp_moved_constant_457 + jac_blending_inv_2_0_q_2*tmp_moved_constant_458)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_456 + jac_blending_inv_1_0_q_2*tmp_moved_constant_457 + jac_blending_inv_2_0_q_2*tmp_moved_constant_458)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_456 + jac_blending_inv_1_1_q_2*tmp_moved_constant_457 + jac_blending_inv_2_1_q_2*tmp_moved_constant_458)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_456 + jac_blending_inv_1_1_q_2*tmp_moved_constant_457 + jac_blending_inv_2_1_q_2*tmp_moved_constant_458)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_456 + jac_blending_inv_1_2_q_2*tmp_moved_constant_457 + jac_blending_inv_2_2_q_2*tmp_moved_constant_458)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_456 + jac_blending_inv_1_2_q_2*tmp_moved_constant_457 + jac_blending_inv_2_2_q_2*tmp_moved_constant_458))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_459 + jac_blending_inv_1_0_q_3*tmp_moved_constant_460 + jac_blending_inv_2_0_q_3*tmp_moved_constant_461)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_459 + jac_blending_inv_1_0_q_3*tmp_moved_constant_460 + jac_blending_inv_2_0_q_3*tmp_moved_constant_461)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_459 + jac_blending_inv_1_1_q_3*tmp_moved_constant_460 + jac_blending_inv_2_1_q_3*tmp_moved_constant_461)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_459 + jac_blending_inv_1_1_q_3*tmp_moved_constant_460 + jac_blending_inv_2_1_q_3*tmp_moved_constant_461)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_459 + jac_blending_inv_1_2_q_3*tmp_moved_constant_460 + jac_blending_inv_2_2_q_3*tmp_moved_constant_461)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_459 + jac_blending_inv_1_2_q_3*tmp_moved_constant_460 + jac_blending_inv_2_2_q_3*tmp_moved_constant_461))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_462 + jac_blending_inv_1_0_q_4*tmp_moved_constant_463 + jac_blending_inv_2_0_q_4*tmp_moved_constant_464)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_462 + jac_blending_inv_1_0_q_4*tmp_moved_constant_463 + jac_blending_inv_2_0_q_4*tmp_moved_constant_464)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_462 + jac_blending_inv_1_1_q_4*tmp_moved_constant_463 + jac_blending_inv_2_1_q_4*tmp_moved_constant_464)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_462 + jac_blending_inv_1_1_q_4*tmp_moved_constant_463 + jac_blending_inv_2_1_q_4*tmp_moved_constant_464)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_462 + jac_blending_inv_1_2_q_4*tmp_moved_constant_463 + jac_blending_inv_2_2_q_4*tmp_moved_constant_464)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_462 + jac_blending_inv_1_2_q_4*tmp_moved_constant_463 + jac_blending_inv_2_2_q_4*tmp_moved_constant_464))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_451 + jac_blending_inv_2_0_q_0*tmp_moved_constant_452)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_450 + jac_blending_inv_1_0_q_0*tmp_moved_constant_451 + jac_blending_inv_2_0_q_0*tmp_moved_constant_452)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_451 + jac_blending_inv_2_1_q_0*tmp_moved_constant_452)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_450 + jac_blending_inv_1_1_q_0*tmp_moved_constant_451 + jac_blending_inv_2_1_q_0*tmp_moved_constant_452)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_451 + jac_blending_inv_2_2_q_0*tmp_moved_constant_452)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_450 + jac_blending_inv_1_2_q_0*tmp_moved_constant_451 + jac_blending_inv_2_2_q_0*tmp_moved_constant_452)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_468 + jac_blending_inv_1_0_q_1*tmp_moved_constant_469 + jac_blending_inv_2_0_q_1*tmp_moved_constant_470)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_468 + jac_blending_inv_1_0_q_1*tmp_moved_constant_469 + jac_blending_inv_2_0_q_1*tmp_moved_constant_470)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_468 + jac_blending_inv_1_1_q_1*tmp_moved_constant_469 + jac_blending_inv_2_1_q_1*tmp_moved_constant_470)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_468 + jac_blending_inv_1_1_q_1*tmp_moved_constant_469 + jac_blending_inv_2_1_q_1*tmp_moved_constant_470)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_468 + jac_blending_inv_1_2_q_1*tmp_moved_constant_469 + jac_blending_inv_2_2_q_1*tmp_moved_constant_470)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_468 + jac_blending_inv_1_2_q_1*tmp_moved_constant_469 + jac_blending_inv_2_2_q_1*tmp_moved_constant_470))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_471 + jac_blending_inv_1_0_q_2*tmp_moved_constant_472 + jac_blending_inv_2_0_q_2*tmp_moved_constant_473)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_471 + jac_blending_inv_1_0_q_2*tmp_moved_constant_472 + jac_blending_inv_2_0_q_2*tmp_moved_constant_473)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_471 + jac_blending_inv_1_1_q_2*tmp_moved_constant_472 + jac_blending_inv_2_1_q_2*tmp_moved_constant_473)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_471 + jac_blending_inv_1_1_q_2*tmp_moved_constant_472 + jac_blending_inv_2_1_q_2*tmp_moved_constant_473)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_471 + jac_blending_inv_1_2_q_2*tmp_moved_constant_472 + jac_blending_inv_2_2_q_2*tmp_moved_constant_473)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_471 + jac_blending_inv_1_2_q_2*tmp_moved_constant_472 + jac_blending_inv_2_2_q_2*tmp_moved_constant_473))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_474 + jac_blending_inv_1_0_q_3*tmp_moved_constant_475 + jac_blending_inv_2_0_q_3*tmp_moved_constant_476)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_474 + jac_blending_inv_1_0_q_3*tmp_moved_constant_475 + jac_blending_inv_2_0_q_3*tmp_moved_constant_476)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_474 + jac_blending_inv_1_1_q_3*tmp_moved_constant_475 + jac_blending_inv_2_1_q_3*tmp_moved_constant_476)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_474 + jac_blending_inv_1_1_q_3*tmp_moved_constant_475 + jac_blending_inv_2_1_q_3*tmp_moved_constant_476)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_474 + jac_blending_inv_1_2_q_3*tmp_moved_constant_475 + jac_blending_inv_2_2_q_3*tmp_moved_constant_476)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_474 + jac_blending_inv_1_2_q_3*tmp_moved_constant_475 + jac_blending_inv_2_2_q_3*tmp_moved_constant_476))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_477 + jac_blending_inv_1_0_q_4*tmp_moved_constant_478 + jac_blending_inv_2_0_q_4*tmp_moved_constant_479)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_477 + jac_blending_inv_1_0_q_4*tmp_moved_constant_478 + jac_blending_inv_2_0_q_4*tmp_moved_constant_479)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_477 + jac_blending_inv_1_1_q_4*tmp_moved_constant_478 + jac_blending_inv_2_1_q_4*tmp_moved_constant_479)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_477 + jac_blending_inv_1_1_q_4*tmp_moved_constant_478 + jac_blending_inv_2_1_q_4*tmp_moved_constant_479)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_477 + jac_blending_inv_1_2_q_4*tmp_moved_constant_478 + jac_blending_inv_2_2_q_4*tmp_moved_constant_479)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_477 + jac_blending_inv_1_2_q_4*tmp_moved_constant_478 + jac_blending_inv_2_2_q_4*tmp_moved_constant_479))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_465 + jac_blending_inv_1_0_q_0*tmp_moved_constant_466 + jac_blending_inv_2_0_q_0*tmp_moved_constant_467)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_465 + jac_blending_inv_1_0_q_0*tmp_moved_constant_466 + jac_blending_inv_2_0_q_0*tmp_moved_constant_467)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_465 + jac_blending_inv_1_1_q_0*tmp_moved_constant_466 + jac_blending_inv_2_1_q_0*tmp_moved_constant_467)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_465 + jac_blending_inv_1_1_q_0*tmp_moved_constant_466 + jac_blending_inv_2_1_q_0*tmp_moved_constant_467)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_465 + jac_blending_inv_1_2_q_0*tmp_moved_constant_466 + jac_blending_inv_2_2_q_0*tmp_moved_constant_467)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_465 + jac_blending_inv_1_2_q_0*tmp_moved_constant_466 + jac_blending_inv_2_2_q_0*tmp_moved_constant_467)));
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const real_t tmp_moved_constant_480 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_481 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_482 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_483 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_484 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_485 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_486 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_487 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_488 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_489 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_490 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_491 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_492 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_493 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_494 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_495 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_496 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_497 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_498 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_499 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_500 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_501 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_502 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_503 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_504 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_505 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_506 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_507 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_508 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_509 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_510 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_511 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_512 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_513 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_514 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_515 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_516 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_517 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_518 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_519 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_520 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_521 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_522 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_523 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_524 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_525 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_526 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_527 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_528 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_529 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_530 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_531 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_532 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_533 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_534 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_535 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_536 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_537 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_538 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_539 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_540 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_541 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_542 = tmp_moved_constant_540 + tmp_moved_constant_541;
       const real_t tmp_moved_constant_543 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_544 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_545 = tmp_moved_constant_543 + tmp_moved_constant_544;
       const real_t tmp_moved_constant_546 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_547 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_548 = tmp_moved_constant_546 + tmp_moved_constant_547;
       const real_t tmp_moved_constant_549 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_550 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_551 = tmp_moved_constant_549 + tmp_moved_constant_550;
       const real_t tmp_moved_constant_552 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_553 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_554 = tmp_moved_constant_552 + tmp_moved_constant_553;
       const real_t tmp_moved_constant_555 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_556 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_557 = tmp_moved_constant_555 + tmp_moved_constant_556;
       const real_t tmp_moved_constant_558 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_559 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_560 = tmp_moved_constant_558 + tmp_moved_constant_559;
       const real_t tmp_moved_constant_561 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_562 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_563 = tmp_moved_constant_561 + tmp_moved_constant_562;
       const real_t tmp_moved_constant_564 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_565 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_566 = tmp_moved_constant_564 + tmp_moved_constant_565;
       const real_t tmp_moved_constant_567 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_568 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_569 = tmp_moved_constant_567 + tmp_moved_constant_568;
       const real_t tmp_moved_constant_570 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_571 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_572 = tmp_moved_constant_570 + tmp_moved_constant_571;
       const real_t tmp_moved_constant_573 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_574 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_575 = tmp_moved_constant_573 + tmp_moved_constant_574;
       const real_t tmp_moved_constant_576 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_577 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_578 = tmp_moved_constant_576 + tmp_moved_constant_577;
       const real_t tmp_moved_constant_579 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_580 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_581 = tmp_moved_constant_579 + tmp_moved_constant_580;
       const real_t tmp_moved_constant_582 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_583 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_584 = tmp_moved_constant_582 + tmp_moved_constant_583;
       const real_t tmp_moved_constant_585 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_586 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_587 = tmp_moved_constant_585 + tmp_moved_constant_586;
       const real_t tmp_moved_constant_588 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_589 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_590 = tmp_moved_constant_588 + tmp_moved_constant_589;
       const real_t tmp_moved_constant_591 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_592 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_593 = tmp_moved_constant_591 + tmp_moved_constant_592;
       const real_t tmp_moved_constant_594 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_595 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_596 = tmp_moved_constant_594 + tmp_moved_constant_595;
       const real_t tmp_moved_constant_597 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_598 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_599 = tmp_moved_constant_597 + tmp_moved_constant_598;
       const real_t tmp_moved_constant_600 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_601 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_602 = tmp_moved_constant_600 + tmp_moved_constant_601;
       const real_t tmp_moved_constant_603 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_604 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_605 = tmp_moved_constant_603 + tmp_moved_constant_604;
       const real_t tmp_moved_constant_606 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_607 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_608 = tmp_moved_constant_606 + tmp_moved_constant_607;
       const real_t tmp_moved_constant_609 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_610 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_611 = tmp_moved_constant_609 + tmp_moved_constant_610;
       const real_t tmp_moved_constant_612 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_613 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_614 = tmp_moved_constant_612 + tmp_moved_constant_613;
       const real_t tmp_moved_constant_615 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_616 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_617 = tmp_moved_constant_615 + tmp_moved_constant_616;
       const real_t tmp_moved_constant_618 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_619 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_620 = tmp_moved_constant_618 + tmp_moved_constant_619;
       const real_t tmp_moved_constant_621 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_622 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_623 = tmp_moved_constant_621 + tmp_moved_constant_622;
       const real_t tmp_moved_constant_624 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_625 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_626 = tmp_moved_constant_624 + tmp_moved_constant_625;
       const real_t tmp_moved_constant_627 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_628 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_629 = tmp_moved_constant_627 + tmp_moved_constant_628;
       const real_t tmp_moved_constant_630 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_631 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_632 = tmp_moved_constant_630 + tmp_moved_constant_631;
       const real_t tmp_moved_constant_633 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_634 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_635 = tmp_moved_constant_633 + tmp_moved_constant_634;
       const real_t tmp_moved_constant_636 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_637 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_638 = tmp_moved_constant_636 + tmp_moved_constant_637;
       const real_t tmp_moved_constant_639 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_640 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_641 = tmp_moved_constant_639 + tmp_moved_constant_640;
       const real_t tmp_moved_constant_642 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_643 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_644 = tmp_moved_constant_642 + tmp_moved_constant_643;
       const real_t tmp_moved_constant_645 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_646 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_647 = tmp_moved_constant_645 + tmp_moved_constant_646;
       const real_t tmp_moved_constant_648 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_649 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_650 = tmp_moved_constant_648 + tmp_moved_constant_649;
       const real_t tmp_moved_constant_651 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_652 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_653 = tmp_moved_constant_651 + tmp_moved_constant_652;
       const real_t tmp_moved_constant_654 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_655 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_656 = tmp_moved_constant_654 + tmp_moved_constant_655;
       const real_t tmp_moved_constant_657 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_658 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_659 = tmp_moved_constant_657 + tmp_moved_constant_658;
       const real_t tmp_moved_constant_660 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_661 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_662 = tmp_moved_constant_660 + tmp_moved_constant_661;
       const real_t tmp_moved_constant_663 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_664 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_665 = tmp_moved_constant_663 + tmp_moved_constant_664;
       const real_t tmp_moved_constant_666 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_667 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_668 = tmp_moved_constant_666 + tmp_moved_constant_667;
       const real_t tmp_moved_constant_669 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_670 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_671 = tmp_moved_constant_669 + tmp_moved_constant_670;
       const real_t tmp_moved_constant_672 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_673 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_674 = tmp_moved_constant_672 + tmp_moved_constant_673;
       const real_t tmp_moved_constant_675 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_540 - tmp_moved_constant_585;
       const real_t tmp_moved_constant_676 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_543 - tmp_moved_constant_588;
       const real_t tmp_moved_constant_677 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_240 - tmp_moved_constant_546 - tmp_moved_constant_591;
       const real_t tmp_moved_constant_678 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_549 - tmp_moved_constant_594;
       const real_t tmp_moved_constant_679 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_552 - tmp_moved_constant_597;
       const real_t tmp_moved_constant_680 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_244 - tmp_moved_constant_555 - tmp_moved_constant_600;
       const real_t tmp_moved_constant_681 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_558 - tmp_moved_constant_603;
       const real_t tmp_moved_constant_682 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_561 - tmp_moved_constant_606;
       const real_t tmp_moved_constant_683 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_248 - tmp_moved_constant_564 - tmp_moved_constant_609;
       const real_t tmp_moved_constant_684 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_567 - tmp_moved_constant_612;
       const real_t tmp_moved_constant_685 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_570 - tmp_moved_constant_615;
       const real_t tmp_moved_constant_686 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_252 - tmp_moved_constant_573 - tmp_moved_constant_618;
       const real_t tmp_moved_constant_687 = jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_576 - tmp_moved_constant_621;
       const real_t tmp_moved_constant_688 = jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_579 - tmp_moved_constant_624;
       const real_t tmp_moved_constant_689 = jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_256 - tmp_moved_constant_582 - tmp_moved_constant_627;
       const real_t tmp_moved_constant_690 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_541 - tmp_moved_constant_630;
       const real_t tmp_moved_constant_691 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_544 - tmp_moved_constant_633;
       const real_t tmp_moved_constant_692 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_261 - tmp_moved_constant_547 - tmp_moved_constant_636;
       const real_t tmp_moved_constant_693 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_550 - tmp_moved_constant_639;
       const real_t tmp_moved_constant_694 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_553 - tmp_moved_constant_642;
       const real_t tmp_moved_constant_695 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_266 - tmp_moved_constant_556 - tmp_moved_constant_645;
       const real_t tmp_moved_constant_696 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_559 - tmp_moved_constant_648;
       const real_t tmp_moved_constant_697 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_562 - tmp_moved_constant_651;
       const real_t tmp_moved_constant_698 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_271 - tmp_moved_constant_565 - tmp_moved_constant_654;
       const real_t tmp_moved_constant_699 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_568 - tmp_moved_constant_657;
       const real_t tmp_moved_constant_700 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_571 - tmp_moved_constant_660;
       const real_t tmp_moved_constant_701 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_276 - tmp_moved_constant_574 - tmp_moved_constant_663;
       const real_t tmp_moved_constant_702 = jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_577 - tmp_moved_constant_666;
       const real_t tmp_moved_constant_703 = jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_580 - tmp_moved_constant_669;
       const real_t tmp_moved_constant_704 = jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_281 - tmp_moved_constant_583 - tmp_moved_constant_672;
       const real_t tmp_moved_constant_705 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_586 - tmp_moved_constant_631;
       const real_t tmp_moved_constant_706 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_589 - tmp_moved_constant_634;
       const real_t tmp_moved_constant_707 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_285 - tmp_moved_constant_592 - tmp_moved_constant_637;
       const real_t tmp_moved_constant_708 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_595 - tmp_moved_constant_640;
       const real_t tmp_moved_constant_709 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_598 - tmp_moved_constant_643;
       const real_t tmp_moved_constant_710 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_289 - tmp_moved_constant_601 - tmp_moved_constant_646;
       const real_t tmp_moved_constant_711 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_604 - tmp_moved_constant_649;
       const real_t tmp_moved_constant_712 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_607 - tmp_moved_constant_652;
       const real_t tmp_moved_constant_713 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_293 - tmp_moved_constant_610 - tmp_moved_constant_655;
       const real_t tmp_moved_constant_714 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_613 - tmp_moved_constant_658;
       const real_t tmp_moved_constant_715 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_616 - tmp_moved_constant_661;
       const real_t tmp_moved_constant_716 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_297 - tmp_moved_constant_619 - tmp_moved_constant_664;
       const real_t tmp_moved_constant_717 = jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_622 - tmp_moved_constant_667;
       const real_t tmp_moved_constant_718 = jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_625 - tmp_moved_constant_670;
       const real_t tmp_moved_constant_719 = jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_301 - tmp_moved_constant_628 - tmp_moved_constant_673;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480,tmp_moved_constant_480)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481,tmp_moved_constant_481))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482,tmp_moved_constant_482)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483,tmp_moved_constant_483)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484,tmp_moved_constant_484))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485,tmp_moved_constant_485))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486,tmp_moved_constant_486)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487,tmp_moved_constant_487))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488,tmp_moved_constant_488))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489,tmp_moved_constant_489)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490,tmp_moved_constant_490))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491,tmp_moved_constant_491))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492,tmp_moved_constant_492)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493,tmp_moved_constant_493))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494,tmp_moved_constant_494)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495,tmp_moved_constant_495)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496,tmp_moved_constant_496))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497,tmp_moved_constant_497)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498,tmp_moved_constant_498)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499,tmp_moved_constant_499))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500,tmp_moved_constant_500))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501,tmp_moved_constant_501)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502,tmp_moved_constant_502))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503,tmp_moved_constant_503))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504,tmp_moved_constant_504)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505,tmp_moved_constant_505))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506,tmp_moved_constant_506))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507,tmp_moved_constant_507)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508,tmp_moved_constant_508))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509,tmp_moved_constant_509)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510,tmp_moved_constant_510)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511,tmp_moved_constant_511))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512,tmp_moved_constant_512)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513,tmp_moved_constant_513)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514,tmp_moved_constant_514))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515,tmp_moved_constant_515))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516,tmp_moved_constant_516)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517,tmp_moved_constant_517))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518,tmp_moved_constant_518))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519,tmp_moved_constant_519)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520,tmp_moved_constant_520))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521,tmp_moved_constant_521))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522,tmp_moved_constant_522)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523,tmp_moved_constant_523))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524,tmp_moved_constant_524)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525,tmp_moved_constant_525)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526,tmp_moved_constant_526))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527,tmp_moved_constant_527)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528,tmp_moved_constant_528)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529,tmp_moved_constant_529))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530,tmp_moved_constant_530))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531,tmp_moved_constant_531)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532,tmp_moved_constant_532))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533,tmp_moved_constant_533))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534,tmp_moved_constant_534)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535,tmp_moved_constant_535))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536,tmp_moved_constant_536))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537,tmp_moved_constant_537)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538,tmp_moved_constant_538))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539,tmp_moved_constant_539)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542,tmp_moved_constant_542)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545,tmp_moved_constant_545))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548,tmp_moved_constant_548)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551,tmp_moved_constant_551)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554,tmp_moved_constant_554))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557,tmp_moved_constant_557))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560,tmp_moved_constant_560)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563,tmp_moved_constant_563))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566,tmp_moved_constant_566))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569,tmp_moved_constant_569)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572,tmp_moved_constant_572))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575,tmp_moved_constant_575))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578,tmp_moved_constant_578)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581,tmp_moved_constant_581))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584,tmp_moved_constant_584)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587,tmp_moved_constant_587)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590,tmp_moved_constant_590))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593,tmp_moved_constant_593)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596,tmp_moved_constant_596)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599,tmp_moved_constant_599))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602,tmp_moved_constant_602))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605,tmp_moved_constant_605)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608,tmp_moved_constant_608))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611,tmp_moved_constant_611))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614,tmp_moved_constant_614)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617,tmp_moved_constant_617))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620,tmp_moved_constant_620))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623,tmp_moved_constant_623)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626,tmp_moved_constant_626))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629,tmp_moved_constant_629)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632,tmp_moved_constant_632)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635,tmp_moved_constant_635))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638,tmp_moved_constant_638)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641,tmp_moved_constant_641)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644,tmp_moved_constant_644))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647,tmp_moved_constant_647))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650,tmp_moved_constant_650)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653,tmp_moved_constant_653))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656,tmp_moved_constant_656))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659,tmp_moved_constant_659)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662,tmp_moved_constant_662))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665,tmp_moved_constant_665))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668,tmp_moved_constant_668)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671,tmp_moved_constant_671))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674,tmp_moved_constant_674)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675,tmp_moved_constant_675)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676,tmp_moved_constant_676))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677,tmp_moved_constant_677)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678,tmp_moved_constant_678)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679,tmp_moved_constant_679))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680,tmp_moved_constant_680))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681,tmp_moved_constant_681)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682,tmp_moved_constant_682))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683,tmp_moved_constant_683))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684,tmp_moved_constant_684)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685,tmp_moved_constant_685))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686,tmp_moved_constant_686))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687,tmp_moved_constant_687)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688,tmp_moved_constant_688))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689,tmp_moved_constant_689)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690,tmp_moved_constant_690)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691,tmp_moved_constant_691))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692,tmp_moved_constant_692)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693,tmp_moved_constant_693)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694,tmp_moved_constant_694))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695,tmp_moved_constant_695))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696,tmp_moved_constant_696)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697,tmp_moved_constant_697))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698,tmp_moved_constant_698))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699,tmp_moved_constant_699)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700,tmp_moved_constant_700))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701,tmp_moved_constant_701))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702,tmp_moved_constant_702)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703,tmp_moved_constant_703))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704,tmp_moved_constant_704)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705,tmp_moved_constant_705)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706,tmp_moved_constant_706))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707,tmp_moved_constant_707)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708,tmp_moved_constant_708)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709,tmp_moved_constant_709))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710,tmp_moved_constant_710))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711,tmp_moved_constant_711)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712,tmp_moved_constant_712))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713,tmp_moved_constant_713))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714,tmp_moved_constant_714)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715,tmp_moved_constant_715))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716,tmp_moved_constant_716))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717,tmp_moved_constant_717)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718,tmp_moved_constant_718))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719,tmp_moved_constant_719)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_BLUE_DOWN*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_483 + jac_blending_inv_1_0_q_1*tmp_moved_constant_484 + jac_blending_inv_2_0_q_1*tmp_moved_constant_485)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_483 + jac_blending_inv_1_0_q_1*tmp_moved_constant_484 + jac_blending_inv_2_0_q_1*tmp_moved_constant_485)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_483 + jac_blending_inv_1_1_q_1*tmp_moved_constant_484 + jac_blending_inv_2_1_q_1*tmp_moved_constant_485)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_483 + jac_blending_inv_1_1_q_1*tmp_moved_constant_484 + jac_blending_inv_2_1_q_1*tmp_moved_constant_485)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_483 + jac_blending_inv_1_2_q_1*tmp_moved_constant_484 + jac_blending_inv_2_2_q_1*tmp_moved_constant_485)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_483 + jac_blending_inv_1_2_q_1*tmp_moved_constant_484 + jac_blending_inv_2_2_q_1*tmp_moved_constant_485))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_486 + jac_blending_inv_1_0_q_2*tmp_moved_constant_487 + jac_blending_inv_2_0_q_2*tmp_moved_constant_488)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_486 + jac_blending_inv_1_0_q_2*tmp_moved_constant_487 + jac_blending_inv_2_0_q_2*tmp_moved_constant_488)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_486 + jac_blending_inv_1_1_q_2*tmp_moved_constant_487 + jac_blending_inv_2_1_q_2*tmp_moved_constant_488)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_486 + jac_blending_inv_1_1_q_2*tmp_moved_constant_487 + jac_blending_inv_2_1_q_2*tmp_moved_constant_488)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_486 + jac_blending_inv_1_2_q_2*tmp_moved_constant_487 + jac_blending_inv_2_2_q_2*tmp_moved_constant_488)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_486 + jac_blending_inv_1_2_q_2*tmp_moved_constant_487 + jac_blending_inv_2_2_q_2*tmp_moved_constant_488))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_489 + jac_blending_inv_1_0_q_3*tmp_moved_constant_490 + jac_blending_inv_2_0_q_3*tmp_moved_constant_491)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_489 + jac_blending_inv_1_0_q_3*tmp_moved_constant_490 + jac_blending_inv_2_0_q_3*tmp_moved_constant_491)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_489 + jac_blending_inv_1_1_q_3*tmp_moved_constant_490 + jac_blending_inv_2_1_q_3*tmp_moved_constant_491)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_489 + jac_blending_inv_1_1_q_3*tmp_moved_constant_490 + jac_blending_inv_2_1_q_3*tmp_moved_constant_491)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_489 + jac_blending_inv_1_2_q_3*tmp_moved_constant_490 + jac_blending_inv_2_2_q_3*tmp_moved_constant_491)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_489 + jac_blending_inv_1_2_q_3*tmp_moved_constant_490 + jac_blending_inv_2_2_q_3*tmp_moved_constant_491))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_492 + jac_blending_inv_1_0_q_4*tmp_moved_constant_493 + jac_blending_inv_2_0_q_4*tmp_moved_constant_494)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_492 + jac_blending_inv_1_0_q_4*tmp_moved_constant_493 + jac_blending_inv_2_0_q_4*tmp_moved_constant_494)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_492 + jac_blending_inv_1_1_q_4*tmp_moved_constant_493 + jac_blending_inv_2_1_q_4*tmp_moved_constant_494)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_492 + jac_blending_inv_1_1_q_4*tmp_moved_constant_493 + jac_blending_inv_2_1_q_4*tmp_moved_constant_494)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_492 + jac_blending_inv_1_2_q_4*tmp_moved_constant_493 + jac_blending_inv_2_2_q_4*tmp_moved_constant_494)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_492 + jac_blending_inv_1_2_q_4*tmp_moved_constant_493 + jac_blending_inv_2_2_q_4*tmp_moved_constant_494))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_480 + jac_blending_inv_1_0_q_0*tmp_moved_constant_481 + jac_blending_inv_2_0_q_0*tmp_moved_constant_482)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_480 + jac_blending_inv_1_0_q_0*tmp_moved_constant_481 + jac_blending_inv_2_0_q_0*tmp_moved_constant_482)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_480 + jac_blending_inv_1_1_q_0*tmp_moved_constant_481 + jac_blending_inv_2_1_q_0*tmp_moved_constant_482)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_480 + jac_blending_inv_1_1_q_0*tmp_moved_constant_481 + jac_blending_inv_2_1_q_0*tmp_moved_constant_482)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_480 + jac_blending_inv_1_2_q_0*tmp_moved_constant_481 + jac_blending_inv_2_2_q_0*tmp_moved_constant_482)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_480 + jac_blending_inv_1_2_q_0*tmp_moved_constant_481 + jac_blending_inv_2_2_q_0*tmp_moved_constant_482)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_498 + jac_blending_inv_1_0_q_1*tmp_moved_constant_499 + jac_blending_inv_2_0_q_1*tmp_moved_constant_500)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_498 + jac_blending_inv_1_0_q_1*tmp_moved_constant_499 + jac_blending_inv_2_0_q_1*tmp_moved_constant_500)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_498 + jac_blending_inv_1_1_q_1*tmp_moved_constant_499 + jac_blending_inv_2_1_q_1*tmp_moved_constant_500)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_498 + jac_blending_inv_1_1_q_1*tmp_moved_constant_499 + jac_blending_inv_2_1_q_1*tmp_moved_constant_500)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_498 + jac_blending_inv_1_2_q_1*tmp_moved_constant_499 + jac_blending_inv_2_2_q_1*tmp_moved_constant_500)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_498 + jac_blending_inv_1_2_q_1*tmp_moved_constant_499 + jac_blending_inv_2_2_q_1*tmp_moved_constant_500))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_501 + jac_blending_inv_1_0_q_2*tmp_moved_constant_502 + jac_blending_inv_2_0_q_2*tmp_moved_constant_503)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_501 + jac_blending_inv_1_0_q_2*tmp_moved_constant_502 + jac_blending_inv_2_0_q_2*tmp_moved_constant_503)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_501 + jac_blending_inv_1_1_q_2*tmp_moved_constant_502 + jac_blending_inv_2_1_q_2*tmp_moved_constant_503)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_501 + jac_blending_inv_1_1_q_2*tmp_moved_constant_502 + jac_blending_inv_2_1_q_2*tmp_moved_constant_503)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_501 + jac_blending_inv_1_2_q_2*tmp_moved_constant_502 + jac_blending_inv_2_2_q_2*tmp_moved_constant_503)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_501 + jac_blending_inv_1_2_q_2*tmp_moved_constant_502 + jac_blending_inv_2_2_q_2*tmp_moved_constant_503))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_504 + jac_blending_inv_1_0_q_3*tmp_moved_constant_505 + jac_blending_inv_2_0_q_3*tmp_moved_constant_506)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_504 + jac_blending_inv_1_0_q_3*tmp_moved_constant_505 + jac_blending_inv_2_0_q_3*tmp_moved_constant_506)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_504 + jac_blending_inv_1_1_q_3*tmp_moved_constant_505 + jac_blending_inv_2_1_q_3*tmp_moved_constant_506)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_504 + jac_blending_inv_1_1_q_3*tmp_moved_constant_505 + jac_blending_inv_2_1_q_3*tmp_moved_constant_506)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_504 + jac_blending_inv_1_2_q_3*tmp_moved_constant_505 + jac_blending_inv_2_2_q_3*tmp_moved_constant_506)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_504 + jac_blending_inv_1_2_q_3*tmp_moved_constant_505 + jac_blending_inv_2_2_q_3*tmp_moved_constant_506))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_507 + jac_blending_inv_1_0_q_4*tmp_moved_constant_508 + jac_blending_inv_2_0_q_4*tmp_moved_constant_509)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_507 + jac_blending_inv_1_0_q_4*tmp_moved_constant_508 + jac_blending_inv_2_0_q_4*tmp_moved_constant_509)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_507 + jac_blending_inv_1_1_q_4*tmp_moved_constant_508 + jac_blending_inv_2_1_q_4*tmp_moved_constant_509)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_507 + jac_blending_inv_1_1_q_4*tmp_moved_constant_508 + jac_blending_inv_2_1_q_4*tmp_moved_constant_509)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_507 + jac_blending_inv_1_2_q_4*tmp_moved_constant_508 + jac_blending_inv_2_2_q_4*tmp_moved_constant_509)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_507 + jac_blending_inv_1_2_q_4*tmp_moved_constant_508 + jac_blending_inv_2_2_q_4*tmp_moved_constant_509))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_495 + jac_blending_inv_1_0_q_0*tmp_moved_constant_496 + jac_blending_inv_2_0_q_0*tmp_moved_constant_497)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_495 + jac_blending_inv_1_0_q_0*tmp_moved_constant_496 + jac_blending_inv_2_0_q_0*tmp_moved_constant_497)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_495 + jac_blending_inv_1_1_q_0*tmp_moved_constant_496 + jac_blending_inv_2_1_q_0*tmp_moved_constant_497)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_495 + jac_blending_inv_1_1_q_0*tmp_moved_constant_496 + jac_blending_inv_2_1_q_0*tmp_moved_constant_497)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_495 + jac_blending_inv_1_2_q_0*tmp_moved_constant_496 + jac_blending_inv_2_2_q_0*tmp_moved_constant_497)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_495 + jac_blending_inv_1_2_q_0*tmp_moved_constant_496 + jac_blending_inv_2_2_q_0*tmp_moved_constant_497)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_513 + jac_blending_inv_1_0_q_1*tmp_moved_constant_514 + jac_blending_inv_2_0_q_1*tmp_moved_constant_515)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_513 + jac_blending_inv_1_0_q_1*tmp_moved_constant_514 + jac_blending_inv_2_0_q_1*tmp_moved_constant_515)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_513 + jac_blending_inv_1_1_q_1*tmp_moved_constant_514 + jac_blending_inv_2_1_q_1*tmp_moved_constant_515)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_513 + jac_blending_inv_1_1_q_1*tmp_moved_constant_514 + jac_blending_inv_2_1_q_1*tmp_moved_constant_515)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_513 + jac_blending_inv_1_2_q_1*tmp_moved_constant_514 + jac_blending_inv_2_2_q_1*tmp_moved_constant_515)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_513 + jac_blending_inv_1_2_q_1*tmp_moved_constant_514 + jac_blending_inv_2_2_q_1*tmp_moved_constant_515))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_516 + jac_blending_inv_1_0_q_2*tmp_moved_constant_517 + jac_blending_inv_2_0_q_2*tmp_moved_constant_518)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_516 + jac_blending_inv_1_0_q_2*tmp_moved_constant_517 + jac_blending_inv_2_0_q_2*tmp_moved_constant_518)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_516 + jac_blending_inv_1_1_q_2*tmp_moved_constant_517 + jac_blending_inv_2_1_q_2*tmp_moved_constant_518)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_516 + jac_blending_inv_1_1_q_2*tmp_moved_constant_517 + jac_blending_inv_2_1_q_2*tmp_moved_constant_518)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_516 + jac_blending_inv_1_2_q_2*tmp_moved_constant_517 + jac_blending_inv_2_2_q_2*tmp_moved_constant_518)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_516 + jac_blending_inv_1_2_q_2*tmp_moved_constant_517 + jac_blending_inv_2_2_q_2*tmp_moved_constant_518))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_519 + jac_blending_inv_1_0_q_3*tmp_moved_constant_520 + jac_blending_inv_2_0_q_3*tmp_moved_constant_521)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_519 + jac_blending_inv_1_0_q_3*tmp_moved_constant_520 + jac_blending_inv_2_0_q_3*tmp_moved_constant_521)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_519 + jac_blending_inv_1_1_q_3*tmp_moved_constant_520 + jac_blending_inv_2_1_q_3*tmp_moved_constant_521)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_519 + jac_blending_inv_1_1_q_3*tmp_moved_constant_520 + jac_blending_inv_2_1_q_3*tmp_moved_constant_521)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_519 + jac_blending_inv_1_2_q_3*tmp_moved_constant_520 + jac_blending_inv_2_2_q_3*tmp_moved_constant_521)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_519 + jac_blending_inv_1_2_q_3*tmp_moved_constant_520 + jac_blending_inv_2_2_q_3*tmp_moved_constant_521))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_522 + jac_blending_inv_1_0_q_4*tmp_moved_constant_523 + jac_blending_inv_2_0_q_4*tmp_moved_constant_524)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_522 + jac_blending_inv_1_0_q_4*tmp_moved_constant_523 + jac_blending_inv_2_0_q_4*tmp_moved_constant_524)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_522 + jac_blending_inv_1_1_q_4*tmp_moved_constant_523 + jac_blending_inv_2_1_q_4*tmp_moved_constant_524)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_522 + jac_blending_inv_1_1_q_4*tmp_moved_constant_523 + jac_blending_inv_2_1_q_4*tmp_moved_constant_524)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_522 + jac_blending_inv_1_2_q_4*tmp_moved_constant_523 + jac_blending_inv_2_2_q_4*tmp_moved_constant_524)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_522 + jac_blending_inv_1_2_q_4*tmp_moved_constant_523 + jac_blending_inv_2_2_q_4*tmp_moved_constant_524))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_510 + jac_blending_inv_1_0_q_0*tmp_moved_constant_511 + jac_blending_inv_2_0_q_0*tmp_moved_constant_512)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_510 + jac_blending_inv_1_0_q_0*tmp_moved_constant_511 + jac_blending_inv_2_0_q_0*tmp_moved_constant_512)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_510 + jac_blending_inv_1_1_q_0*tmp_moved_constant_511 + jac_blending_inv_2_1_q_0*tmp_moved_constant_512)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_510 + jac_blending_inv_1_1_q_0*tmp_moved_constant_511 + jac_blending_inv_2_1_q_0*tmp_moved_constant_512)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_510 + jac_blending_inv_1_2_q_0*tmp_moved_constant_511 + jac_blending_inv_2_2_q_0*tmp_moved_constant_512)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_510 + jac_blending_inv_1_2_q_0*tmp_moved_constant_511 + jac_blending_inv_2_2_q_0*tmp_moved_constant_512)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_528 + jac_blending_inv_1_0_q_1*tmp_moved_constant_529 + jac_blending_inv_2_0_q_1*tmp_moved_constant_530)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_528 + jac_blending_inv_1_0_q_1*tmp_moved_constant_529 + jac_blending_inv_2_0_q_1*tmp_moved_constant_530)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_528 + jac_blending_inv_1_1_q_1*tmp_moved_constant_529 + jac_blending_inv_2_1_q_1*tmp_moved_constant_530)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_528 + jac_blending_inv_1_1_q_1*tmp_moved_constant_529 + jac_blending_inv_2_1_q_1*tmp_moved_constant_530)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_528 + jac_blending_inv_1_2_q_1*tmp_moved_constant_529 + jac_blending_inv_2_2_q_1*tmp_moved_constant_530)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_528 + jac_blending_inv_1_2_q_1*tmp_moved_constant_529 + jac_blending_inv_2_2_q_1*tmp_moved_constant_530))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_531 + jac_blending_inv_1_0_q_2*tmp_moved_constant_532 + jac_blending_inv_2_0_q_2*tmp_moved_constant_533)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_531 + jac_blending_inv_1_0_q_2*tmp_moved_constant_532 + jac_blending_inv_2_0_q_2*tmp_moved_constant_533)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_531 + jac_blending_inv_1_1_q_2*tmp_moved_constant_532 + jac_blending_inv_2_1_q_2*tmp_moved_constant_533)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_531 + jac_blending_inv_1_1_q_2*tmp_moved_constant_532 + jac_blending_inv_2_1_q_2*tmp_moved_constant_533)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_531 + jac_blending_inv_1_2_q_2*tmp_moved_constant_532 + jac_blending_inv_2_2_q_2*tmp_moved_constant_533)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_531 + jac_blending_inv_1_2_q_2*tmp_moved_constant_532 + jac_blending_inv_2_2_q_2*tmp_moved_constant_533))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_534 + jac_blending_inv_1_0_q_3*tmp_moved_constant_535 + jac_blending_inv_2_0_q_3*tmp_moved_constant_536)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_534 + jac_blending_inv_1_0_q_3*tmp_moved_constant_535 + jac_blending_inv_2_0_q_3*tmp_moved_constant_536)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_534 + jac_blending_inv_1_1_q_3*tmp_moved_constant_535 + jac_blending_inv_2_1_q_3*tmp_moved_constant_536)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_534 + jac_blending_inv_1_1_q_3*tmp_moved_constant_535 + jac_blending_inv_2_1_q_3*tmp_moved_constant_536)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_534 + jac_blending_inv_1_2_q_3*tmp_moved_constant_535 + jac_blending_inv_2_2_q_3*tmp_moved_constant_536)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_534 + jac_blending_inv_1_2_q_3*tmp_moved_constant_535 + jac_blending_inv_2_2_q_3*tmp_moved_constant_536))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_538 + jac_blending_inv_2_0_q_4*tmp_moved_constant_539)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_537 + jac_blending_inv_1_0_q_4*tmp_moved_constant_538 + jac_blending_inv_2_0_q_4*tmp_moved_constant_539)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_538 + jac_blending_inv_2_1_q_4*tmp_moved_constant_539)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_537 + jac_blending_inv_1_1_q_4*tmp_moved_constant_538 + jac_blending_inv_2_1_q_4*tmp_moved_constant_539)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_538 + jac_blending_inv_2_2_q_4*tmp_moved_constant_539)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_537 + jac_blending_inv_1_2_q_4*tmp_moved_constant_538 + jac_blending_inv_2_2_q_4*tmp_moved_constant_539))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_525 + jac_blending_inv_1_0_q_0*tmp_moved_constant_526 + jac_blending_inv_2_0_q_0*tmp_moved_constant_527)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_525 + jac_blending_inv_1_0_q_0*tmp_moved_constant_526 + jac_blending_inv_2_0_q_0*tmp_moved_constant_527)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_525 + jac_blending_inv_1_1_q_0*tmp_moved_constant_526 + jac_blending_inv_2_1_q_0*tmp_moved_constant_527)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_525 + jac_blending_inv_1_1_q_0*tmp_moved_constant_526 + jac_blending_inv_2_1_q_0*tmp_moved_constant_527)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_525 + jac_blending_inv_1_2_q_0*tmp_moved_constant_526 + jac_blending_inv_2_2_q_0*tmp_moved_constant_527)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_525 + jac_blending_inv_1_2_q_0*tmp_moved_constant_526 + jac_blending_inv_2_2_q_0*tmp_moved_constant_527)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_551 + jac_blending_inv_1_0_q_1*tmp_moved_constant_554 + jac_blending_inv_2_0_q_1*tmp_moved_constant_557)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_551 + jac_blending_inv_1_0_q_1*tmp_moved_constant_554 + jac_blending_inv_2_0_q_1*tmp_moved_constant_557)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_551 + jac_blending_inv_1_1_q_1*tmp_moved_constant_554 + jac_blending_inv_2_1_q_1*tmp_moved_constant_557)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_551 + jac_blending_inv_1_1_q_1*tmp_moved_constant_554 + jac_blending_inv_2_1_q_1*tmp_moved_constant_557)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_551 + jac_blending_inv_1_2_q_1*tmp_moved_constant_554 + jac_blending_inv_2_2_q_1*tmp_moved_constant_557)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_551 + jac_blending_inv_1_2_q_1*tmp_moved_constant_554 + jac_blending_inv_2_2_q_1*tmp_moved_constant_557))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_560 + jac_blending_inv_1_0_q_2*tmp_moved_constant_563 + jac_blending_inv_2_0_q_2*tmp_moved_constant_566)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_560 + jac_blending_inv_1_0_q_2*tmp_moved_constant_563 + jac_blending_inv_2_0_q_2*tmp_moved_constant_566)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_560 + jac_blending_inv_1_1_q_2*tmp_moved_constant_563 + jac_blending_inv_2_1_q_2*tmp_moved_constant_566)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_560 + jac_blending_inv_1_1_q_2*tmp_moved_constant_563 + jac_blending_inv_2_1_q_2*tmp_moved_constant_566)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_560 + jac_blending_inv_1_2_q_2*tmp_moved_constant_563 + jac_blending_inv_2_2_q_2*tmp_moved_constant_566)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_560 + jac_blending_inv_1_2_q_2*tmp_moved_constant_563 + jac_blending_inv_2_2_q_2*tmp_moved_constant_566))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_569 + jac_blending_inv_1_0_q_3*tmp_moved_constant_572 + jac_blending_inv_2_0_q_3*tmp_moved_constant_575)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_569 + jac_blending_inv_1_0_q_3*tmp_moved_constant_572 + jac_blending_inv_2_0_q_3*tmp_moved_constant_575)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_569 + jac_blending_inv_1_1_q_3*tmp_moved_constant_572 + jac_blending_inv_2_1_q_3*tmp_moved_constant_575)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_569 + jac_blending_inv_1_1_q_3*tmp_moved_constant_572 + jac_blending_inv_2_1_q_3*tmp_moved_constant_575)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_569 + jac_blending_inv_1_2_q_3*tmp_moved_constant_572 + jac_blending_inv_2_2_q_3*tmp_moved_constant_575)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_569 + jac_blending_inv_1_2_q_3*tmp_moved_constant_572 + jac_blending_inv_2_2_q_3*tmp_moved_constant_575))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_578 + jac_blending_inv_1_0_q_4*tmp_moved_constant_581 + jac_blending_inv_2_0_q_4*tmp_moved_constant_584)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_578 + jac_blending_inv_1_0_q_4*tmp_moved_constant_581 + jac_blending_inv_2_0_q_4*tmp_moved_constant_584)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_578 + jac_blending_inv_1_1_q_4*tmp_moved_constant_581 + jac_blending_inv_2_1_q_4*tmp_moved_constant_584)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_578 + jac_blending_inv_1_1_q_4*tmp_moved_constant_581 + jac_blending_inv_2_1_q_4*tmp_moved_constant_584)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_578 + jac_blending_inv_1_2_q_4*tmp_moved_constant_581 + jac_blending_inv_2_2_q_4*tmp_moved_constant_584)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_578 + jac_blending_inv_1_2_q_4*tmp_moved_constant_581 + jac_blending_inv_2_2_q_4*tmp_moved_constant_584))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_542 + jac_blending_inv_1_0_q_0*tmp_moved_constant_545 + jac_blending_inv_2_0_q_0*tmp_moved_constant_548)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_542 + jac_blending_inv_1_0_q_0*tmp_moved_constant_545 + jac_blending_inv_2_0_q_0*tmp_moved_constant_548)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_542 + jac_blending_inv_1_1_q_0*tmp_moved_constant_545 + jac_blending_inv_2_1_q_0*tmp_moved_constant_548)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_542 + jac_blending_inv_1_1_q_0*tmp_moved_constant_545 + jac_blending_inv_2_1_q_0*tmp_moved_constant_548)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_542 + jac_blending_inv_1_2_q_0*tmp_moved_constant_545 + jac_blending_inv_2_2_q_0*tmp_moved_constant_548)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_542 + jac_blending_inv_1_2_q_0*tmp_moved_constant_545 + jac_blending_inv_2_2_q_0*tmp_moved_constant_548)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_596 + jac_blending_inv_1_0_q_1*tmp_moved_constant_599 + jac_blending_inv_2_0_q_1*tmp_moved_constant_602)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_596 + jac_blending_inv_1_0_q_1*tmp_moved_constant_599 + jac_blending_inv_2_0_q_1*tmp_moved_constant_602)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_596 + jac_blending_inv_1_1_q_1*tmp_moved_constant_599 + jac_blending_inv_2_1_q_1*tmp_moved_constant_602)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_596 + jac_blending_inv_1_1_q_1*tmp_moved_constant_599 + jac_blending_inv_2_1_q_1*tmp_moved_constant_602)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_596 + jac_blending_inv_1_2_q_1*tmp_moved_constant_599 + jac_blending_inv_2_2_q_1*tmp_moved_constant_602)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_596 + jac_blending_inv_1_2_q_1*tmp_moved_constant_599 + jac_blending_inv_2_2_q_1*tmp_moved_constant_602))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_605 + jac_blending_inv_1_0_q_2*tmp_moved_constant_608 + jac_blending_inv_2_0_q_2*tmp_moved_constant_611)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_605 + jac_blending_inv_1_0_q_2*tmp_moved_constant_608 + jac_blending_inv_2_0_q_2*tmp_moved_constant_611)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_605 + jac_blending_inv_1_1_q_2*tmp_moved_constant_608 + jac_blending_inv_2_1_q_2*tmp_moved_constant_611)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_605 + jac_blending_inv_1_1_q_2*tmp_moved_constant_608 + jac_blending_inv_2_1_q_2*tmp_moved_constant_611)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_605 + jac_blending_inv_1_2_q_2*tmp_moved_constant_608 + jac_blending_inv_2_2_q_2*tmp_moved_constant_611)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_605 + jac_blending_inv_1_2_q_2*tmp_moved_constant_608 + jac_blending_inv_2_2_q_2*tmp_moved_constant_611))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_614 + jac_blending_inv_1_0_q_3*tmp_moved_constant_617 + jac_blending_inv_2_0_q_3*tmp_moved_constant_620)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_614 + jac_blending_inv_1_0_q_3*tmp_moved_constant_617 + jac_blending_inv_2_0_q_3*tmp_moved_constant_620)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_614 + jac_blending_inv_1_1_q_3*tmp_moved_constant_617 + jac_blending_inv_2_1_q_3*tmp_moved_constant_620)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_614 + jac_blending_inv_1_1_q_3*tmp_moved_constant_617 + jac_blending_inv_2_1_q_3*tmp_moved_constant_620)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_614 + jac_blending_inv_1_2_q_3*tmp_moved_constant_617 + jac_blending_inv_2_2_q_3*tmp_moved_constant_620)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_614 + jac_blending_inv_1_2_q_3*tmp_moved_constant_617 + jac_blending_inv_2_2_q_3*tmp_moved_constant_620))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_623 + jac_blending_inv_1_0_q_4*tmp_moved_constant_626 + jac_blending_inv_2_0_q_4*tmp_moved_constant_629)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_623 + jac_blending_inv_1_0_q_4*tmp_moved_constant_626 + jac_blending_inv_2_0_q_4*tmp_moved_constant_629)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_623 + jac_blending_inv_1_1_q_4*tmp_moved_constant_626 + jac_blending_inv_2_1_q_4*tmp_moved_constant_629)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_623 + jac_blending_inv_1_1_q_4*tmp_moved_constant_626 + jac_blending_inv_2_1_q_4*tmp_moved_constant_629)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_623 + jac_blending_inv_1_2_q_4*tmp_moved_constant_626 + jac_blending_inv_2_2_q_4*tmp_moved_constant_629)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_623 + jac_blending_inv_1_2_q_4*tmp_moved_constant_626 + jac_blending_inv_2_2_q_4*tmp_moved_constant_629))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_587 + jac_blending_inv_1_0_q_0*tmp_moved_constant_590 + jac_blending_inv_2_0_q_0*tmp_moved_constant_593)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_587 + jac_blending_inv_1_0_q_0*tmp_moved_constant_590 + jac_blending_inv_2_0_q_0*tmp_moved_constant_593)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_587 + jac_blending_inv_1_1_q_0*tmp_moved_constant_590 + jac_blending_inv_2_1_q_0*tmp_moved_constant_593)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_587 + jac_blending_inv_1_1_q_0*tmp_moved_constant_590 + jac_blending_inv_2_1_q_0*tmp_moved_constant_593)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_587 + jac_blending_inv_1_2_q_0*tmp_moved_constant_590 + jac_blending_inv_2_2_q_0*tmp_moved_constant_593)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_587 + jac_blending_inv_1_2_q_0*tmp_moved_constant_590 + jac_blending_inv_2_2_q_0*tmp_moved_constant_593)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_641 + jac_blending_inv_1_0_q_1*tmp_moved_constant_644 + jac_blending_inv_2_0_q_1*tmp_moved_constant_647)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_641 + jac_blending_inv_1_0_q_1*tmp_moved_constant_644 + jac_blending_inv_2_0_q_1*tmp_moved_constant_647)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_641 + jac_blending_inv_1_1_q_1*tmp_moved_constant_644 + jac_blending_inv_2_1_q_1*tmp_moved_constant_647)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_641 + jac_blending_inv_1_1_q_1*tmp_moved_constant_644 + jac_blending_inv_2_1_q_1*tmp_moved_constant_647)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_641 + jac_blending_inv_1_2_q_1*tmp_moved_constant_644 + jac_blending_inv_2_2_q_1*tmp_moved_constant_647)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_641 + jac_blending_inv_1_2_q_1*tmp_moved_constant_644 + jac_blending_inv_2_2_q_1*tmp_moved_constant_647))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_650 + jac_blending_inv_1_0_q_2*tmp_moved_constant_653 + jac_blending_inv_2_0_q_2*tmp_moved_constant_656)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_650 + jac_blending_inv_1_0_q_2*tmp_moved_constant_653 + jac_blending_inv_2_0_q_2*tmp_moved_constant_656)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_650 + jac_blending_inv_1_1_q_2*tmp_moved_constant_653 + jac_blending_inv_2_1_q_2*tmp_moved_constant_656)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_650 + jac_blending_inv_1_1_q_2*tmp_moved_constant_653 + jac_blending_inv_2_1_q_2*tmp_moved_constant_656)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_650 + jac_blending_inv_1_2_q_2*tmp_moved_constant_653 + jac_blending_inv_2_2_q_2*tmp_moved_constant_656)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_650 + jac_blending_inv_1_2_q_2*tmp_moved_constant_653 + jac_blending_inv_2_2_q_2*tmp_moved_constant_656))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_659 + jac_blending_inv_1_0_q_3*tmp_moved_constant_662 + jac_blending_inv_2_0_q_3*tmp_moved_constant_665)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_659 + jac_blending_inv_1_0_q_3*tmp_moved_constant_662 + jac_blending_inv_2_0_q_3*tmp_moved_constant_665)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_659 + jac_blending_inv_1_1_q_3*tmp_moved_constant_662 + jac_blending_inv_2_1_q_3*tmp_moved_constant_665)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_659 + jac_blending_inv_1_1_q_3*tmp_moved_constant_662 + jac_blending_inv_2_1_q_3*tmp_moved_constant_665)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_659 + jac_blending_inv_1_2_q_3*tmp_moved_constant_662 + jac_blending_inv_2_2_q_3*tmp_moved_constant_665)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_659 + jac_blending_inv_1_2_q_3*tmp_moved_constant_662 + jac_blending_inv_2_2_q_3*tmp_moved_constant_665))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_668 + jac_blending_inv_1_0_q_4*tmp_moved_constant_671 + jac_blending_inv_2_0_q_4*tmp_moved_constant_674)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_668 + jac_blending_inv_1_0_q_4*tmp_moved_constant_671 + jac_blending_inv_2_0_q_4*tmp_moved_constant_674)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_668 + jac_blending_inv_1_1_q_4*tmp_moved_constant_671 + jac_blending_inv_2_1_q_4*tmp_moved_constant_674)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_668 + jac_blending_inv_1_1_q_4*tmp_moved_constant_671 + jac_blending_inv_2_1_q_4*tmp_moved_constant_674)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_668 + jac_blending_inv_1_2_q_4*tmp_moved_constant_671 + jac_blending_inv_2_2_q_4*tmp_moved_constant_674)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_668 + jac_blending_inv_1_2_q_4*tmp_moved_constant_671 + jac_blending_inv_2_2_q_4*tmp_moved_constant_674))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_632 + jac_blending_inv_1_0_q_0*tmp_moved_constant_635 + jac_blending_inv_2_0_q_0*tmp_moved_constant_638)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_632 + jac_blending_inv_1_0_q_0*tmp_moved_constant_635 + jac_blending_inv_2_0_q_0*tmp_moved_constant_638)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_632 + jac_blending_inv_1_1_q_0*tmp_moved_constant_635 + jac_blending_inv_2_1_q_0*tmp_moved_constant_638)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_632 + jac_blending_inv_1_1_q_0*tmp_moved_constant_635 + jac_blending_inv_2_1_q_0*tmp_moved_constant_638)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_632 + jac_blending_inv_1_2_q_0*tmp_moved_constant_635 + jac_blending_inv_2_2_q_0*tmp_moved_constant_638)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_632 + jac_blending_inv_1_2_q_0*tmp_moved_constant_635 + jac_blending_inv_2_2_q_0*tmp_moved_constant_638)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_678 + jac_blending_inv_1_0_q_1*tmp_moved_constant_679 + jac_blending_inv_2_0_q_1*tmp_moved_constant_680)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_678 + jac_blending_inv_1_0_q_1*tmp_moved_constant_679 + jac_blending_inv_2_0_q_1*tmp_moved_constant_680)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_678 + jac_blending_inv_1_1_q_1*tmp_moved_constant_679 + jac_blending_inv_2_1_q_1*tmp_moved_constant_680)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_678 + jac_blending_inv_1_1_q_1*tmp_moved_constant_679 + jac_blending_inv_2_1_q_1*tmp_moved_constant_680)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_678 + jac_blending_inv_1_2_q_1*tmp_moved_constant_679 + jac_blending_inv_2_2_q_1*tmp_moved_constant_680)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_678 + jac_blending_inv_1_2_q_1*tmp_moved_constant_679 + jac_blending_inv_2_2_q_1*tmp_moved_constant_680))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_681 + jac_blending_inv_1_0_q_2*tmp_moved_constant_682 + jac_blending_inv_2_0_q_2*tmp_moved_constant_683)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_681 + jac_blending_inv_1_0_q_2*tmp_moved_constant_682 + jac_blending_inv_2_0_q_2*tmp_moved_constant_683)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_681 + jac_blending_inv_1_1_q_2*tmp_moved_constant_682 + jac_blending_inv_2_1_q_2*tmp_moved_constant_683)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_681 + jac_blending_inv_1_1_q_2*tmp_moved_constant_682 + jac_blending_inv_2_1_q_2*tmp_moved_constant_683)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_681 + jac_blending_inv_1_2_q_2*tmp_moved_constant_682 + jac_blending_inv_2_2_q_2*tmp_moved_constant_683)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_681 + jac_blending_inv_1_2_q_2*tmp_moved_constant_682 + jac_blending_inv_2_2_q_2*tmp_moved_constant_683))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_684 + jac_blending_inv_1_0_q_3*tmp_moved_constant_685 + jac_blending_inv_2_0_q_3*tmp_moved_constant_686)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_684 + jac_blending_inv_1_0_q_3*tmp_moved_constant_685 + jac_blending_inv_2_0_q_3*tmp_moved_constant_686)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_684 + jac_blending_inv_1_1_q_3*tmp_moved_constant_685 + jac_blending_inv_2_1_q_3*tmp_moved_constant_686)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_684 + jac_blending_inv_1_1_q_3*tmp_moved_constant_685 + jac_blending_inv_2_1_q_3*tmp_moved_constant_686)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_684 + jac_blending_inv_1_2_q_3*tmp_moved_constant_685 + jac_blending_inv_2_2_q_3*tmp_moved_constant_686)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_684 + jac_blending_inv_1_2_q_3*tmp_moved_constant_685 + jac_blending_inv_2_2_q_3*tmp_moved_constant_686))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_687 + jac_blending_inv_1_0_q_4*tmp_moved_constant_688 + jac_blending_inv_2_0_q_4*tmp_moved_constant_689)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_687 + jac_blending_inv_1_0_q_4*tmp_moved_constant_688 + jac_blending_inv_2_0_q_4*tmp_moved_constant_689)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_687 + jac_blending_inv_1_1_q_4*tmp_moved_constant_688 + jac_blending_inv_2_1_q_4*tmp_moved_constant_689)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_687 + jac_blending_inv_1_1_q_4*tmp_moved_constant_688 + jac_blending_inv_2_1_q_4*tmp_moved_constant_689)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_687 + jac_blending_inv_1_2_q_4*tmp_moved_constant_688 + jac_blending_inv_2_2_q_4*tmp_moved_constant_689)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_687 + jac_blending_inv_1_2_q_4*tmp_moved_constant_688 + jac_blending_inv_2_2_q_4*tmp_moved_constant_689))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_675 + jac_blending_inv_1_0_q_0*tmp_moved_constant_676 + jac_blending_inv_2_0_q_0*tmp_moved_constant_677)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_675 + jac_blending_inv_1_0_q_0*tmp_moved_constant_676 + jac_blending_inv_2_0_q_0*tmp_moved_constant_677)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_675 + jac_blending_inv_1_1_q_0*tmp_moved_constant_676 + jac_blending_inv_2_1_q_0*tmp_moved_constant_677)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_675 + jac_blending_inv_1_1_q_0*tmp_moved_constant_676 + jac_blending_inv_2_1_q_0*tmp_moved_constant_677)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_675 + jac_blending_inv_1_2_q_0*tmp_moved_constant_676 + jac_blending_inv_2_2_q_0*tmp_moved_constant_677)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_675 + jac_blending_inv_1_2_q_0*tmp_moved_constant_676 + jac_blending_inv_2_2_q_0*tmp_moved_constant_677)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_693 + jac_blending_inv_1_0_q_1*tmp_moved_constant_694 + jac_blending_inv_2_0_q_1*tmp_moved_constant_695)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_693 + jac_blending_inv_1_0_q_1*tmp_moved_constant_694 + jac_blending_inv_2_0_q_1*tmp_moved_constant_695)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_693 + jac_blending_inv_1_1_q_1*tmp_moved_constant_694 + jac_blending_inv_2_1_q_1*tmp_moved_constant_695)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_693 + jac_blending_inv_1_1_q_1*tmp_moved_constant_694 + jac_blending_inv_2_1_q_1*tmp_moved_constant_695)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_693 + jac_blending_inv_1_2_q_1*tmp_moved_constant_694 + jac_blending_inv_2_2_q_1*tmp_moved_constant_695)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_693 + jac_blending_inv_1_2_q_1*tmp_moved_constant_694 + jac_blending_inv_2_2_q_1*tmp_moved_constant_695))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_696 + jac_blending_inv_1_0_q_2*tmp_moved_constant_697 + jac_blending_inv_2_0_q_2*tmp_moved_constant_698)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_696 + jac_blending_inv_1_0_q_2*tmp_moved_constant_697 + jac_blending_inv_2_0_q_2*tmp_moved_constant_698)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_696 + jac_blending_inv_1_1_q_2*tmp_moved_constant_697 + jac_blending_inv_2_1_q_2*tmp_moved_constant_698)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_696 + jac_blending_inv_1_1_q_2*tmp_moved_constant_697 + jac_blending_inv_2_1_q_2*tmp_moved_constant_698)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_696 + jac_blending_inv_1_2_q_2*tmp_moved_constant_697 + jac_blending_inv_2_2_q_2*tmp_moved_constant_698)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_696 + jac_blending_inv_1_2_q_2*tmp_moved_constant_697 + jac_blending_inv_2_2_q_2*tmp_moved_constant_698))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_699 + jac_blending_inv_1_0_q_3*tmp_moved_constant_700 + jac_blending_inv_2_0_q_3*tmp_moved_constant_701)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_699 + jac_blending_inv_1_0_q_3*tmp_moved_constant_700 + jac_blending_inv_2_0_q_3*tmp_moved_constant_701)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_699 + jac_blending_inv_1_1_q_3*tmp_moved_constant_700 + jac_blending_inv_2_1_q_3*tmp_moved_constant_701)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_699 + jac_blending_inv_1_1_q_3*tmp_moved_constant_700 + jac_blending_inv_2_1_q_3*tmp_moved_constant_701)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_699 + jac_blending_inv_1_2_q_3*tmp_moved_constant_700 + jac_blending_inv_2_2_q_3*tmp_moved_constant_701)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_699 + jac_blending_inv_1_2_q_3*tmp_moved_constant_700 + jac_blending_inv_2_2_q_3*tmp_moved_constant_701))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_702 + jac_blending_inv_1_0_q_4*tmp_moved_constant_703 + jac_blending_inv_2_0_q_4*tmp_moved_constant_704)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_702 + jac_blending_inv_1_0_q_4*tmp_moved_constant_703 + jac_blending_inv_2_0_q_4*tmp_moved_constant_704)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_702 + jac_blending_inv_1_1_q_4*tmp_moved_constant_703 + jac_blending_inv_2_1_q_4*tmp_moved_constant_704)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_702 + jac_blending_inv_1_1_q_4*tmp_moved_constant_703 + jac_blending_inv_2_1_q_4*tmp_moved_constant_704)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_702 + jac_blending_inv_1_2_q_4*tmp_moved_constant_703 + jac_blending_inv_2_2_q_4*tmp_moved_constant_704)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_702 + jac_blending_inv_1_2_q_4*tmp_moved_constant_703 + jac_blending_inv_2_2_q_4*tmp_moved_constant_704))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_690 + jac_blending_inv_1_0_q_0*tmp_moved_constant_691 + jac_blending_inv_2_0_q_0*tmp_moved_constant_692)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_690 + jac_blending_inv_1_0_q_0*tmp_moved_constant_691 + jac_blending_inv_2_0_q_0*tmp_moved_constant_692)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_690 + jac_blending_inv_1_1_q_0*tmp_moved_constant_691 + jac_blending_inv_2_1_q_0*tmp_moved_constant_692)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_690 + jac_blending_inv_1_1_q_0*tmp_moved_constant_691 + jac_blending_inv_2_1_q_0*tmp_moved_constant_692)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_690 + jac_blending_inv_1_2_q_0*tmp_moved_constant_691 + jac_blending_inv_2_2_q_0*tmp_moved_constant_692)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_690 + jac_blending_inv_1_2_q_0*tmp_moved_constant_691 + jac_blending_inv_2_2_q_0*tmp_moved_constant_692)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_708 + jac_blending_inv_1_0_q_1*tmp_moved_constant_709 + jac_blending_inv_2_0_q_1*tmp_moved_constant_710)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_708 + jac_blending_inv_1_0_q_1*tmp_moved_constant_709 + jac_blending_inv_2_0_q_1*tmp_moved_constant_710)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_708 + jac_blending_inv_1_1_q_1*tmp_moved_constant_709 + jac_blending_inv_2_1_q_1*tmp_moved_constant_710)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_708 + jac_blending_inv_1_1_q_1*tmp_moved_constant_709 + jac_blending_inv_2_1_q_1*tmp_moved_constant_710)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_708 + jac_blending_inv_1_2_q_1*tmp_moved_constant_709 + jac_blending_inv_2_2_q_1*tmp_moved_constant_710)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_708 + jac_blending_inv_1_2_q_1*tmp_moved_constant_709 + jac_blending_inv_2_2_q_1*tmp_moved_constant_710))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_711 + jac_blending_inv_1_0_q_2*tmp_moved_constant_712 + jac_blending_inv_2_0_q_2*tmp_moved_constant_713)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_711 + jac_blending_inv_1_0_q_2*tmp_moved_constant_712 + jac_blending_inv_2_0_q_2*tmp_moved_constant_713)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_711 + jac_blending_inv_1_1_q_2*tmp_moved_constant_712 + jac_blending_inv_2_1_q_2*tmp_moved_constant_713)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_711 + jac_blending_inv_1_1_q_2*tmp_moved_constant_712 + jac_blending_inv_2_1_q_2*tmp_moved_constant_713)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_711 + jac_blending_inv_1_2_q_2*tmp_moved_constant_712 + jac_blending_inv_2_2_q_2*tmp_moved_constant_713)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_711 + jac_blending_inv_1_2_q_2*tmp_moved_constant_712 + jac_blending_inv_2_2_q_2*tmp_moved_constant_713))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_714 + jac_blending_inv_1_0_q_3*tmp_moved_constant_715 + jac_blending_inv_2_0_q_3*tmp_moved_constant_716)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_714 + jac_blending_inv_1_0_q_3*tmp_moved_constant_715 + jac_blending_inv_2_0_q_3*tmp_moved_constant_716)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_714 + jac_blending_inv_1_1_q_3*tmp_moved_constant_715 + jac_blending_inv_2_1_q_3*tmp_moved_constant_716)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_714 + jac_blending_inv_1_1_q_3*tmp_moved_constant_715 + jac_blending_inv_2_1_q_3*tmp_moved_constant_716)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_714 + jac_blending_inv_1_2_q_3*tmp_moved_constant_715 + jac_blending_inv_2_2_q_3*tmp_moved_constant_716)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_714 + jac_blending_inv_1_2_q_3*tmp_moved_constant_715 + jac_blending_inv_2_2_q_3*tmp_moved_constant_716))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_717 + jac_blending_inv_1_0_q_4*tmp_moved_constant_718 + jac_blending_inv_2_0_q_4*tmp_moved_constant_719)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_717 + jac_blending_inv_1_0_q_4*tmp_moved_constant_718 + jac_blending_inv_2_0_q_4*tmp_moved_constant_719)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_717 + jac_blending_inv_1_1_q_4*tmp_moved_constant_718 + jac_blending_inv_2_1_q_4*tmp_moved_constant_719)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_717 + jac_blending_inv_1_1_q_4*tmp_moved_constant_718 + jac_blending_inv_2_1_q_4*tmp_moved_constant_719)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_717 + jac_blending_inv_1_2_q_4*tmp_moved_constant_718 + jac_blending_inv_2_2_q_4*tmp_moved_constant_719)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_717 + jac_blending_inv_1_2_q_4*tmp_moved_constant_718 + jac_blending_inv_2_2_q_4*tmp_moved_constant_719))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_705 + jac_blending_inv_1_0_q_0*tmp_moved_constant_706 + jac_blending_inv_2_0_q_0*tmp_moved_constant_707)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_705 + jac_blending_inv_1_0_q_0*tmp_moved_constant_706 + jac_blending_inv_2_0_q_0*tmp_moved_constant_707)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_705 + jac_blending_inv_1_1_q_0*tmp_moved_constant_706 + jac_blending_inv_2_1_q_0*tmp_moved_constant_707)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_705 + jac_blending_inv_1_1_q_0*tmp_moved_constant_706 + jac_blending_inv_2_1_q_0*tmp_moved_constant_707)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_705 + jac_blending_inv_1_2_q_0*tmp_moved_constant_706 + jac_blending_inv_2_2_q_0*tmp_moved_constant_707)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_705 + jac_blending_inv_1_2_q_0*tmp_moved_constant_706 + jac_blending_inv_2_2_q_0*tmp_moved_constant_707)));
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const real_t tmp_moved_constant_720 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_721 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_722 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_4 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_4;
       const real_t tmp_moved_constant_723 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_724 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_725 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_13 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_13;
       const real_t tmp_moved_constant_726 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_727 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_728 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_22 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_22;
       const real_t tmp_moved_constant_729 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_730 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_731 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_31 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_31;
       const real_t tmp_moved_constant_732 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_733 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_734 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_40 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_40;
       const real_t tmp_moved_constant_735 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_736 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_737 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_45;
       const real_t tmp_moved_constant_738 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_739 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_740 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_49;
       const real_t tmp_moved_constant_741 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_742 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_743 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_53;
       const real_t tmp_moved_constant_744 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_745 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_746 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_57;
       const real_t tmp_moved_constant_747 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_748 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_749 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_61;
       const real_t tmp_moved_constant_750 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_751 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_752 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_65;
       const real_t tmp_moved_constant_753 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_754 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_755 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_69;
       const real_t tmp_moved_constant_756 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_757 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_758 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_73;
       const real_t tmp_moved_constant_759 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_760 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_761 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_77;
       const real_t tmp_moved_constant_762 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_763 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_764 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_81;
       const real_t tmp_moved_constant_765 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_766 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_767 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_85;
       const real_t tmp_moved_constant_768 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_769 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_770 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_89;
       const real_t tmp_moved_constant_771 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_772 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_773 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_93;
       const real_t tmp_moved_constant_774 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_775 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_776 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_97;
       const real_t tmp_moved_constant_777 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_778 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_779 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_101;
       const real_t tmp_moved_constant_780 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_781 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_782 = tmp_moved_constant_780 + tmp_moved_constant_781;
       const real_t tmp_moved_constant_783 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_784 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_785 = tmp_moved_constant_783 + tmp_moved_constant_784;
       const real_t tmp_moved_constant_786 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_787 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_788 = tmp_moved_constant_786 + tmp_moved_constant_787;
       const real_t tmp_moved_constant_789 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_790 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_791 = tmp_moved_constant_789 + tmp_moved_constant_790;
       const real_t tmp_moved_constant_792 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_793 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_794 = tmp_moved_constant_792 + tmp_moved_constant_793;
       const real_t tmp_moved_constant_795 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_796 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_797 = tmp_moved_constant_795 + tmp_moved_constant_796;
       const real_t tmp_moved_constant_798 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_799 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_800 = tmp_moved_constant_798 + tmp_moved_constant_799;
       const real_t tmp_moved_constant_801 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_802 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_803 = tmp_moved_constant_801 + tmp_moved_constant_802;
       const real_t tmp_moved_constant_804 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_805 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_806 = tmp_moved_constant_804 + tmp_moved_constant_805;
       const real_t tmp_moved_constant_807 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_808 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_809 = tmp_moved_constant_807 + tmp_moved_constant_808;
       const real_t tmp_moved_constant_810 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_811 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_812 = tmp_moved_constant_810 + tmp_moved_constant_811;
       const real_t tmp_moved_constant_813 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_814 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_815 = tmp_moved_constant_813 + tmp_moved_constant_814;
       const real_t tmp_moved_constant_816 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_817 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_818 = tmp_moved_constant_816 + tmp_moved_constant_817;
       const real_t tmp_moved_constant_819 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_820 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_821 = tmp_moved_constant_819 + tmp_moved_constant_820;
       const real_t tmp_moved_constant_822 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_823 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_824 = tmp_moved_constant_822 + tmp_moved_constant_823;
       const real_t tmp_moved_constant_825 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_826 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_827 = tmp_moved_constant_825 + tmp_moved_constant_826;
       const real_t tmp_moved_constant_828 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_829 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_830 = tmp_moved_constant_828 + tmp_moved_constant_829;
       const real_t tmp_moved_constant_831 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_0;
       const real_t tmp_moved_constant_832 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_833 = tmp_moved_constant_831 + tmp_moved_constant_832;
       const real_t tmp_moved_constant_834 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_835 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_836 = tmp_moved_constant_834 + tmp_moved_constant_835;
       const real_t tmp_moved_constant_837 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_838 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_839 = tmp_moved_constant_837 + tmp_moved_constant_838;
       const real_t tmp_moved_constant_840 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_9;
       const real_t tmp_moved_constant_841 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_842 = tmp_moved_constant_840 + tmp_moved_constant_841;
       const real_t tmp_moved_constant_843 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_844 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_845 = tmp_moved_constant_843 + tmp_moved_constant_844;
       const real_t tmp_moved_constant_846 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_847 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_848 = tmp_moved_constant_846 + tmp_moved_constant_847;
       const real_t tmp_moved_constant_849 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_18;
       const real_t tmp_moved_constant_850 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_851 = tmp_moved_constant_849 + tmp_moved_constant_850;
       const real_t tmp_moved_constant_852 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_853 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_854 = tmp_moved_constant_852 + tmp_moved_constant_853;
       const real_t tmp_moved_constant_855 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_856 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_857 = tmp_moved_constant_855 + tmp_moved_constant_856;
       const real_t tmp_moved_constant_858 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_27;
       const real_t tmp_moved_constant_859 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_860 = tmp_moved_constant_858 + tmp_moved_constant_859;
       const real_t tmp_moved_constant_861 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_862 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_863 = tmp_moved_constant_861 + tmp_moved_constant_862;
       const real_t tmp_moved_constant_864 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_865 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_866 = tmp_moved_constant_864 + tmp_moved_constant_865;
       const real_t tmp_moved_constant_867 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_36;
       const real_t tmp_moved_constant_868 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_869 = tmp_moved_constant_867 + tmp_moved_constant_868;
       const real_t tmp_moved_constant_870 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_871 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_872 = tmp_moved_constant_870 + tmp_moved_constant_871;
       const real_t tmp_moved_constant_873 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_874 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_875 = tmp_moved_constant_873 + tmp_moved_constant_874;
       const real_t tmp_moved_constant_876 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_2;
       const real_t tmp_moved_constant_877 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_1;
       const real_t tmp_moved_constant_878 = tmp_moved_constant_876 + tmp_moved_constant_877;
       const real_t tmp_moved_constant_879 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_880 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_881 = tmp_moved_constant_879 + tmp_moved_constant_880;
       const real_t tmp_moved_constant_882 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_883 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_884 = tmp_moved_constant_882 + tmp_moved_constant_883;
       const real_t tmp_moved_constant_885 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_11;
       const real_t tmp_moved_constant_886 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_10;
       const real_t tmp_moved_constant_887 = tmp_moved_constant_885 + tmp_moved_constant_886;
       const real_t tmp_moved_constant_888 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_889 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_890 = tmp_moved_constant_888 + tmp_moved_constant_889;
       const real_t tmp_moved_constant_891 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_892 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_893 = tmp_moved_constant_891 + tmp_moved_constant_892;
       const real_t tmp_moved_constant_894 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_20;
       const real_t tmp_moved_constant_895 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_19;
       const real_t tmp_moved_constant_896 = tmp_moved_constant_894 + tmp_moved_constant_895;
       const real_t tmp_moved_constant_897 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_898 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_899 = tmp_moved_constant_897 + tmp_moved_constant_898;
       const real_t tmp_moved_constant_900 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_901 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_902 = tmp_moved_constant_900 + tmp_moved_constant_901;
       const real_t tmp_moved_constant_903 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_29;
       const real_t tmp_moved_constant_904 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_28;
       const real_t tmp_moved_constant_905 = tmp_moved_constant_903 + tmp_moved_constant_904;
       const real_t tmp_moved_constant_906 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_907 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_908 = tmp_moved_constant_906 + tmp_moved_constant_907;
       const real_t tmp_moved_constant_909 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_910 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_911 = tmp_moved_constant_909 + tmp_moved_constant_910;
       const real_t tmp_moved_constant_912 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_38;
       const real_t tmp_moved_constant_913 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_37;
       const real_t tmp_moved_constant_914 = tmp_moved_constant_912 + tmp_moved_constant_913;
       const real_t tmp_moved_constant_915 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_240 - tmp_moved_constant_780 - tmp_moved_constant_825;
       const real_t tmp_moved_constant_916 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_240 - tmp_moved_constant_783 - tmp_moved_constant_828;
       const real_t tmp_moved_constant_917 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_240 - tmp_moved_constant_786 - tmp_moved_constant_831;
       const real_t tmp_moved_constant_918 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_244 - tmp_moved_constant_789 - tmp_moved_constant_834;
       const real_t tmp_moved_constant_919 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_244 - tmp_moved_constant_792 - tmp_moved_constant_837;
       const real_t tmp_moved_constant_920 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_244 - tmp_moved_constant_795 - tmp_moved_constant_840;
       const real_t tmp_moved_constant_921 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_248 - tmp_moved_constant_798 - tmp_moved_constant_843;
       const real_t tmp_moved_constant_922 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_248 - tmp_moved_constant_801 - tmp_moved_constant_846;
       const real_t tmp_moved_constant_923 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_248 - tmp_moved_constant_804 - tmp_moved_constant_849;
       const real_t tmp_moved_constant_924 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_252 - tmp_moved_constant_807 - tmp_moved_constant_852;
       const real_t tmp_moved_constant_925 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_252 - tmp_moved_constant_810 - tmp_moved_constant_855;
       const real_t tmp_moved_constant_926 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_252 - tmp_moved_constant_813 - tmp_moved_constant_858;
       const real_t tmp_moved_constant_927 = jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_256 - tmp_moved_constant_816 - tmp_moved_constant_861;
       const real_t tmp_moved_constant_928 = jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_256 - tmp_moved_constant_819 - tmp_moved_constant_864;
       const real_t tmp_moved_constant_929 = jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_256 - tmp_moved_constant_822 - tmp_moved_constant_867;
       const real_t tmp_moved_constant_930 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_261 - tmp_moved_constant_781 - tmp_moved_constant_870;
       const real_t tmp_moved_constant_931 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_261 - tmp_moved_constant_784 - tmp_moved_constant_873;
       const real_t tmp_moved_constant_932 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_261 - tmp_moved_constant_787 - tmp_moved_constant_876;
       const real_t tmp_moved_constant_933 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_266 - tmp_moved_constant_790 - tmp_moved_constant_879;
       const real_t tmp_moved_constant_934 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_266 - tmp_moved_constant_793 - tmp_moved_constant_882;
       const real_t tmp_moved_constant_935 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_266 - tmp_moved_constant_796 - tmp_moved_constant_885;
       const real_t tmp_moved_constant_936 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_271 - tmp_moved_constant_799 - tmp_moved_constant_888;
       const real_t tmp_moved_constant_937 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_271 - tmp_moved_constant_802 - tmp_moved_constant_891;
       const real_t tmp_moved_constant_938 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_271 - tmp_moved_constant_805 - tmp_moved_constant_894;
       const real_t tmp_moved_constant_939 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_276 - tmp_moved_constant_808 - tmp_moved_constant_897;
       const real_t tmp_moved_constant_940 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_276 - tmp_moved_constant_811 - tmp_moved_constant_900;
       const real_t tmp_moved_constant_941 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_276 - tmp_moved_constant_814 - tmp_moved_constant_903;
       const real_t tmp_moved_constant_942 = jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_281 - tmp_moved_constant_817 - tmp_moved_constant_906;
       const real_t tmp_moved_constant_943 = jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_281 - tmp_moved_constant_820 - tmp_moved_constant_909;
       const real_t tmp_moved_constant_944 = jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_281 - tmp_moved_constant_823 - tmp_moved_constant_912;
       const real_t tmp_moved_constant_945 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_285 - tmp_moved_constant_826 - tmp_moved_constant_871;
       const real_t tmp_moved_constant_946 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_285 - tmp_moved_constant_829 - tmp_moved_constant_874;
       const real_t tmp_moved_constant_947 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_285 - tmp_moved_constant_832 - tmp_moved_constant_877;
       const real_t tmp_moved_constant_948 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_289 - tmp_moved_constant_835 - tmp_moved_constant_880;
       const real_t tmp_moved_constant_949 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_289 - tmp_moved_constant_838 - tmp_moved_constant_883;
       const real_t tmp_moved_constant_950 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_289 - tmp_moved_constant_841 - tmp_moved_constant_886;
       const real_t tmp_moved_constant_951 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_293 - tmp_moved_constant_844 - tmp_moved_constant_889;
       const real_t tmp_moved_constant_952 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_293 - tmp_moved_constant_847 - tmp_moved_constant_892;
       const real_t tmp_moved_constant_953 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_293 - tmp_moved_constant_850 - tmp_moved_constant_895;
       const real_t tmp_moved_constant_954 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_297 - tmp_moved_constant_853 - tmp_moved_constant_898;
       const real_t tmp_moved_constant_955 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_297 - tmp_moved_constant_856 - tmp_moved_constant_901;
       const real_t tmp_moved_constant_956 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_297 - tmp_moved_constant_859 - tmp_moved_constant_904;
       const real_t tmp_moved_constant_957 = jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_301 - tmp_moved_constant_862 - tmp_moved_constant_907;
       const real_t tmp_moved_constant_958 = jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_301 - tmp_moved_constant_865 - tmp_moved_constant_910;
       const real_t tmp_moved_constant_959 = jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_301 - tmp_moved_constant_868 - tmp_moved_constant_913;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720,tmp_moved_constant_720)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721,tmp_moved_constant_721))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722,tmp_moved_constant_722)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723,tmp_moved_constant_723)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724,tmp_moved_constant_724))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725,tmp_moved_constant_725))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726,tmp_moved_constant_726)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727,tmp_moved_constant_727))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728,tmp_moved_constant_728))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729,tmp_moved_constant_729)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730,tmp_moved_constant_730))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731,tmp_moved_constant_731))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732,tmp_moved_constant_732)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733,tmp_moved_constant_733))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734,tmp_moved_constant_734)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735,tmp_moved_constant_735)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736,tmp_moved_constant_736))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737,tmp_moved_constant_737)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738,tmp_moved_constant_738)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739,tmp_moved_constant_739))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740,tmp_moved_constant_740))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741,tmp_moved_constant_741)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742,tmp_moved_constant_742))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743,tmp_moved_constant_743))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744,tmp_moved_constant_744)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745,tmp_moved_constant_745))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746,tmp_moved_constant_746))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747,tmp_moved_constant_747)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748,tmp_moved_constant_748))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749,tmp_moved_constant_749)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750,tmp_moved_constant_750)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751,tmp_moved_constant_751))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752,tmp_moved_constant_752)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753,tmp_moved_constant_753)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754,tmp_moved_constant_754))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755,tmp_moved_constant_755))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756,tmp_moved_constant_756)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757,tmp_moved_constant_757))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758,tmp_moved_constant_758))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759,tmp_moved_constant_759)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760,tmp_moved_constant_760))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761,tmp_moved_constant_761))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762,tmp_moved_constant_762)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763,tmp_moved_constant_763))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764,tmp_moved_constant_764)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765,tmp_moved_constant_765)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766,tmp_moved_constant_766))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767,tmp_moved_constant_767)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768,tmp_moved_constant_768)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769,tmp_moved_constant_769))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770,tmp_moved_constant_770))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771,tmp_moved_constant_771)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772,tmp_moved_constant_772))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773,tmp_moved_constant_773))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774,tmp_moved_constant_774)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775,tmp_moved_constant_775))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776,tmp_moved_constant_776))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777,tmp_moved_constant_777)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778,tmp_moved_constant_778))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779,tmp_moved_constant_779)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782,tmp_moved_constant_782)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785,tmp_moved_constant_785))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788,tmp_moved_constant_788)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791,tmp_moved_constant_791)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794,tmp_moved_constant_794))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797,tmp_moved_constant_797))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800,tmp_moved_constant_800)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803,tmp_moved_constant_803))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806,tmp_moved_constant_806))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809,tmp_moved_constant_809)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812,tmp_moved_constant_812))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815,tmp_moved_constant_815))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818,tmp_moved_constant_818)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821,tmp_moved_constant_821))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824,tmp_moved_constant_824)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827,tmp_moved_constant_827)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830,tmp_moved_constant_830))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833,tmp_moved_constant_833)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836,tmp_moved_constant_836)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839,tmp_moved_constant_839))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842,tmp_moved_constant_842))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845,tmp_moved_constant_845)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848,tmp_moved_constant_848))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851,tmp_moved_constant_851))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854,tmp_moved_constant_854)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857,tmp_moved_constant_857))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860,tmp_moved_constant_860))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863,tmp_moved_constant_863)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866,tmp_moved_constant_866))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869,tmp_moved_constant_869)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872,tmp_moved_constant_872)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875,tmp_moved_constant_875))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878,tmp_moved_constant_878)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881,tmp_moved_constant_881)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884,tmp_moved_constant_884))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887,tmp_moved_constant_887))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890,tmp_moved_constant_890)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893,tmp_moved_constant_893))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896,tmp_moved_constant_896))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899,tmp_moved_constant_899)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902,tmp_moved_constant_902))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905,tmp_moved_constant_905))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908,tmp_moved_constant_908)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911,tmp_moved_constant_911))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914,tmp_moved_constant_914)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915,tmp_moved_constant_915)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916,tmp_moved_constant_916))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917,tmp_moved_constant_917)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918,tmp_moved_constant_918)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919,tmp_moved_constant_919))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920,tmp_moved_constant_920))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921,tmp_moved_constant_921)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922,tmp_moved_constant_922))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923,tmp_moved_constant_923))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924,tmp_moved_constant_924)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925,tmp_moved_constant_925))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926,tmp_moved_constant_926))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927,tmp_moved_constant_927)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928,tmp_moved_constant_928))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929,tmp_moved_constant_929)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930,tmp_moved_constant_930)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931,tmp_moved_constant_931))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932,tmp_moved_constant_932)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933,tmp_moved_constant_933)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934,tmp_moved_constant_934))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935,tmp_moved_constant_935))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936,tmp_moved_constant_936)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937,tmp_moved_constant_937))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938,tmp_moved_constant_938))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939,tmp_moved_constant_939)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940,tmp_moved_constant_940))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941,tmp_moved_constant_941))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942,tmp_moved_constant_942)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943,tmp_moved_constant_943))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944,tmp_moved_constant_944)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945,tmp_moved_constant_945)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946,tmp_moved_constant_946))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947,tmp_moved_constant_947)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948,tmp_moved_constant_948)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949,tmp_moved_constant_949))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950,tmp_moved_constant_950))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951,tmp_moved_constant_951)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952,tmp_moved_constant_952))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953,tmp_moved_constant_953))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954,tmp_moved_constant_954)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955,tmp_moved_constant_955))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956,tmp_moved_constant_956))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957,tmp_moved_constant_957)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958,tmp_moved_constant_958))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959,tmp_moved_constant_959)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_GREEN_UP*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_723 + jac_blending_inv_1_0_q_1*tmp_moved_constant_724 + jac_blending_inv_2_0_q_1*tmp_moved_constant_725)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_723 + jac_blending_inv_1_0_q_1*tmp_moved_constant_724 + jac_blending_inv_2_0_q_1*tmp_moved_constant_725)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_723 + jac_blending_inv_1_1_q_1*tmp_moved_constant_724 + jac_blending_inv_2_1_q_1*tmp_moved_constant_725)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_723 + jac_blending_inv_1_1_q_1*tmp_moved_constant_724 + jac_blending_inv_2_1_q_1*tmp_moved_constant_725)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_723 + jac_blending_inv_1_2_q_1*tmp_moved_constant_724 + jac_blending_inv_2_2_q_1*tmp_moved_constant_725)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_723 + jac_blending_inv_1_2_q_1*tmp_moved_constant_724 + jac_blending_inv_2_2_q_1*tmp_moved_constant_725))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_726 + jac_blending_inv_1_0_q_2*tmp_moved_constant_727 + jac_blending_inv_2_0_q_2*tmp_moved_constant_728)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_726 + jac_blending_inv_1_0_q_2*tmp_moved_constant_727 + jac_blending_inv_2_0_q_2*tmp_moved_constant_728)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_726 + jac_blending_inv_1_1_q_2*tmp_moved_constant_727 + jac_blending_inv_2_1_q_2*tmp_moved_constant_728)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_726 + jac_blending_inv_1_1_q_2*tmp_moved_constant_727 + jac_blending_inv_2_1_q_2*tmp_moved_constant_728)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_726 + jac_blending_inv_1_2_q_2*tmp_moved_constant_727 + jac_blending_inv_2_2_q_2*tmp_moved_constant_728)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_726 + jac_blending_inv_1_2_q_2*tmp_moved_constant_727 + jac_blending_inv_2_2_q_2*tmp_moved_constant_728))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_729 + jac_blending_inv_1_0_q_3*tmp_moved_constant_730 + jac_blending_inv_2_0_q_3*tmp_moved_constant_731)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_729 + jac_blending_inv_1_0_q_3*tmp_moved_constant_730 + jac_blending_inv_2_0_q_3*tmp_moved_constant_731)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_729 + jac_blending_inv_1_1_q_3*tmp_moved_constant_730 + jac_blending_inv_2_1_q_3*tmp_moved_constant_731)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_729 + jac_blending_inv_1_1_q_3*tmp_moved_constant_730 + jac_blending_inv_2_1_q_3*tmp_moved_constant_731)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_729 + jac_blending_inv_1_2_q_3*tmp_moved_constant_730 + jac_blending_inv_2_2_q_3*tmp_moved_constant_731)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_729 + jac_blending_inv_1_2_q_3*tmp_moved_constant_730 + jac_blending_inv_2_2_q_3*tmp_moved_constant_731))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_732 + jac_blending_inv_1_0_q_4*tmp_moved_constant_733 + jac_blending_inv_2_0_q_4*tmp_moved_constant_734)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_732 + jac_blending_inv_1_0_q_4*tmp_moved_constant_733 + jac_blending_inv_2_0_q_4*tmp_moved_constant_734)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_732 + jac_blending_inv_1_1_q_4*tmp_moved_constant_733 + jac_blending_inv_2_1_q_4*tmp_moved_constant_734)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_732 + jac_blending_inv_1_1_q_4*tmp_moved_constant_733 + jac_blending_inv_2_1_q_4*tmp_moved_constant_734)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_732 + jac_blending_inv_1_2_q_4*tmp_moved_constant_733 + jac_blending_inv_2_2_q_4*tmp_moved_constant_734)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_732 + jac_blending_inv_1_2_q_4*tmp_moved_constant_733 + jac_blending_inv_2_2_q_4*tmp_moved_constant_734))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_720 + jac_blending_inv_1_0_q_0*tmp_moved_constant_721 + jac_blending_inv_2_0_q_0*tmp_moved_constant_722)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_720 + jac_blending_inv_1_0_q_0*tmp_moved_constant_721 + jac_blending_inv_2_0_q_0*tmp_moved_constant_722)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_720 + jac_blending_inv_1_1_q_0*tmp_moved_constant_721 + jac_blending_inv_2_1_q_0*tmp_moved_constant_722)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_720 + jac_blending_inv_1_1_q_0*tmp_moved_constant_721 + jac_blending_inv_2_1_q_0*tmp_moved_constant_722)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_720 + jac_blending_inv_1_2_q_0*tmp_moved_constant_721 + jac_blending_inv_2_2_q_0*tmp_moved_constant_722)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_720 + jac_blending_inv_1_2_q_0*tmp_moved_constant_721 + jac_blending_inv_2_2_q_0*tmp_moved_constant_722)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_738 + jac_blending_inv_1_0_q_1*tmp_moved_constant_739 + jac_blending_inv_2_0_q_1*tmp_moved_constant_740)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_738 + jac_blending_inv_1_0_q_1*tmp_moved_constant_739 + jac_blending_inv_2_0_q_1*tmp_moved_constant_740)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_738 + jac_blending_inv_1_1_q_1*tmp_moved_constant_739 + jac_blending_inv_2_1_q_1*tmp_moved_constant_740)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_738 + jac_blending_inv_1_1_q_1*tmp_moved_constant_739 + jac_blending_inv_2_1_q_1*tmp_moved_constant_740)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_738 + jac_blending_inv_1_2_q_1*tmp_moved_constant_739 + jac_blending_inv_2_2_q_1*tmp_moved_constant_740)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_738 + jac_blending_inv_1_2_q_1*tmp_moved_constant_739 + jac_blending_inv_2_2_q_1*tmp_moved_constant_740))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_741 + jac_blending_inv_1_0_q_2*tmp_moved_constant_742 + jac_blending_inv_2_0_q_2*tmp_moved_constant_743)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_741 + jac_blending_inv_1_0_q_2*tmp_moved_constant_742 + jac_blending_inv_2_0_q_2*tmp_moved_constant_743)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_741 + jac_blending_inv_1_1_q_2*tmp_moved_constant_742 + jac_blending_inv_2_1_q_2*tmp_moved_constant_743)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_741 + jac_blending_inv_1_1_q_2*tmp_moved_constant_742 + jac_blending_inv_2_1_q_2*tmp_moved_constant_743)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_741 + jac_blending_inv_1_2_q_2*tmp_moved_constant_742 + jac_blending_inv_2_2_q_2*tmp_moved_constant_743)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_741 + jac_blending_inv_1_2_q_2*tmp_moved_constant_742 + jac_blending_inv_2_2_q_2*tmp_moved_constant_743))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_744 + jac_blending_inv_1_0_q_3*tmp_moved_constant_745 + jac_blending_inv_2_0_q_3*tmp_moved_constant_746)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_744 + jac_blending_inv_1_0_q_3*tmp_moved_constant_745 + jac_blending_inv_2_0_q_3*tmp_moved_constant_746)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_744 + jac_blending_inv_1_1_q_3*tmp_moved_constant_745 + jac_blending_inv_2_1_q_3*tmp_moved_constant_746)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_744 + jac_blending_inv_1_1_q_3*tmp_moved_constant_745 + jac_blending_inv_2_1_q_3*tmp_moved_constant_746)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_744 + jac_blending_inv_1_2_q_3*tmp_moved_constant_745 + jac_blending_inv_2_2_q_3*tmp_moved_constant_746)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_744 + jac_blending_inv_1_2_q_3*tmp_moved_constant_745 + jac_blending_inv_2_2_q_3*tmp_moved_constant_746))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_747 + jac_blending_inv_1_0_q_4*tmp_moved_constant_748 + jac_blending_inv_2_0_q_4*tmp_moved_constant_749)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_747 + jac_blending_inv_1_0_q_4*tmp_moved_constant_748 + jac_blending_inv_2_0_q_4*tmp_moved_constant_749)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_747 + jac_blending_inv_1_1_q_4*tmp_moved_constant_748 + jac_blending_inv_2_1_q_4*tmp_moved_constant_749)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_747 + jac_blending_inv_1_1_q_4*tmp_moved_constant_748 + jac_blending_inv_2_1_q_4*tmp_moved_constant_749)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_747 + jac_blending_inv_1_2_q_4*tmp_moved_constant_748 + jac_blending_inv_2_2_q_4*tmp_moved_constant_749)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_747 + jac_blending_inv_1_2_q_4*tmp_moved_constant_748 + jac_blending_inv_2_2_q_4*tmp_moved_constant_749))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_735 + jac_blending_inv_1_0_q_0*tmp_moved_constant_736 + jac_blending_inv_2_0_q_0*tmp_moved_constant_737)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_735 + jac_blending_inv_1_0_q_0*tmp_moved_constant_736 + jac_blending_inv_2_0_q_0*tmp_moved_constant_737)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_735 + jac_blending_inv_1_1_q_0*tmp_moved_constant_736 + jac_blending_inv_2_1_q_0*tmp_moved_constant_737)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_735 + jac_blending_inv_1_1_q_0*tmp_moved_constant_736 + jac_blending_inv_2_1_q_0*tmp_moved_constant_737)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_735 + jac_blending_inv_1_2_q_0*tmp_moved_constant_736 + jac_blending_inv_2_2_q_0*tmp_moved_constant_737)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_735 + jac_blending_inv_1_2_q_0*tmp_moved_constant_736 + jac_blending_inv_2_2_q_0*tmp_moved_constant_737)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_753 + jac_blending_inv_1_0_q_1*tmp_moved_constant_754 + jac_blending_inv_2_0_q_1*tmp_moved_constant_755)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_753 + jac_blending_inv_1_0_q_1*tmp_moved_constant_754 + jac_blending_inv_2_0_q_1*tmp_moved_constant_755)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_753 + jac_blending_inv_1_1_q_1*tmp_moved_constant_754 + jac_blending_inv_2_1_q_1*tmp_moved_constant_755)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_753 + jac_blending_inv_1_1_q_1*tmp_moved_constant_754 + jac_blending_inv_2_1_q_1*tmp_moved_constant_755)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_753 + jac_blending_inv_1_2_q_1*tmp_moved_constant_754 + jac_blending_inv_2_2_q_1*tmp_moved_constant_755)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_753 + jac_blending_inv_1_2_q_1*tmp_moved_constant_754 + jac_blending_inv_2_2_q_1*tmp_moved_constant_755))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_756 + jac_blending_inv_1_0_q_2*tmp_moved_constant_757 + jac_blending_inv_2_0_q_2*tmp_moved_constant_758)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_756 + jac_blending_inv_1_0_q_2*tmp_moved_constant_757 + jac_blending_inv_2_0_q_2*tmp_moved_constant_758)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_756 + jac_blending_inv_1_1_q_2*tmp_moved_constant_757 + jac_blending_inv_2_1_q_2*tmp_moved_constant_758)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_756 + jac_blending_inv_1_1_q_2*tmp_moved_constant_757 + jac_blending_inv_2_1_q_2*tmp_moved_constant_758)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_756 + jac_blending_inv_1_2_q_2*tmp_moved_constant_757 + jac_blending_inv_2_2_q_2*tmp_moved_constant_758)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_756 + jac_blending_inv_1_2_q_2*tmp_moved_constant_757 + jac_blending_inv_2_2_q_2*tmp_moved_constant_758))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_759 + jac_blending_inv_1_0_q_3*tmp_moved_constant_760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_761)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_759 + jac_blending_inv_1_0_q_3*tmp_moved_constant_760 + jac_blending_inv_2_0_q_3*tmp_moved_constant_761)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_759 + jac_blending_inv_1_1_q_3*tmp_moved_constant_760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_761)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_759 + jac_blending_inv_1_1_q_3*tmp_moved_constant_760 + jac_blending_inv_2_1_q_3*tmp_moved_constant_761)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_759 + jac_blending_inv_1_2_q_3*tmp_moved_constant_760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_761)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_759 + jac_blending_inv_1_2_q_3*tmp_moved_constant_760 + jac_blending_inv_2_2_q_3*tmp_moved_constant_761))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_762 + jac_blending_inv_1_0_q_4*tmp_moved_constant_763 + jac_blending_inv_2_0_q_4*tmp_moved_constant_764)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_762 + jac_blending_inv_1_0_q_4*tmp_moved_constant_763 + jac_blending_inv_2_0_q_4*tmp_moved_constant_764)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_762 + jac_blending_inv_1_1_q_4*tmp_moved_constant_763 + jac_blending_inv_2_1_q_4*tmp_moved_constant_764)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_762 + jac_blending_inv_1_1_q_4*tmp_moved_constant_763 + jac_blending_inv_2_1_q_4*tmp_moved_constant_764)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_762 + jac_blending_inv_1_2_q_4*tmp_moved_constant_763 + jac_blending_inv_2_2_q_4*tmp_moved_constant_764)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_762 + jac_blending_inv_1_2_q_4*tmp_moved_constant_763 + jac_blending_inv_2_2_q_4*tmp_moved_constant_764))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_750 + jac_blending_inv_1_0_q_0*tmp_moved_constant_751 + jac_blending_inv_2_0_q_0*tmp_moved_constant_752)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_750 + jac_blending_inv_1_0_q_0*tmp_moved_constant_751 + jac_blending_inv_2_0_q_0*tmp_moved_constant_752)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_750 + jac_blending_inv_1_1_q_0*tmp_moved_constant_751 + jac_blending_inv_2_1_q_0*tmp_moved_constant_752)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_750 + jac_blending_inv_1_1_q_0*tmp_moved_constant_751 + jac_blending_inv_2_1_q_0*tmp_moved_constant_752)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_750 + jac_blending_inv_1_2_q_0*tmp_moved_constant_751 + jac_blending_inv_2_2_q_0*tmp_moved_constant_752)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_750 + jac_blending_inv_1_2_q_0*tmp_moved_constant_751 + jac_blending_inv_2_2_q_0*tmp_moved_constant_752)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_768 + jac_blending_inv_1_0_q_1*tmp_moved_constant_769 + jac_blending_inv_2_0_q_1*tmp_moved_constant_770)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_768 + jac_blending_inv_1_0_q_1*tmp_moved_constant_769 + jac_blending_inv_2_0_q_1*tmp_moved_constant_770)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_768 + jac_blending_inv_1_1_q_1*tmp_moved_constant_769 + jac_blending_inv_2_1_q_1*tmp_moved_constant_770)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_768 + jac_blending_inv_1_1_q_1*tmp_moved_constant_769 + jac_blending_inv_2_1_q_1*tmp_moved_constant_770)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_768 + jac_blending_inv_1_2_q_1*tmp_moved_constant_769 + jac_blending_inv_2_2_q_1*tmp_moved_constant_770)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_768 + jac_blending_inv_1_2_q_1*tmp_moved_constant_769 + jac_blending_inv_2_2_q_1*tmp_moved_constant_770))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_771 + jac_blending_inv_1_0_q_2*tmp_moved_constant_772 + jac_blending_inv_2_0_q_2*tmp_moved_constant_773)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_771 + jac_blending_inv_1_0_q_2*tmp_moved_constant_772 + jac_blending_inv_2_0_q_2*tmp_moved_constant_773)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_771 + jac_blending_inv_1_1_q_2*tmp_moved_constant_772 + jac_blending_inv_2_1_q_2*tmp_moved_constant_773)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_771 + jac_blending_inv_1_1_q_2*tmp_moved_constant_772 + jac_blending_inv_2_1_q_2*tmp_moved_constant_773)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_771 + jac_blending_inv_1_2_q_2*tmp_moved_constant_772 + jac_blending_inv_2_2_q_2*tmp_moved_constant_773)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_771 + jac_blending_inv_1_2_q_2*tmp_moved_constant_772 + jac_blending_inv_2_2_q_2*tmp_moved_constant_773))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_774 + jac_blending_inv_1_0_q_3*tmp_moved_constant_775 + jac_blending_inv_2_0_q_3*tmp_moved_constant_776)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_774 + jac_blending_inv_1_0_q_3*tmp_moved_constant_775 + jac_blending_inv_2_0_q_3*tmp_moved_constant_776)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_774 + jac_blending_inv_1_1_q_3*tmp_moved_constant_775 + jac_blending_inv_2_1_q_3*tmp_moved_constant_776)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_774 + jac_blending_inv_1_1_q_3*tmp_moved_constant_775 + jac_blending_inv_2_1_q_3*tmp_moved_constant_776)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_774 + jac_blending_inv_1_2_q_3*tmp_moved_constant_775 + jac_blending_inv_2_2_q_3*tmp_moved_constant_776)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_774 + jac_blending_inv_1_2_q_3*tmp_moved_constant_775 + jac_blending_inv_2_2_q_3*tmp_moved_constant_776))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_777 + jac_blending_inv_1_0_q_4*tmp_moved_constant_778 + jac_blending_inv_2_0_q_4*tmp_moved_constant_779)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_777 + jac_blending_inv_1_0_q_4*tmp_moved_constant_778 + jac_blending_inv_2_0_q_4*tmp_moved_constant_779)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_777 + jac_blending_inv_1_1_q_4*tmp_moved_constant_778 + jac_blending_inv_2_1_q_4*tmp_moved_constant_779)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_777 + jac_blending_inv_1_1_q_4*tmp_moved_constant_778 + jac_blending_inv_2_1_q_4*tmp_moved_constant_779)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_777 + jac_blending_inv_1_2_q_4*tmp_moved_constant_778 + jac_blending_inv_2_2_q_4*tmp_moved_constant_779)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_777 + jac_blending_inv_1_2_q_4*tmp_moved_constant_778 + jac_blending_inv_2_2_q_4*tmp_moved_constant_779))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_765 + jac_blending_inv_1_0_q_0*tmp_moved_constant_766 + jac_blending_inv_2_0_q_0*tmp_moved_constant_767)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_765 + jac_blending_inv_1_0_q_0*tmp_moved_constant_766 + jac_blending_inv_2_0_q_0*tmp_moved_constant_767)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_765 + jac_blending_inv_1_1_q_0*tmp_moved_constant_766 + jac_blending_inv_2_1_q_0*tmp_moved_constant_767)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_765 + jac_blending_inv_1_1_q_0*tmp_moved_constant_766 + jac_blending_inv_2_1_q_0*tmp_moved_constant_767)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_765 + jac_blending_inv_1_2_q_0*tmp_moved_constant_766 + jac_blending_inv_2_2_q_0*tmp_moved_constant_767)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_765 + jac_blending_inv_1_2_q_0*tmp_moved_constant_766 + jac_blending_inv_2_2_q_0*tmp_moved_constant_767)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_791 + jac_blending_inv_1_0_q_1*tmp_moved_constant_794 + jac_blending_inv_2_0_q_1*tmp_moved_constant_797)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_791 + jac_blending_inv_1_0_q_1*tmp_moved_constant_794 + jac_blending_inv_2_0_q_1*tmp_moved_constant_797)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_791 + jac_blending_inv_1_1_q_1*tmp_moved_constant_794 + jac_blending_inv_2_1_q_1*tmp_moved_constant_797)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_791 + jac_blending_inv_1_1_q_1*tmp_moved_constant_794 + jac_blending_inv_2_1_q_1*tmp_moved_constant_797)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_791 + jac_blending_inv_1_2_q_1*tmp_moved_constant_794 + jac_blending_inv_2_2_q_1*tmp_moved_constant_797)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_791 + jac_blending_inv_1_2_q_1*tmp_moved_constant_794 + jac_blending_inv_2_2_q_1*tmp_moved_constant_797))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_800 + jac_blending_inv_1_0_q_2*tmp_moved_constant_803 + jac_blending_inv_2_0_q_2*tmp_moved_constant_806)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_800 + jac_blending_inv_1_0_q_2*tmp_moved_constant_803 + jac_blending_inv_2_0_q_2*tmp_moved_constant_806)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_800 + jac_blending_inv_1_1_q_2*tmp_moved_constant_803 + jac_blending_inv_2_1_q_2*tmp_moved_constant_806)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_800 + jac_blending_inv_1_1_q_2*tmp_moved_constant_803 + jac_blending_inv_2_1_q_2*tmp_moved_constant_806)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_800 + jac_blending_inv_1_2_q_2*tmp_moved_constant_803 + jac_blending_inv_2_2_q_2*tmp_moved_constant_806)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_800 + jac_blending_inv_1_2_q_2*tmp_moved_constant_803 + jac_blending_inv_2_2_q_2*tmp_moved_constant_806))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_809 + jac_blending_inv_1_0_q_3*tmp_moved_constant_812 + jac_blending_inv_2_0_q_3*tmp_moved_constant_815)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_809 + jac_blending_inv_1_0_q_3*tmp_moved_constant_812 + jac_blending_inv_2_0_q_3*tmp_moved_constant_815)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_809 + jac_blending_inv_1_1_q_3*tmp_moved_constant_812 + jac_blending_inv_2_1_q_3*tmp_moved_constant_815)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_809 + jac_blending_inv_1_1_q_3*tmp_moved_constant_812 + jac_blending_inv_2_1_q_3*tmp_moved_constant_815)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_809 + jac_blending_inv_1_2_q_3*tmp_moved_constant_812 + jac_blending_inv_2_2_q_3*tmp_moved_constant_815)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_809 + jac_blending_inv_1_2_q_3*tmp_moved_constant_812 + jac_blending_inv_2_2_q_3*tmp_moved_constant_815))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_818 + jac_blending_inv_1_0_q_4*tmp_moved_constant_821 + jac_blending_inv_2_0_q_4*tmp_moved_constant_824)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_818 + jac_blending_inv_1_0_q_4*tmp_moved_constant_821 + jac_blending_inv_2_0_q_4*tmp_moved_constant_824)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_818 + jac_blending_inv_1_1_q_4*tmp_moved_constant_821 + jac_blending_inv_2_1_q_4*tmp_moved_constant_824)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_818 + jac_blending_inv_1_1_q_4*tmp_moved_constant_821 + jac_blending_inv_2_1_q_4*tmp_moved_constant_824)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_818 + jac_blending_inv_1_2_q_4*tmp_moved_constant_821 + jac_blending_inv_2_2_q_4*tmp_moved_constant_824)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_818 + jac_blending_inv_1_2_q_4*tmp_moved_constant_821 + jac_blending_inv_2_2_q_4*tmp_moved_constant_824))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_782 + jac_blending_inv_1_0_q_0*tmp_moved_constant_785 + jac_blending_inv_2_0_q_0*tmp_moved_constant_788)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_782 + jac_blending_inv_1_0_q_0*tmp_moved_constant_785 + jac_blending_inv_2_0_q_0*tmp_moved_constant_788)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_782 + jac_blending_inv_1_1_q_0*tmp_moved_constant_785 + jac_blending_inv_2_1_q_0*tmp_moved_constant_788)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_782 + jac_blending_inv_1_1_q_0*tmp_moved_constant_785 + jac_blending_inv_2_1_q_0*tmp_moved_constant_788)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_782 + jac_blending_inv_1_2_q_0*tmp_moved_constant_785 + jac_blending_inv_2_2_q_0*tmp_moved_constant_788)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_782 + jac_blending_inv_1_2_q_0*tmp_moved_constant_785 + jac_blending_inv_2_2_q_0*tmp_moved_constant_788)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_836 + jac_blending_inv_1_0_q_1*tmp_moved_constant_839 + jac_blending_inv_2_0_q_1*tmp_moved_constant_842)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_836 + jac_blending_inv_1_0_q_1*tmp_moved_constant_839 + jac_blending_inv_2_0_q_1*tmp_moved_constant_842)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_836 + jac_blending_inv_1_1_q_1*tmp_moved_constant_839 + jac_blending_inv_2_1_q_1*tmp_moved_constant_842)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_836 + jac_blending_inv_1_1_q_1*tmp_moved_constant_839 + jac_blending_inv_2_1_q_1*tmp_moved_constant_842)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_836 + jac_blending_inv_1_2_q_1*tmp_moved_constant_839 + jac_blending_inv_2_2_q_1*tmp_moved_constant_842)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_836 + jac_blending_inv_1_2_q_1*tmp_moved_constant_839 + jac_blending_inv_2_2_q_1*tmp_moved_constant_842))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_845 + jac_blending_inv_1_0_q_2*tmp_moved_constant_848 + jac_blending_inv_2_0_q_2*tmp_moved_constant_851)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_845 + jac_blending_inv_1_0_q_2*tmp_moved_constant_848 + jac_blending_inv_2_0_q_2*tmp_moved_constant_851)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_845 + jac_blending_inv_1_1_q_2*tmp_moved_constant_848 + jac_blending_inv_2_1_q_2*tmp_moved_constant_851)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_845 + jac_blending_inv_1_1_q_2*tmp_moved_constant_848 + jac_blending_inv_2_1_q_2*tmp_moved_constant_851)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_845 + jac_blending_inv_1_2_q_2*tmp_moved_constant_848 + jac_blending_inv_2_2_q_2*tmp_moved_constant_851)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_845 + jac_blending_inv_1_2_q_2*tmp_moved_constant_848 + jac_blending_inv_2_2_q_2*tmp_moved_constant_851))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_854 + jac_blending_inv_1_0_q_3*tmp_moved_constant_857 + jac_blending_inv_2_0_q_3*tmp_moved_constant_860)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_854 + jac_blending_inv_1_0_q_3*tmp_moved_constant_857 + jac_blending_inv_2_0_q_3*tmp_moved_constant_860)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_854 + jac_blending_inv_1_1_q_3*tmp_moved_constant_857 + jac_blending_inv_2_1_q_3*tmp_moved_constant_860)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_854 + jac_blending_inv_1_1_q_3*tmp_moved_constant_857 + jac_blending_inv_2_1_q_3*tmp_moved_constant_860)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_854 + jac_blending_inv_1_2_q_3*tmp_moved_constant_857 + jac_blending_inv_2_2_q_3*tmp_moved_constant_860)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_854 + jac_blending_inv_1_2_q_3*tmp_moved_constant_857 + jac_blending_inv_2_2_q_3*tmp_moved_constant_860))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_863 + jac_blending_inv_1_0_q_4*tmp_moved_constant_866 + jac_blending_inv_2_0_q_4*tmp_moved_constant_869)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_863 + jac_blending_inv_1_0_q_4*tmp_moved_constant_866 + jac_blending_inv_2_0_q_4*tmp_moved_constant_869)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_863 + jac_blending_inv_1_1_q_4*tmp_moved_constant_866 + jac_blending_inv_2_1_q_4*tmp_moved_constant_869)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_863 + jac_blending_inv_1_1_q_4*tmp_moved_constant_866 + jac_blending_inv_2_1_q_4*tmp_moved_constant_869)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_863 + jac_blending_inv_1_2_q_4*tmp_moved_constant_866 + jac_blending_inv_2_2_q_4*tmp_moved_constant_869)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_863 + jac_blending_inv_1_2_q_4*tmp_moved_constant_866 + jac_blending_inv_2_2_q_4*tmp_moved_constant_869))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_827 + jac_blending_inv_1_0_q_0*tmp_moved_constant_830 + jac_blending_inv_2_0_q_0*tmp_moved_constant_833)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_827 + jac_blending_inv_1_0_q_0*tmp_moved_constant_830 + jac_blending_inv_2_0_q_0*tmp_moved_constant_833)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_827 + jac_blending_inv_1_1_q_0*tmp_moved_constant_830 + jac_blending_inv_2_1_q_0*tmp_moved_constant_833)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_827 + jac_blending_inv_1_1_q_0*tmp_moved_constant_830 + jac_blending_inv_2_1_q_0*tmp_moved_constant_833)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_827 + jac_blending_inv_1_2_q_0*tmp_moved_constant_830 + jac_blending_inv_2_2_q_0*tmp_moved_constant_833)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_827 + jac_blending_inv_1_2_q_0*tmp_moved_constant_830 + jac_blending_inv_2_2_q_0*tmp_moved_constant_833)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_881 + jac_blending_inv_1_0_q_1*tmp_moved_constant_884 + jac_blending_inv_2_0_q_1*tmp_moved_constant_887)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_881 + jac_blending_inv_1_0_q_1*tmp_moved_constant_884 + jac_blending_inv_2_0_q_1*tmp_moved_constant_887)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_881 + jac_blending_inv_1_1_q_1*tmp_moved_constant_884 + jac_blending_inv_2_1_q_1*tmp_moved_constant_887)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_881 + jac_blending_inv_1_1_q_1*tmp_moved_constant_884 + jac_blending_inv_2_1_q_1*tmp_moved_constant_887)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_881 + jac_blending_inv_1_2_q_1*tmp_moved_constant_884 + jac_blending_inv_2_2_q_1*tmp_moved_constant_887)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_881 + jac_blending_inv_1_2_q_1*tmp_moved_constant_884 + jac_blending_inv_2_2_q_1*tmp_moved_constant_887))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_890 + jac_blending_inv_1_0_q_2*tmp_moved_constant_893 + jac_blending_inv_2_0_q_2*tmp_moved_constant_896)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_890 + jac_blending_inv_1_0_q_2*tmp_moved_constant_893 + jac_blending_inv_2_0_q_2*tmp_moved_constant_896)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_890 + jac_blending_inv_1_1_q_2*tmp_moved_constant_893 + jac_blending_inv_2_1_q_2*tmp_moved_constant_896)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_890 + jac_blending_inv_1_1_q_2*tmp_moved_constant_893 + jac_blending_inv_2_1_q_2*tmp_moved_constant_896)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_890 + jac_blending_inv_1_2_q_2*tmp_moved_constant_893 + jac_blending_inv_2_2_q_2*tmp_moved_constant_896)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_890 + jac_blending_inv_1_2_q_2*tmp_moved_constant_893 + jac_blending_inv_2_2_q_2*tmp_moved_constant_896))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_899 + jac_blending_inv_1_0_q_3*tmp_moved_constant_902 + jac_blending_inv_2_0_q_3*tmp_moved_constant_905)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_899 + jac_blending_inv_1_0_q_3*tmp_moved_constant_902 + jac_blending_inv_2_0_q_3*tmp_moved_constant_905)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_899 + jac_blending_inv_1_1_q_3*tmp_moved_constant_902 + jac_blending_inv_2_1_q_3*tmp_moved_constant_905)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_899 + jac_blending_inv_1_1_q_3*tmp_moved_constant_902 + jac_blending_inv_2_1_q_3*tmp_moved_constant_905)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_899 + jac_blending_inv_1_2_q_3*tmp_moved_constant_902 + jac_blending_inv_2_2_q_3*tmp_moved_constant_905)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_899 + jac_blending_inv_1_2_q_3*tmp_moved_constant_902 + jac_blending_inv_2_2_q_3*tmp_moved_constant_905))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_908 + jac_blending_inv_1_0_q_4*tmp_moved_constant_911 + jac_blending_inv_2_0_q_4*tmp_moved_constant_914)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_908 + jac_blending_inv_1_0_q_4*tmp_moved_constant_911 + jac_blending_inv_2_0_q_4*tmp_moved_constant_914)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_908 + jac_blending_inv_1_1_q_4*tmp_moved_constant_911 + jac_blending_inv_2_1_q_4*tmp_moved_constant_914)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_908 + jac_blending_inv_1_1_q_4*tmp_moved_constant_911 + jac_blending_inv_2_1_q_4*tmp_moved_constant_914)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_908 + jac_blending_inv_1_2_q_4*tmp_moved_constant_911 + jac_blending_inv_2_2_q_4*tmp_moved_constant_914)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_908 + jac_blending_inv_1_2_q_4*tmp_moved_constant_911 + jac_blending_inv_2_2_q_4*tmp_moved_constant_914))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_872 + jac_blending_inv_1_0_q_0*tmp_moved_constant_875 + jac_blending_inv_2_0_q_0*tmp_moved_constant_878)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_872 + jac_blending_inv_1_0_q_0*tmp_moved_constant_875 + jac_blending_inv_2_0_q_0*tmp_moved_constant_878)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_872 + jac_blending_inv_1_1_q_0*tmp_moved_constant_875 + jac_blending_inv_2_1_q_0*tmp_moved_constant_878)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_872 + jac_blending_inv_1_1_q_0*tmp_moved_constant_875 + jac_blending_inv_2_1_q_0*tmp_moved_constant_878)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_872 + jac_blending_inv_1_2_q_0*tmp_moved_constant_875 + jac_blending_inv_2_2_q_0*tmp_moved_constant_878)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_872 + jac_blending_inv_1_2_q_0*tmp_moved_constant_875 + jac_blending_inv_2_2_q_0*tmp_moved_constant_878)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_918 + jac_blending_inv_1_0_q_1*tmp_moved_constant_919 + jac_blending_inv_2_0_q_1*tmp_moved_constant_920)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_918 + jac_blending_inv_1_0_q_1*tmp_moved_constant_919 + jac_blending_inv_2_0_q_1*tmp_moved_constant_920)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_918 + jac_blending_inv_1_1_q_1*tmp_moved_constant_919 + jac_blending_inv_2_1_q_1*tmp_moved_constant_920)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_918 + jac_blending_inv_1_1_q_1*tmp_moved_constant_919 + jac_blending_inv_2_1_q_1*tmp_moved_constant_920)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_918 + jac_blending_inv_1_2_q_1*tmp_moved_constant_919 + jac_blending_inv_2_2_q_1*tmp_moved_constant_920)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_918 + jac_blending_inv_1_2_q_1*tmp_moved_constant_919 + jac_blending_inv_2_2_q_1*tmp_moved_constant_920))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_921 + jac_blending_inv_1_0_q_2*tmp_moved_constant_922 + jac_blending_inv_2_0_q_2*tmp_moved_constant_923)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_921 + jac_blending_inv_1_0_q_2*tmp_moved_constant_922 + jac_blending_inv_2_0_q_2*tmp_moved_constant_923)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_921 + jac_blending_inv_1_1_q_2*tmp_moved_constant_922 + jac_blending_inv_2_1_q_2*tmp_moved_constant_923)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_921 + jac_blending_inv_1_1_q_2*tmp_moved_constant_922 + jac_blending_inv_2_1_q_2*tmp_moved_constant_923)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_921 + jac_blending_inv_1_2_q_2*tmp_moved_constant_922 + jac_blending_inv_2_2_q_2*tmp_moved_constant_923)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_921 + jac_blending_inv_1_2_q_2*tmp_moved_constant_922 + jac_blending_inv_2_2_q_2*tmp_moved_constant_923))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_924 + jac_blending_inv_1_0_q_3*tmp_moved_constant_925 + jac_blending_inv_2_0_q_3*tmp_moved_constant_926)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_924 + jac_blending_inv_1_0_q_3*tmp_moved_constant_925 + jac_blending_inv_2_0_q_3*tmp_moved_constant_926)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_924 + jac_blending_inv_1_1_q_3*tmp_moved_constant_925 + jac_blending_inv_2_1_q_3*tmp_moved_constant_926)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_924 + jac_blending_inv_1_1_q_3*tmp_moved_constant_925 + jac_blending_inv_2_1_q_3*tmp_moved_constant_926)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_924 + jac_blending_inv_1_2_q_3*tmp_moved_constant_925 + jac_blending_inv_2_2_q_3*tmp_moved_constant_926)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_924 + jac_blending_inv_1_2_q_3*tmp_moved_constant_925 + jac_blending_inv_2_2_q_3*tmp_moved_constant_926))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_927 + jac_blending_inv_1_0_q_4*tmp_moved_constant_928 + jac_blending_inv_2_0_q_4*tmp_moved_constant_929)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_927 + jac_blending_inv_1_0_q_4*tmp_moved_constant_928 + jac_blending_inv_2_0_q_4*tmp_moved_constant_929)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_927 + jac_blending_inv_1_1_q_4*tmp_moved_constant_928 + jac_blending_inv_2_1_q_4*tmp_moved_constant_929)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_927 + jac_blending_inv_1_1_q_4*tmp_moved_constant_928 + jac_blending_inv_2_1_q_4*tmp_moved_constant_929)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_927 + jac_blending_inv_1_2_q_4*tmp_moved_constant_928 + jac_blending_inv_2_2_q_4*tmp_moved_constant_929)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_927 + jac_blending_inv_1_2_q_4*tmp_moved_constant_928 + jac_blending_inv_2_2_q_4*tmp_moved_constant_929))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_915 + jac_blending_inv_1_0_q_0*tmp_moved_constant_916 + jac_blending_inv_2_0_q_0*tmp_moved_constant_917)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_915 + jac_blending_inv_1_0_q_0*tmp_moved_constant_916 + jac_blending_inv_2_0_q_0*tmp_moved_constant_917)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_915 + jac_blending_inv_1_1_q_0*tmp_moved_constant_916 + jac_blending_inv_2_1_q_0*tmp_moved_constant_917)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_915 + jac_blending_inv_1_1_q_0*tmp_moved_constant_916 + jac_blending_inv_2_1_q_0*tmp_moved_constant_917)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_915 + jac_blending_inv_1_2_q_0*tmp_moved_constant_916 + jac_blending_inv_2_2_q_0*tmp_moved_constant_917)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_915 + jac_blending_inv_1_2_q_0*tmp_moved_constant_916 + jac_blending_inv_2_2_q_0*tmp_moved_constant_917)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_933 + jac_blending_inv_1_0_q_1*tmp_moved_constant_934 + jac_blending_inv_2_0_q_1*tmp_moved_constant_935)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_933 + jac_blending_inv_1_0_q_1*tmp_moved_constant_934 + jac_blending_inv_2_0_q_1*tmp_moved_constant_935)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_933 + jac_blending_inv_1_1_q_1*tmp_moved_constant_934 + jac_blending_inv_2_1_q_1*tmp_moved_constant_935)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_933 + jac_blending_inv_1_1_q_1*tmp_moved_constant_934 + jac_blending_inv_2_1_q_1*tmp_moved_constant_935)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_933 + jac_blending_inv_1_2_q_1*tmp_moved_constant_934 + jac_blending_inv_2_2_q_1*tmp_moved_constant_935)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_933 + jac_blending_inv_1_2_q_1*tmp_moved_constant_934 + jac_blending_inv_2_2_q_1*tmp_moved_constant_935))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_936 + jac_blending_inv_1_0_q_2*tmp_moved_constant_937 + jac_blending_inv_2_0_q_2*tmp_moved_constant_938)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_936 + jac_blending_inv_1_0_q_2*tmp_moved_constant_937 + jac_blending_inv_2_0_q_2*tmp_moved_constant_938)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_936 + jac_blending_inv_1_1_q_2*tmp_moved_constant_937 + jac_blending_inv_2_1_q_2*tmp_moved_constant_938)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_936 + jac_blending_inv_1_1_q_2*tmp_moved_constant_937 + jac_blending_inv_2_1_q_2*tmp_moved_constant_938)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_936 + jac_blending_inv_1_2_q_2*tmp_moved_constant_937 + jac_blending_inv_2_2_q_2*tmp_moved_constant_938)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_936 + jac_blending_inv_1_2_q_2*tmp_moved_constant_937 + jac_blending_inv_2_2_q_2*tmp_moved_constant_938))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_939 + jac_blending_inv_1_0_q_3*tmp_moved_constant_940 + jac_blending_inv_2_0_q_3*tmp_moved_constant_941)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_939 + jac_blending_inv_1_0_q_3*tmp_moved_constant_940 + jac_blending_inv_2_0_q_3*tmp_moved_constant_941)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_939 + jac_blending_inv_1_1_q_3*tmp_moved_constant_940 + jac_blending_inv_2_1_q_3*tmp_moved_constant_941)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_939 + jac_blending_inv_1_1_q_3*tmp_moved_constant_940 + jac_blending_inv_2_1_q_3*tmp_moved_constant_941)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_939 + jac_blending_inv_1_2_q_3*tmp_moved_constant_940 + jac_blending_inv_2_2_q_3*tmp_moved_constant_941)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_939 + jac_blending_inv_1_2_q_3*tmp_moved_constant_940 + jac_blending_inv_2_2_q_3*tmp_moved_constant_941))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_942 + jac_blending_inv_1_0_q_4*tmp_moved_constant_943 + jac_blending_inv_2_0_q_4*tmp_moved_constant_944)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_942 + jac_blending_inv_1_0_q_4*tmp_moved_constant_943 + jac_blending_inv_2_0_q_4*tmp_moved_constant_944)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_942 + jac_blending_inv_1_1_q_4*tmp_moved_constant_943 + jac_blending_inv_2_1_q_4*tmp_moved_constant_944)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_942 + jac_blending_inv_1_1_q_4*tmp_moved_constant_943 + jac_blending_inv_2_1_q_4*tmp_moved_constant_944)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_942 + jac_blending_inv_1_2_q_4*tmp_moved_constant_943 + jac_blending_inv_2_2_q_4*tmp_moved_constant_944)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_942 + jac_blending_inv_1_2_q_4*tmp_moved_constant_943 + jac_blending_inv_2_2_q_4*tmp_moved_constant_944))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_930 + jac_blending_inv_1_0_q_0*tmp_moved_constant_931 + jac_blending_inv_2_0_q_0*tmp_moved_constant_932)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_930 + jac_blending_inv_1_0_q_0*tmp_moved_constant_931 + jac_blending_inv_2_0_q_0*tmp_moved_constant_932)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_930 + jac_blending_inv_1_1_q_0*tmp_moved_constant_931 + jac_blending_inv_2_1_q_0*tmp_moved_constant_932)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_930 + jac_blending_inv_1_1_q_0*tmp_moved_constant_931 + jac_blending_inv_2_1_q_0*tmp_moved_constant_932)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_930 + jac_blending_inv_1_2_q_0*tmp_moved_constant_931 + jac_blending_inv_2_2_q_0*tmp_moved_constant_932)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_930 + jac_blending_inv_1_2_q_0*tmp_moved_constant_931 + jac_blending_inv_2_2_q_0*tmp_moved_constant_932)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_948 + jac_blending_inv_1_0_q_1*tmp_moved_constant_949 + jac_blending_inv_2_0_q_1*tmp_moved_constant_950)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_948 + jac_blending_inv_1_0_q_1*tmp_moved_constant_949 + jac_blending_inv_2_0_q_1*tmp_moved_constant_950)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_948 + jac_blending_inv_1_1_q_1*tmp_moved_constant_949 + jac_blending_inv_2_1_q_1*tmp_moved_constant_950)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_948 + jac_blending_inv_1_1_q_1*tmp_moved_constant_949 + jac_blending_inv_2_1_q_1*tmp_moved_constant_950)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_948 + jac_blending_inv_1_2_q_1*tmp_moved_constant_949 + jac_blending_inv_2_2_q_1*tmp_moved_constant_950)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_948 + jac_blending_inv_1_2_q_1*tmp_moved_constant_949 + jac_blending_inv_2_2_q_1*tmp_moved_constant_950))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_951 + jac_blending_inv_1_0_q_2*tmp_moved_constant_952 + jac_blending_inv_2_0_q_2*tmp_moved_constant_953)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_951 + jac_blending_inv_1_0_q_2*tmp_moved_constant_952 + jac_blending_inv_2_0_q_2*tmp_moved_constant_953)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_951 + jac_blending_inv_1_1_q_2*tmp_moved_constant_952 + jac_blending_inv_2_1_q_2*tmp_moved_constant_953)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_951 + jac_blending_inv_1_1_q_2*tmp_moved_constant_952 + jac_blending_inv_2_1_q_2*tmp_moved_constant_953)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_951 + jac_blending_inv_1_2_q_2*tmp_moved_constant_952 + jac_blending_inv_2_2_q_2*tmp_moved_constant_953)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_951 + jac_blending_inv_1_2_q_2*tmp_moved_constant_952 + jac_blending_inv_2_2_q_2*tmp_moved_constant_953))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_954 + jac_blending_inv_1_0_q_3*tmp_moved_constant_955 + jac_blending_inv_2_0_q_3*tmp_moved_constant_956)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_954 + jac_blending_inv_1_0_q_3*tmp_moved_constant_955 + jac_blending_inv_2_0_q_3*tmp_moved_constant_956)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_954 + jac_blending_inv_1_1_q_3*tmp_moved_constant_955 + jac_blending_inv_2_1_q_3*tmp_moved_constant_956)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_954 + jac_blending_inv_1_1_q_3*tmp_moved_constant_955 + jac_blending_inv_2_1_q_3*tmp_moved_constant_956)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_954 + jac_blending_inv_1_2_q_3*tmp_moved_constant_955 + jac_blending_inv_2_2_q_3*tmp_moved_constant_956)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_954 + jac_blending_inv_1_2_q_3*tmp_moved_constant_955 + jac_blending_inv_2_2_q_3*tmp_moved_constant_956))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_957 + jac_blending_inv_1_0_q_4*tmp_moved_constant_958 + jac_blending_inv_2_0_q_4*tmp_moved_constant_959)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_957 + jac_blending_inv_1_0_q_4*tmp_moved_constant_958 + jac_blending_inv_2_0_q_4*tmp_moved_constant_959)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_957 + jac_blending_inv_1_1_q_4*tmp_moved_constant_958 + jac_blending_inv_2_1_q_4*tmp_moved_constant_959)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_957 + jac_blending_inv_1_1_q_4*tmp_moved_constant_958 + jac_blending_inv_2_1_q_4*tmp_moved_constant_959)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_957 + jac_blending_inv_1_2_q_4*tmp_moved_constant_958 + jac_blending_inv_2_2_q_4*tmp_moved_constant_959)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_957 + jac_blending_inv_1_2_q_4*tmp_moved_constant_958 + jac_blending_inv_2_2_q_4*tmp_moved_constant_959))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_945 + jac_blending_inv_1_0_q_0*tmp_moved_constant_946 + jac_blending_inv_2_0_q_0*tmp_moved_constant_947)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_945 + jac_blending_inv_1_0_q_0*tmp_moved_constant_946 + jac_blending_inv_2_0_q_0*tmp_moved_constant_947)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_945 + jac_blending_inv_1_1_q_0*tmp_moved_constant_946 + jac_blending_inv_2_1_q_0*tmp_moved_constant_947)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_945 + jac_blending_inv_1_1_q_0*tmp_moved_constant_946 + jac_blending_inv_2_1_q_0*tmp_moved_constant_947)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_945 + jac_blending_inv_1_2_q_0*tmp_moved_constant_946 + jac_blending_inv_2_2_q_0*tmp_moved_constant_947)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_945 + jac_blending_inv_1_2_q_0*tmp_moved_constant_946 + jac_blending_inv_2_2_q_0*tmp_moved_constant_947)));
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const real_t tmp_moved_constant_960 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_961 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_962 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_4 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_4;
       const real_t tmp_moved_constant_963 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_964 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_965 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_13 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_13;
       const real_t tmp_moved_constant_966 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_967 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_968 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_22 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_22;
       const real_t tmp_moved_constant_969 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_970 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_971 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_31 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_31;
       const real_t tmp_moved_constant_972 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_973 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_974 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_40 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_40;
       const real_t tmp_moved_constant_975 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_976 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_977 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_45;
       const real_t tmp_moved_constant_978 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_979 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_980 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_49;
       const real_t tmp_moved_constant_981 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_982 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_983 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_53;
       const real_t tmp_moved_constant_984 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_985 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_986 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_57;
       const real_t tmp_moved_constant_987 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_988 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_989 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_61;
       const real_t tmp_moved_constant_990 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_991 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_992 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_65;
       const real_t tmp_moved_constant_993 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_994 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_995 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_69;
       const real_t tmp_moved_constant_996 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_997 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_998 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_73;
       const real_t tmp_moved_constant_999 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_1000 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_1001 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_77;
       const real_t tmp_moved_constant_1002 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_1003 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_1004 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_81;
       const real_t tmp_moved_constant_1005 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_1006 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_1007 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_85;
       const real_t tmp_moved_constant_1008 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1009 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1010 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_89;
       const real_t tmp_moved_constant_1011 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_1012 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_1013 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_93;
       const real_t tmp_moved_constant_1014 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_1015 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_1016 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_97;
       const real_t tmp_moved_constant_1017 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_1018 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_1019 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_101;
       const real_t tmp_moved_constant_1020 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1021 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1022 = tmp_moved_constant_1020 + tmp_moved_constant_1021;
       const real_t tmp_moved_constant_1023 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1024 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1025 = tmp_moved_constant_1023 + tmp_moved_constant_1024;
       const real_t tmp_moved_constant_1026 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1027 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1028 = tmp_moved_constant_1026 + tmp_moved_constant_1027;
       const real_t tmp_moved_constant_1029 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1030 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1031 = tmp_moved_constant_1029 + tmp_moved_constant_1030;
       const real_t tmp_moved_constant_1032 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1033 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1034 = tmp_moved_constant_1032 + tmp_moved_constant_1033;
       const real_t tmp_moved_constant_1035 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1036 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1037 = tmp_moved_constant_1035 + tmp_moved_constant_1036;
       const real_t tmp_moved_constant_1038 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1039 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1040 = tmp_moved_constant_1038 + tmp_moved_constant_1039;
       const real_t tmp_moved_constant_1041 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1042 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1043 = tmp_moved_constant_1041 + tmp_moved_constant_1042;
       const real_t tmp_moved_constant_1044 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1045 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1046 = tmp_moved_constant_1044 + tmp_moved_constant_1045;
       const real_t tmp_moved_constant_1047 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1048 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1049 = tmp_moved_constant_1047 + tmp_moved_constant_1048;
       const real_t tmp_moved_constant_1050 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1051 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1052 = tmp_moved_constant_1050 + tmp_moved_constant_1051;
       const real_t tmp_moved_constant_1053 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1054 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1055 = tmp_moved_constant_1053 + tmp_moved_constant_1054;
       const real_t tmp_moved_constant_1056 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1057 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1058 = tmp_moved_constant_1056 + tmp_moved_constant_1057;
       const real_t tmp_moved_constant_1059 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1060 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1061 = tmp_moved_constant_1059 + tmp_moved_constant_1060;
       const real_t tmp_moved_constant_1062 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1063 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1064 = tmp_moved_constant_1062 + tmp_moved_constant_1063;
       const real_t tmp_moved_constant_1065 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1066 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1067 = tmp_moved_constant_1065 + tmp_moved_constant_1066;
       const real_t tmp_moved_constant_1068 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1069 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1070 = tmp_moved_constant_1068 + tmp_moved_constant_1069;
       const real_t tmp_moved_constant_1071 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_0;
       const real_t tmp_moved_constant_1072 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1073 = tmp_moved_constant_1071 + tmp_moved_constant_1072;
       const real_t tmp_moved_constant_1074 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1075 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1076 = tmp_moved_constant_1074 + tmp_moved_constant_1075;
       const real_t tmp_moved_constant_1077 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1078 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1079 = tmp_moved_constant_1077 + tmp_moved_constant_1078;
       const real_t tmp_moved_constant_1080 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_9;
       const real_t tmp_moved_constant_1081 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1082 = tmp_moved_constant_1080 + tmp_moved_constant_1081;
       const real_t tmp_moved_constant_1083 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1084 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1085 = tmp_moved_constant_1083 + tmp_moved_constant_1084;
       const real_t tmp_moved_constant_1086 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1087 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1088 = tmp_moved_constant_1086 + tmp_moved_constant_1087;
       const real_t tmp_moved_constant_1089 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_18;
       const real_t tmp_moved_constant_1090 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1091 = tmp_moved_constant_1089 + tmp_moved_constant_1090;
       const real_t tmp_moved_constant_1092 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1093 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1094 = tmp_moved_constant_1092 + tmp_moved_constant_1093;
       const real_t tmp_moved_constant_1095 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1096 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1097 = tmp_moved_constant_1095 + tmp_moved_constant_1096;
       const real_t tmp_moved_constant_1098 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_27;
       const real_t tmp_moved_constant_1099 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1100 = tmp_moved_constant_1098 + tmp_moved_constant_1099;
       const real_t tmp_moved_constant_1101 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1102 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1103 = tmp_moved_constant_1101 + tmp_moved_constant_1102;
       const real_t tmp_moved_constant_1104 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1105 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1106 = tmp_moved_constant_1104 + tmp_moved_constant_1105;
       const real_t tmp_moved_constant_1107 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_36;
       const real_t tmp_moved_constant_1108 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1109 = tmp_moved_constant_1107 + tmp_moved_constant_1108;
       const real_t tmp_moved_constant_1110 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1111 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1112 = tmp_moved_constant_1110 + tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1113 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1114 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1115 = tmp_moved_constant_1113 + tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1116 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_2;
       const real_t tmp_moved_constant_1117 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_1;
       const real_t tmp_moved_constant_1118 = tmp_moved_constant_1116 + tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1119 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1120 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1121 = tmp_moved_constant_1119 + tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1122 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1123 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1124 = tmp_moved_constant_1122 + tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1125 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_11;
       const real_t tmp_moved_constant_1126 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_10;
       const real_t tmp_moved_constant_1127 = tmp_moved_constant_1125 + tmp_moved_constant_1126;
       const real_t tmp_moved_constant_1128 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1129 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1130 = tmp_moved_constant_1128 + tmp_moved_constant_1129;
       const real_t tmp_moved_constant_1131 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1132 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1133 = tmp_moved_constant_1131 + tmp_moved_constant_1132;
       const real_t tmp_moved_constant_1134 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_20;
       const real_t tmp_moved_constant_1135 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_19;
       const real_t tmp_moved_constant_1136 = tmp_moved_constant_1134 + tmp_moved_constant_1135;
       const real_t tmp_moved_constant_1137 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1138 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1139 = tmp_moved_constant_1137 + tmp_moved_constant_1138;
       const real_t tmp_moved_constant_1140 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1141 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1142 = tmp_moved_constant_1140 + tmp_moved_constant_1141;
       const real_t tmp_moved_constant_1143 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_29;
       const real_t tmp_moved_constant_1144 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_28;
       const real_t tmp_moved_constant_1145 = tmp_moved_constant_1143 + tmp_moved_constant_1144;
       const real_t tmp_moved_constant_1146 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1147 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1148 = tmp_moved_constant_1146 + tmp_moved_constant_1147;
       const real_t tmp_moved_constant_1149 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1150 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1151 = tmp_moved_constant_1149 + tmp_moved_constant_1150;
       const real_t tmp_moved_constant_1152 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_38;
       const real_t tmp_moved_constant_1153 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_37;
       const real_t tmp_moved_constant_1154 = tmp_moved_constant_1152 + tmp_moved_constant_1153;
       const real_t tmp_moved_constant_1155 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_240 - tmp_moved_constant_1020 - tmp_moved_constant_1065;
       const real_t tmp_moved_constant_1156 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_240 - tmp_moved_constant_1023 - tmp_moved_constant_1068;
       const real_t tmp_moved_constant_1157 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_240 - tmp_moved_constant_1026 - tmp_moved_constant_1071;
       const real_t tmp_moved_constant_1158 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_244 - tmp_moved_constant_1029 - tmp_moved_constant_1074;
       const real_t tmp_moved_constant_1159 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_244 - tmp_moved_constant_1032 - tmp_moved_constant_1077;
       const real_t tmp_moved_constant_1160 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_244 - tmp_moved_constant_1035 - tmp_moved_constant_1080;
       const real_t tmp_moved_constant_1161 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_248 - tmp_moved_constant_1038 - tmp_moved_constant_1083;
       const real_t tmp_moved_constant_1162 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_248 - tmp_moved_constant_1041 - tmp_moved_constant_1086;
       const real_t tmp_moved_constant_1163 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_248 - tmp_moved_constant_1044 - tmp_moved_constant_1089;
       const real_t tmp_moved_constant_1164 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_252 - tmp_moved_constant_1047 - tmp_moved_constant_1092;
       const real_t tmp_moved_constant_1165 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_252 - tmp_moved_constant_1050 - tmp_moved_constant_1095;
       const real_t tmp_moved_constant_1166 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_252 - tmp_moved_constant_1053 - tmp_moved_constant_1098;
       const real_t tmp_moved_constant_1167 = jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_256 - tmp_moved_constant_1056 - tmp_moved_constant_1101;
       const real_t tmp_moved_constant_1168 = jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_256 - tmp_moved_constant_1059 - tmp_moved_constant_1104;
       const real_t tmp_moved_constant_1169 = jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_256 - tmp_moved_constant_1062 - tmp_moved_constant_1107;
       const real_t tmp_moved_constant_1170 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_261 - tmp_moved_constant_1021 - tmp_moved_constant_1110;
       const real_t tmp_moved_constant_1171 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_261 - tmp_moved_constant_1024 - tmp_moved_constant_1113;
       const real_t tmp_moved_constant_1172 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_261 - tmp_moved_constant_1027 - tmp_moved_constant_1116;
       const real_t tmp_moved_constant_1173 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_266 - tmp_moved_constant_1030 - tmp_moved_constant_1119;
       const real_t tmp_moved_constant_1174 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_266 - tmp_moved_constant_1033 - tmp_moved_constant_1122;
       const real_t tmp_moved_constant_1175 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_266 - tmp_moved_constant_1036 - tmp_moved_constant_1125;
       const real_t tmp_moved_constant_1176 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_271 - tmp_moved_constant_1039 - tmp_moved_constant_1128;
       const real_t tmp_moved_constant_1177 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_271 - tmp_moved_constant_1042 - tmp_moved_constant_1131;
       const real_t tmp_moved_constant_1178 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_271 - tmp_moved_constant_1045 - tmp_moved_constant_1134;
       const real_t tmp_moved_constant_1179 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_276 - tmp_moved_constant_1048 - tmp_moved_constant_1137;
       const real_t tmp_moved_constant_1180 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_276 - tmp_moved_constant_1051 - tmp_moved_constant_1140;
       const real_t tmp_moved_constant_1181 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_276 - tmp_moved_constant_1054 - tmp_moved_constant_1143;
       const real_t tmp_moved_constant_1182 = jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_281 - tmp_moved_constant_1057 - tmp_moved_constant_1146;
       const real_t tmp_moved_constant_1183 = jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_281 - tmp_moved_constant_1060 - tmp_moved_constant_1149;
       const real_t tmp_moved_constant_1184 = jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_281 - tmp_moved_constant_1063 - tmp_moved_constant_1152;
       const real_t tmp_moved_constant_1185 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_285 - tmp_moved_constant_1066 - tmp_moved_constant_1111;
       const real_t tmp_moved_constant_1186 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_285 - tmp_moved_constant_1069 - tmp_moved_constant_1114;
       const real_t tmp_moved_constant_1187 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_285 - tmp_moved_constant_1072 - tmp_moved_constant_1117;
       const real_t tmp_moved_constant_1188 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_289 - tmp_moved_constant_1075 - tmp_moved_constant_1120;
       const real_t tmp_moved_constant_1189 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_289 - tmp_moved_constant_1078 - tmp_moved_constant_1123;
       const real_t tmp_moved_constant_1190 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_289 - tmp_moved_constant_1081 - tmp_moved_constant_1126;
       const real_t tmp_moved_constant_1191 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_293 - tmp_moved_constant_1084 - tmp_moved_constant_1129;
       const real_t tmp_moved_constant_1192 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_293 - tmp_moved_constant_1087 - tmp_moved_constant_1132;
       const real_t tmp_moved_constant_1193 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_293 - tmp_moved_constant_1090 - tmp_moved_constant_1135;
       const real_t tmp_moved_constant_1194 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_297 - tmp_moved_constant_1093 - tmp_moved_constant_1138;
       const real_t tmp_moved_constant_1195 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_297 - tmp_moved_constant_1096 - tmp_moved_constant_1141;
       const real_t tmp_moved_constant_1196 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_297 - tmp_moved_constant_1099 - tmp_moved_constant_1144;
       const real_t tmp_moved_constant_1197 = jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_301 - tmp_moved_constant_1102 - tmp_moved_constant_1147;
       const real_t tmp_moved_constant_1198 = jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_301 - tmp_moved_constant_1105 - tmp_moved_constant_1150;
       const real_t tmp_moved_constant_1199 = jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_301 - tmp_moved_constant_1108 - tmp_moved_constant_1153;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d tmp_blending_op_0 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_2);
                const __m256d tmp_blending_op_1 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_2);
                const __m256d tmp_blending_op_2 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_2,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_2);
                const __m256d tmp_blending_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_4 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_3);
                const __m256d tmp_blending_op_24 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_25 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_0);
                const __m256d tmp_blending_op_26 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_0);
                const __m256d tmp_blending_op_27 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_0,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_0);
                const __m256d tmp_blending_op_28 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_30 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_1_1);
                const __m256d tmp_blending_op_31 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_2_1);
                const __m256d tmp_blending_op_32 = _mm256_add_pd(_mm256_mul_pd(p_affine_0_1,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),p_affine_3_1);
                const __m256d tmp_blending_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_34 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_35 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_29,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_24,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_34,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_36 = _mm256_mul_pd(tmp_blending_op_35,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_37 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_28);
                const __m256d tmp_blending_op_38 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_33);
                const __m256d tmp_blending_op_39 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_37,tmp_blending_op_38),tmp_blending_op_4);
                const __m256d tmp_blending_op_42 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_39),_mm256_mul_pd(tmp_blending_op_39,tmp_blending_op_39)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_44 = _mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23));
                const __m256d tmp_blending_op_45 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43,tmp_blending_op_43)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_46 = _mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_42);
                const __m256d tmp_blending_op_48 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_44,_mm256_set_pd(tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47,tmp_blending_op_47)),_mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_36));
                const __m256d tmp_blending_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_3,tmp_blending_op_36));
                const __m256d tmp_blending_op_50 = _mm256_mul_pd(tmp_blending_op_33,tmp_blending_op_42);
                const __m256d tmp_blending_op_52 = _mm256_mul_pd(tmp_blending_op_28,tmp_blending_op_42);
                const __m256d tmp_blending_op_61 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_62 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_61);
                const __m256d tmp_blending_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_65 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_66 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_67 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_68 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_65,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_63,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_67,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_69 = _mm256_mul_pd(tmp_blending_op_68,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_70 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_64);
                const __m256d tmp_blending_op_71 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_66);
                const __m256d tmp_blending_op_72 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_62,tmp_blending_op_70),tmp_blending_op_71);
                const __m256d tmp_blending_op_73 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_72),_mm256_mul_pd(tmp_blending_op_72,tmp_blending_op_72)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_75 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_68),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_76 = _mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_73);
                const __m256d tmp_blending_op_77 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_69));
                const __m256d tmp_blending_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_61,tmp_blending_op_69));
                const __m256d tmp_blending_op_79 = _mm256_mul_pd(tmp_blending_op_66,tmp_blending_op_73);
                const __m256d tmp_blending_op_80 = _mm256_mul_pd(tmp_blending_op_64,tmp_blending_op_73);
                const __m256d tmp_blending_op_88 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_89 = _mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_88);
                const __m256d tmp_blending_op_90 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_91 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_92 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_94 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_95 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_92,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_90,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_94,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_96 = _mm256_mul_pd(tmp_blending_op_95,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_97 = _mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_91);
                const __m256d tmp_blending_op_98 = _mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_93);
                const __m256d tmp_blending_op_99 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_89,tmp_blending_op_97),tmp_blending_op_98);
                const __m256d tmp_blending_op_100 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_99),_mm256_mul_pd(tmp_blending_op_99,tmp_blending_op_99)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_101 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_93,tmp_blending_op_95),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_102 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_88);
                const __m256d tmp_blending_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_91,tmp_blending_op_96));
                const __m256d tmp_blending_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_88,tmp_blending_op_96));
                const __m256d tmp_blending_op_105 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_93);
                const __m256d tmp_blending_op_106 = _mm256_mul_pd(tmp_blending_op_100,tmp_blending_op_91);
                const __m256d tmp_blending_op_114 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_2);
                const __m256d tmp_blending_op_115 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_114);
                const __m256d tmp_blending_op_116 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_117 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_0);
                const __m256d tmp_blending_op_118 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_119 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.5,0.5,0.5,0.5)),_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.16666666666666666,0.16666666666666666,0.16666666666666666,0.16666666666666666))),p_affine_0_1);
                const __m256d tmp_blending_op_120 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_121 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_118,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_116,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_120,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_122 = _mm256_mul_pd(tmp_blending_op_121,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_123 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_117);
                const __m256d tmp_blending_op_124 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_119);
                const __m256d tmp_blending_op_125 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_115,tmp_blending_op_123),tmp_blending_op_124);
                const __m256d tmp_blending_op_126 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_125),_mm256_mul_pd(tmp_blending_op_125,tmp_blending_op_125)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_127 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_121),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_128 = _mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_126);
                const __m256d tmp_blending_op_129 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_122));
                const __m256d tmp_blending_op_130 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_114,tmp_blending_op_122));
                const __m256d tmp_blending_op_131 = _mm256_mul_pd(tmp_blending_op_119,tmp_blending_op_126);
                const __m256d tmp_blending_op_132 = _mm256_mul_pd(tmp_blending_op_117,tmp_blending_op_126);
                const __m256d tmp_blending_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_0,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_1,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_2,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_2);
                const __m256d tmp_blending_op_141 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_140);
                const __m256d tmp_blending_op_142 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17,tmp_blending_op_17)),_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_25,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_26,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_27,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_0);
                const __m256d tmp_blending_op_144 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6,tmp_blending_op_6)),_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_145 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_30,_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_mul_pd(tmp_blending_op_31,_mm256_set_pd(0.25,0.25,0.25,0.25))),_mm256_mul_pd(tmp_blending_op_32,_mm256_set_pd(0.25,0.25,0.25,0.25))),p_affine_0_1);
                const __m256d tmp_blending_op_146 = _mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13,tmp_blending_op_13)),_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_147 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12,tmp_blending_op_12)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19,tmp_blending_op_19))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20,tmp_blending_op_20))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_144,_mm256_set_pd(tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11,tmp_blending_op_11)),_mm256_set_pd(tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18,tmp_blending_op_18))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_142,_mm256_set_pd(tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14,tmp_blending_op_14)),_mm256_set_pd(tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15,tmp_blending_op_15))),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_146,_mm256_set_pd(tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7,tmp_blending_op_7)),_mm256_set_pd(tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8,tmp_blending_op_8))),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23,tmp_blending_op_23)),_mm256_set_pd(tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22,tmp_blending_op_22));
                const __m256d tmp_blending_op_148 = _mm256_mul_pd(tmp_blending_op_147,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0));
                const __m256d tmp_blending_op_149 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_143);
                const __m256d tmp_blending_op_150 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_145);
                const __m256d tmp_blending_op_151 = _mm256_add_pd(_mm256_add_pd(tmp_blending_op_141,tmp_blending_op_149),tmp_blending_op_150);
                const __m256d tmp_blending_op_152 = _mm256_mul_pd(_mm256_div_pd(_mm256_sqrt_pd(tmp_blending_op_151),_mm256_mul_pd(tmp_blending_op_151,tmp_blending_op_151)),_mm256_set_pd(tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41,tmp_blending_op_41));
                const __m256d tmp_blending_op_153 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74,tmp_blending_op_74)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_147),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_blending_op_154 = _mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_152);
                const __m256d tmp_blending_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),_mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_148));
                const __m256d tmp_blending_op_156 = _mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),_mm256_mul_pd(tmp_blending_op_140,tmp_blending_op_148));
                const __m256d tmp_blending_op_157 = _mm256_mul_pd(tmp_blending_op_145,tmp_blending_op_152);
                const __m256d tmp_blending_op_158 = _mm256_mul_pd(tmp_blending_op_143,tmp_blending_op_152);
                const __m256d jac_blending_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_3,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_4)));
                const __m256d jac_blending_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_46);
                const __m256d jac_blending_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_46,tmp_blending_op_48);
                const __m256d jac_blending_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_50);
                const __m256d jac_blending_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_33,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_35)),_mm256_mul_pd(tmp_blending_op_36,tmp_blending_op_38)));
                const __m256d tmp_blending_op_58 = _mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_0_q_4);
                const __m256d jac_blending_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_48,tmp_blending_op_50);
                const __m256d tmp_blending_op_55 = _mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_1_q_4);
                const __m256d jac_blending_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_49,tmp_blending_op_52);
                const __m256d jac_blending_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_45,tmp_blending_op_52);
                const __m256d tmp_blending_op_57 = _mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_0_q_4);
                const __m256d jac_blending_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_42,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_39,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_28,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_35)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_35,tmp_blending_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_54 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_1_q_4);
                const __m256d tmp_blending_op_56 = _mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_1_q_4);
                const __m256d tmp_blending_op_59 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_55),_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_54)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,tmp_blending_op_58),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,tmp_blending_op_56),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_4,tmp_blending_op_57),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),jac_blending_2_0_q_4));
                const __m256d tmp_blending_op_60 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_59);
                const __m256d abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const __m256d jac_blending_inv_2_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_57,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_54));
                const __m256d jac_blending_inv_2_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_56,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_0_q_4)));
                const __m256d jac_blending_inv_2_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_58,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_55));
                const __m256d jac_blending_inv_1_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_1_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_0_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_0_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_1_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_1_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_4,jac_blending_2_1_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_4,jac_blending_2_2_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_4 = _mm256_mul_pd(tmp_blending_op_60,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_4,jac_blending_2_2_q_4),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_4,jac_blending_2_1_q_4),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_61,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_62,tmp_blending_op_69)));
                const __m256d jac_blending_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_76);
                const __m256d jac_blending_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_76,tmp_blending_op_77);
                const __m256d jac_blending_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_79);
                const __m256d jac_blending_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_66,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_68)),_mm256_mul_pd(tmp_blending_op_69,tmp_blending_op_71)));
                const __m256d tmp_blending_op_85 = _mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_0_q_3);
                const __m256d jac_blending_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_77,tmp_blending_op_79);
                const __m256d tmp_blending_op_82 = _mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_1_q_3);
                const __m256d jac_blending_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_78,tmp_blending_op_80);
                const __m256d jac_blending_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_75,tmp_blending_op_80);
                const __m256d tmp_blending_op_84 = _mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_0_q_3);
                const __m256d jac_blending_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_73,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_72,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_64,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_68)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_68,tmp_blending_op_70),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_81 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_1_q_3);
                const __m256d tmp_blending_op_83 = _mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_1_q_3);
                const __m256d tmp_blending_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_82),_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_81)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,tmp_blending_op_85),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,tmp_blending_op_83),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_3,tmp_blending_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),jac_blending_2_0_q_3));
                const __m256d tmp_blending_op_87 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_86);
                const __m256d abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const __m256d jac_blending_inv_2_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_84,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_81));
                const __m256d jac_blending_inv_2_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_83,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_0_q_3)));
                const __m256d jac_blending_inv_2_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_85,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_82));
                const __m256d jac_blending_inv_1_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_1_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_0_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_0_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_1_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_1_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_3,jac_blending_2_1_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_3,jac_blending_2_2_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_3 = _mm256_mul_pd(tmp_blending_op_87,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_3,jac_blending_2_2_q_3),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_3,jac_blending_2_1_q_3),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_88,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_89,tmp_blending_op_96)));
                const __m256d jac_blending_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_102);
                const __m256d jac_blending_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_102,tmp_blending_op_103);
                const __m256d jac_blending_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_105);
                const __m256d jac_blending_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_93,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_95)),_mm256_mul_pd(tmp_blending_op_96,tmp_blending_op_98)));
                const __m256d tmp_blending_op_111 = _mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_0_q_2);
                const __m256d jac_blending_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_103,tmp_blending_op_105);
                const __m256d tmp_blending_op_108 = _mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_1_q_2);
                const __m256d jac_blending_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_104,tmp_blending_op_106);
                const __m256d jac_blending_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_101,tmp_blending_op_106);
                const __m256d tmp_blending_op_110 = _mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_0_q_2);
                const __m256d jac_blending_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_100,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_99,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_91,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_95)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_95,tmp_blending_op_97),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_107 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_1_q_2);
                const __m256d tmp_blending_op_109 = _mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_1_q_2);
                const __m256d tmp_blending_op_112 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_108),_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_107)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,tmp_blending_op_111),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,tmp_blending_op_109),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_2,tmp_blending_op_110),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),jac_blending_2_0_q_2));
                const __m256d tmp_blending_op_113 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_112);
                const __m256d abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const __m256d jac_blending_inv_2_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_110,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_107));
                const __m256d jac_blending_inv_2_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_109,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_0_q_2)));
                const __m256d jac_blending_inv_2_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_111,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_108));
                const __m256d jac_blending_inv_1_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_1_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_0_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_0_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_1_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_1_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_2,jac_blending_2_1_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_2,jac_blending_2_2_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_2 = _mm256_mul_pd(tmp_blending_op_113,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_2,jac_blending_2_2_q_2),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_2,jac_blending_2_1_q_2),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_114,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_115,tmp_blending_op_122)));
                const __m256d jac_blending_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_128);
                const __m256d jac_blending_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_128,tmp_blending_op_129);
                const __m256d jac_blending_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_131);
                const __m256d jac_blending_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_119,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_121)),_mm256_mul_pd(tmp_blending_op_122,tmp_blending_op_124)));
                const __m256d tmp_blending_op_137 = _mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_0_q_1);
                const __m256d jac_blending_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_129,tmp_blending_op_131);
                const __m256d tmp_blending_op_134 = _mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_1_q_1);
                const __m256d jac_blending_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_130,tmp_blending_op_132);
                const __m256d jac_blending_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_127,tmp_blending_op_132);
                const __m256d tmp_blending_op_136 = _mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_0_q_1);
                const __m256d jac_blending_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_126,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_125,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_117,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_121)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_121,tmp_blending_op_123),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_133 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_1_q_1);
                const __m256d tmp_blending_op_135 = _mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_1_q_1);
                const __m256d tmp_blending_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_134),_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_133)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,tmp_blending_op_137),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,tmp_blending_op_135),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_1,tmp_blending_op_136),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),jac_blending_2_0_q_1));
                const __m256d tmp_blending_op_139 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_138);
                const __m256d abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const __m256d jac_blending_inv_2_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_136,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_133));
                const __m256d jac_blending_inv_2_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_135,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_0_q_1)));
                const __m256d jac_blending_inv_2_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_137,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_134));
                const __m256d jac_blending_inv_1_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_1_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_0_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_0_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_1_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_1_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_1,jac_blending_2_1_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_1,jac_blending_2_2_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_1 = _mm256_mul_pd(tmp_blending_op_139,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_1,jac_blending_2_2_q_1),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_1,jac_blending_2_1_q_1),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_140,_mm256_set_pd(tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40,tmp_blending_op_40)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_141,tmp_blending_op_148)));
                const __m256d jac_blending_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_154);
                const __m256d jac_blending_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_154,tmp_blending_op_155);
                const __m256d jac_blending_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_157);
                const __m256d jac_blending_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_145,_mm256_set_pd(tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51,tmp_blending_op_51)),tmp_blending_op_147)),_mm256_mul_pd(tmp_blending_op_148,tmp_blending_op_150)));
                const __m256d tmp_blending_op_163 = _mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_0_q_0);
                const __m256d jac_blending_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_155,tmp_blending_op_157);
                const __m256d tmp_blending_op_160 = _mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_1_q_0);
                const __m256d jac_blending_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_156,tmp_blending_op_158);
                const __m256d jac_blending_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_153,tmp_blending_op_158);
                const __m256d tmp_blending_op_162 = _mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_0_q_0);
                const __m256d jac_blending_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_152,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_151,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_143,_mm256_set_pd(tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53,tmp_blending_op_53)),tmp_blending_op_147)),_mm256_mul_pd(_mm256_mul_pd(tmp_blending_op_147,tmp_blending_op_149),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_blending_op_159 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_1_q_0);
                const __m256d tmp_blending_op_161 = _mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_1_q_0);
                const __m256d tmp_blending_op_164 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_160),_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_159)),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,tmp_blending_op_163),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,tmp_blending_op_161),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_2_2_q_0,tmp_blending_op_162),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),jac_blending_2_0_q_0));
                const __m256d tmp_blending_op_165 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_blending_op_164);
                const __m256d abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const __m256d jac_blending_inv_2_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_162,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_159));
                const __m256d jac_blending_inv_2_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_161,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_0_q_0)));
                const __m256d jac_blending_inv_2_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(tmp_blending_op_163,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_blending_op_160));
                const __m256d jac_blending_inv_1_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_1_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_0_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_0_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_1_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_0_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_0_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_2_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_1_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_1_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_1_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_0_2_q_0,jac_blending_2_1_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_0_1_q_0,jac_blending_2_2_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d jac_blending_inv_0_0_q_0 = _mm256_mul_pd(tmp_blending_op_165,_mm256_add_pd(_mm256_mul_pd(jac_blending_1_1_q_0,jac_blending_2_2_q_0),_mm256_mul_pd(_mm256_mul_pd(jac_blending_1_2_q_0,jac_blending_2_1_q_0),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_0,_mm256_set_pd(-0.1333333333333333,-0.1333333333333333,-0.1333333333333333,-0.1333333333333333)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_1,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_26 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_2,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_35 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_3,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d tmp_kernel_op_44 = _mm256_mul_pd(_mm256_mul_pd(abs_det_jac_blending_q_4,_mm256_set_pd(0.074999999999999983,0.074999999999999983,0.074999999999999983,0.074999999999999983)),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960,tmp_moved_constant_960)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961,tmp_moved_constant_961))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962,tmp_moved_constant_962)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963,tmp_moved_constant_963)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964,tmp_moved_constant_964))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965,tmp_moved_constant_965))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966,tmp_moved_constant_966)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967,tmp_moved_constant_967))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968,tmp_moved_constant_968))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969,tmp_moved_constant_969)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970,tmp_moved_constant_970))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971,tmp_moved_constant_971))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972,tmp_moved_constant_972)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973,tmp_moved_constant_973))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974,tmp_moved_constant_974)))))));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975,tmp_moved_constant_975)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976,tmp_moved_constant_976))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977,tmp_moved_constant_977)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978,tmp_moved_constant_978)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979,tmp_moved_constant_979))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980,tmp_moved_constant_980))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981,tmp_moved_constant_981)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982,tmp_moved_constant_982))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983,tmp_moved_constant_983))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984,tmp_moved_constant_984)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985,tmp_moved_constant_985))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986,tmp_moved_constant_986))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987,tmp_moved_constant_987)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988,tmp_moved_constant_988))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989,tmp_moved_constant_989)))))));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000,tmp_moved_constant_1000)),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001,tmp_moved_constant_1001))),_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999,tmp_moved_constant_999)))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002,tmp_moved_constant_1002)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003,tmp_moved_constant_1003))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004,tmp_moved_constant_1004))))))),_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990,tmp_moved_constant_990)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991,tmp_moved_constant_991))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992,tmp_moved_constant_992))))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993,tmp_moved_constant_993)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994,tmp_moved_constant_994))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995,tmp_moved_constant_995))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996,tmp_moved_constant_996)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997,tmp_moved_constant_997))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998,tmp_moved_constant_998)))))));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005,tmp_moved_constant_1005)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006,tmp_moved_constant_1006))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007,tmp_moved_constant_1007)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008,tmp_moved_constant_1008)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009,tmp_moved_constant_1009))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010,tmp_moved_constant_1010))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011,tmp_moved_constant_1011)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012,tmp_moved_constant_1012))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013,tmp_moved_constant_1013))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014,tmp_moved_constant_1014)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015,tmp_moved_constant_1015))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016,tmp_moved_constant_1016))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017,tmp_moved_constant_1017)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018,tmp_moved_constant_1018))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019,tmp_moved_constant_1019)))))));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022,tmp_moved_constant_1022)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025,tmp_moved_constant_1025))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028,tmp_moved_constant_1028)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031,tmp_moved_constant_1031)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034,tmp_moved_constant_1034))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037,tmp_moved_constant_1037))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040,tmp_moved_constant_1040)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043,tmp_moved_constant_1043))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046,tmp_moved_constant_1046))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049,tmp_moved_constant_1049)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052,tmp_moved_constant_1052))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055,tmp_moved_constant_1055))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058,tmp_moved_constant_1058)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061,tmp_moved_constant_1061))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064,tmp_moved_constant_1064)))))));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067,tmp_moved_constant_1067)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070,tmp_moved_constant_1070))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073,tmp_moved_constant_1073)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076,tmp_moved_constant_1076)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079,tmp_moved_constant_1079))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082,tmp_moved_constant_1082))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085,tmp_moved_constant_1085)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088,tmp_moved_constant_1088))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091,tmp_moved_constant_1091))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094,tmp_moved_constant_1094)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097,tmp_moved_constant_1097))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100,tmp_moved_constant_1100))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103,tmp_moved_constant_1103)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106,tmp_moved_constant_1106))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109,tmp_moved_constant_1109)))))));
                const __m256d elMatDiag_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112,tmp_moved_constant_1112)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115,tmp_moved_constant_1115))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118,tmp_moved_constant_1118)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121,tmp_moved_constant_1121)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124,tmp_moved_constant_1124))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127,tmp_moved_constant_1127))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130,tmp_moved_constant_1130)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133,tmp_moved_constant_1133))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136,tmp_moved_constant_1136))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139,tmp_moved_constant_1139)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142,tmp_moved_constant_1142))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145,tmp_moved_constant_1145))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148,tmp_moved_constant_1148)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151,tmp_moved_constant_1151))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154,tmp_moved_constant_1154)))))));
                const __m256d elMatDiag_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155,tmp_moved_constant_1155)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156,tmp_moved_constant_1156))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157,tmp_moved_constant_1157)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158,tmp_moved_constant_1158)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159,tmp_moved_constant_1159))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160,tmp_moved_constant_1160))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161,tmp_moved_constant_1161)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162,tmp_moved_constant_1162))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163,tmp_moved_constant_1163))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164,tmp_moved_constant_1164)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165,tmp_moved_constant_1165))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166,tmp_moved_constant_1166))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167,tmp_moved_constant_1167)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168,tmp_moved_constant_1168))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169,tmp_moved_constant_1169)))))));
                const __m256d elMatDiag_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170,tmp_moved_constant_1170)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171,tmp_moved_constant_1171))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172,tmp_moved_constant_1172)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173,tmp_moved_constant_1173)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174,tmp_moved_constant_1174))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175,tmp_moved_constant_1175))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176,tmp_moved_constant_1176)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177,tmp_moved_constant_1177))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178,tmp_moved_constant_1178))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179,tmp_moved_constant_1179)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180,tmp_moved_constant_1180))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181,tmp_moved_constant_1181))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182,tmp_moved_constant_1182)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183,tmp_moved_constant_1183))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184,tmp_moved_constant_1184)))))));
                const __m256d elMatDiag_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_8,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_0_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_0_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_1_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_1_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_0,_mm256_set_pd(tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185,tmp_moved_constant_1185)),_mm256_mul_pd(jac_blending_inv_1_2_q_0,_mm256_set_pd(tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186,tmp_moved_constant_1186))),_mm256_mul_pd(jac_blending_inv_2_2_q_0,_mm256_set_pd(tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187,tmp_moved_constant_1187)))))),_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_0_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_0_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_1_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_1_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_1,_mm256_set_pd(tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188,tmp_moved_constant_1188)),_mm256_mul_pd(jac_blending_inv_1_2_q_1,_mm256_set_pd(tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189,tmp_moved_constant_1189))),_mm256_mul_pd(jac_blending_inv_2_2_q_1,_mm256_set_pd(tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190,tmp_moved_constant_1190))))))),_mm256_mul_pd(tmp_kernel_op_26,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_0_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_0_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_1_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_1_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_2,_mm256_set_pd(tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191,tmp_moved_constant_1191)),_mm256_mul_pd(jac_blending_inv_1_2_q_2,_mm256_set_pd(tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192,tmp_moved_constant_1192))),_mm256_mul_pd(jac_blending_inv_2_2_q_2,_mm256_set_pd(tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193,tmp_moved_constant_1193))))))),_mm256_mul_pd(tmp_kernel_op_35,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_0_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_0_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_1_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_1_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_3,_mm256_set_pd(tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194,tmp_moved_constant_1194)),_mm256_mul_pd(jac_blending_inv_1_2_q_3,_mm256_set_pd(tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195,tmp_moved_constant_1195))),_mm256_mul_pd(jac_blending_inv_2_2_q_3,_mm256_set_pd(tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196,tmp_moved_constant_1196))))))),_mm256_mul_pd(tmp_kernel_op_44,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_0_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_0_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_0_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_1_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_1_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_1_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(jac_blending_inv_0_2_q_4,_mm256_set_pd(tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197,tmp_moved_constant_1197)),_mm256_mul_pd(jac_blending_inv_1_2_q_4,_mm256_set_pd(tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198,tmp_moved_constant_1198))),_mm256_mul_pd(jac_blending_inv_2_2_q_4,_mm256_set_pd(tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199,tmp_moved_constant_1199)))))));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatDiag_6,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_7,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatDiag_8,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_9,_mm256_loadu_pd(& _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t tmp_blending_op_0 = -p_affine_0_2 + p_affine_1_2;
                const real_t tmp_blending_op_1 = -p_affine_0_2 + p_affine_2_2;
                const real_t tmp_blending_op_2 = -p_affine_0_2 + p_affine_3_2;
                const real_t tmp_blending_op_3 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_4 = (tmp_blending_op_3*tmp_blending_op_3);
                const real_t tmp_blending_op_24 = -tmp_blending_op_17 - tmp_blending_op_3;
                const real_t tmp_blending_op_25 = -p_affine_0_0 + p_affine_1_0;
                const real_t tmp_blending_op_26 = -p_affine_0_0 + p_affine_2_0;
                const real_t tmp_blending_op_27 = -p_affine_0_0 + p_affine_3_0;
                const real_t tmp_blending_op_28 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_29 = -tmp_blending_op_28 - tmp_blending_op_6;
                const real_t tmp_blending_op_30 = -p_affine_0_1 + p_affine_1_1;
                const real_t tmp_blending_op_31 = -p_affine_0_1 + p_affine_2_1;
                const real_t tmp_blending_op_32 = -p_affine_0_1 + p_affine_3_1;
                const real_t tmp_blending_op_33 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_34 = -tmp_blending_op_13 - tmp_blending_op_33;
                const real_t tmp_blending_op_35 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_29 - tmp_blending_op_12*tmp_blending_op_24 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_24 - tmp_blending_op_19*tmp_blending_op_29 - tmp_blending_op_20*tmp_blending_op_34 + tmp_blending_op_34*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_36 = -tmp_blending_op_35;
                const real_t tmp_blending_op_37 = (tmp_blending_op_28*tmp_blending_op_28);
                const real_t tmp_blending_op_38 = (tmp_blending_op_33*tmp_blending_op_33);
                const real_t tmp_blending_op_39 = tmp_blending_op_37 + tmp_blending_op_38 + tmp_blending_op_4;
                const real_t tmp_blending_op_42 = pow(tmp_blending_op_39, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_44 = tmp_blending_op_23*tmp_blending_op_39;
                const real_t tmp_blending_op_45 = -tmp_blending_op_33*tmp_blending_op_35 - tmp_blending_op_43*tmp_blending_op_44;
                const real_t tmp_blending_op_46 = tmp_blending_op_3*tmp_blending_op_42;
                const real_t tmp_blending_op_48 = tmp_blending_op_28*tmp_blending_op_36 + tmp_blending_op_44*tmp_blending_op_47;
                const real_t tmp_blending_op_49 = tmp_blending_op_3*tmp_blending_op_36 + tmp_blending_op_39*tmp_blending_op_40;
                const real_t tmp_blending_op_50 = tmp_blending_op_33*tmp_blending_op_42;
                const real_t tmp_blending_op_52 = tmp_blending_op_28*tmp_blending_op_42;
                const real_t tmp_blending_op_61 = p_affine_0_2 + tmp_blending_op_0*0.5 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_62 = (tmp_blending_op_61*tmp_blending_op_61);
                const real_t tmp_blending_op_63 = -tmp_blending_op_17 - tmp_blending_op_61;
                const real_t tmp_blending_op_64 = p_affine_0_0 + tmp_blending_op_25*0.5 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_65 = -tmp_blending_op_6 - tmp_blending_op_64;
                const real_t tmp_blending_op_66 = p_affine_0_1 + tmp_blending_op_30*0.5 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_67 = -tmp_blending_op_13 - tmp_blending_op_66;
                const real_t tmp_blending_op_68 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_65 - tmp_blending_op_12*tmp_blending_op_63 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_63 - tmp_blending_op_19*tmp_blending_op_65 - tmp_blending_op_20*tmp_blending_op_67 + tmp_blending_op_67*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_69 = -tmp_blending_op_68;
                const real_t tmp_blending_op_70 = (tmp_blending_op_64*tmp_blending_op_64);
                const real_t tmp_blending_op_71 = (tmp_blending_op_66*tmp_blending_op_66);
                const real_t tmp_blending_op_72 = tmp_blending_op_62 + tmp_blending_op_70 + tmp_blending_op_71;
                const real_t tmp_blending_op_73 = tmp_blending_op_41*pow(tmp_blending_op_72, -1.5000000000000000);
                const real_t tmp_blending_op_75 = -tmp_blending_op_66*tmp_blending_op_68 - tmp_blending_op_72*tmp_blending_op_74;
                const real_t tmp_blending_op_76 = tmp_blending_op_61*tmp_blending_op_73;
                const real_t tmp_blending_op_77 = tmp_blending_op_53*tmp_blending_op_72 + tmp_blending_op_64*tmp_blending_op_69;
                const real_t tmp_blending_op_78 = tmp_blending_op_40*tmp_blending_op_72 + tmp_blending_op_61*tmp_blending_op_69;
                const real_t tmp_blending_op_79 = tmp_blending_op_66*tmp_blending_op_73;
                const real_t tmp_blending_op_80 = tmp_blending_op_64*tmp_blending_op_73;
                const real_t tmp_blending_op_88 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.5 + tmp_blending_op_2*0.16666666666666666;
                const real_t tmp_blending_op_89 = (tmp_blending_op_88*tmp_blending_op_88);
                const real_t tmp_blending_op_90 = -tmp_blending_op_17 - tmp_blending_op_88;
                const real_t tmp_blending_op_91 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.5 + tmp_blending_op_27*0.16666666666666666;
                const real_t tmp_blending_op_92 = -tmp_blending_op_6 - tmp_blending_op_91;
                const real_t tmp_blending_op_93 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.5 + tmp_blending_op_32*0.16666666666666666;
                const real_t tmp_blending_op_94 = -tmp_blending_op_13 - tmp_blending_op_93;
                const real_t tmp_blending_op_95 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_18*tmp_blending_op_92 - tmp_blending_op_12*tmp_blending_op_90 + tmp_blending_op_14*tmp_blending_op_15*tmp_blending_op_90 - tmp_blending_op_19*tmp_blending_op_92 - tmp_blending_op_20*tmp_blending_op_94 + tmp_blending_op_7*tmp_blending_op_8*tmp_blending_op_94);
                const real_t tmp_blending_op_96 = -tmp_blending_op_95;
                const real_t tmp_blending_op_97 = (tmp_blending_op_91*tmp_blending_op_91);
                const real_t tmp_blending_op_98 = (tmp_blending_op_93*tmp_blending_op_93);
                const real_t tmp_blending_op_99 = tmp_blending_op_89 + tmp_blending_op_97 + tmp_blending_op_98;
                const real_t tmp_blending_op_100 = tmp_blending_op_41*pow(tmp_blending_op_99, -1.5000000000000000);
                const real_t tmp_blending_op_101 = -tmp_blending_op_74*tmp_blending_op_99 - tmp_blending_op_93*tmp_blending_op_95;
                const real_t tmp_blending_op_102 = tmp_blending_op_100*tmp_blending_op_88;
                const real_t tmp_blending_op_103 = tmp_blending_op_53*tmp_blending_op_99 + tmp_blending_op_91*tmp_blending_op_96;
                const real_t tmp_blending_op_104 = tmp_blending_op_40*tmp_blending_op_99 + tmp_blending_op_88*tmp_blending_op_96;
                const real_t tmp_blending_op_105 = tmp_blending_op_100*tmp_blending_op_93;
                const real_t tmp_blending_op_106 = tmp_blending_op_100*tmp_blending_op_91;
                const real_t tmp_blending_op_114 = p_affine_0_2 + tmp_blending_op_0*0.16666666666666666 + tmp_blending_op_1*0.16666666666666666 + tmp_blending_op_2*0.5;
                const real_t tmp_blending_op_115 = (tmp_blending_op_114*tmp_blending_op_114);
                const real_t tmp_blending_op_116 = -tmp_blending_op_114 - tmp_blending_op_17;
                const real_t tmp_blending_op_117 = p_affine_0_0 + tmp_blending_op_25*0.16666666666666666 + tmp_blending_op_26*0.16666666666666666 + tmp_blending_op_27*0.5;
                const real_t tmp_blending_op_118 = -tmp_blending_op_117 - tmp_blending_op_6;
                const real_t tmp_blending_op_119 = p_affine_0_1 + tmp_blending_op_30*0.16666666666666666 + tmp_blending_op_31*0.16666666666666666 + tmp_blending_op_32*0.5;
                const real_t tmp_blending_op_120 = -tmp_blending_op_119 - tmp_blending_op_13;
                const real_t tmp_blending_op_121 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_118*tmp_blending_op_18 - tmp_blending_op_116*tmp_blending_op_12 + tmp_blending_op_116*tmp_blending_op_14*tmp_blending_op_15 - tmp_blending_op_118*tmp_blending_op_19 - tmp_blending_op_120*tmp_blending_op_20 + tmp_blending_op_120*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_122 = -tmp_blending_op_121;
                const real_t tmp_blending_op_123 = (tmp_blending_op_117*tmp_blending_op_117);
                const real_t tmp_blending_op_124 = (tmp_blending_op_119*tmp_blending_op_119);
                const real_t tmp_blending_op_125 = tmp_blending_op_115 + tmp_blending_op_123 + tmp_blending_op_124;
                const real_t tmp_blending_op_126 = pow(tmp_blending_op_125, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_127 = -tmp_blending_op_119*tmp_blending_op_121 - tmp_blending_op_125*tmp_blending_op_74;
                const real_t tmp_blending_op_128 = tmp_blending_op_114*tmp_blending_op_126;
                const real_t tmp_blending_op_129 = tmp_blending_op_117*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_53;
                const real_t tmp_blending_op_130 = tmp_blending_op_114*tmp_blending_op_122 + tmp_blending_op_125*tmp_blending_op_40;
                const real_t tmp_blending_op_131 = tmp_blending_op_119*tmp_blending_op_126;
                const real_t tmp_blending_op_132 = tmp_blending_op_117*tmp_blending_op_126;
                const real_t tmp_blending_op_140 = p_affine_0_2 + tmp_blending_op_0*0.25 + tmp_blending_op_1*0.25 + tmp_blending_op_2*0.25;
                const real_t tmp_blending_op_141 = (tmp_blending_op_140*tmp_blending_op_140);
                const real_t tmp_blending_op_142 = -tmp_blending_op_140 - tmp_blending_op_17;
                const real_t tmp_blending_op_143 = p_affine_0_0 + tmp_blending_op_25*0.25 + tmp_blending_op_26*0.25 + tmp_blending_op_27*0.25;
                const real_t tmp_blending_op_144 = -tmp_blending_op_143 - tmp_blending_op_6;
                const real_t tmp_blending_op_145 = p_affine_0_1 + tmp_blending_op_30*0.25 + tmp_blending_op_31*0.25 + tmp_blending_op_32*0.25;
                const real_t tmp_blending_op_146 = -tmp_blending_op_13 - tmp_blending_op_145;
                const real_t tmp_blending_op_147 = tmp_blending_op_22 - tmp_blending_op_23*(tmp_blending_op_11*tmp_blending_op_144*tmp_blending_op_18 - tmp_blending_op_12*tmp_blending_op_142 + tmp_blending_op_14*tmp_blending_op_142*tmp_blending_op_15 - tmp_blending_op_144*tmp_blending_op_19 - tmp_blending_op_146*tmp_blending_op_20 + tmp_blending_op_146*tmp_blending_op_7*tmp_blending_op_8);
                const real_t tmp_blending_op_148 = -tmp_blending_op_147;
                const real_t tmp_blending_op_149 = (tmp_blending_op_143*tmp_blending_op_143);
                const real_t tmp_blending_op_150 = (tmp_blending_op_145*tmp_blending_op_145);
                const real_t tmp_blending_op_151 = tmp_blending_op_141 + tmp_blending_op_149 + tmp_blending_op_150;
                const real_t tmp_blending_op_152 = pow(tmp_blending_op_151, -1.5000000000000000)*tmp_blending_op_41;
                const real_t tmp_blending_op_153 = -tmp_blending_op_145*tmp_blending_op_147 - tmp_blending_op_151*tmp_blending_op_74;
                const real_t tmp_blending_op_154 = tmp_blending_op_140*tmp_blending_op_152;
                const real_t tmp_blending_op_155 = tmp_blending_op_143*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_53;
                const real_t tmp_blending_op_156 = tmp_blending_op_140*tmp_blending_op_148 + tmp_blending_op_151*tmp_blending_op_40;
                const real_t tmp_blending_op_157 = tmp_blending_op_145*tmp_blending_op_152;
                const real_t tmp_blending_op_158 = tmp_blending_op_143*tmp_blending_op_152;
                const real_t jac_blending_2_2_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_4 + tmp_blending_op_39*(tmp_blending_op_3*tmp_blending_op_40 + tmp_blending_op_35));
                const real_t jac_blending_2_1_q_4 = tmp_blending_op_45*tmp_blending_op_46;
                const real_t jac_blending_2_0_q_4 = tmp_blending_op_46*tmp_blending_op_48;
                const real_t jac_blending_1_2_q_4 = tmp_blending_op_49*tmp_blending_op_50;
                const real_t jac_blending_1_1_q_4 = tmp_blending_op_42*(tmp_blending_op_36*tmp_blending_op_38 + tmp_blending_op_39*(tmp_blending_op_33*tmp_blending_op_51 + tmp_blending_op_35));
                const real_t tmp_blending_op_58 = jac_blending_1_1_q_4*jac_blending_2_0_q_4;
                const real_t jac_blending_1_0_q_4 = tmp_blending_op_48*tmp_blending_op_50;
                const real_t tmp_blending_op_55 = jac_blending_1_0_q_4*jac_blending_2_1_q_4;
                const real_t jac_blending_0_2_q_4 = tmp_blending_op_49*tmp_blending_op_52;
                const real_t jac_blending_0_1_q_4 = tmp_blending_op_45*tmp_blending_op_52;
                const real_t tmp_blending_op_57 = jac_blending_0_1_q_4*jac_blending_1_0_q_4;
                const real_t jac_blending_0_0_q_4 = tmp_blending_op_42*(-tmp_blending_op_35*tmp_blending_op_37 + tmp_blending_op_39*(tmp_blending_op_28*tmp_blending_op_53 + tmp_blending_op_35));
                const real_t tmp_blending_op_54 = jac_blending_0_0_q_4*jac_blending_1_1_q_4;
                const real_t tmp_blending_op_56 = jac_blending_0_0_q_4*jac_blending_2_1_q_4;
                const real_t tmp_blending_op_59 = jac_blending_0_1_q_4*jac_blending_1_2_q_4*jac_blending_2_0_q_4 + jac_blending_0_2_q_4*tmp_blending_op_55 - jac_blending_0_2_q_4*tmp_blending_op_58 - jac_blending_1_2_q_4*tmp_blending_op_56 + jac_blending_2_2_q_4*tmp_blending_op_54 - jac_blending_2_2_q_4*tmp_blending_op_57;
                const real_t tmp_blending_op_60 = 1.0 / (tmp_blending_op_59);
                const real_t abs_det_jac_blending_q_4 = tmp_blending_op_59;
                const real_t jac_blending_inv_2_2_q_4 = tmp_blending_op_60*(tmp_blending_op_54 - tmp_blending_op_57);
                const real_t jac_blending_inv_2_1_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_2_0_q_4 - tmp_blending_op_56);
                const real_t jac_blending_inv_2_0_q_4 = tmp_blending_op_60*(tmp_blending_op_55 - tmp_blending_op_58);
                const real_t jac_blending_inv_1_2_q_4 = tmp_blending_op_60*(-jac_blending_0_0_q_4*jac_blending_1_2_q_4 + jac_blending_0_2_q_4*jac_blending_1_0_q_4);
                const real_t jac_blending_inv_1_1_q_4 = tmp_blending_op_60*(jac_blending_0_0_q_4*jac_blending_2_2_q_4 - jac_blending_0_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_1_0_q_4 = tmp_blending_op_60*(-jac_blending_1_0_q_4*jac_blending_2_2_q_4 + jac_blending_1_2_q_4*jac_blending_2_0_q_4);
                const real_t jac_blending_inv_0_2_q_4 = tmp_blending_op_60*(jac_blending_0_1_q_4*jac_blending_1_2_q_4 - jac_blending_0_2_q_4*jac_blending_1_1_q_4);
                const real_t jac_blending_inv_0_1_q_4 = tmp_blending_op_60*(-jac_blending_0_1_q_4*jac_blending_2_2_q_4 + jac_blending_0_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_inv_0_0_q_4 = tmp_blending_op_60*(jac_blending_1_1_q_4*jac_blending_2_2_q_4 - jac_blending_1_2_q_4*jac_blending_2_1_q_4);
                const real_t jac_blending_2_2_q_3 = tmp_blending_op_73*(tmp_blending_op_62*tmp_blending_op_69 + tmp_blending_op_72*(tmp_blending_op_40*tmp_blending_op_61 + tmp_blending_op_68));
                const real_t jac_blending_2_1_q_3 = tmp_blending_op_75*tmp_blending_op_76;
                const real_t jac_blending_2_0_q_3 = tmp_blending_op_76*tmp_blending_op_77;
                const real_t jac_blending_1_2_q_3 = tmp_blending_op_78*tmp_blending_op_79;
                const real_t jac_blending_1_1_q_3 = tmp_blending_op_73*(tmp_blending_op_69*tmp_blending_op_71 + tmp_blending_op_72*(tmp_blending_op_51*tmp_blending_op_66 + tmp_blending_op_68));
                const real_t tmp_blending_op_85 = jac_blending_1_1_q_3*jac_blending_2_0_q_3;
                const real_t jac_blending_1_0_q_3 = tmp_blending_op_77*tmp_blending_op_79;
                const real_t tmp_blending_op_82 = jac_blending_1_0_q_3*jac_blending_2_1_q_3;
                const real_t jac_blending_0_2_q_3 = tmp_blending_op_78*tmp_blending_op_80;
                const real_t jac_blending_0_1_q_3 = tmp_blending_op_75*tmp_blending_op_80;
                const real_t tmp_blending_op_84 = jac_blending_0_1_q_3*jac_blending_1_0_q_3;
                const real_t jac_blending_0_0_q_3 = tmp_blending_op_73*(-tmp_blending_op_68*tmp_blending_op_70 + tmp_blending_op_72*(tmp_blending_op_53*tmp_blending_op_64 + tmp_blending_op_68));
                const real_t tmp_blending_op_81 = jac_blending_0_0_q_3*jac_blending_1_1_q_3;
                const real_t tmp_blending_op_83 = jac_blending_0_0_q_3*jac_blending_2_1_q_3;
                const real_t tmp_blending_op_86 = jac_blending_0_1_q_3*jac_blending_1_2_q_3*jac_blending_2_0_q_3 + jac_blending_0_2_q_3*tmp_blending_op_82 - jac_blending_0_2_q_3*tmp_blending_op_85 - jac_blending_1_2_q_3*tmp_blending_op_83 + jac_blending_2_2_q_3*tmp_blending_op_81 - jac_blending_2_2_q_3*tmp_blending_op_84;
                const real_t tmp_blending_op_87 = 1.0 / (tmp_blending_op_86);
                const real_t abs_det_jac_blending_q_3 = tmp_blending_op_86;
                const real_t jac_blending_inv_2_2_q_3 = tmp_blending_op_87*(tmp_blending_op_81 - tmp_blending_op_84);
                const real_t jac_blending_inv_2_1_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_2_0_q_3 - tmp_blending_op_83);
                const real_t jac_blending_inv_2_0_q_3 = tmp_blending_op_87*(tmp_blending_op_82 - tmp_blending_op_85);
                const real_t jac_blending_inv_1_2_q_3 = tmp_blending_op_87*(-jac_blending_0_0_q_3*jac_blending_1_2_q_3 + jac_blending_0_2_q_3*jac_blending_1_0_q_3);
                const real_t jac_blending_inv_1_1_q_3 = tmp_blending_op_87*(jac_blending_0_0_q_3*jac_blending_2_2_q_3 - jac_blending_0_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_1_0_q_3 = tmp_blending_op_87*(-jac_blending_1_0_q_3*jac_blending_2_2_q_3 + jac_blending_1_2_q_3*jac_blending_2_0_q_3);
                const real_t jac_blending_inv_0_2_q_3 = tmp_blending_op_87*(jac_blending_0_1_q_3*jac_blending_1_2_q_3 - jac_blending_0_2_q_3*jac_blending_1_1_q_3);
                const real_t jac_blending_inv_0_1_q_3 = tmp_blending_op_87*(-jac_blending_0_1_q_3*jac_blending_2_2_q_3 + jac_blending_0_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_inv_0_0_q_3 = tmp_blending_op_87*(jac_blending_1_1_q_3*jac_blending_2_2_q_3 - jac_blending_1_2_q_3*jac_blending_2_1_q_3);
                const real_t jac_blending_2_2_q_2 = tmp_blending_op_100*(tmp_blending_op_89*tmp_blending_op_96 + tmp_blending_op_99*(tmp_blending_op_40*tmp_blending_op_88 + tmp_blending_op_95));
                const real_t jac_blending_2_1_q_2 = tmp_blending_op_101*tmp_blending_op_102;
                const real_t jac_blending_2_0_q_2 = tmp_blending_op_102*tmp_blending_op_103;
                const real_t jac_blending_1_2_q_2 = tmp_blending_op_104*tmp_blending_op_105;
                const real_t jac_blending_1_1_q_2 = tmp_blending_op_100*(tmp_blending_op_96*tmp_blending_op_98 + tmp_blending_op_99*(tmp_blending_op_51*tmp_blending_op_93 + tmp_blending_op_95));
                const real_t tmp_blending_op_111 = jac_blending_1_1_q_2*jac_blending_2_0_q_2;
                const real_t jac_blending_1_0_q_2 = tmp_blending_op_103*tmp_blending_op_105;
                const real_t tmp_blending_op_108 = jac_blending_1_0_q_2*jac_blending_2_1_q_2;
                const real_t jac_blending_0_2_q_2 = tmp_blending_op_104*tmp_blending_op_106;
                const real_t jac_blending_0_1_q_2 = tmp_blending_op_101*tmp_blending_op_106;
                const real_t tmp_blending_op_110 = jac_blending_0_1_q_2*jac_blending_1_0_q_2;
                const real_t jac_blending_0_0_q_2 = tmp_blending_op_100*(-tmp_blending_op_95*tmp_blending_op_97 + tmp_blending_op_99*(tmp_blending_op_53*tmp_blending_op_91 + tmp_blending_op_95));
                const real_t tmp_blending_op_107 = jac_blending_0_0_q_2*jac_blending_1_1_q_2;
                const real_t tmp_blending_op_109 = jac_blending_0_0_q_2*jac_blending_2_1_q_2;
                const real_t tmp_blending_op_112 = jac_blending_0_1_q_2*jac_blending_1_2_q_2*jac_blending_2_0_q_2 + jac_blending_0_2_q_2*tmp_blending_op_108 - jac_blending_0_2_q_2*tmp_blending_op_111 - jac_blending_1_2_q_2*tmp_blending_op_109 + jac_blending_2_2_q_2*tmp_blending_op_107 - jac_blending_2_2_q_2*tmp_blending_op_110;
                const real_t tmp_blending_op_113 = 1.0 / (tmp_blending_op_112);
                const real_t abs_det_jac_blending_q_2 = tmp_blending_op_112;
                const real_t jac_blending_inv_2_2_q_2 = tmp_blending_op_113*(tmp_blending_op_107 - tmp_blending_op_110);
                const real_t jac_blending_inv_2_1_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_2_0_q_2 - tmp_blending_op_109);
                const real_t jac_blending_inv_2_0_q_2 = tmp_blending_op_113*(tmp_blending_op_108 - tmp_blending_op_111);
                const real_t jac_blending_inv_1_2_q_2 = tmp_blending_op_113*(-jac_blending_0_0_q_2*jac_blending_1_2_q_2 + jac_blending_0_2_q_2*jac_blending_1_0_q_2);
                const real_t jac_blending_inv_1_1_q_2 = tmp_blending_op_113*(jac_blending_0_0_q_2*jac_blending_2_2_q_2 - jac_blending_0_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_1_0_q_2 = tmp_blending_op_113*(-jac_blending_1_0_q_2*jac_blending_2_2_q_2 + jac_blending_1_2_q_2*jac_blending_2_0_q_2);
                const real_t jac_blending_inv_0_2_q_2 = tmp_blending_op_113*(jac_blending_0_1_q_2*jac_blending_1_2_q_2 - jac_blending_0_2_q_2*jac_blending_1_1_q_2);
                const real_t jac_blending_inv_0_1_q_2 = tmp_blending_op_113*(-jac_blending_0_1_q_2*jac_blending_2_2_q_2 + jac_blending_0_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_inv_0_0_q_2 = tmp_blending_op_113*(jac_blending_1_1_q_2*jac_blending_2_2_q_2 - jac_blending_1_2_q_2*jac_blending_2_1_q_2);
                const real_t jac_blending_2_2_q_1 = tmp_blending_op_126*(tmp_blending_op_115*tmp_blending_op_122 + tmp_blending_op_125*(tmp_blending_op_114*tmp_blending_op_40 + tmp_blending_op_121));
                const real_t jac_blending_2_1_q_1 = tmp_blending_op_127*tmp_blending_op_128;
                const real_t jac_blending_2_0_q_1 = tmp_blending_op_128*tmp_blending_op_129;
                const real_t jac_blending_1_2_q_1 = tmp_blending_op_130*tmp_blending_op_131;
                const real_t jac_blending_1_1_q_1 = tmp_blending_op_126*(tmp_blending_op_122*tmp_blending_op_124 + tmp_blending_op_125*(tmp_blending_op_119*tmp_blending_op_51 + tmp_blending_op_121));
                const real_t tmp_blending_op_137 = jac_blending_1_1_q_1*jac_blending_2_0_q_1;
                const real_t jac_blending_1_0_q_1 = tmp_blending_op_129*tmp_blending_op_131;
                const real_t tmp_blending_op_134 = jac_blending_1_0_q_1*jac_blending_2_1_q_1;
                const real_t jac_blending_0_2_q_1 = tmp_blending_op_130*tmp_blending_op_132;
                const real_t jac_blending_0_1_q_1 = tmp_blending_op_127*tmp_blending_op_132;
                const real_t tmp_blending_op_136 = jac_blending_0_1_q_1*jac_blending_1_0_q_1;
                const real_t jac_blending_0_0_q_1 = tmp_blending_op_126*(-tmp_blending_op_121*tmp_blending_op_123 + tmp_blending_op_125*(tmp_blending_op_117*tmp_blending_op_53 + tmp_blending_op_121));
                const real_t tmp_blending_op_133 = jac_blending_0_0_q_1*jac_blending_1_1_q_1;
                const real_t tmp_blending_op_135 = jac_blending_0_0_q_1*jac_blending_2_1_q_1;
                const real_t tmp_blending_op_138 = jac_blending_0_1_q_1*jac_blending_1_2_q_1*jac_blending_2_0_q_1 + jac_blending_0_2_q_1*tmp_blending_op_134 - jac_blending_0_2_q_1*tmp_blending_op_137 - jac_blending_1_2_q_1*tmp_blending_op_135 + jac_blending_2_2_q_1*tmp_blending_op_133 - jac_blending_2_2_q_1*tmp_blending_op_136;
                const real_t tmp_blending_op_139 = 1.0 / (tmp_blending_op_138);
                const real_t abs_det_jac_blending_q_1 = tmp_blending_op_138;
                const real_t jac_blending_inv_2_2_q_1 = tmp_blending_op_139*(tmp_blending_op_133 - tmp_blending_op_136);
                const real_t jac_blending_inv_2_1_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_2_0_q_1 - tmp_blending_op_135);
                const real_t jac_blending_inv_2_0_q_1 = tmp_blending_op_139*(tmp_blending_op_134 - tmp_blending_op_137);
                const real_t jac_blending_inv_1_2_q_1 = tmp_blending_op_139*(-jac_blending_0_0_q_1*jac_blending_1_2_q_1 + jac_blending_0_2_q_1*jac_blending_1_0_q_1);
                const real_t jac_blending_inv_1_1_q_1 = tmp_blending_op_139*(jac_blending_0_0_q_1*jac_blending_2_2_q_1 - jac_blending_0_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_1_0_q_1 = tmp_blending_op_139*(-jac_blending_1_0_q_1*jac_blending_2_2_q_1 + jac_blending_1_2_q_1*jac_blending_2_0_q_1);
                const real_t jac_blending_inv_0_2_q_1 = tmp_blending_op_139*(jac_blending_0_1_q_1*jac_blending_1_2_q_1 - jac_blending_0_2_q_1*jac_blending_1_1_q_1);
                const real_t jac_blending_inv_0_1_q_1 = tmp_blending_op_139*(-jac_blending_0_1_q_1*jac_blending_2_2_q_1 + jac_blending_0_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_inv_0_0_q_1 = tmp_blending_op_139*(jac_blending_1_1_q_1*jac_blending_2_2_q_1 - jac_blending_1_2_q_1*jac_blending_2_1_q_1);
                const real_t jac_blending_2_2_q_0 = tmp_blending_op_152*(tmp_blending_op_141*tmp_blending_op_148 + tmp_blending_op_151*(tmp_blending_op_140*tmp_blending_op_40 + tmp_blending_op_147));
                const real_t jac_blending_2_1_q_0 = tmp_blending_op_153*tmp_blending_op_154;
                const real_t jac_blending_2_0_q_0 = tmp_blending_op_154*tmp_blending_op_155;
                const real_t jac_blending_1_2_q_0 = tmp_blending_op_156*tmp_blending_op_157;
                const real_t jac_blending_1_1_q_0 = tmp_blending_op_152*(tmp_blending_op_148*tmp_blending_op_150 + tmp_blending_op_151*(tmp_blending_op_145*tmp_blending_op_51 + tmp_blending_op_147));
                const real_t tmp_blending_op_163 = jac_blending_1_1_q_0*jac_blending_2_0_q_0;
                const real_t jac_blending_1_0_q_0 = tmp_blending_op_155*tmp_blending_op_157;
                const real_t tmp_blending_op_160 = jac_blending_1_0_q_0*jac_blending_2_1_q_0;
                const real_t jac_blending_0_2_q_0 = tmp_blending_op_156*tmp_blending_op_158;
                const real_t jac_blending_0_1_q_0 = tmp_blending_op_153*tmp_blending_op_158;
                const real_t tmp_blending_op_162 = jac_blending_0_1_q_0*jac_blending_1_0_q_0;
                const real_t jac_blending_0_0_q_0 = tmp_blending_op_152*(-tmp_blending_op_147*tmp_blending_op_149 + tmp_blending_op_151*(tmp_blending_op_143*tmp_blending_op_53 + tmp_blending_op_147));
                const real_t tmp_blending_op_159 = jac_blending_0_0_q_0*jac_blending_1_1_q_0;
                const real_t tmp_blending_op_161 = jac_blending_0_0_q_0*jac_blending_2_1_q_0;
                const real_t tmp_blending_op_164 = jac_blending_0_1_q_0*jac_blending_1_2_q_0*jac_blending_2_0_q_0 + jac_blending_0_2_q_0*tmp_blending_op_160 - jac_blending_0_2_q_0*tmp_blending_op_163 - jac_blending_1_2_q_0*tmp_blending_op_161 + jac_blending_2_2_q_0*tmp_blending_op_159 - jac_blending_2_2_q_0*tmp_blending_op_162;
                const real_t tmp_blending_op_165 = 1.0 / (tmp_blending_op_164);
                const real_t abs_det_jac_blending_q_0 = tmp_blending_op_164;
                const real_t jac_blending_inv_2_2_q_0 = tmp_blending_op_165*(tmp_blending_op_159 - tmp_blending_op_162);
                const real_t jac_blending_inv_2_1_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_2_0_q_0 - tmp_blending_op_161);
                const real_t jac_blending_inv_2_0_q_0 = tmp_blending_op_165*(tmp_blending_op_160 - tmp_blending_op_163);
                const real_t jac_blending_inv_1_2_q_0 = tmp_blending_op_165*(-jac_blending_0_0_q_0*jac_blending_1_2_q_0 + jac_blending_0_2_q_0*jac_blending_1_0_q_0);
                const real_t jac_blending_inv_1_1_q_0 = tmp_blending_op_165*(jac_blending_0_0_q_0*jac_blending_2_2_q_0 - jac_blending_0_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_1_0_q_0 = tmp_blending_op_165*(-jac_blending_1_0_q_0*jac_blending_2_2_q_0 + jac_blending_1_2_q_0*jac_blending_2_0_q_0);
                const real_t jac_blending_inv_0_2_q_0 = tmp_blending_op_165*(jac_blending_0_1_q_0*jac_blending_1_2_q_0 - jac_blending_0_2_q_0*jac_blending_1_1_q_0);
                const real_t jac_blending_inv_0_1_q_0 = tmp_blending_op_165*(-jac_blending_0_1_q_0*jac_blending_2_2_q_0 + jac_blending_0_2_q_0*jac_blending_2_1_q_0);
                const real_t jac_blending_inv_0_0_q_0 = tmp_blending_op_165*(jac_blending_1_1_q_0*jac_blending_2_2_q_0 - jac_blending_1_2_q_0*jac_blending_2_1_q_0);
                const real_t tmp_kernel_op_8 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_0*-0.1333333333333333;
                const real_t tmp_kernel_op_17 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_1*0.074999999999999983;
                const real_t tmp_kernel_op_26 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_2*0.074999999999999983;
                const real_t tmp_kernel_op_35 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_3*0.074999999999999983;
                const real_t tmp_kernel_op_44 = abs_det_jac_affine_GREEN_DOWN*abs_det_jac_blending_q_4*0.074999999999999983;
                const real_t elMatDiag_0 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_963 + jac_blending_inv_1_0_q_1*tmp_moved_constant_964 + jac_blending_inv_2_0_q_1*tmp_moved_constant_965)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_963 + jac_blending_inv_1_0_q_1*tmp_moved_constant_964 + jac_blending_inv_2_0_q_1*tmp_moved_constant_965)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_963 + jac_blending_inv_1_1_q_1*tmp_moved_constant_964 + jac_blending_inv_2_1_q_1*tmp_moved_constant_965)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_963 + jac_blending_inv_1_1_q_1*tmp_moved_constant_964 + jac_blending_inv_2_1_q_1*tmp_moved_constant_965)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_963 + jac_blending_inv_1_2_q_1*tmp_moved_constant_964 + jac_blending_inv_2_2_q_1*tmp_moved_constant_965)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_963 + jac_blending_inv_1_2_q_1*tmp_moved_constant_964 + jac_blending_inv_2_2_q_1*tmp_moved_constant_965))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_966 + jac_blending_inv_1_0_q_2*tmp_moved_constant_967 + jac_blending_inv_2_0_q_2*tmp_moved_constant_968)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_966 + jac_blending_inv_1_0_q_2*tmp_moved_constant_967 + jac_blending_inv_2_0_q_2*tmp_moved_constant_968)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_966 + jac_blending_inv_1_1_q_2*tmp_moved_constant_967 + jac_blending_inv_2_1_q_2*tmp_moved_constant_968)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_966 + jac_blending_inv_1_1_q_2*tmp_moved_constant_967 + jac_blending_inv_2_1_q_2*tmp_moved_constant_968)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_966 + jac_blending_inv_1_2_q_2*tmp_moved_constant_967 + jac_blending_inv_2_2_q_2*tmp_moved_constant_968)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_966 + jac_blending_inv_1_2_q_2*tmp_moved_constant_967 + jac_blending_inv_2_2_q_2*tmp_moved_constant_968))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_969 + jac_blending_inv_1_0_q_3*tmp_moved_constant_970 + jac_blending_inv_2_0_q_3*tmp_moved_constant_971)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_969 + jac_blending_inv_1_0_q_3*tmp_moved_constant_970 + jac_blending_inv_2_0_q_3*tmp_moved_constant_971)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_969 + jac_blending_inv_1_1_q_3*tmp_moved_constant_970 + jac_blending_inv_2_1_q_3*tmp_moved_constant_971)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_969 + jac_blending_inv_1_1_q_3*tmp_moved_constant_970 + jac_blending_inv_2_1_q_3*tmp_moved_constant_971)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_969 + jac_blending_inv_1_2_q_3*tmp_moved_constant_970 + jac_blending_inv_2_2_q_3*tmp_moved_constant_971)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_969 + jac_blending_inv_1_2_q_3*tmp_moved_constant_970 + jac_blending_inv_2_2_q_3*tmp_moved_constant_971))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_972 + jac_blending_inv_1_0_q_4*tmp_moved_constant_973 + jac_blending_inv_2_0_q_4*tmp_moved_constant_974)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_972 + jac_blending_inv_1_0_q_4*tmp_moved_constant_973 + jac_blending_inv_2_0_q_4*tmp_moved_constant_974)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_972 + jac_blending_inv_1_1_q_4*tmp_moved_constant_973 + jac_blending_inv_2_1_q_4*tmp_moved_constant_974)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_972 + jac_blending_inv_1_1_q_4*tmp_moved_constant_973 + jac_blending_inv_2_1_q_4*tmp_moved_constant_974)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_972 + jac_blending_inv_1_2_q_4*tmp_moved_constant_973 + jac_blending_inv_2_2_q_4*tmp_moved_constant_974)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_972 + jac_blending_inv_1_2_q_4*tmp_moved_constant_973 + jac_blending_inv_2_2_q_4*tmp_moved_constant_974))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_960 + jac_blending_inv_1_0_q_0*tmp_moved_constant_961 + jac_blending_inv_2_0_q_0*tmp_moved_constant_962)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_960 + jac_blending_inv_1_0_q_0*tmp_moved_constant_961 + jac_blending_inv_2_0_q_0*tmp_moved_constant_962)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_960 + jac_blending_inv_1_1_q_0*tmp_moved_constant_961 + jac_blending_inv_2_1_q_0*tmp_moved_constant_962)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_960 + jac_blending_inv_1_1_q_0*tmp_moved_constant_961 + jac_blending_inv_2_1_q_0*tmp_moved_constant_962)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_960 + jac_blending_inv_1_2_q_0*tmp_moved_constant_961 + jac_blending_inv_2_2_q_0*tmp_moved_constant_962)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_960 + jac_blending_inv_1_2_q_0*tmp_moved_constant_961 + jac_blending_inv_2_2_q_0*tmp_moved_constant_962)));
                const real_t elMatDiag_1 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_978 + jac_blending_inv_1_0_q_1*tmp_moved_constant_979 + jac_blending_inv_2_0_q_1*tmp_moved_constant_980)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_978 + jac_blending_inv_1_0_q_1*tmp_moved_constant_979 + jac_blending_inv_2_0_q_1*tmp_moved_constant_980)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_978 + jac_blending_inv_1_1_q_1*tmp_moved_constant_979 + jac_blending_inv_2_1_q_1*tmp_moved_constant_980)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_978 + jac_blending_inv_1_1_q_1*tmp_moved_constant_979 + jac_blending_inv_2_1_q_1*tmp_moved_constant_980)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_978 + jac_blending_inv_1_2_q_1*tmp_moved_constant_979 + jac_blending_inv_2_2_q_1*tmp_moved_constant_980)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_978 + jac_blending_inv_1_2_q_1*tmp_moved_constant_979 + jac_blending_inv_2_2_q_1*tmp_moved_constant_980))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_981 + jac_blending_inv_1_0_q_2*tmp_moved_constant_982 + jac_blending_inv_2_0_q_2*tmp_moved_constant_983)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_981 + jac_blending_inv_1_0_q_2*tmp_moved_constant_982 + jac_blending_inv_2_0_q_2*tmp_moved_constant_983)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_981 + jac_blending_inv_1_1_q_2*tmp_moved_constant_982 + jac_blending_inv_2_1_q_2*tmp_moved_constant_983)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_981 + jac_blending_inv_1_1_q_2*tmp_moved_constant_982 + jac_blending_inv_2_1_q_2*tmp_moved_constant_983)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_981 + jac_blending_inv_1_2_q_2*tmp_moved_constant_982 + jac_blending_inv_2_2_q_2*tmp_moved_constant_983)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_981 + jac_blending_inv_1_2_q_2*tmp_moved_constant_982 + jac_blending_inv_2_2_q_2*tmp_moved_constant_983))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_984 + jac_blending_inv_1_0_q_3*tmp_moved_constant_985 + jac_blending_inv_2_0_q_3*tmp_moved_constant_986)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_984 + jac_blending_inv_1_0_q_3*tmp_moved_constant_985 + jac_blending_inv_2_0_q_3*tmp_moved_constant_986)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_984 + jac_blending_inv_1_1_q_3*tmp_moved_constant_985 + jac_blending_inv_2_1_q_3*tmp_moved_constant_986)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_984 + jac_blending_inv_1_1_q_3*tmp_moved_constant_985 + jac_blending_inv_2_1_q_3*tmp_moved_constant_986)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_984 + jac_blending_inv_1_2_q_3*tmp_moved_constant_985 + jac_blending_inv_2_2_q_3*tmp_moved_constant_986)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_984 + jac_blending_inv_1_2_q_3*tmp_moved_constant_985 + jac_blending_inv_2_2_q_3*tmp_moved_constant_986))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_987 + jac_blending_inv_1_0_q_4*tmp_moved_constant_988 + jac_blending_inv_2_0_q_4*tmp_moved_constant_989)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_987 + jac_blending_inv_1_0_q_4*tmp_moved_constant_988 + jac_blending_inv_2_0_q_4*tmp_moved_constant_989)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_987 + jac_blending_inv_1_1_q_4*tmp_moved_constant_988 + jac_blending_inv_2_1_q_4*tmp_moved_constant_989)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_987 + jac_blending_inv_1_1_q_4*tmp_moved_constant_988 + jac_blending_inv_2_1_q_4*tmp_moved_constant_989)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_987 + jac_blending_inv_1_2_q_4*tmp_moved_constant_988 + jac_blending_inv_2_2_q_4*tmp_moved_constant_989)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_987 + jac_blending_inv_1_2_q_4*tmp_moved_constant_988 + jac_blending_inv_2_2_q_4*tmp_moved_constant_989))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_975 + jac_blending_inv_1_0_q_0*tmp_moved_constant_976 + jac_blending_inv_2_0_q_0*tmp_moved_constant_977)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_975 + jac_blending_inv_1_0_q_0*tmp_moved_constant_976 + jac_blending_inv_2_0_q_0*tmp_moved_constant_977)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_975 + jac_blending_inv_1_1_q_0*tmp_moved_constant_976 + jac_blending_inv_2_1_q_0*tmp_moved_constant_977)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_975 + jac_blending_inv_1_1_q_0*tmp_moved_constant_976 + jac_blending_inv_2_1_q_0*tmp_moved_constant_977)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_975 + jac_blending_inv_1_2_q_0*tmp_moved_constant_976 + jac_blending_inv_2_2_q_0*tmp_moved_constant_977)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_975 + jac_blending_inv_1_2_q_0*tmp_moved_constant_976 + jac_blending_inv_2_2_q_0*tmp_moved_constant_977)));
                const real_t elMatDiag_2 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_993 + jac_blending_inv_1_0_q_1*tmp_moved_constant_994 + jac_blending_inv_2_0_q_1*tmp_moved_constant_995)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_993 + jac_blending_inv_1_0_q_1*tmp_moved_constant_994 + jac_blending_inv_2_0_q_1*tmp_moved_constant_995)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_993 + jac_blending_inv_1_1_q_1*tmp_moved_constant_994 + jac_blending_inv_2_1_q_1*tmp_moved_constant_995)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_993 + jac_blending_inv_1_1_q_1*tmp_moved_constant_994 + jac_blending_inv_2_1_q_1*tmp_moved_constant_995)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_993 + jac_blending_inv_1_2_q_1*tmp_moved_constant_994 + jac_blending_inv_2_2_q_1*tmp_moved_constant_995)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_993 + jac_blending_inv_1_2_q_1*tmp_moved_constant_994 + jac_blending_inv_2_2_q_1*tmp_moved_constant_995))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_996 + jac_blending_inv_1_0_q_2*tmp_moved_constant_997 + jac_blending_inv_2_0_q_2*tmp_moved_constant_998)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_996 + jac_blending_inv_1_0_q_2*tmp_moved_constant_997 + jac_blending_inv_2_0_q_2*tmp_moved_constant_998)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_996 + jac_blending_inv_1_1_q_2*tmp_moved_constant_997 + jac_blending_inv_2_1_q_2*tmp_moved_constant_998)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_996 + jac_blending_inv_1_1_q_2*tmp_moved_constant_997 + jac_blending_inv_2_1_q_2*tmp_moved_constant_998)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_996 + jac_blending_inv_1_2_q_2*tmp_moved_constant_997 + jac_blending_inv_2_2_q_2*tmp_moved_constant_998)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_996 + jac_blending_inv_1_2_q_2*tmp_moved_constant_997 + jac_blending_inv_2_2_q_2*tmp_moved_constant_998))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_999 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1001)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_999 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1001)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_999 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1001)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_999 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1001)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_999 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1001)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_999 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1000 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1001))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1004)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1004)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1004)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1004)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1004)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1002 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1003 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1004))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_990 + jac_blending_inv_1_0_q_0*tmp_moved_constant_991 + jac_blending_inv_2_0_q_0*tmp_moved_constant_992)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_990 + jac_blending_inv_1_0_q_0*tmp_moved_constant_991 + jac_blending_inv_2_0_q_0*tmp_moved_constant_992)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_990 + jac_blending_inv_1_1_q_0*tmp_moved_constant_991 + jac_blending_inv_2_1_q_0*tmp_moved_constant_992)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_990 + jac_blending_inv_1_1_q_0*tmp_moved_constant_991 + jac_blending_inv_2_1_q_0*tmp_moved_constant_992)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_990 + jac_blending_inv_1_2_q_0*tmp_moved_constant_991 + jac_blending_inv_2_2_q_0*tmp_moved_constant_992)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_990 + jac_blending_inv_1_2_q_0*tmp_moved_constant_991 + jac_blending_inv_2_2_q_0*tmp_moved_constant_992)));
                const real_t elMatDiag_3 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1010)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1010)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1010)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1010)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1010)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1008 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1009 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1010))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1013)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1013)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1013)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1013)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1013)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1011 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1012 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1013))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1016)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1016)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1016)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1016)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1016)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1014 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1015 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1016))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1019)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1019)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1019)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1019)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1019)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1017 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1018 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1019))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1007)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1007)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1007)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1007)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1007)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1005 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1006 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1007)));
                const real_t elMatDiag_4 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1037)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1037)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1037)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1037)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1037)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1031 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1034 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1037))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1046)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1046)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1046)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1046)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1046)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1040 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1043 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1046))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1055)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1055)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1055)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1055)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1055)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1049 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1052 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1055))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1064)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1064)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1064)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1064)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1064)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1058 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1061 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1064))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1028)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1028)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1028)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1028)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1028)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1022 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1025 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1028)));
                const real_t elMatDiag_5 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1082)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1082)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1082)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1082)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1082)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1076 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1079 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1082))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1091)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1091)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1091)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1091)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1091)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1085 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1088 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1091))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1100)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1100)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1100)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1100)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1100)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1094 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1097 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1100))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1109)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1109)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1109)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1109)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1109)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1103 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1106 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1109))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1073)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1073)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1073)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1073)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1073)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1067 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1070 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1073)));
                const real_t elMatDiag_6 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1127)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1127)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1127)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1127)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1127)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1121 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1124 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1127))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1136)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1136)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1136)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1136)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1136)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1130 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1133 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1136))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1145)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1145)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1145)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1145)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1145)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1139 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1142 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1145))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1154)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1154)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1154)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1154)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1154)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1148 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1151 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1154))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1118)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1118)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1118)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1118)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1118)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1112 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1115 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1118)));
                const real_t elMatDiag_7 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1160)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1160)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1160)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1160)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1160)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1158 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1159 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1160))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1163)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1163)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1163)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1163)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1163)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1161 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1162 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1163))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1166)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1166)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1166)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1166)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1166)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1164 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1165 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1166))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1169)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1169)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1169)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1169)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1169)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1167 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1168 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1169))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1157)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1157)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1157)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1157)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1157)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1155 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1156 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1157)));
                const real_t elMatDiag_8 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1175)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1175)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1175)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1175)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1175)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1173 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1174 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1175))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1178)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1178)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1178)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1178)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1178)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1176 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1177 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1178))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1181)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1181)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1181)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1181)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1181)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1179 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1180 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1181))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1184)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1184)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1184)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1184)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1184)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1182 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1183 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1184))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1172)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1172)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1172)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1172)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1172)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1170 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1171 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1172)));
                const real_t elMatDiag_9 = tmp_kernel_op_17*(((jac_blending_inv_0_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1190)*(jac_blending_inv_0_0_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_0_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_0_q_1*tmp_moved_constant_1190)) + ((jac_blending_inv_0_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1190)*(jac_blending_inv_0_1_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_1_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_1_q_1*tmp_moved_constant_1190)) + ((jac_blending_inv_0_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1190)*(jac_blending_inv_0_2_q_1*tmp_moved_constant_1188 + jac_blending_inv_1_2_q_1*tmp_moved_constant_1189 + jac_blending_inv_2_2_q_1*tmp_moved_constant_1190))) + tmp_kernel_op_26*(((jac_blending_inv_0_0_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1193)*(jac_blending_inv_0_0_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_0_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_0_q_2*tmp_moved_constant_1193)) + ((jac_blending_inv_0_1_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1193)*(jac_blending_inv_0_1_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_1_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_1_q_2*tmp_moved_constant_1193)) + ((jac_blending_inv_0_2_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1193)*(jac_blending_inv_0_2_q_2*tmp_moved_constant_1191 + jac_blending_inv_1_2_q_2*tmp_moved_constant_1192 + jac_blending_inv_2_2_q_2*tmp_moved_constant_1193))) + tmp_kernel_op_35*(((jac_blending_inv_0_0_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1196)*(jac_blending_inv_0_0_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_0_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_0_q_3*tmp_moved_constant_1196)) + ((jac_blending_inv_0_1_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1196)*(jac_blending_inv_0_1_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_1_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_1_q_3*tmp_moved_constant_1196)) + ((jac_blending_inv_0_2_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1196)*(jac_blending_inv_0_2_q_3*tmp_moved_constant_1194 + jac_blending_inv_1_2_q_3*tmp_moved_constant_1195 + jac_blending_inv_2_2_q_3*tmp_moved_constant_1196))) + tmp_kernel_op_44*(((jac_blending_inv_0_0_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1199)*(jac_blending_inv_0_0_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_0_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_0_q_4*tmp_moved_constant_1199)) + ((jac_blending_inv_0_1_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1199)*(jac_blending_inv_0_1_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_1_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_1_q_4*tmp_moved_constant_1199)) + ((jac_blending_inv_0_2_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1199)*(jac_blending_inv_0_2_q_4*tmp_moved_constant_1197 + jac_blending_inv_1_2_q_4*tmp_moved_constant_1198 + jac_blending_inv_2_2_q_4*tmp_moved_constant_1199))) + tmp_kernel_op_8*(((jac_blending_inv_0_0_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1187)*(jac_blending_inv_0_0_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_0_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_0_q_0*tmp_moved_constant_1187)) + ((jac_blending_inv_0_1_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1187)*(jac_blending_inv_0_1_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_1_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_1_q_0*tmp_moved_constant_1187)) + ((jac_blending_inv_0_2_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1187)*(jac_blending_inv_0_2_q_0*tmp_moved_constant_1185 + jac_blending_inv_1_2_q_0*tmp_moved_constant_1186 + jac_blending_inv_2_2_q_0*tmp_moved_constant_1187)));
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
