/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

































#include "../P2ElementwiseDiffusionParametricP2Map.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDiffusionParametricP2Map::apply_P2ElementwiseDiffusionParametricP2Map_macro_3D( real_t * RESTRICT  _data_dstEdge, real_t * RESTRICT  _data_dstVertex, real_t * RESTRICT  _data_micromesh_edge_0, real_t * RESTRICT  _data_micromesh_edge_1, real_t * RESTRICT  _data_micromesh_edge_2, real_t * RESTRICT  _data_micromesh_vertex_0, real_t * RESTRICT  _data_micromesh_vertex_1, real_t * RESTRICT  _data_micromesh_vertex_2, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_kernel_op_0 = 0.55278640450004202;
       const real_t tmp_kernel_op_1 = tmp_kernel_op_0 - 1.0;
       const real_t tmp_kernel_op_2 = 0.55278640450004202;
       const real_t tmp_kernel_op_3 = 2.3416407864998736;
       const real_t tmp_kernel_op_4 = tmp_kernel_op_2 + tmp_kernel_op_3;
       const real_t tmp_kernel_op_5 = -tmp_kernel_op_4 + 2.8944271909999157;
       const real_t tmp_kernel_op_7 = tmp_kernel_op_0 + tmp_kernel_op_4 - 3.0;
       const real_t tmp_kernel_op_11 = tmp_kernel_op_2 - 1.0;
       const real_t tmp_kernel_op_12 = tmp_kernel_op_0 - 4.0;
       const real_t tmp_kernel_op_13 = -tmp_kernel_op_12 - tmp_kernel_op_3 - 1.105572809000084;
       const real_t tmp_kernel_op_25 = tmp_kernel_op_3 - 1.0;
       const real_t tmp_kernel_op_26 = -tmp_kernel_op_12 - tmp_kernel_op_2 - 4.6832815729997472;
       const real_t tmp_kernel_op_54 = 0.55278640450004202;
       const real_t tmp_kernel_op_55 = tmp_kernel_op_54 - 1.0;
       const real_t tmp_kernel_op_56 = 2.3416407864998736;
       const real_t tmp_kernel_op_57 = 0.55278640450004202;
       const real_t tmp_kernel_op_58 = tmp_kernel_op_56 + tmp_kernel_op_57;
       const real_t tmp_kernel_op_59 = -tmp_kernel_op_58 + 2.8944271909999157;
       const real_t tmp_kernel_op_61 = tmp_kernel_op_54 + tmp_kernel_op_58 - 3.0;
       const real_t tmp_kernel_op_65 = tmp_kernel_op_56 - 1.0;
       const real_t tmp_kernel_op_66 = tmp_kernel_op_54 - 4.0;
       const real_t tmp_kernel_op_67 = -tmp_kernel_op_57 - tmp_kernel_op_66 - 4.6832815729997472;
       const real_t tmp_kernel_op_79 = tmp_kernel_op_57 - 1.0;
       const real_t tmp_kernel_op_80 = -tmp_kernel_op_56 - tmp_kernel_op_66 - 1.105572809000084;
       const real_t tmp_kernel_op_108 = 2.3416407864998736;
       const real_t tmp_kernel_op_109 = tmp_kernel_op_108 - 1.0;
       const real_t tmp_kernel_op_110 = 0.55278640450004202;
       const real_t tmp_kernel_op_111 = 0.55278640450004202;
       const real_t tmp_kernel_op_112 = tmp_kernel_op_110 + tmp_kernel_op_111;
       const real_t tmp_kernel_op_113 = -tmp_kernel_op_112 - 0.68328157299974723;
       const real_t tmp_kernel_op_115 = tmp_kernel_op_108 + tmp_kernel_op_112 - 3.0;
       const real_t tmp_kernel_op_119 = tmp_kernel_op_110 - 1.0;
       const real_t tmp_kernel_op_120 = tmp_kernel_op_108 - 4.0;
       const real_t tmp_kernel_op_121 = -tmp_kernel_op_111 - tmp_kernel_op_120 - 1.105572809000084;
       const real_t tmp_kernel_op_133 = tmp_kernel_op_111 - 1.0;
       const real_t tmp_kernel_op_134 = -tmp_kernel_op_110 - tmp_kernel_op_120 - 1.105572809000084;
       const real_t tmp_kernel_op_162 = 0.55278640450004202;
       const real_t tmp_kernel_op_163 = tmp_kernel_op_162 - 1.0;
       const real_t tmp_kernel_op_164 = 0.55278640450004202;
       const real_t tmp_kernel_op_165 = 0.55278640450004202;
       const real_t tmp_kernel_op_166 = tmp_kernel_op_164 + tmp_kernel_op_165;
       const real_t tmp_kernel_op_167 = -tmp_kernel_op_166 + 2.8944271909999157;
       const real_t tmp_kernel_op_169 = tmp_kernel_op_162 + tmp_kernel_op_166 - 3.0;
       const real_t tmp_kernel_op_173 = tmp_kernel_op_164 - 1.0;
       const real_t tmp_kernel_op_174 = tmp_kernel_op_162 - 4.0;
       const real_t tmp_kernel_op_175 = -tmp_kernel_op_165 - tmp_kernel_op_174 - 1.105572809000084;
       const real_t tmp_kernel_op_187 = tmp_kernel_op_165 - 1.0;
       const real_t tmp_kernel_op_188 = -tmp_kernel_op_164 - tmp_kernel_op_174 - 1.105572809000084;
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_7 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 += 4)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const __m256d p_affine_0_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_0_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_0_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_1_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_1_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_1_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_2_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_2_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_2_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d p_affine_3_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0,macro_vertex_coord_id_1comp0)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0,macro_vertex_coord_id_2comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0)),_mm256_set_pd(macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0,macro_vertex_coord_id_3comp0)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0,macro_vertex_coord_id_0comp0));
                const __m256d p_affine_3_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1,macro_vertex_coord_id_1comp1)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1,macro_vertex_coord_id_2comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1)),_mm256_set_pd(macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1,macro_vertex_coord_id_3comp1)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1,macro_vertex_coord_id_0comp1));
                const __m256d p_affine_3_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2,macro_vertex_coord_id_1comp2)),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float))),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2,macro_vertex_coord_id_2comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2)),_mm256_set_pd(macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2,macro_vertex_coord_id_3comp2)),_mm256_add_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_loadu_pd(& _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0]))),_mm256_set_pd(1.0,1.0,1.0,1.0)),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),_mm256_set_pd(micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float,micro_edges_per_macro_edge_float)))),_mm256_set_pd(macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2,macro_vertex_coord_id_0comp2));
                const __m256d src_dof_0 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_1 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_2 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d src_dof_3 = _mm256_loadu_pd(& _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d src_dof_4 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_5 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_6 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d src_dof_7 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d src_dof_8 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d src_dof_9 = _mm256_loadu_pd(& _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_0 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_1 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_10 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_11 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_12 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_13 = _mm256_loadu_pd(& _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_14 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_15 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_16 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_17 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_18 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_19 = _mm256_loadu_pd(& _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_2 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_20 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_21 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_22 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d micromesh_dof_23 = _mm256_loadu_pd(& _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_24 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_25 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_26 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_27 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_28 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_29 = _mm256_loadu_pd(& _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_3 = _mm256_loadu_pd(& _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d micromesh_dof_4 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_5 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_6 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]);
                const __m256d micromesh_dof_7 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d micromesh_dof_8 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]);
                const __m256d micromesh_dof_9 = _mm256_loadu_pd(& _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]);
                const __m256d tmp_kernel_op_6 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_8 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_9 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_10 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_6),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_14 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_15 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_16 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3)),tmp_kernel_op_15);
                const __m256d tmp_kernel_op_17 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_14),tmp_kernel_op_16);
                const __m256d tmp_kernel_op_18 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_17);
                const __m256d tmp_kernel_op_19 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_20 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_19),tmp_kernel_op_6),tmp_kernel_op_8);
                const __m256d tmp_kernel_op_21 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_22 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_16),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_23 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_22);
                const __m256d tmp_kernel_op_24 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_23,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_18);
                const __m256d tmp_kernel_op_27 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_28 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),tmp_kernel_op_28);
                const __m256d tmp_kernel_op_30 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_27),tmp_kernel_op_29);
                const __m256d tmp_kernel_op_31 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_32 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),tmp_kernel_op_27),tmp_kernel_op_28),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_33 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_14),tmp_kernel_op_15),tmp_kernel_op_21);
                const __m256d tmp_kernel_op_34 = _mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_35 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3))),tmp_kernel_op_29),tmp_kernel_op_31);
                const __m256d tmp_kernel_op_36 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),tmp_kernel_op_19),tmp_kernel_op_9);
                const __m256d tmp_kernel_op_37 = _mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_33);
                const __m256d tmp_kernel_op_38 = _mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_36);
                const __m256d tmp_kernel_op_39 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_18,tmp_kernel_op_30),_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_34)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_23,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_38),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_37),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),tmp_kernel_op_36));
                const __m256d tmp_kernel_op_40 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39);
                const __m256d tmp_kernel_op_41 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7));
                const __m256d tmp_kernel_op_42 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_37,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_36));
                const __m256d tmp_kernel_op_43 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_38,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_34);
                const __m256d tmp_kernel_op_44 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_41),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_42)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_43));
                const __m256d tmp_kernel_op_45 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_32),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_46 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_10,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_36),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_47 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_35,tmp_kernel_op_36),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_20,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_48 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_45),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_46)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_47));
                const __m256d tmp_kernel_op_49 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_35),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_32),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_50 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_32,tmp_kernel_op_33),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_22,tmp_kernel_op_30),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_51 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_17,tmp_kernel_op_30),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,tmp_kernel_op_35),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_52 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_49),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_50)),_mm256_mul_pd(tmp_kernel_op_41,tmp_kernel_op_51));
                const __m256d tmp_kernel_op_53 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_39))));
                const __m256d tmp_kernel_op_60 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_62 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_63 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),tmp_kernel_op_62);
                const __m256d tmp_kernel_op_64 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_60),tmp_kernel_op_63);
                const __m256d tmp_kernel_op_68 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_69 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_70 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),tmp_kernel_op_69);
                const __m256d tmp_kernel_op_71 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_68),tmp_kernel_op_70);
                const __m256d tmp_kernel_op_72 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_71);
                const __m256d tmp_kernel_op_73 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_74 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_60),tmp_kernel_op_62),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_75 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_76 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_70),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_77 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_76);
                const __m256d tmp_kernel_op_78 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_77,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_72);
                const __m256d tmp_kernel_op_81 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_82 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_83 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),tmp_kernel_op_82);
                const __m256d tmp_kernel_op_84 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_81),tmp_kernel_op_83);
                const __m256d tmp_kernel_op_85 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_86 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),tmp_kernel_op_81),tmp_kernel_op_82),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_87 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_68),tmp_kernel_op_69),tmp_kernel_op_75);
                const __m256d tmp_kernel_op_88 = _mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_89 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),tmp_kernel_op_83),tmp_kernel_op_85);
                const __m256d tmp_kernel_op_90 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),tmp_kernel_op_63),tmp_kernel_op_73);
                const __m256d tmp_kernel_op_91 = _mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_87);
                const __m256d tmp_kernel_op_92 = _mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_90);
                const __m256d tmp_kernel_op_93 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_72,tmp_kernel_op_84),_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_88)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_77,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_92),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_91),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),tmp_kernel_op_90));
                const __m256d tmp_kernel_op_94 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93);
                const __m256d tmp_kernel_op_95 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61,tmp_kernel_op_61));
                const __m256d tmp_kernel_op_96 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_91,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_90));
                const __m256d tmp_kernel_op_97 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_92,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_88);
                const __m256d tmp_kernel_op_98 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_96)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_97));
                const __m256d tmp_kernel_op_99 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_86),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_100 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_64,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_90),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_101 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_89,tmp_kernel_op_90),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_74,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_102 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_95,tmp_kernel_op_99));
                const __m256d tmp_kernel_op_103 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_89),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_86),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_104 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_86,tmp_kernel_op_87),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_76,tmp_kernel_op_84),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_105 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_71,tmp_kernel_op_84),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_87,tmp_kernel_op_89),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_106 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_95),_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_95)),_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_95));
                const __m256d tmp_kernel_op_107 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_93))));
                const __m256d tmp_kernel_op_114 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_116 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_117 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110)),tmp_kernel_op_116);
                const __m256d tmp_kernel_op_118 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_114),tmp_kernel_op_117);
                const __m256d tmp_kernel_op_122 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_123 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_124 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111)),tmp_kernel_op_123);
                const __m256d tmp_kernel_op_125 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_122),tmp_kernel_op_124);
                const __m256d tmp_kernel_op_126 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_125);
                const __m256d tmp_kernel_op_127 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_128 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_114),tmp_kernel_op_116),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_129 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_130 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_124),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_131 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_130);
                const __m256d tmp_kernel_op_132 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_131,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_126);
                const __m256d tmp_kernel_op_135 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_136 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_137 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),tmp_kernel_op_136);
                const __m256d tmp_kernel_op_138 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_135),tmp_kernel_op_137);
                const __m256d tmp_kernel_op_139 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_140 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),tmp_kernel_op_135),tmp_kernel_op_136),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_141 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_122),tmp_kernel_op_123),tmp_kernel_op_129);
                const __m256d tmp_kernel_op_142 = _mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_143 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),tmp_kernel_op_137),tmp_kernel_op_139);
                const __m256d tmp_kernel_op_144 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),tmp_kernel_op_117),tmp_kernel_op_127);
                const __m256d tmp_kernel_op_145 = _mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_141);
                const __m256d tmp_kernel_op_146 = _mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_144);
                const __m256d tmp_kernel_op_147 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_126,tmp_kernel_op_138),_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_142)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_131,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_146),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_145),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),tmp_kernel_op_144));
                const __m256d tmp_kernel_op_148 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147);
                const __m256d tmp_kernel_op_149 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115,tmp_kernel_op_115));
                const __m256d tmp_kernel_op_150 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_145,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_144));
                const __m256d tmp_kernel_op_151 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_146,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_142);
                const __m256d tmp_kernel_op_152 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_149),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_150)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_151));
                const __m256d tmp_kernel_op_153 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_140),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_154 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_118,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_144),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_155 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_143,tmp_kernel_op_144),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_128,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_156 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_153),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_154)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_155));
                const __m256d tmp_kernel_op_157 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_143),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_140),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_158 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_140,tmp_kernel_op_141),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_130,tmp_kernel_op_138),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_159 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_125,tmp_kernel_op_138),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_141,tmp_kernel_op_143),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_160 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_157),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_158)),_mm256_mul_pd(tmp_kernel_op_149,tmp_kernel_op_159));
                const __m256d tmp_kernel_op_161 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_147))));
                const __m256d tmp_kernel_op_168 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_170 = _mm256_mul_pd(micromesh_dof_0,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_171 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164)),tmp_kernel_op_170);
                const __m256d tmp_kernel_op_172 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_1,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_168),tmp_kernel_op_171);
                const __m256d tmp_kernel_op_176 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_177 = _mm256_mul_pd(micromesh_dof_10,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_178 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165)),tmp_kernel_op_177);
                const __m256d tmp_kernel_op_179 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_12,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_176),tmp_kernel_op_178);
                const __m256d tmp_kernel_op_180 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_179);
                const __m256d tmp_kernel_op_181 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_9,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_182 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_6,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_2,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_8,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_168),tmp_kernel_op_170),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_183 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_18,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_184 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_11,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_16,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_19,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_178),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_185 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_184);
                const __m256d tmp_kernel_op_186 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_185,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_180);
                const __m256d tmp_kernel_op_189 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_190 = _mm256_mul_pd(micromesh_dof_20,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_191 = _mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),tmp_kernel_op_190);
                const __m256d tmp_kernel_op_192 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_23,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_189),tmp_kernel_op_191);
                const __m256d tmp_kernel_op_193 = _mm256_mul_pd(_mm256_mul_pd(micromesh_dof_27,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_194 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_21,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163)),_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_25,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_29,_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),tmp_kernel_op_189),tmp_kernel_op_190),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_195 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_15,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_14,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_13,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_17,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_176),tmp_kernel_op_177),tmp_kernel_op_183);
                const __m256d tmp_kernel_op_196 = _mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_197 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_26,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_24,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165))),_mm256_mul_pd(micromesh_dof_22,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173))),_mm256_mul_pd(micromesh_dof_28,_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),tmp_kernel_op_191),tmp_kernel_op_193);
                const __m256d tmp_kernel_op_198 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(micromesh_dof_5,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162)),_mm256_mul_pd(micromesh_dof_4,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164))),_mm256_mul_pd(micromesh_dof_3,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187))),_mm256_mul_pd(micromesh_dof_7,_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),tmp_kernel_op_171),tmp_kernel_op_181);
                const __m256d tmp_kernel_op_199 = _mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_195);
                const __m256d tmp_kernel_op_200 = _mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_198);
                const __m256d tmp_kernel_op_201 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_180,tmp_kernel_op_192),_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_196)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_185,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_200),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_199),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),tmp_kernel_op_198));
                const __m256d tmp_kernel_op_202 = _mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201);
                const __m256d tmp_kernel_op_203 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169,tmp_kernel_op_169));
                const __m256d tmp_kernel_op_204 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_199,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_198));
                const __m256d tmp_kernel_op_205 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_200,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),tmp_kernel_op_196);
                const __m256d tmp_kernel_op_206 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_203),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_204)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_205));
                const __m256d tmp_kernel_op_207 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_194),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_208 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_172,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_198),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_209 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_197,tmp_kernel_op_198),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_182,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_210 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_207),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_208)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_209));
                const __m256d tmp_kernel_op_211 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_197),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_194),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_212 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_194,tmp_kernel_op_195),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_184,tmp_kernel_op_192),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_213 = _mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_179,tmp_kernel_op_192),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_195,tmp_kernel_op_197),_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)));
                const __m256d tmp_kernel_op_214 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_211),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_212)),_mm256_mul_pd(tmp_kernel_op_203,tmp_kernel_op_213));
                const __m256d tmp_kernel_op_215 = _mm256_mul_pd(_mm256_set_pd(0.041666666666666657,0.041666666666666657,0.041666666666666657,0.041666666666666657),_mm256_castsi256_pd(_mm256_and_si256(_mm256_set1_epi64x(0x7fffffffffffffff), _mm256_castpd_si256(tmp_kernel_op_201))));
                const __m256d tmp_kernel_op_216 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_217 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_218 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_219 = _mm256_mul_pd(tmp_kernel_op_216,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_220 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_221 = _mm256_mul_pd(tmp_kernel_op_220,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_222 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_223 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_220);
                const __m256d tmp_kernel_op_224 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_225 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_226 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_227 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_224);
                const __m256d tmp_kernel_op_228 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_229 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_230 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_231 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_228);
                const __m256d tmp_kernel_op_232 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_222),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_223)),_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_225),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_226)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_227)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_229),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_230)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_231)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_233 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_234 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_235 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_236 = _mm256_mul_pd(tmp_kernel_op_233,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_237 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_238 = _mm256_mul_pd(tmp_kernel_op_237,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_239 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_240 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_237);
                const __m256d tmp_kernel_op_241 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_242 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_243 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_244 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_241);
                const __m256d tmp_kernel_op_245 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_246 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_247 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_248 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_245);
                const __m256d tmp_kernel_op_249 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_239),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_240)),_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_242),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_243)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_244)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_246),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_247)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_248)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_250 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_251 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_250);
                const __m256d tmp_kernel_op_252 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_253 = _mm256_mul_pd(tmp_kernel_op_250,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_254 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_255 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_256 = _mm256_mul_pd(tmp_kernel_op_254,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_257 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_254);
                const __m256d tmp_kernel_op_258 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_259 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_260 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_261 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_258);
                const __m256d tmp_kernel_op_262 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_263 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_264 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_265 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_262);
                const __m256d tmp_kernel_op_266 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_256),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_257)),_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_259),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_260)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_261)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_263),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_264)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_265)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_267 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2));
                const __m256d tmp_kernel_op_268 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_267);
                const __m256d tmp_kernel_op_269 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3,tmp_kernel_op_3));
                const __m256d tmp_kernel_op_270 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_271 = _mm256_add_pd(tmp_kernel_op_268,tmp_kernel_op_270);
                const __m256d tmp_kernel_op_272 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_273 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_274 = _mm256_add_pd(tmp_kernel_op_272,tmp_kernel_op_273);
                const __m256d tmp_kernel_op_275 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_276 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_277 = _mm256_add_pd(tmp_kernel_op_275,tmp_kernel_op_276);
                const __m256d tmp_kernel_op_278 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56));
                const __m256d tmp_kernel_op_279 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_280 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57));
                const __m256d tmp_kernel_op_281 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_282 = _mm256_add_pd(tmp_kernel_op_279,tmp_kernel_op_281);
                const __m256d tmp_kernel_op_283 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_284 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_285 = _mm256_add_pd(tmp_kernel_op_283,tmp_kernel_op_284);
                const __m256d tmp_kernel_op_286 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_287 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_288 = _mm256_add_pd(tmp_kernel_op_286,tmp_kernel_op_287);
                const __m256d tmp_kernel_op_289 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110,tmp_kernel_op_110));
                const __m256d tmp_kernel_op_290 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_291 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111,tmp_kernel_op_111));
                const __m256d tmp_kernel_op_292 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_293 = _mm256_add_pd(tmp_kernel_op_290,tmp_kernel_op_292);
                const __m256d tmp_kernel_op_294 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_295 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_296 = _mm256_add_pd(tmp_kernel_op_294,tmp_kernel_op_295);
                const __m256d tmp_kernel_op_297 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_298 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_299 = _mm256_add_pd(tmp_kernel_op_297,tmp_kernel_op_298);
                const __m256d tmp_kernel_op_300 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164,tmp_kernel_op_164));
                const __m256d tmp_kernel_op_301 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_302 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165,tmp_kernel_op_165));
                const __m256d tmp_kernel_op_303 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_304 = _mm256_add_pd(tmp_kernel_op_301,tmp_kernel_op_303);
                const __m256d tmp_kernel_op_305 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_306 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_307 = _mm256_add_pd(tmp_kernel_op_305,tmp_kernel_op_306);
                const __m256d tmp_kernel_op_308 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_309 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_310 = _mm256_add_pd(tmp_kernel_op_308,tmp_kernel_op_309);
                const __m256d tmp_kernel_op_311 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_285),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_288)),_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_310)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_312 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0,tmp_kernel_op_0));
                const __m256d tmp_kernel_op_313 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_312);
                const __m256d tmp_kernel_op_314 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_315 = _mm256_add_pd(tmp_kernel_op_313,tmp_kernel_op_314);
                const __m256d tmp_kernel_op_316 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_45);
                const __m256d tmp_kernel_op_317 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_318 = _mm256_add_pd(tmp_kernel_op_316,tmp_kernel_op_317);
                const __m256d tmp_kernel_op_319 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_320 = _mm256_mul_pd(tmp_kernel_op_269,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_321 = _mm256_add_pd(tmp_kernel_op_319,tmp_kernel_op_320);
                const __m256d tmp_kernel_op_322 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54));
                const __m256d tmp_kernel_op_323 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_324 = _mm256_mul_pd(tmp_kernel_op_280,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_325 = _mm256_add_pd(tmp_kernel_op_323,tmp_kernel_op_324);
                const __m256d tmp_kernel_op_326 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_327 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_328 = _mm256_add_pd(tmp_kernel_op_326,tmp_kernel_op_327);
                const __m256d tmp_kernel_op_329 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_330 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_280);
                const __m256d tmp_kernel_op_331 = _mm256_add_pd(tmp_kernel_op_329,tmp_kernel_op_330);
                const __m256d tmp_kernel_op_332 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108,tmp_kernel_op_108));
                const __m256d tmp_kernel_op_333 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_334 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_335 = _mm256_add_pd(tmp_kernel_op_333,tmp_kernel_op_334);
                const __m256d tmp_kernel_op_336 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_337 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_338 = _mm256_add_pd(tmp_kernel_op_336,tmp_kernel_op_337);
                const __m256d tmp_kernel_op_339 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_340 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_291);
                const __m256d tmp_kernel_op_341 = _mm256_add_pd(tmp_kernel_op_339,tmp_kernel_op_340);
                const __m256d tmp_kernel_op_342 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162,tmp_kernel_op_162));
                const __m256d tmp_kernel_op_343 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_344 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_345 = _mm256_add_pd(tmp_kernel_op_343,tmp_kernel_op_344);
                const __m256d tmp_kernel_op_346 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_347 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_348 = _mm256_add_pd(tmp_kernel_op_346,tmp_kernel_op_347);
                const __m256d tmp_kernel_op_349 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_350 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_302);
                const __m256d tmp_kernel_op_351 = _mm256_add_pd(tmp_kernel_op_349,tmp_kernel_op_350);
                const __m256d tmp_kernel_op_352 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_328),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_331)),_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_351)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_353 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_42);
                const __m256d tmp_kernel_op_354 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_43);
                const __m256d tmp_kernel_op_355 = _mm256_add_pd(tmp_kernel_op_353,tmp_kernel_op_354);
                const __m256d tmp_kernel_op_356 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_46);
                const __m256d tmp_kernel_op_357 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_47);
                const __m256d tmp_kernel_op_358 = _mm256_add_pd(tmp_kernel_op_356,tmp_kernel_op_357);
                const __m256d tmp_kernel_op_359 = _mm256_mul_pd(tmp_kernel_op_312,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_360 = _mm256_mul_pd(tmp_kernel_op_267,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_361 = _mm256_add_pd(tmp_kernel_op_359,tmp_kernel_op_360);
                const __m256d tmp_kernel_op_362 = _mm256_mul_pd(tmp_kernel_op_322,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_363 = _mm256_mul_pd(tmp_kernel_op_278,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_364 = _mm256_add_pd(tmp_kernel_op_362,tmp_kernel_op_363);
                const __m256d tmp_kernel_op_365 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_366 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_367 = _mm256_add_pd(tmp_kernel_op_365,tmp_kernel_op_366);
                const __m256d tmp_kernel_op_368 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_322);
                const __m256d tmp_kernel_op_369 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_278);
                const __m256d tmp_kernel_op_370 = _mm256_add_pd(tmp_kernel_op_368,tmp_kernel_op_369);
                const __m256d tmp_kernel_op_371 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_372 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_373 = _mm256_add_pd(tmp_kernel_op_371,tmp_kernel_op_372);
                const __m256d tmp_kernel_op_374 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_375 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_376 = _mm256_add_pd(tmp_kernel_op_374,tmp_kernel_op_375);
                const __m256d tmp_kernel_op_377 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_332);
                const __m256d tmp_kernel_op_378 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_289);
                const __m256d tmp_kernel_op_379 = _mm256_add_pd(tmp_kernel_op_377,tmp_kernel_op_378);
                const __m256d tmp_kernel_op_380 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_381 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_382 = _mm256_add_pd(tmp_kernel_op_380,tmp_kernel_op_381);
                const __m256d tmp_kernel_op_383 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_384 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_385 = _mm256_add_pd(tmp_kernel_op_383,tmp_kernel_op_384);
                const __m256d tmp_kernel_op_386 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_342);
                const __m256d tmp_kernel_op_387 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_300);
                const __m256d tmp_kernel_op_388 = _mm256_add_pd(tmp_kernel_op_386,tmp_kernel_op_387);
                const __m256d tmp_kernel_op_389 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_367),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_370)),_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_388)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_390 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_270,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_314,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_391 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_273,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_317,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_392 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_276,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_320,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)));
                const __m256d tmp_kernel_op_393 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_281,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_324,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_394 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_284,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_327,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_395 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_287,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_330,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)));
                const __m256d tmp_kernel_op_396 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_292,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_334,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_397 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_295,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_337,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_398 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_298,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_340,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)));
                const __m256d tmp_kernel_op_399 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_303,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_344,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_400 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_306,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_347,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_401 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_309,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_350,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)));
                const __m256d tmp_kernel_op_402 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_394),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_395)),_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_401)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_403 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_268,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_354,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_404 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_272,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_357,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_405 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_275,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_360,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)));
                const __m256d tmp_kernel_op_406 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_279,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_363,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_407 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_283,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_366,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_408 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_286,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_369,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)));
                const __m256d tmp_kernel_op_409 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_290,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_372,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_410 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_294,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_375,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_411 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_297,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_378,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)));
                const __m256d tmp_kernel_op_412 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_301,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_381,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_413 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_305,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_384,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_414 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_308,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_387,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)));
                const __m256d tmp_kernel_op_415 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_407),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_408)),_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_414)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_416 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_313,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_353,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_417 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_316,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_356,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_418 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_319,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_359,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d tmp_kernel_op_419 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_323,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_362,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_420 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_326,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_365,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_421 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_329,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_368,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)));
                const __m256d tmp_kernel_op_422 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_333,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_371,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_423 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_336,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_374,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_424 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_339,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_377,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)));
                const __m256d tmp_kernel_op_425 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_343,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_380,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_426 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_346,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_383,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_427 = _mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_349,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_386,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)));
                const __m256d tmp_kernel_op_428 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_420),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_421)),_mm256_mul_pd(tmp_kernel_op_419,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_427)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_416,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_417,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_418,tmp_kernel_op_52))));
                const __m256d tmp_kernel_op_429 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_39));
                const __m256d tmp_kernel_op_430 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_431 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_432 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_93));
                const __m256d tmp_kernel_op_433 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_434 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_435 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_147));
                const __m256d tmp_kernel_op_436 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_437 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_438 = _mm256_mul_pd(_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201),_mm256_div_pd(_mm256_set_pd(1.0,1.0,1.0,1.0),tmp_kernel_op_201));
                const __m256d tmp_kernel_op_439 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(16.0,16.0,16.0,16.0));
                const __m256d tmp_kernel_op_440 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_441 = _mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1,tmp_kernel_op_1));
                const __m256d tmp_kernel_op_442 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11));
                const __m256d tmp_kernel_op_443 = _mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55));
                const __m256d tmp_kernel_op_444 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65));
                const __m256d tmp_kernel_op_445 = _mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109,tmp_kernel_op_109));
                const __m256d tmp_kernel_op_446 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119));
                const __m256d tmp_kernel_op_447 = _mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163,tmp_kernel_op_163));
                const __m256d tmp_kernel_op_448 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173));
                const __m256d tmp_kernel_op_449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_101),tmp_kernel_op_444),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_105),tmp_kernel_op_444)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_444,tmp_kernel_op_96),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_151),tmp_kernel_op_446),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_155),tmp_kernel_op_446)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_159),tmp_kernel_op_446)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_205),tmp_kernel_op_448),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_209),tmp_kernel_op_448)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_213),tmp_kernel_op_448)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_43),tmp_kernel_op_442),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_46),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_442,tmp_kernel_op_50),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_450 = _mm256_mul_pd(tmp_kernel_op_441,_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_451 = _mm256_mul_pd(tmp_kernel_op_443,_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_452 = _mm256_mul_pd(tmp_kernel_op_445,_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_453 = _mm256_mul_pd(tmp_kernel_op_447,_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_454 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_451),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_105),tmp_kernel_op_451)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_451,tmp_kernel_op_78),tmp_kernel_op_97))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_151),tmp_kernel_op_452),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_155),tmp_kernel_op_452)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_159),tmp_kernel_op_452)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_205),tmp_kernel_op_453),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_209),tmp_kernel_op_453)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_213),tmp_kernel_op_453)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_43),tmp_kernel_op_450),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_450),tmp_kernel_op_47)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_450,tmp_kernel_op_49),tmp_kernel_op_51))));
                const __m256d tmp_kernel_op_455 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_456 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_457 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_458 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_459 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_460 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_217,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_218,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_219,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_221,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_222,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_223,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_225,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_226,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_227,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_229,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_230,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_231,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_461 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_462 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_463 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_464 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_465 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_429,_mm256_set_pd(tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11,tmp_kernel_op_11)),_mm256_set_pd(tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25,tmp_kernel_op_25));
                const __m256d tmp_kernel_op_466 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_432,_mm256_set_pd(tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65,tmp_kernel_op_65)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79));
                const __m256d tmp_kernel_op_467 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_435,_mm256_set_pd(tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119,tmp_kernel_op_119)),_mm256_set_pd(tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133,tmp_kernel_op_133));
                const __m256d tmp_kernel_op_468 = _mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_438,_mm256_set_pd(tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173,tmp_kernel_op_173)),_mm256_set_pd(tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187,tmp_kernel_op_187));
                const __m256d tmp_kernel_op_469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_466),tmp_kernel_op_99),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_104),tmp_kernel_op_466)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_466,tmp_kernel_op_78),tmp_kernel_op_96))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_150),tmp_kernel_op_467),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_154),tmp_kernel_op_467)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_158),tmp_kernel_op_467)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_204),tmp_kernel_op_468),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_208),tmp_kernel_op_468)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_212),tmp_kernel_op_468)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_42),tmp_kernel_op_465),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_46),tmp_kernel_op_465)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_465,tmp_kernel_op_49),tmp_kernel_op_50))));
                const __m256d tmp_kernel_op_470 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_471 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_472 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_473 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_475 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_234,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_235,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_236,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_238,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_239,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_240,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_242,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_243,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_244,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_246,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_247,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_248,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_476 = _mm256_mul_pd(tmp_kernel_op_430,_mm256_set_pd(0.11249999999999996,0.11249999999999996,0.11249999999999996,0.11249999999999996));
                const __m256d tmp_kernel_op_477 = _mm256_mul_pd(tmp_kernel_op_433,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_478 = _mm256_mul_pd(tmp_kernel_op_436,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_479 = _mm256_mul_pd(tmp_kernel_op_439,_mm256_set_pd(0.012500000000000002,0.012500000000000002,0.012500000000000002,0.012500000000000002));
                const __m256d tmp_kernel_op_480 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_271),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_274)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_277))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_282),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_285)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_288)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_293),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_296)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_299)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_304),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_307)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_310))));
                const __m256d tmp_kernel_op_481 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_482 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_483 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_484 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_485 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_251,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_252,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_253,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_255,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_256,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_257,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_259,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_260,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_261,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_263,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_264,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_265,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_486 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_487 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_488 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_489 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_490 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_491 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_492 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_49);
                const __m256d tmp_kernel_op_493 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_50);
                const __m256d tmp_kernel_op_494 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_495 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_496 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_497 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_498 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_499 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_500 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_501 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_502 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_503 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_504 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_505 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_506 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_507 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_508 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_509 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_510 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_511 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_512 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_513 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_514 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_515 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_516 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_517 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_518 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_315),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_318)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_321))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_325),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_328)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_331)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_335),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_338)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_341)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_345),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_348)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_351))));
                const __m256d tmp_kernel_op_519 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_520 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_521 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_271,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_274,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_277,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_282,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_285,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_288,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_293,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_296,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_299,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_304,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_307,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_310,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_523 = _mm256_mul_pd(tmp_kernel_op_40,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_524 = _mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_525 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_526 = _mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_527 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_488);
                const __m256d tmp_kernel_op_528 = _mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_529 = _mm256_mul_pd(tmp_kernel_op_488,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_530 = _mm256_mul_pd(tmp_kernel_op_94,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_531 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_78);
                const __m256d tmp_kernel_op_532 = _mm256_mul_pd(tmp_kernel_op_496,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_533 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_99);
                const __m256d tmp_kernel_op_534 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_535 = _mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_536 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_496);
                const __m256d tmp_kernel_op_537 = _mm256_mul_pd(tmp_kernel_op_148,_mm256_set_pd(0.5854101966249684,0.5854101966249684,0.5854101966249684,0.5854101966249684));
                const __m256d tmp_kernel_op_538 = _mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_539 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_540 = _mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_541 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_542 = _mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_543 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_504);
                const __m256d tmp_kernel_op_544 = _mm256_mul_pd(tmp_kernel_op_202,_mm256_set_pd(0.1381966011250105,0.1381966011250105,0.1381966011250105,0.1381966011250105));
                const __m256d tmp_kernel_op_545 = _mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_546 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_547 = _mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_548 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_549 = _mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_550 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_512);
                const __m256d tmp_kernel_op_551 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_355),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_358)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_361))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_364),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_367)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_370)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_373),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_376)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_379)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_382),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_385)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_388))));
                const __m256d tmp_kernel_op_552 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_554 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_315,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_318,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_321,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_325,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_328,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_331,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_335,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_338,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_341,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_345,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_348,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_351,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_555 = _mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_556 = _mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_557 = _mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_558 = _mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_486);
                const __m256d tmp_kernel_op_559 = _mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_523);
                const __m256d tmp_kernel_op_560 = _mm256_mul_pd(tmp_kernel_op_486,tmp_kernel_op_51);
                const __m256d tmp_kernel_op_561 = _mm256_mul_pd(tmp_kernel_op_530,tmp_kernel_op_96);
                const __m256d tmp_kernel_op_562 = _mm256_mul_pd(tmp_kernel_op_494,tmp_kernel_op_97);
                const __m256d tmp_kernel_op_563 = _mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_564 = _mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_565 = _mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_530);
                const __m256d tmp_kernel_op_566 = _mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_494);
                const __m256d tmp_kernel_op_567 = _mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_568 = _mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_569 = _mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_570 = _mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_571 = _mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_537);
                const __m256d tmp_kernel_op_572 = _mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_502);
                const __m256d tmp_kernel_op_573 = _mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_574 = _mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_575 = _mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_576 = _mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_577 = _mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_544);
                const __m256d tmp_kernel_op_578 = _mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_510);
                const __m256d tmp_kernel_op_579 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_390),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_391)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_392))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_393),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_394)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_395)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_396),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_397)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_398)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_399),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_400)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_401))));
                const __m256d tmp_kernel_op_580 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_581 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_355,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_358,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_361,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_364,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_367,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_370,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_373,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_376,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_379,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_382,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_385,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_388,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_582 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_403),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_404)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_405))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_406),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_407)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_408)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_409),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_410)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_411)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_412),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_413)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_414))));
                const __m256d tmp_kernel_op_583 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_390,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_391,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_392,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_393,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_394,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_395,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_396,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_397,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_398,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_399,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_400,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_401,tmp_kernel_op_427))));
                const __m256d tmp_kernel_op_584 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_403,tmp_kernel_op_416),_mm256_mul_pd(tmp_kernel_op_404,tmp_kernel_op_417)),_mm256_mul_pd(tmp_kernel_op_405,tmp_kernel_op_418))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_406,tmp_kernel_op_419),_mm256_mul_pd(tmp_kernel_op_407,tmp_kernel_op_420)),_mm256_mul_pd(tmp_kernel_op_408,tmp_kernel_op_421)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_409,tmp_kernel_op_422),_mm256_mul_pd(tmp_kernel_op_410,tmp_kernel_op_423)),_mm256_mul_pd(tmp_kernel_op_411,tmp_kernel_op_424)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_412,tmp_kernel_op_425),_mm256_mul_pd(tmp_kernel_op_413,tmp_kernel_op_426)),_mm256_mul_pd(tmp_kernel_op_414,tmp_kernel_op_427))));
                const __m256d elMatVec_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_0,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_102,tmp_kernel_op_102),_mm256_mul_pd(tmp_kernel_op_106,tmp_kernel_op_106)),_mm256_mul_pd(tmp_kernel_op_98,tmp_kernel_op_98))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_152,tmp_kernel_op_152),_mm256_mul_pd(tmp_kernel_op_156,tmp_kernel_op_156)),_mm256_mul_pd(tmp_kernel_op_160,tmp_kernel_op_160)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_206,tmp_kernel_op_206),_mm256_mul_pd(tmp_kernel_op_210,tmp_kernel_op_210)),_mm256_mul_pd(tmp_kernel_op_214,tmp_kernel_op_214)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_44,tmp_kernel_op_44),_mm256_mul_pd(tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(tmp_kernel_op_52,tmp_kernel_op_52))))),_mm256_mul_pd(src_dof_1,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_428));
                const __m256d elMatVec_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_1,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_101),tmp_kernel_op_434),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_105),tmp_kernel_op_434)),_mm256_mul_pd(tmp_kernel_op_434,_mm256_mul_pd(tmp_kernel_op_97,tmp_kernel_op_97)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_151,tmp_kernel_op_151),tmp_kernel_op_437),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_155,tmp_kernel_op_155),tmp_kernel_op_437)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_159,tmp_kernel_op_159),tmp_kernel_op_437)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_205,tmp_kernel_op_205),tmp_kernel_op_440),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_209,tmp_kernel_op_209),tmp_kernel_op_440)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_213,tmp_kernel_op_213),tmp_kernel_op_440)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_43,tmp_kernel_op_43),tmp_kernel_op_431),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(tmp_kernel_op_431,_mm256_mul_pd(tmp_kernel_op_51,tmp_kernel_op_51)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_232)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_460));
                const __m256d elMatVec_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_2,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_100),tmp_kernel_op_462),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_104),tmp_kernel_op_462)),_mm256_mul_pd(tmp_kernel_op_462,_mm256_mul_pd(tmp_kernel_op_96,tmp_kernel_op_96)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_150,tmp_kernel_op_150),tmp_kernel_op_463),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_154,tmp_kernel_op_154),tmp_kernel_op_463)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_158,tmp_kernel_op_158),tmp_kernel_op_463)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_204,tmp_kernel_op_204),tmp_kernel_op_464),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_208,tmp_kernel_op_208),tmp_kernel_op_464)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_212,tmp_kernel_op_212),tmp_kernel_op_464)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_42,tmp_kernel_op_42),tmp_kernel_op_461),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_46,tmp_kernel_op_46),tmp_kernel_op_461)),_mm256_mul_pd(tmp_kernel_op_461,_mm256_mul_pd(tmp_kernel_op_50,tmp_kernel_op_50)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_249)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_449)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_475));
                const __m256d elMatVec_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_3,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_103),tmp_kernel_op_477),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_mul_pd(tmp_kernel_op_477,_mm256_mul_pd(tmp_kernel_op_99,tmp_kernel_op_99)))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_132),tmp_kernel_op_478),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_153,tmp_kernel_op_153),tmp_kernel_op_478)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_157,tmp_kernel_op_157),tmp_kernel_op_478)))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_186),tmp_kernel_op_479),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_207,tmp_kernel_op_207),tmp_kernel_op_479)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_211,tmp_kernel_op_211),tmp_kernel_op_479)))),_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_24),tmp_kernel_op_476),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_45,tmp_kernel_op_45),tmp_kernel_op_476)),_mm256_mul_pd(tmp_kernel_op_476,_mm256_mul_pd(tmp_kernel_op_49,tmp_kernel_op_49)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_266)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_454)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_469)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_485));
                const __m256d elMatVec_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_4,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489),_mm256_add_pd(tmp_kernel_op_487,tmp_kernel_op_489)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491),_mm256_add_pd(tmp_kernel_op_490,tmp_kernel_op_491)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493),_mm256_add_pd(tmp_kernel_op_492,tmp_kernel_op_493)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497),_mm256_add_pd(tmp_kernel_op_495,tmp_kernel_op_497)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499),_mm256_add_pd(tmp_kernel_op_498,tmp_kernel_op_499)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501),_mm256_add_pd(tmp_kernel_op_500,tmp_kernel_op_501)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505),_mm256_add_pd(tmp_kernel_op_503,tmp_kernel_op_505)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507),_mm256_add_pd(tmp_kernel_op_506,tmp_kernel_op_507)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509),_mm256_add_pd(tmp_kernel_op_508,tmp_kernel_op_509)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513),_mm256_add_pd(tmp_kernel_op_511,tmp_kernel_op_513)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515),_mm256_add_pd(tmp_kernel_op_514,tmp_kernel_op_515)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517),_mm256_add_pd(tmp_kernel_op_516,tmp_kernel_op_517)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_311)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_455)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_470)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_480)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_522));
                const __m256d elMatVec_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_5,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525),_mm256_add_pd(tmp_kernel_op_524,tmp_kernel_op_525)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527),_mm256_add_pd(tmp_kernel_op_526,tmp_kernel_op_527)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529),_mm256_add_pd(tmp_kernel_op_528,tmp_kernel_op_529)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532),_mm256_add_pd(tmp_kernel_op_531,tmp_kernel_op_532)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534),_mm256_add_pd(tmp_kernel_op_533,tmp_kernel_op_534)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536),_mm256_add_pd(tmp_kernel_op_535,tmp_kernel_op_536)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539),_mm256_add_pd(tmp_kernel_op_538,tmp_kernel_op_539)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541),_mm256_add_pd(tmp_kernel_op_540,tmp_kernel_op_541)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543),_mm256_add_pd(tmp_kernel_op_542,tmp_kernel_op_543)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546),_mm256_add_pd(tmp_kernel_op_545,tmp_kernel_op_546)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548),_mm256_add_pd(tmp_kernel_op_547,tmp_kernel_op_548)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550),_mm256_add_pd(tmp_kernel_op_549,tmp_kernel_op_550)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_352)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_456)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_471)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_481)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_518)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_554));
                const __m256d elMatVec_6 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_6,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556),_mm256_add_pd(tmp_kernel_op_555,tmp_kernel_op_556)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558),_mm256_add_pd(tmp_kernel_op_557,tmp_kernel_op_558)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560),_mm256_add_pd(tmp_kernel_op_559,tmp_kernel_op_560)),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562),_mm256_add_pd(tmp_kernel_op_561,tmp_kernel_op_562)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564),_mm256_add_pd(tmp_kernel_op_563,tmp_kernel_op_564)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566),_mm256_add_pd(tmp_kernel_op_565,tmp_kernel_op_566)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568),_mm256_add_pd(tmp_kernel_op_567,tmp_kernel_op_568)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570),_mm256_add_pd(tmp_kernel_op_569,tmp_kernel_op_570)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572),_mm256_add_pd(tmp_kernel_op_571,tmp_kernel_op_572)),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574),_mm256_add_pd(tmp_kernel_op_573,tmp_kernel_op_574)),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576),_mm256_add_pd(tmp_kernel_op_575,tmp_kernel_op_576)),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578),_mm256_add_pd(tmp_kernel_op_577,tmp_kernel_op_578)),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_389)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_457)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_472)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_482)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_519)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_551)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_581));
                const __m256d elMatVec_7 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_7,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_489,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_525,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_24,tmp_kernel_op_40),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_491,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_527,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_45),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_493,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_529,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_49),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26,tmp_kernel_op_26)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_497,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_532,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_78,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_499,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_534,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_99),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_501,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_536,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_103,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_505,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_539,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_132,tmp_kernel_op_148),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_507,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_541,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_153),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_509,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_543,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_157),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134,tmp_kernel_op_134)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_513,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_546,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_186,tmp_kernel_op_202),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_515,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_548,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_207),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_517,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_550,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_211),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188,tmp_kernel_op_188)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_402)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_458)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_473)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_483)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_520)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_552)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_579)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_583));
                const __m256d elMatVec_8 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_8,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_487,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_556,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_42),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_490,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_558,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_46),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_492,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_560,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_50),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13,tmp_kernel_op_13)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_495,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_562,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_96),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_498,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_564,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_100,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_500,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_566,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_104,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_503,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_568,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_150),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_506,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_570,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_154),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_508,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_572,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_158),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121,tmp_kernel_op_121)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_511,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_574,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_204),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_514,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_576,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_208),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_516,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_578,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_212),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175,tmp_kernel_op_175)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_415)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_459)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_474)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_484)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_521)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_553)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_580)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_582)),_mm256_mul_pd(src_dof_9,tmp_kernel_op_584));
                const __m256d elMatVec_9 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(src_dof_9,_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_53,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_524,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_555,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_43),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_526,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_557,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_47),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_528,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_559,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_40,tmp_kernel_op_51),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))),_mm256_mul_pd(tmp_kernel_op_107,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_531,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_561,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_94,tmp_kernel_op_97),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_533,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_563,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_101,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_535,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_565,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_105,tmp_kernel_op_94),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_161,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_538,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_567,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_151),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_540,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_569,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_155),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_542,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_571,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_148,tmp_kernel_op_159),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113,tmp_kernel_op_113)))),_mm256_set_pd(16.0,16.0,16.0,16.0))))),_mm256_mul_pd(tmp_kernel_op_215,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_545,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_573,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_205),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_547,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_575,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_209),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(tmp_kernel_op_549,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0)),_mm256_mul_pd(tmp_kernel_op_577,_mm256_set_pd(-1.0,-1.0,-1.0,-1.0))),_mm256_mul_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_202,tmp_kernel_op_213),_mm256_set_pd(0.25,0.25,0.25,0.25)),_mm256_set_pd(tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167,tmp_kernel_op_167)))),_mm256_set_pd(16.0,16.0,16.0,16.0)))))),_mm256_mul_pd(src_dof_0,tmp_kernel_op_428)),_mm256_mul_pd(src_dof_1,tmp_kernel_op_460)),_mm256_mul_pd(src_dof_2,tmp_kernel_op_475)),_mm256_mul_pd(src_dof_3,tmp_kernel_op_485)),_mm256_mul_pd(src_dof_4,tmp_kernel_op_522)),_mm256_mul_pd(src_dof_5,tmp_kernel_op_554)),_mm256_mul_pd(src_dof_6,tmp_kernel_op_581)),_mm256_mul_pd(src_dof_7,tmp_kernel_op_583)),_mm256_mul_pd(src_dof_8,tmp_kernel_op_584));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_0,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_1,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1],_mm256_add_pd(elMatVec_2,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))],_mm256_add_pd(elMatVec_3,_mm256_loadu_pd(& _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_4,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_5,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(elMatVec_6,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_7,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(elMatVec_8,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                _mm256_storeu_pd(&_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatVec_9,_mm256_loadu_pd(& _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
             {
            
                const int64_t phantom_ctr_0 = ctr_0;
                real_t _data_float_loop_ctr_array_dim_0[4];
                _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
                _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
                _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
                _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
                real_t _data_float_loop_ctr_array_dim_1[4];
                _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
                _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
                real_t _data_float_loop_ctr_array_dim_2[4];
                _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
                _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
            
                const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
                const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
                const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_0 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_1 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_10 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_11 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_12 = _data_micromesh_vertex_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_13 = _data_micromesh_vertex_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_14 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_15 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_16 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_17 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_18 = _data_micromesh_edge_1[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_19 = _data_micromesh_edge_1[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_2 = _data_micromesh_vertex_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_20 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_21 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_22 = _data_micromesh_vertex_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const real_t micromesh_dof_23 = _data_micromesh_vertex_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_24 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_25 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_26 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_27 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_28 = _data_micromesh_edge_2[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_29 = _data_micromesh_edge_2[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_3 = _data_micromesh_vertex_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const real_t micromesh_dof_4 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_5 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_6 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                const real_t micromesh_dof_7 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t micromesh_dof_8 = _data_micromesh_edge_0[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                const real_t micromesh_dof_9 = _data_micromesh_edge_0[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                const real_t tmp_kernel_op_6 = -micromesh_dof_7*tmp_kernel_op_3;
                const real_t tmp_kernel_op_8 = micromesh_dof_0*tmp_kernel_op_7;
                const real_t tmp_kernel_op_9 = -micromesh_dof_8*tmp_kernel_op_2 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_10 = micromesh_dof_1*tmp_kernel_op_1 + micromesh_dof_5*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_2 + micromesh_dof_9*tmp_kernel_op_5 + tmp_kernel_op_6 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_14 = -micromesh_dof_19*tmp_kernel_op_0;
                const real_t tmp_kernel_op_15 = micromesh_dof_10*tmp_kernel_op_7;
                const real_t tmp_kernel_op_16 = -micromesh_dof_17*tmp_kernel_op_3 + tmp_kernel_op_15;
                const real_t tmp_kernel_op_17 = micromesh_dof_12*tmp_kernel_op_11 + micromesh_dof_14*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_0 + micromesh_dof_18*tmp_kernel_op_13 + tmp_kernel_op_14 + tmp_kernel_op_16;
                const real_t tmp_kernel_op_18 = tmp_kernel_op_10*tmp_kernel_op_17;
                const real_t tmp_kernel_op_19 = -micromesh_dof_9*tmp_kernel_op_0;
                const real_t tmp_kernel_op_20 = micromesh_dof_2*tmp_kernel_op_11 + micromesh_dof_4*tmp_kernel_op_3 + micromesh_dof_6*tmp_kernel_op_0 + micromesh_dof_8*tmp_kernel_op_13 + tmp_kernel_op_19 + tmp_kernel_op_6 + tmp_kernel_op_8;
                const real_t tmp_kernel_op_21 = -micromesh_dof_18*tmp_kernel_op_2;
                const real_t tmp_kernel_op_22 = micromesh_dof_11*tmp_kernel_op_1 + micromesh_dof_15*tmp_kernel_op_3 + micromesh_dof_16*tmp_kernel_op_2 + micromesh_dof_19*tmp_kernel_op_5 + tmp_kernel_op_16 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_23 = tmp_kernel_op_20*tmp_kernel_op_22;
                const real_t tmp_kernel_op_24 = tmp_kernel_op_18 - tmp_kernel_op_23;
                const real_t tmp_kernel_op_27 = -micromesh_dof_28*tmp_kernel_op_2;
                const real_t tmp_kernel_op_28 = micromesh_dof_20*tmp_kernel_op_7;
                const real_t tmp_kernel_op_29 = -micromesh_dof_29*tmp_kernel_op_0 + tmp_kernel_op_28;
                const real_t tmp_kernel_op_30 = micromesh_dof_23*tmp_kernel_op_25 + micromesh_dof_24*tmp_kernel_op_2 + micromesh_dof_25*tmp_kernel_op_0 + micromesh_dof_27*tmp_kernel_op_26 + tmp_kernel_op_27 + tmp_kernel_op_29;
                const real_t tmp_kernel_op_31 = -micromesh_dof_27*tmp_kernel_op_3;
                const real_t tmp_kernel_op_32 = micromesh_dof_21*tmp_kernel_op_1 + micromesh_dof_25*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_2 + micromesh_dof_29*tmp_kernel_op_5 + tmp_kernel_op_27 + tmp_kernel_op_28 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_33 = micromesh_dof_13*tmp_kernel_op_25 + micromesh_dof_14*tmp_kernel_op_2 + micromesh_dof_15*tmp_kernel_op_0 + micromesh_dof_17*tmp_kernel_op_26 + tmp_kernel_op_14 + tmp_kernel_op_15 + tmp_kernel_op_21;
                const real_t tmp_kernel_op_34 = tmp_kernel_op_20*tmp_kernel_op_33;
                const real_t tmp_kernel_op_35 = micromesh_dof_22*tmp_kernel_op_11 + micromesh_dof_24*tmp_kernel_op_3 + micromesh_dof_26*tmp_kernel_op_0 + micromesh_dof_28*tmp_kernel_op_13 + tmp_kernel_op_29 + tmp_kernel_op_31;
                const real_t tmp_kernel_op_36 = micromesh_dof_3*tmp_kernel_op_25 + micromesh_dof_4*tmp_kernel_op_2 + micromesh_dof_5*tmp_kernel_op_0 + micromesh_dof_7*tmp_kernel_op_26 + tmp_kernel_op_19 + tmp_kernel_op_9;
                const real_t tmp_kernel_op_37 = tmp_kernel_op_10*tmp_kernel_op_33;
                const real_t tmp_kernel_op_38 = tmp_kernel_op_17*tmp_kernel_op_36;
                const real_t tmp_kernel_op_39 = tmp_kernel_op_18*tmp_kernel_op_30 + tmp_kernel_op_22*tmp_kernel_op_35*tmp_kernel_op_36 - tmp_kernel_op_23*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_34 - tmp_kernel_op_32*tmp_kernel_op_38 - tmp_kernel_op_35*tmp_kernel_op_37;
                const real_t tmp_kernel_op_40 = 1.0 / (tmp_kernel_op_39);
                const real_t tmp_kernel_op_41 = tmp_kernel_op_40*tmp_kernel_op_7;
                const real_t tmp_kernel_op_42 = tmp_kernel_op_22*tmp_kernel_op_36 - tmp_kernel_op_37;
                const real_t tmp_kernel_op_43 = tmp_kernel_op_34 - tmp_kernel_op_38;
                const real_t tmp_kernel_op_44 = tmp_kernel_op_24*tmp_kernel_op_41 + tmp_kernel_op_41*tmp_kernel_op_42 + tmp_kernel_op_41*tmp_kernel_op_43;
                const real_t tmp_kernel_op_45 = -tmp_kernel_op_10*tmp_kernel_op_35 + tmp_kernel_op_20*tmp_kernel_op_32;
                const real_t tmp_kernel_op_46 = tmp_kernel_op_10*tmp_kernel_op_30 - tmp_kernel_op_32*tmp_kernel_op_36;
                const real_t tmp_kernel_op_47 = -tmp_kernel_op_20*tmp_kernel_op_30 + tmp_kernel_op_35*tmp_kernel_op_36;
                const real_t tmp_kernel_op_48 = tmp_kernel_op_41*tmp_kernel_op_45 + tmp_kernel_op_41*tmp_kernel_op_46 + tmp_kernel_op_41*tmp_kernel_op_47;
                const real_t tmp_kernel_op_49 = -tmp_kernel_op_17*tmp_kernel_op_32 + tmp_kernel_op_22*tmp_kernel_op_35;
                const real_t tmp_kernel_op_50 = -tmp_kernel_op_22*tmp_kernel_op_30 + tmp_kernel_op_32*tmp_kernel_op_33;
                const real_t tmp_kernel_op_51 = tmp_kernel_op_17*tmp_kernel_op_30 - tmp_kernel_op_33*tmp_kernel_op_35;
                const real_t tmp_kernel_op_52 = tmp_kernel_op_41*tmp_kernel_op_49 + tmp_kernel_op_41*tmp_kernel_op_50 + tmp_kernel_op_41*tmp_kernel_op_51;
                const real_t tmp_kernel_op_53 = 0.041666666666666657*abs(tmp_kernel_op_39);
                const real_t tmp_kernel_op_60 = -micromesh_dof_7*tmp_kernel_op_57;
                const real_t tmp_kernel_op_62 = micromesh_dof_0*tmp_kernel_op_61;
                const real_t tmp_kernel_op_63 = -micromesh_dof_8*tmp_kernel_op_56 + tmp_kernel_op_62;
                const real_t tmp_kernel_op_64 = micromesh_dof_1*tmp_kernel_op_55 + micromesh_dof_5*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_56 + micromesh_dof_9*tmp_kernel_op_59 + tmp_kernel_op_60 + tmp_kernel_op_63;
                const real_t tmp_kernel_op_68 = -micromesh_dof_19*tmp_kernel_op_54;
                const real_t tmp_kernel_op_69 = micromesh_dof_10*tmp_kernel_op_61;
                const real_t tmp_kernel_op_70 = -micromesh_dof_17*tmp_kernel_op_57 + tmp_kernel_op_69;
                const real_t tmp_kernel_op_71 = micromesh_dof_12*tmp_kernel_op_65 + micromesh_dof_14*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_54 + micromesh_dof_18*tmp_kernel_op_67 + tmp_kernel_op_68 + tmp_kernel_op_70;
                const real_t tmp_kernel_op_72 = tmp_kernel_op_64*tmp_kernel_op_71;
                const real_t tmp_kernel_op_73 = -micromesh_dof_9*tmp_kernel_op_54;
                const real_t tmp_kernel_op_74 = micromesh_dof_2*tmp_kernel_op_65 + micromesh_dof_4*tmp_kernel_op_57 + micromesh_dof_6*tmp_kernel_op_54 + micromesh_dof_8*tmp_kernel_op_67 + tmp_kernel_op_60 + tmp_kernel_op_62 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_75 = -micromesh_dof_18*tmp_kernel_op_56;
                const real_t tmp_kernel_op_76 = micromesh_dof_11*tmp_kernel_op_55 + micromesh_dof_15*tmp_kernel_op_57 + micromesh_dof_16*tmp_kernel_op_56 + micromesh_dof_19*tmp_kernel_op_59 + tmp_kernel_op_70 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_77 = tmp_kernel_op_74*tmp_kernel_op_76;
                const real_t tmp_kernel_op_78 = tmp_kernel_op_72 - tmp_kernel_op_77;
                const real_t tmp_kernel_op_81 = -micromesh_dof_28*tmp_kernel_op_56;
                const real_t tmp_kernel_op_82 = micromesh_dof_20*tmp_kernel_op_61;
                const real_t tmp_kernel_op_83 = -micromesh_dof_29*tmp_kernel_op_54 + tmp_kernel_op_82;
                const real_t tmp_kernel_op_84 = micromesh_dof_23*tmp_kernel_op_79 + micromesh_dof_24*tmp_kernel_op_56 + micromesh_dof_25*tmp_kernel_op_54 + micromesh_dof_27*tmp_kernel_op_80 + tmp_kernel_op_81 + tmp_kernel_op_83;
                const real_t tmp_kernel_op_85 = -micromesh_dof_27*tmp_kernel_op_57;
                const real_t tmp_kernel_op_86 = micromesh_dof_21*tmp_kernel_op_55 + micromesh_dof_25*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_56 + micromesh_dof_29*tmp_kernel_op_59 + tmp_kernel_op_81 + tmp_kernel_op_82 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_87 = micromesh_dof_13*tmp_kernel_op_79 + micromesh_dof_14*tmp_kernel_op_56 + micromesh_dof_15*tmp_kernel_op_54 + micromesh_dof_17*tmp_kernel_op_80 + tmp_kernel_op_68 + tmp_kernel_op_69 + tmp_kernel_op_75;
                const real_t tmp_kernel_op_88 = tmp_kernel_op_74*tmp_kernel_op_87;
                const real_t tmp_kernel_op_89 = micromesh_dof_22*tmp_kernel_op_65 + micromesh_dof_24*tmp_kernel_op_57 + micromesh_dof_26*tmp_kernel_op_54 + micromesh_dof_28*tmp_kernel_op_67 + tmp_kernel_op_83 + tmp_kernel_op_85;
                const real_t tmp_kernel_op_90 = micromesh_dof_3*tmp_kernel_op_79 + micromesh_dof_4*tmp_kernel_op_56 + micromesh_dof_5*tmp_kernel_op_54 + micromesh_dof_7*tmp_kernel_op_80 + tmp_kernel_op_63 + tmp_kernel_op_73;
                const real_t tmp_kernel_op_91 = tmp_kernel_op_64*tmp_kernel_op_87;
                const real_t tmp_kernel_op_92 = tmp_kernel_op_71*tmp_kernel_op_90;
                const real_t tmp_kernel_op_93 = tmp_kernel_op_72*tmp_kernel_op_84 + tmp_kernel_op_76*tmp_kernel_op_89*tmp_kernel_op_90 - tmp_kernel_op_77*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_88 - tmp_kernel_op_86*tmp_kernel_op_92 - tmp_kernel_op_89*tmp_kernel_op_91;
                const real_t tmp_kernel_op_94 = 1.0 / (tmp_kernel_op_93);
                const real_t tmp_kernel_op_95 = tmp_kernel_op_61*tmp_kernel_op_94;
                const real_t tmp_kernel_op_96 = tmp_kernel_op_76*tmp_kernel_op_90 - tmp_kernel_op_91;
                const real_t tmp_kernel_op_97 = tmp_kernel_op_88 - tmp_kernel_op_92;
                const real_t tmp_kernel_op_98 = tmp_kernel_op_78*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_96 + tmp_kernel_op_95*tmp_kernel_op_97;
                const real_t tmp_kernel_op_99 = -tmp_kernel_op_64*tmp_kernel_op_89 + tmp_kernel_op_74*tmp_kernel_op_86;
                const real_t tmp_kernel_op_100 = tmp_kernel_op_64*tmp_kernel_op_84 - tmp_kernel_op_86*tmp_kernel_op_90;
                const real_t tmp_kernel_op_101 = -tmp_kernel_op_74*tmp_kernel_op_84 + tmp_kernel_op_89*tmp_kernel_op_90;
                const real_t tmp_kernel_op_102 = tmp_kernel_op_100*tmp_kernel_op_95 + tmp_kernel_op_101*tmp_kernel_op_95 + tmp_kernel_op_95*tmp_kernel_op_99;
                const real_t tmp_kernel_op_103 = -tmp_kernel_op_71*tmp_kernel_op_86 + tmp_kernel_op_76*tmp_kernel_op_89;
                const real_t tmp_kernel_op_104 = -tmp_kernel_op_76*tmp_kernel_op_84 + tmp_kernel_op_86*tmp_kernel_op_87;
                const real_t tmp_kernel_op_105 = tmp_kernel_op_71*tmp_kernel_op_84 - tmp_kernel_op_87*tmp_kernel_op_89;
                const real_t tmp_kernel_op_106 = tmp_kernel_op_103*tmp_kernel_op_95 + tmp_kernel_op_104*tmp_kernel_op_95 + tmp_kernel_op_105*tmp_kernel_op_95;
                const real_t tmp_kernel_op_107 = 0.041666666666666657*abs(tmp_kernel_op_93);
                const real_t tmp_kernel_op_114 = -micromesh_dof_7*tmp_kernel_op_111;
                const real_t tmp_kernel_op_116 = micromesh_dof_0*tmp_kernel_op_115;
                const real_t tmp_kernel_op_117 = -micromesh_dof_8*tmp_kernel_op_110 + tmp_kernel_op_116;
                const real_t tmp_kernel_op_118 = micromesh_dof_1*tmp_kernel_op_109 + micromesh_dof_5*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_110 + micromesh_dof_9*tmp_kernel_op_113 + tmp_kernel_op_114 + tmp_kernel_op_117;
                const real_t tmp_kernel_op_122 = -micromesh_dof_19*tmp_kernel_op_108;
                const real_t tmp_kernel_op_123 = micromesh_dof_10*tmp_kernel_op_115;
                const real_t tmp_kernel_op_124 = -micromesh_dof_17*tmp_kernel_op_111 + tmp_kernel_op_123;
                const real_t tmp_kernel_op_125 = micromesh_dof_12*tmp_kernel_op_119 + micromesh_dof_14*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_108 + micromesh_dof_18*tmp_kernel_op_121 + tmp_kernel_op_122 + tmp_kernel_op_124;
                const real_t tmp_kernel_op_126 = tmp_kernel_op_118*tmp_kernel_op_125;
                const real_t tmp_kernel_op_127 = -micromesh_dof_9*tmp_kernel_op_108;
                const real_t tmp_kernel_op_128 = micromesh_dof_2*tmp_kernel_op_119 + micromesh_dof_4*tmp_kernel_op_111 + micromesh_dof_6*tmp_kernel_op_108 + micromesh_dof_8*tmp_kernel_op_121 + tmp_kernel_op_114 + tmp_kernel_op_116 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_129 = -micromesh_dof_18*tmp_kernel_op_110;
                const real_t tmp_kernel_op_130 = micromesh_dof_11*tmp_kernel_op_109 + micromesh_dof_15*tmp_kernel_op_111 + micromesh_dof_16*tmp_kernel_op_110 + micromesh_dof_19*tmp_kernel_op_113 + tmp_kernel_op_124 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_131 = tmp_kernel_op_128*tmp_kernel_op_130;
                const real_t tmp_kernel_op_132 = tmp_kernel_op_126 - tmp_kernel_op_131;
                const real_t tmp_kernel_op_135 = -micromesh_dof_28*tmp_kernel_op_110;
                const real_t tmp_kernel_op_136 = micromesh_dof_20*tmp_kernel_op_115;
                const real_t tmp_kernel_op_137 = -micromesh_dof_29*tmp_kernel_op_108 + tmp_kernel_op_136;
                const real_t tmp_kernel_op_138 = micromesh_dof_23*tmp_kernel_op_133 + micromesh_dof_24*tmp_kernel_op_110 + micromesh_dof_25*tmp_kernel_op_108 + micromesh_dof_27*tmp_kernel_op_134 + tmp_kernel_op_135 + tmp_kernel_op_137;
                const real_t tmp_kernel_op_139 = -micromesh_dof_27*tmp_kernel_op_111;
                const real_t tmp_kernel_op_140 = micromesh_dof_21*tmp_kernel_op_109 + micromesh_dof_25*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_110 + micromesh_dof_29*tmp_kernel_op_113 + tmp_kernel_op_135 + tmp_kernel_op_136 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_141 = micromesh_dof_13*tmp_kernel_op_133 + micromesh_dof_14*tmp_kernel_op_110 + micromesh_dof_15*tmp_kernel_op_108 + micromesh_dof_17*tmp_kernel_op_134 + tmp_kernel_op_122 + tmp_kernel_op_123 + tmp_kernel_op_129;
                const real_t tmp_kernel_op_142 = tmp_kernel_op_128*tmp_kernel_op_141;
                const real_t tmp_kernel_op_143 = micromesh_dof_22*tmp_kernel_op_119 + micromesh_dof_24*tmp_kernel_op_111 + micromesh_dof_26*tmp_kernel_op_108 + micromesh_dof_28*tmp_kernel_op_121 + tmp_kernel_op_137 + tmp_kernel_op_139;
                const real_t tmp_kernel_op_144 = micromesh_dof_3*tmp_kernel_op_133 + micromesh_dof_4*tmp_kernel_op_110 + micromesh_dof_5*tmp_kernel_op_108 + micromesh_dof_7*tmp_kernel_op_134 + tmp_kernel_op_117 + tmp_kernel_op_127;
                const real_t tmp_kernel_op_145 = tmp_kernel_op_118*tmp_kernel_op_141;
                const real_t tmp_kernel_op_146 = tmp_kernel_op_125*tmp_kernel_op_144;
                const real_t tmp_kernel_op_147 = tmp_kernel_op_126*tmp_kernel_op_138 + tmp_kernel_op_130*tmp_kernel_op_143*tmp_kernel_op_144 - tmp_kernel_op_131*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_142 - tmp_kernel_op_140*tmp_kernel_op_146 - tmp_kernel_op_143*tmp_kernel_op_145;
                const real_t tmp_kernel_op_148 = 1.0 / (tmp_kernel_op_147);
                const real_t tmp_kernel_op_149 = tmp_kernel_op_115*tmp_kernel_op_148;
                const real_t tmp_kernel_op_150 = tmp_kernel_op_130*tmp_kernel_op_144 - tmp_kernel_op_145;
                const real_t tmp_kernel_op_151 = tmp_kernel_op_142 - tmp_kernel_op_146;
                const real_t tmp_kernel_op_152 = tmp_kernel_op_132*tmp_kernel_op_149 + tmp_kernel_op_149*tmp_kernel_op_150 + tmp_kernel_op_149*tmp_kernel_op_151;
                const real_t tmp_kernel_op_153 = -tmp_kernel_op_118*tmp_kernel_op_143 + tmp_kernel_op_128*tmp_kernel_op_140;
                const real_t tmp_kernel_op_154 = tmp_kernel_op_118*tmp_kernel_op_138 - tmp_kernel_op_140*tmp_kernel_op_144;
                const real_t tmp_kernel_op_155 = -tmp_kernel_op_128*tmp_kernel_op_138 + tmp_kernel_op_143*tmp_kernel_op_144;
                const real_t tmp_kernel_op_156 = tmp_kernel_op_149*tmp_kernel_op_153 + tmp_kernel_op_149*tmp_kernel_op_154 + tmp_kernel_op_149*tmp_kernel_op_155;
                const real_t tmp_kernel_op_157 = -tmp_kernel_op_125*tmp_kernel_op_140 + tmp_kernel_op_130*tmp_kernel_op_143;
                const real_t tmp_kernel_op_158 = -tmp_kernel_op_130*tmp_kernel_op_138 + tmp_kernel_op_140*tmp_kernel_op_141;
                const real_t tmp_kernel_op_159 = tmp_kernel_op_125*tmp_kernel_op_138 - tmp_kernel_op_141*tmp_kernel_op_143;
                const real_t tmp_kernel_op_160 = tmp_kernel_op_149*tmp_kernel_op_157 + tmp_kernel_op_149*tmp_kernel_op_158 + tmp_kernel_op_149*tmp_kernel_op_159;
                const real_t tmp_kernel_op_161 = 0.041666666666666657*abs(tmp_kernel_op_147);
                const real_t tmp_kernel_op_168 = -micromesh_dof_7*tmp_kernel_op_165;
                const real_t tmp_kernel_op_170 = micromesh_dof_0*tmp_kernel_op_169;
                const real_t tmp_kernel_op_171 = -micromesh_dof_8*tmp_kernel_op_164 + tmp_kernel_op_170;
                const real_t tmp_kernel_op_172 = micromesh_dof_1*tmp_kernel_op_163 + micromesh_dof_5*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_164 + micromesh_dof_9*tmp_kernel_op_167 + tmp_kernel_op_168 + tmp_kernel_op_171;
                const real_t tmp_kernel_op_176 = -micromesh_dof_19*tmp_kernel_op_162;
                const real_t tmp_kernel_op_177 = micromesh_dof_10*tmp_kernel_op_169;
                const real_t tmp_kernel_op_178 = -micromesh_dof_17*tmp_kernel_op_165 + tmp_kernel_op_177;
                const real_t tmp_kernel_op_179 = micromesh_dof_12*tmp_kernel_op_173 + micromesh_dof_14*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_162 + micromesh_dof_18*tmp_kernel_op_175 + tmp_kernel_op_176 + tmp_kernel_op_178;
                const real_t tmp_kernel_op_180 = tmp_kernel_op_172*tmp_kernel_op_179;
                const real_t tmp_kernel_op_181 = -micromesh_dof_9*tmp_kernel_op_162;
                const real_t tmp_kernel_op_182 = micromesh_dof_2*tmp_kernel_op_173 + micromesh_dof_4*tmp_kernel_op_165 + micromesh_dof_6*tmp_kernel_op_162 + micromesh_dof_8*tmp_kernel_op_175 + tmp_kernel_op_168 + tmp_kernel_op_170 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_183 = -micromesh_dof_18*tmp_kernel_op_164;
                const real_t tmp_kernel_op_184 = micromesh_dof_11*tmp_kernel_op_163 + micromesh_dof_15*tmp_kernel_op_165 + micromesh_dof_16*tmp_kernel_op_164 + micromesh_dof_19*tmp_kernel_op_167 + tmp_kernel_op_178 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_185 = tmp_kernel_op_182*tmp_kernel_op_184;
                const real_t tmp_kernel_op_186 = tmp_kernel_op_180 - tmp_kernel_op_185;
                const real_t tmp_kernel_op_189 = -micromesh_dof_28*tmp_kernel_op_164;
                const real_t tmp_kernel_op_190 = micromesh_dof_20*tmp_kernel_op_169;
                const real_t tmp_kernel_op_191 = -micromesh_dof_29*tmp_kernel_op_162 + tmp_kernel_op_190;
                const real_t tmp_kernel_op_192 = micromesh_dof_23*tmp_kernel_op_187 + micromesh_dof_24*tmp_kernel_op_164 + micromesh_dof_25*tmp_kernel_op_162 + micromesh_dof_27*tmp_kernel_op_188 + tmp_kernel_op_189 + tmp_kernel_op_191;
                const real_t tmp_kernel_op_193 = -micromesh_dof_27*tmp_kernel_op_165;
                const real_t tmp_kernel_op_194 = micromesh_dof_21*tmp_kernel_op_163 + micromesh_dof_25*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_164 + micromesh_dof_29*tmp_kernel_op_167 + tmp_kernel_op_189 + tmp_kernel_op_190 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_195 = micromesh_dof_13*tmp_kernel_op_187 + micromesh_dof_14*tmp_kernel_op_164 + micromesh_dof_15*tmp_kernel_op_162 + micromesh_dof_17*tmp_kernel_op_188 + tmp_kernel_op_176 + tmp_kernel_op_177 + tmp_kernel_op_183;
                const real_t tmp_kernel_op_196 = tmp_kernel_op_182*tmp_kernel_op_195;
                const real_t tmp_kernel_op_197 = micromesh_dof_22*tmp_kernel_op_173 + micromesh_dof_24*tmp_kernel_op_165 + micromesh_dof_26*tmp_kernel_op_162 + micromesh_dof_28*tmp_kernel_op_175 + tmp_kernel_op_191 + tmp_kernel_op_193;
                const real_t tmp_kernel_op_198 = micromesh_dof_3*tmp_kernel_op_187 + micromesh_dof_4*tmp_kernel_op_164 + micromesh_dof_5*tmp_kernel_op_162 + micromesh_dof_7*tmp_kernel_op_188 + tmp_kernel_op_171 + tmp_kernel_op_181;
                const real_t tmp_kernel_op_199 = tmp_kernel_op_172*tmp_kernel_op_195;
                const real_t tmp_kernel_op_200 = tmp_kernel_op_179*tmp_kernel_op_198;
                const real_t tmp_kernel_op_201 = tmp_kernel_op_180*tmp_kernel_op_192 + tmp_kernel_op_184*tmp_kernel_op_197*tmp_kernel_op_198 - tmp_kernel_op_185*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_196 - tmp_kernel_op_194*tmp_kernel_op_200 - tmp_kernel_op_197*tmp_kernel_op_199;
                const real_t tmp_kernel_op_202 = 1.0 / (tmp_kernel_op_201);
                const real_t tmp_kernel_op_203 = tmp_kernel_op_169*tmp_kernel_op_202;
                const real_t tmp_kernel_op_204 = tmp_kernel_op_184*tmp_kernel_op_198 - tmp_kernel_op_199;
                const real_t tmp_kernel_op_205 = tmp_kernel_op_196 - tmp_kernel_op_200;
                const real_t tmp_kernel_op_206 = tmp_kernel_op_186*tmp_kernel_op_203 + tmp_kernel_op_203*tmp_kernel_op_204 + tmp_kernel_op_203*tmp_kernel_op_205;
                const real_t tmp_kernel_op_207 = -tmp_kernel_op_172*tmp_kernel_op_197 + tmp_kernel_op_182*tmp_kernel_op_194;
                const real_t tmp_kernel_op_208 = tmp_kernel_op_172*tmp_kernel_op_192 - tmp_kernel_op_194*tmp_kernel_op_198;
                const real_t tmp_kernel_op_209 = -tmp_kernel_op_182*tmp_kernel_op_192 + tmp_kernel_op_197*tmp_kernel_op_198;
                const real_t tmp_kernel_op_210 = tmp_kernel_op_203*tmp_kernel_op_207 + tmp_kernel_op_203*tmp_kernel_op_208 + tmp_kernel_op_203*tmp_kernel_op_209;
                const real_t tmp_kernel_op_211 = -tmp_kernel_op_179*tmp_kernel_op_194 + tmp_kernel_op_184*tmp_kernel_op_197;
                const real_t tmp_kernel_op_212 = -tmp_kernel_op_184*tmp_kernel_op_192 + tmp_kernel_op_194*tmp_kernel_op_195;
                const real_t tmp_kernel_op_213 = tmp_kernel_op_179*tmp_kernel_op_192 - tmp_kernel_op_195*tmp_kernel_op_197;
                const real_t tmp_kernel_op_214 = tmp_kernel_op_203*tmp_kernel_op_211 + tmp_kernel_op_203*tmp_kernel_op_212 + tmp_kernel_op_203*tmp_kernel_op_213;
                const real_t tmp_kernel_op_215 = 0.041666666666666657*abs(tmp_kernel_op_201);
                const real_t tmp_kernel_op_216 = tmp_kernel_op_1*tmp_kernel_op_40;
                const real_t tmp_kernel_op_217 = tmp_kernel_op_216*tmp_kernel_op_43;
                const real_t tmp_kernel_op_218 = tmp_kernel_op_216*tmp_kernel_op_47;
                const real_t tmp_kernel_op_219 = tmp_kernel_op_216*tmp_kernel_op_51;
                const real_t tmp_kernel_op_220 = tmp_kernel_op_55*tmp_kernel_op_94;
                const real_t tmp_kernel_op_221 = tmp_kernel_op_220*tmp_kernel_op_97;
                const real_t tmp_kernel_op_222 = tmp_kernel_op_101*tmp_kernel_op_220;
                const real_t tmp_kernel_op_223 = tmp_kernel_op_105*tmp_kernel_op_220;
                const real_t tmp_kernel_op_224 = tmp_kernel_op_109*tmp_kernel_op_148;
                const real_t tmp_kernel_op_225 = tmp_kernel_op_151*tmp_kernel_op_224;
                const real_t tmp_kernel_op_226 = tmp_kernel_op_155*tmp_kernel_op_224;
                const real_t tmp_kernel_op_227 = tmp_kernel_op_159*tmp_kernel_op_224;
                const real_t tmp_kernel_op_228 = tmp_kernel_op_163*tmp_kernel_op_202;
                const real_t tmp_kernel_op_229 = tmp_kernel_op_205*tmp_kernel_op_228;
                const real_t tmp_kernel_op_230 = tmp_kernel_op_209*tmp_kernel_op_228;
                const real_t tmp_kernel_op_231 = tmp_kernel_op_213*tmp_kernel_op_228;
                const real_t tmp_kernel_op_232 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_222 + tmp_kernel_op_106*tmp_kernel_op_223 + tmp_kernel_op_221*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_225 + tmp_kernel_op_156*tmp_kernel_op_226 + tmp_kernel_op_160*tmp_kernel_op_227) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_229 + tmp_kernel_op_210*tmp_kernel_op_230 + tmp_kernel_op_214*tmp_kernel_op_231) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_44 + tmp_kernel_op_218*tmp_kernel_op_48 + tmp_kernel_op_219*tmp_kernel_op_52);
                const real_t tmp_kernel_op_233 = tmp_kernel_op_11*tmp_kernel_op_40;
                const real_t tmp_kernel_op_234 = tmp_kernel_op_233*tmp_kernel_op_42;
                const real_t tmp_kernel_op_235 = tmp_kernel_op_233*tmp_kernel_op_46;
                const real_t tmp_kernel_op_236 = tmp_kernel_op_233*tmp_kernel_op_50;
                const real_t tmp_kernel_op_237 = tmp_kernel_op_65*tmp_kernel_op_94;
                const real_t tmp_kernel_op_238 = tmp_kernel_op_237*tmp_kernel_op_96;
                const real_t tmp_kernel_op_239 = tmp_kernel_op_100*tmp_kernel_op_237;
                const real_t tmp_kernel_op_240 = tmp_kernel_op_104*tmp_kernel_op_237;
                const real_t tmp_kernel_op_241 = tmp_kernel_op_119*tmp_kernel_op_148;
                const real_t tmp_kernel_op_242 = tmp_kernel_op_150*tmp_kernel_op_241;
                const real_t tmp_kernel_op_243 = tmp_kernel_op_154*tmp_kernel_op_241;
                const real_t tmp_kernel_op_244 = tmp_kernel_op_158*tmp_kernel_op_241;
                const real_t tmp_kernel_op_245 = tmp_kernel_op_173*tmp_kernel_op_202;
                const real_t tmp_kernel_op_246 = tmp_kernel_op_204*tmp_kernel_op_245;
                const real_t tmp_kernel_op_247 = tmp_kernel_op_208*tmp_kernel_op_245;
                const real_t tmp_kernel_op_248 = tmp_kernel_op_212*tmp_kernel_op_245;
                const real_t tmp_kernel_op_249 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_239 + tmp_kernel_op_106*tmp_kernel_op_240 + tmp_kernel_op_238*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_242 + tmp_kernel_op_156*tmp_kernel_op_243 + tmp_kernel_op_160*tmp_kernel_op_244) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_246 + tmp_kernel_op_210*tmp_kernel_op_247 + tmp_kernel_op_214*tmp_kernel_op_248) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_44 + tmp_kernel_op_235*tmp_kernel_op_48 + tmp_kernel_op_236*tmp_kernel_op_52);
                const real_t tmp_kernel_op_250 = tmp_kernel_op_25*tmp_kernel_op_40;
                const real_t tmp_kernel_op_251 = tmp_kernel_op_24*tmp_kernel_op_250;
                const real_t tmp_kernel_op_252 = tmp_kernel_op_250*tmp_kernel_op_45;
                const real_t tmp_kernel_op_253 = tmp_kernel_op_250*tmp_kernel_op_49;
                const real_t tmp_kernel_op_254 = tmp_kernel_op_79*tmp_kernel_op_94;
                const real_t tmp_kernel_op_255 = tmp_kernel_op_254*tmp_kernel_op_78;
                const real_t tmp_kernel_op_256 = tmp_kernel_op_254*tmp_kernel_op_99;
                const real_t tmp_kernel_op_257 = tmp_kernel_op_103*tmp_kernel_op_254;
                const real_t tmp_kernel_op_258 = tmp_kernel_op_133*tmp_kernel_op_148;
                const real_t tmp_kernel_op_259 = tmp_kernel_op_132*tmp_kernel_op_258;
                const real_t tmp_kernel_op_260 = tmp_kernel_op_153*tmp_kernel_op_258;
                const real_t tmp_kernel_op_261 = tmp_kernel_op_157*tmp_kernel_op_258;
                const real_t tmp_kernel_op_262 = tmp_kernel_op_187*tmp_kernel_op_202;
                const real_t tmp_kernel_op_263 = tmp_kernel_op_186*tmp_kernel_op_262;
                const real_t tmp_kernel_op_264 = tmp_kernel_op_207*tmp_kernel_op_262;
                const real_t tmp_kernel_op_265 = tmp_kernel_op_211*tmp_kernel_op_262;
                const real_t tmp_kernel_op_266 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_256 + tmp_kernel_op_106*tmp_kernel_op_257 + tmp_kernel_op_255*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_259 + tmp_kernel_op_156*tmp_kernel_op_260 + tmp_kernel_op_160*tmp_kernel_op_261) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_263 + tmp_kernel_op_210*tmp_kernel_op_264 + tmp_kernel_op_214*tmp_kernel_op_265) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_44 + tmp_kernel_op_252*tmp_kernel_op_48 + tmp_kernel_op_253*tmp_kernel_op_52);
                const real_t tmp_kernel_op_267 = tmp_kernel_op_2*tmp_kernel_op_40;
                const real_t tmp_kernel_op_268 = tmp_kernel_op_24*tmp_kernel_op_267;
                const real_t tmp_kernel_op_269 = tmp_kernel_op_3*tmp_kernel_op_40;
                const real_t tmp_kernel_op_270 = tmp_kernel_op_269*tmp_kernel_op_42;
                const real_t tmp_kernel_op_271 = tmp_kernel_op_268 + tmp_kernel_op_270;
                const real_t tmp_kernel_op_272 = tmp_kernel_op_267*tmp_kernel_op_45;
                const real_t tmp_kernel_op_273 = tmp_kernel_op_269*tmp_kernel_op_46;
                const real_t tmp_kernel_op_274 = tmp_kernel_op_272 + tmp_kernel_op_273;
                const real_t tmp_kernel_op_275 = tmp_kernel_op_267*tmp_kernel_op_49;
                const real_t tmp_kernel_op_276 = tmp_kernel_op_269*tmp_kernel_op_50;
                const real_t tmp_kernel_op_277 = tmp_kernel_op_275 + tmp_kernel_op_276;
                const real_t tmp_kernel_op_278 = tmp_kernel_op_56*tmp_kernel_op_94;
                const real_t tmp_kernel_op_279 = tmp_kernel_op_278*tmp_kernel_op_78;
                const real_t tmp_kernel_op_280 = tmp_kernel_op_57*tmp_kernel_op_94;
                const real_t tmp_kernel_op_281 = tmp_kernel_op_280*tmp_kernel_op_96;
                const real_t tmp_kernel_op_282 = tmp_kernel_op_279 + tmp_kernel_op_281;
                const real_t tmp_kernel_op_283 = tmp_kernel_op_278*tmp_kernel_op_99;
                const real_t tmp_kernel_op_284 = tmp_kernel_op_100*tmp_kernel_op_280;
                const real_t tmp_kernel_op_285 = tmp_kernel_op_283 + tmp_kernel_op_284;
                const real_t tmp_kernel_op_286 = tmp_kernel_op_103*tmp_kernel_op_278;
                const real_t tmp_kernel_op_287 = tmp_kernel_op_104*tmp_kernel_op_280;
                const real_t tmp_kernel_op_288 = tmp_kernel_op_286 + tmp_kernel_op_287;
                const real_t tmp_kernel_op_289 = tmp_kernel_op_110*tmp_kernel_op_148;
                const real_t tmp_kernel_op_290 = tmp_kernel_op_132*tmp_kernel_op_289;
                const real_t tmp_kernel_op_291 = tmp_kernel_op_111*tmp_kernel_op_148;
                const real_t tmp_kernel_op_292 = tmp_kernel_op_150*tmp_kernel_op_291;
                const real_t tmp_kernel_op_293 = tmp_kernel_op_290 + tmp_kernel_op_292;
                const real_t tmp_kernel_op_294 = tmp_kernel_op_153*tmp_kernel_op_289;
                const real_t tmp_kernel_op_295 = tmp_kernel_op_154*tmp_kernel_op_291;
                const real_t tmp_kernel_op_296 = tmp_kernel_op_294 + tmp_kernel_op_295;
                const real_t tmp_kernel_op_297 = tmp_kernel_op_157*tmp_kernel_op_289;
                const real_t tmp_kernel_op_298 = tmp_kernel_op_158*tmp_kernel_op_291;
                const real_t tmp_kernel_op_299 = tmp_kernel_op_297 + tmp_kernel_op_298;
                const real_t tmp_kernel_op_300 = tmp_kernel_op_164*tmp_kernel_op_202;
                const real_t tmp_kernel_op_301 = tmp_kernel_op_186*tmp_kernel_op_300;
                const real_t tmp_kernel_op_302 = tmp_kernel_op_165*tmp_kernel_op_202;
                const real_t tmp_kernel_op_303 = tmp_kernel_op_204*tmp_kernel_op_302;
                const real_t tmp_kernel_op_304 = tmp_kernel_op_301 + tmp_kernel_op_303;
                const real_t tmp_kernel_op_305 = tmp_kernel_op_207*tmp_kernel_op_300;
                const real_t tmp_kernel_op_306 = tmp_kernel_op_208*tmp_kernel_op_302;
                const real_t tmp_kernel_op_307 = tmp_kernel_op_305 + tmp_kernel_op_306;
                const real_t tmp_kernel_op_308 = tmp_kernel_op_211*tmp_kernel_op_300;
                const real_t tmp_kernel_op_309 = tmp_kernel_op_212*tmp_kernel_op_302;
                const real_t tmp_kernel_op_310 = tmp_kernel_op_308 + tmp_kernel_op_309;
                const real_t tmp_kernel_op_311 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_285 + tmp_kernel_op_106*tmp_kernel_op_288 + tmp_kernel_op_282*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_293 + tmp_kernel_op_156*tmp_kernel_op_296 + tmp_kernel_op_160*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_304 + tmp_kernel_op_210*tmp_kernel_op_307 + tmp_kernel_op_214*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_44 + tmp_kernel_op_274*tmp_kernel_op_48 + tmp_kernel_op_277*tmp_kernel_op_52);
                const real_t tmp_kernel_op_312 = tmp_kernel_op_0*tmp_kernel_op_40;
                const real_t tmp_kernel_op_313 = tmp_kernel_op_24*tmp_kernel_op_312;
                const real_t tmp_kernel_op_314 = tmp_kernel_op_269*tmp_kernel_op_43;
                const real_t tmp_kernel_op_315 = tmp_kernel_op_313 + tmp_kernel_op_314;
                const real_t tmp_kernel_op_316 = tmp_kernel_op_312*tmp_kernel_op_45;
                const real_t tmp_kernel_op_317 = tmp_kernel_op_269*tmp_kernel_op_47;
                const real_t tmp_kernel_op_318 = tmp_kernel_op_316 + tmp_kernel_op_317;
                const real_t tmp_kernel_op_319 = tmp_kernel_op_312*tmp_kernel_op_49;
                const real_t tmp_kernel_op_320 = tmp_kernel_op_269*tmp_kernel_op_51;
                const real_t tmp_kernel_op_321 = tmp_kernel_op_319 + tmp_kernel_op_320;
                const real_t tmp_kernel_op_322 = tmp_kernel_op_54*tmp_kernel_op_94;
                const real_t tmp_kernel_op_323 = tmp_kernel_op_322*tmp_kernel_op_78;
                const real_t tmp_kernel_op_324 = tmp_kernel_op_280*tmp_kernel_op_97;
                const real_t tmp_kernel_op_325 = tmp_kernel_op_323 + tmp_kernel_op_324;
                const real_t tmp_kernel_op_326 = tmp_kernel_op_322*tmp_kernel_op_99;
                const real_t tmp_kernel_op_327 = tmp_kernel_op_101*tmp_kernel_op_280;
                const real_t tmp_kernel_op_328 = tmp_kernel_op_326 + tmp_kernel_op_327;
                const real_t tmp_kernel_op_329 = tmp_kernel_op_103*tmp_kernel_op_322;
                const real_t tmp_kernel_op_330 = tmp_kernel_op_105*tmp_kernel_op_280;
                const real_t tmp_kernel_op_331 = tmp_kernel_op_329 + tmp_kernel_op_330;
                const real_t tmp_kernel_op_332 = tmp_kernel_op_108*tmp_kernel_op_148;
                const real_t tmp_kernel_op_333 = tmp_kernel_op_132*tmp_kernel_op_332;
                const real_t tmp_kernel_op_334 = tmp_kernel_op_151*tmp_kernel_op_291;
                const real_t tmp_kernel_op_335 = tmp_kernel_op_333 + tmp_kernel_op_334;
                const real_t tmp_kernel_op_336 = tmp_kernel_op_153*tmp_kernel_op_332;
                const real_t tmp_kernel_op_337 = tmp_kernel_op_155*tmp_kernel_op_291;
                const real_t tmp_kernel_op_338 = tmp_kernel_op_336 + tmp_kernel_op_337;
                const real_t tmp_kernel_op_339 = tmp_kernel_op_157*tmp_kernel_op_332;
                const real_t tmp_kernel_op_340 = tmp_kernel_op_159*tmp_kernel_op_291;
                const real_t tmp_kernel_op_341 = tmp_kernel_op_339 + tmp_kernel_op_340;
                const real_t tmp_kernel_op_342 = tmp_kernel_op_162*tmp_kernel_op_202;
                const real_t tmp_kernel_op_343 = tmp_kernel_op_186*tmp_kernel_op_342;
                const real_t tmp_kernel_op_344 = tmp_kernel_op_205*tmp_kernel_op_302;
                const real_t tmp_kernel_op_345 = tmp_kernel_op_343 + tmp_kernel_op_344;
                const real_t tmp_kernel_op_346 = tmp_kernel_op_207*tmp_kernel_op_342;
                const real_t tmp_kernel_op_347 = tmp_kernel_op_209*tmp_kernel_op_302;
                const real_t tmp_kernel_op_348 = tmp_kernel_op_346 + tmp_kernel_op_347;
                const real_t tmp_kernel_op_349 = tmp_kernel_op_211*tmp_kernel_op_342;
                const real_t tmp_kernel_op_350 = tmp_kernel_op_213*tmp_kernel_op_302;
                const real_t tmp_kernel_op_351 = tmp_kernel_op_349 + tmp_kernel_op_350;
                const real_t tmp_kernel_op_352 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_328 + tmp_kernel_op_106*tmp_kernel_op_331 + tmp_kernel_op_325*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_335 + tmp_kernel_op_156*tmp_kernel_op_338 + tmp_kernel_op_160*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_345 + tmp_kernel_op_210*tmp_kernel_op_348 + tmp_kernel_op_214*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_44 + tmp_kernel_op_318*tmp_kernel_op_48 + tmp_kernel_op_321*tmp_kernel_op_52);
                const real_t tmp_kernel_op_353 = tmp_kernel_op_312*tmp_kernel_op_42;
                const real_t tmp_kernel_op_354 = tmp_kernel_op_267*tmp_kernel_op_43;
                const real_t tmp_kernel_op_355 = tmp_kernel_op_353 + tmp_kernel_op_354;
                const real_t tmp_kernel_op_356 = tmp_kernel_op_312*tmp_kernel_op_46;
                const real_t tmp_kernel_op_357 = tmp_kernel_op_267*tmp_kernel_op_47;
                const real_t tmp_kernel_op_358 = tmp_kernel_op_356 + tmp_kernel_op_357;
                const real_t tmp_kernel_op_359 = tmp_kernel_op_312*tmp_kernel_op_50;
                const real_t tmp_kernel_op_360 = tmp_kernel_op_267*tmp_kernel_op_51;
                const real_t tmp_kernel_op_361 = tmp_kernel_op_359 + tmp_kernel_op_360;
                const real_t tmp_kernel_op_362 = tmp_kernel_op_322*tmp_kernel_op_96;
                const real_t tmp_kernel_op_363 = tmp_kernel_op_278*tmp_kernel_op_97;
                const real_t tmp_kernel_op_364 = tmp_kernel_op_362 + tmp_kernel_op_363;
                const real_t tmp_kernel_op_365 = tmp_kernel_op_100*tmp_kernel_op_322;
                const real_t tmp_kernel_op_366 = tmp_kernel_op_101*tmp_kernel_op_278;
                const real_t tmp_kernel_op_367 = tmp_kernel_op_365 + tmp_kernel_op_366;
                const real_t tmp_kernel_op_368 = tmp_kernel_op_104*tmp_kernel_op_322;
                const real_t tmp_kernel_op_369 = tmp_kernel_op_105*tmp_kernel_op_278;
                const real_t tmp_kernel_op_370 = tmp_kernel_op_368 + tmp_kernel_op_369;
                const real_t tmp_kernel_op_371 = tmp_kernel_op_150*tmp_kernel_op_332;
                const real_t tmp_kernel_op_372 = tmp_kernel_op_151*tmp_kernel_op_289;
                const real_t tmp_kernel_op_373 = tmp_kernel_op_371 + tmp_kernel_op_372;
                const real_t tmp_kernel_op_374 = tmp_kernel_op_154*tmp_kernel_op_332;
                const real_t tmp_kernel_op_375 = tmp_kernel_op_155*tmp_kernel_op_289;
                const real_t tmp_kernel_op_376 = tmp_kernel_op_374 + tmp_kernel_op_375;
                const real_t tmp_kernel_op_377 = tmp_kernel_op_158*tmp_kernel_op_332;
                const real_t tmp_kernel_op_378 = tmp_kernel_op_159*tmp_kernel_op_289;
                const real_t tmp_kernel_op_379 = tmp_kernel_op_377 + tmp_kernel_op_378;
                const real_t tmp_kernel_op_380 = tmp_kernel_op_204*tmp_kernel_op_342;
                const real_t tmp_kernel_op_381 = tmp_kernel_op_205*tmp_kernel_op_300;
                const real_t tmp_kernel_op_382 = tmp_kernel_op_380 + tmp_kernel_op_381;
                const real_t tmp_kernel_op_383 = tmp_kernel_op_208*tmp_kernel_op_342;
                const real_t tmp_kernel_op_384 = tmp_kernel_op_209*tmp_kernel_op_300;
                const real_t tmp_kernel_op_385 = tmp_kernel_op_383 + tmp_kernel_op_384;
                const real_t tmp_kernel_op_386 = tmp_kernel_op_212*tmp_kernel_op_342;
                const real_t tmp_kernel_op_387 = tmp_kernel_op_213*tmp_kernel_op_300;
                const real_t tmp_kernel_op_388 = tmp_kernel_op_386 + tmp_kernel_op_387;
                const real_t tmp_kernel_op_389 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_367 + tmp_kernel_op_106*tmp_kernel_op_370 + tmp_kernel_op_364*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_373 + tmp_kernel_op_156*tmp_kernel_op_376 + tmp_kernel_op_160*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_382 + tmp_kernel_op_210*tmp_kernel_op_385 + tmp_kernel_op_214*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_44 + tmp_kernel_op_358*tmp_kernel_op_48 + tmp_kernel_op_361*tmp_kernel_op_52);
                const real_t tmp_kernel_op_390 = tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40 - tmp_kernel_op_270 - tmp_kernel_op_314;
                const real_t tmp_kernel_op_391 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45 - tmp_kernel_op_273 - tmp_kernel_op_317;
                const real_t tmp_kernel_op_392 = tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49 - tmp_kernel_op_276 - tmp_kernel_op_320;
                const real_t tmp_kernel_op_393 = -tmp_kernel_op_281 - tmp_kernel_op_324 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94;
                const real_t tmp_kernel_op_394 = -tmp_kernel_op_284 - tmp_kernel_op_327 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99;
                const real_t tmp_kernel_op_395 = tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94 - tmp_kernel_op_287 - tmp_kernel_op_330;
                const real_t tmp_kernel_op_396 = tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148 - tmp_kernel_op_292 - tmp_kernel_op_334;
                const real_t tmp_kernel_op_397 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153 - tmp_kernel_op_295 - tmp_kernel_op_337;
                const real_t tmp_kernel_op_398 = tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157 - tmp_kernel_op_298 - tmp_kernel_op_340;
                const real_t tmp_kernel_op_399 = tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202 - tmp_kernel_op_303 - tmp_kernel_op_344;
                const real_t tmp_kernel_op_400 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207 - tmp_kernel_op_306 - tmp_kernel_op_347;
                const real_t tmp_kernel_op_401 = tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211 - tmp_kernel_op_309 - tmp_kernel_op_350;
                const real_t tmp_kernel_op_402 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_394 + tmp_kernel_op_106*tmp_kernel_op_395 + tmp_kernel_op_393*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_396 + tmp_kernel_op_156*tmp_kernel_op_397 + tmp_kernel_op_160*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_399 + tmp_kernel_op_210*tmp_kernel_op_400 + tmp_kernel_op_214*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_44 + tmp_kernel_op_391*tmp_kernel_op_48 + tmp_kernel_op_392*tmp_kernel_op_52);
                const real_t tmp_kernel_op_403 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42 - tmp_kernel_op_268 - tmp_kernel_op_354;
                const real_t tmp_kernel_op_404 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46 - tmp_kernel_op_272 - tmp_kernel_op_357;
                const real_t tmp_kernel_op_405 = tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50 - tmp_kernel_op_275 - tmp_kernel_op_360;
                const real_t tmp_kernel_op_406 = -tmp_kernel_op_279 - tmp_kernel_op_363 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96;
                const real_t tmp_kernel_op_407 = tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_283 - tmp_kernel_op_366;
                const real_t tmp_kernel_op_408 = tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94 - tmp_kernel_op_286 - tmp_kernel_op_369;
                const real_t tmp_kernel_op_409 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150 - tmp_kernel_op_290 - tmp_kernel_op_372;
                const real_t tmp_kernel_op_410 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154 - tmp_kernel_op_294 - tmp_kernel_op_375;
                const real_t tmp_kernel_op_411 = tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158 - tmp_kernel_op_297 - tmp_kernel_op_378;
                const real_t tmp_kernel_op_412 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204 - tmp_kernel_op_301 - tmp_kernel_op_381;
                const real_t tmp_kernel_op_413 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208 - tmp_kernel_op_305 - tmp_kernel_op_384;
                const real_t tmp_kernel_op_414 = tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212 - tmp_kernel_op_308 - tmp_kernel_op_387;
                const real_t tmp_kernel_op_415 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_407 + tmp_kernel_op_106*tmp_kernel_op_408 + tmp_kernel_op_406*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_409 + tmp_kernel_op_156*tmp_kernel_op_410 + tmp_kernel_op_160*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_412 + tmp_kernel_op_210*tmp_kernel_op_413 + tmp_kernel_op_214*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_44 + tmp_kernel_op_404*tmp_kernel_op_48 + tmp_kernel_op_405*tmp_kernel_op_52);
                const real_t tmp_kernel_op_416 = -tmp_kernel_op_313 - tmp_kernel_op_353 + tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5;
                const real_t tmp_kernel_op_417 = -tmp_kernel_op_316 - tmp_kernel_op_356 + tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5;
                const real_t tmp_kernel_op_418 = -tmp_kernel_op_319 - tmp_kernel_op_359 + tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51;
                const real_t tmp_kernel_op_419 = -tmp_kernel_op_323 - tmp_kernel_op_362 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97;
                const real_t tmp_kernel_op_420 = tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_326 - tmp_kernel_op_365;
                const real_t tmp_kernel_op_421 = tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94 - tmp_kernel_op_329 - tmp_kernel_op_368;
                const real_t tmp_kernel_op_422 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151 - tmp_kernel_op_333 - tmp_kernel_op_371;
                const real_t tmp_kernel_op_423 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155 - tmp_kernel_op_336 - tmp_kernel_op_374;
                const real_t tmp_kernel_op_424 = tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159 - tmp_kernel_op_339 - tmp_kernel_op_377;
                const real_t tmp_kernel_op_425 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205 - tmp_kernel_op_343 - tmp_kernel_op_380;
                const real_t tmp_kernel_op_426 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209 - tmp_kernel_op_346 - tmp_kernel_op_383;
                const real_t tmp_kernel_op_427 = tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213 - tmp_kernel_op_349 - tmp_kernel_op_386;
                const real_t tmp_kernel_op_428 = tmp_kernel_op_107*(tmp_kernel_op_102*tmp_kernel_op_420 + tmp_kernel_op_106*tmp_kernel_op_421 + tmp_kernel_op_419*tmp_kernel_op_98) + tmp_kernel_op_161*(tmp_kernel_op_152*tmp_kernel_op_422 + tmp_kernel_op_156*tmp_kernel_op_423 + tmp_kernel_op_160*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_206*tmp_kernel_op_425 + tmp_kernel_op_210*tmp_kernel_op_426 + tmp_kernel_op_214*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_416*tmp_kernel_op_44 + tmp_kernel_op_417*tmp_kernel_op_48 + tmp_kernel_op_418*tmp_kernel_op_52);
                const real_t tmp_kernel_op_429 = 1.0 / (tmp_kernel_op_39*tmp_kernel_op_39);
                const real_t tmp_kernel_op_430 = tmp_kernel_op_429*16.0;
                const real_t tmp_kernel_op_431 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_432 = 1.0 / (tmp_kernel_op_93*tmp_kernel_op_93);
                const real_t tmp_kernel_op_433 = tmp_kernel_op_432*16.0;
                const real_t tmp_kernel_op_434 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_435 = 1.0 / (tmp_kernel_op_147*tmp_kernel_op_147);
                const real_t tmp_kernel_op_436 = tmp_kernel_op_435*16.0;
                const real_t tmp_kernel_op_437 = tmp_kernel_op_436*0.11249999999999996;
                const real_t tmp_kernel_op_438 = 1.0 / (tmp_kernel_op_201*tmp_kernel_op_201);
                const real_t tmp_kernel_op_439 = tmp_kernel_op_438*16.0;
                const real_t tmp_kernel_op_440 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_441 = tmp_kernel_op_1*tmp_kernel_op_429;
                const real_t tmp_kernel_op_442 = tmp_kernel_op_11*tmp_kernel_op_441;
                const real_t tmp_kernel_op_443 = tmp_kernel_op_432*tmp_kernel_op_55;
                const real_t tmp_kernel_op_444 = tmp_kernel_op_443*tmp_kernel_op_65;
                const real_t tmp_kernel_op_445 = tmp_kernel_op_109*tmp_kernel_op_435;
                const real_t tmp_kernel_op_446 = tmp_kernel_op_119*tmp_kernel_op_445;
                const real_t tmp_kernel_op_447 = tmp_kernel_op_163*tmp_kernel_op_438;
                const real_t tmp_kernel_op_448 = tmp_kernel_op_173*tmp_kernel_op_447;
                const real_t tmp_kernel_op_449 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_101*tmp_kernel_op_444 + tmp_kernel_op_104*tmp_kernel_op_105*tmp_kernel_op_444 + tmp_kernel_op_444*tmp_kernel_op_96*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_150*tmp_kernel_op_151*tmp_kernel_op_446 + tmp_kernel_op_154*tmp_kernel_op_155*tmp_kernel_op_446 + tmp_kernel_op_158*tmp_kernel_op_159*tmp_kernel_op_446) + tmp_kernel_op_215*(tmp_kernel_op_204*tmp_kernel_op_205*tmp_kernel_op_448 + tmp_kernel_op_208*tmp_kernel_op_209*tmp_kernel_op_448 + tmp_kernel_op_212*tmp_kernel_op_213*tmp_kernel_op_448) + tmp_kernel_op_53*(tmp_kernel_op_42*tmp_kernel_op_43*tmp_kernel_op_442 + tmp_kernel_op_442*tmp_kernel_op_46*tmp_kernel_op_47 + tmp_kernel_op_442*tmp_kernel_op_50*tmp_kernel_op_51);
                const real_t tmp_kernel_op_450 = tmp_kernel_op_25*tmp_kernel_op_441;
                const real_t tmp_kernel_op_451 = tmp_kernel_op_443*tmp_kernel_op_79;
                const real_t tmp_kernel_op_452 = tmp_kernel_op_133*tmp_kernel_op_445;
                const real_t tmp_kernel_op_453 = tmp_kernel_op_187*tmp_kernel_op_447;
                const real_t tmp_kernel_op_454 = tmp_kernel_op_107*(tmp_kernel_op_101*tmp_kernel_op_451*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_105*tmp_kernel_op_451 + tmp_kernel_op_451*tmp_kernel_op_78*tmp_kernel_op_97) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_151*tmp_kernel_op_452 + tmp_kernel_op_153*tmp_kernel_op_155*tmp_kernel_op_452 + tmp_kernel_op_157*tmp_kernel_op_159*tmp_kernel_op_452) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_205*tmp_kernel_op_453 + tmp_kernel_op_207*tmp_kernel_op_209*tmp_kernel_op_453 + tmp_kernel_op_211*tmp_kernel_op_213*tmp_kernel_op_453) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_43*tmp_kernel_op_450 + tmp_kernel_op_45*tmp_kernel_op_450*tmp_kernel_op_47 + tmp_kernel_op_450*tmp_kernel_op_49*tmp_kernel_op_51);
                const real_t tmp_kernel_op_455 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_282 + tmp_kernel_op_222*tmp_kernel_op_285 + tmp_kernel_op_223*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_293 + tmp_kernel_op_226*tmp_kernel_op_296 + tmp_kernel_op_227*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_304 + tmp_kernel_op_230*tmp_kernel_op_307 + tmp_kernel_op_231*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_271 + tmp_kernel_op_218*tmp_kernel_op_274 + tmp_kernel_op_219*tmp_kernel_op_277);
                const real_t tmp_kernel_op_456 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_325 + tmp_kernel_op_222*tmp_kernel_op_328 + tmp_kernel_op_223*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_335 + tmp_kernel_op_226*tmp_kernel_op_338 + tmp_kernel_op_227*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_345 + tmp_kernel_op_230*tmp_kernel_op_348 + tmp_kernel_op_231*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_315 + tmp_kernel_op_218*tmp_kernel_op_318 + tmp_kernel_op_219*tmp_kernel_op_321);
                const real_t tmp_kernel_op_457 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_364 + tmp_kernel_op_222*tmp_kernel_op_367 + tmp_kernel_op_223*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_373 + tmp_kernel_op_226*tmp_kernel_op_376 + tmp_kernel_op_227*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_382 + tmp_kernel_op_230*tmp_kernel_op_385 + tmp_kernel_op_231*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_355 + tmp_kernel_op_218*tmp_kernel_op_358 + tmp_kernel_op_219*tmp_kernel_op_361);
                const real_t tmp_kernel_op_458 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_393 + tmp_kernel_op_222*tmp_kernel_op_394 + tmp_kernel_op_223*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_396 + tmp_kernel_op_226*tmp_kernel_op_397 + tmp_kernel_op_227*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_399 + tmp_kernel_op_230*tmp_kernel_op_400 + tmp_kernel_op_231*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_390 + tmp_kernel_op_218*tmp_kernel_op_391 + tmp_kernel_op_219*tmp_kernel_op_392);
                const real_t tmp_kernel_op_459 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_406 + tmp_kernel_op_222*tmp_kernel_op_407 + tmp_kernel_op_223*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_409 + tmp_kernel_op_226*tmp_kernel_op_410 + tmp_kernel_op_227*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_412 + tmp_kernel_op_230*tmp_kernel_op_413 + tmp_kernel_op_231*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_403 + tmp_kernel_op_218*tmp_kernel_op_404 + tmp_kernel_op_219*tmp_kernel_op_405);
                const real_t tmp_kernel_op_460 = tmp_kernel_op_107*(tmp_kernel_op_221*tmp_kernel_op_419 + tmp_kernel_op_222*tmp_kernel_op_420 + tmp_kernel_op_223*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_225*tmp_kernel_op_422 + tmp_kernel_op_226*tmp_kernel_op_423 + tmp_kernel_op_227*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_229*tmp_kernel_op_425 + tmp_kernel_op_230*tmp_kernel_op_426 + tmp_kernel_op_231*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_217*tmp_kernel_op_416 + tmp_kernel_op_218*tmp_kernel_op_417 + tmp_kernel_op_219*tmp_kernel_op_418);
                const real_t tmp_kernel_op_461 = tmp_kernel_op_430*0.012500000000000002;
                const real_t tmp_kernel_op_462 = tmp_kernel_op_433*0.11249999999999996;
                const real_t tmp_kernel_op_463 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_464 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_465 = tmp_kernel_op_11*tmp_kernel_op_25*tmp_kernel_op_429;
                const real_t tmp_kernel_op_466 = tmp_kernel_op_432*tmp_kernel_op_65*tmp_kernel_op_79;
                const real_t tmp_kernel_op_467 = tmp_kernel_op_119*tmp_kernel_op_133*tmp_kernel_op_435;
                const real_t tmp_kernel_op_468 = tmp_kernel_op_173*tmp_kernel_op_187*tmp_kernel_op_438;
                const real_t tmp_kernel_op_469 = tmp_kernel_op_107*(tmp_kernel_op_100*tmp_kernel_op_466*tmp_kernel_op_99 + tmp_kernel_op_103*tmp_kernel_op_104*tmp_kernel_op_466 + tmp_kernel_op_466*tmp_kernel_op_78*tmp_kernel_op_96) + tmp_kernel_op_161*(tmp_kernel_op_132*tmp_kernel_op_150*tmp_kernel_op_467 + tmp_kernel_op_153*tmp_kernel_op_154*tmp_kernel_op_467 + tmp_kernel_op_157*tmp_kernel_op_158*tmp_kernel_op_467) + tmp_kernel_op_215*(tmp_kernel_op_186*tmp_kernel_op_204*tmp_kernel_op_468 + tmp_kernel_op_207*tmp_kernel_op_208*tmp_kernel_op_468 + tmp_kernel_op_211*tmp_kernel_op_212*tmp_kernel_op_468) + tmp_kernel_op_53*(tmp_kernel_op_24*tmp_kernel_op_42*tmp_kernel_op_465 + tmp_kernel_op_45*tmp_kernel_op_46*tmp_kernel_op_465 + tmp_kernel_op_465*tmp_kernel_op_49*tmp_kernel_op_50);
                const real_t tmp_kernel_op_470 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_282 + tmp_kernel_op_239*tmp_kernel_op_285 + tmp_kernel_op_240*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_293 + tmp_kernel_op_243*tmp_kernel_op_296 + tmp_kernel_op_244*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_304 + tmp_kernel_op_247*tmp_kernel_op_307 + tmp_kernel_op_248*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_271 + tmp_kernel_op_235*tmp_kernel_op_274 + tmp_kernel_op_236*tmp_kernel_op_277);
                const real_t tmp_kernel_op_471 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_325 + tmp_kernel_op_239*tmp_kernel_op_328 + tmp_kernel_op_240*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_335 + tmp_kernel_op_243*tmp_kernel_op_338 + tmp_kernel_op_244*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_345 + tmp_kernel_op_247*tmp_kernel_op_348 + tmp_kernel_op_248*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_315 + tmp_kernel_op_235*tmp_kernel_op_318 + tmp_kernel_op_236*tmp_kernel_op_321);
                const real_t tmp_kernel_op_472 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_364 + tmp_kernel_op_239*tmp_kernel_op_367 + tmp_kernel_op_240*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_373 + tmp_kernel_op_243*tmp_kernel_op_376 + tmp_kernel_op_244*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_382 + tmp_kernel_op_247*tmp_kernel_op_385 + tmp_kernel_op_248*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_355 + tmp_kernel_op_235*tmp_kernel_op_358 + tmp_kernel_op_236*tmp_kernel_op_361);
                const real_t tmp_kernel_op_473 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_393 + tmp_kernel_op_239*tmp_kernel_op_394 + tmp_kernel_op_240*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_396 + tmp_kernel_op_243*tmp_kernel_op_397 + tmp_kernel_op_244*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_399 + tmp_kernel_op_247*tmp_kernel_op_400 + tmp_kernel_op_248*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_390 + tmp_kernel_op_235*tmp_kernel_op_391 + tmp_kernel_op_236*tmp_kernel_op_392);
                const real_t tmp_kernel_op_474 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_406 + tmp_kernel_op_239*tmp_kernel_op_407 + tmp_kernel_op_240*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_409 + tmp_kernel_op_243*tmp_kernel_op_410 + tmp_kernel_op_244*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_412 + tmp_kernel_op_247*tmp_kernel_op_413 + tmp_kernel_op_248*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_403 + tmp_kernel_op_235*tmp_kernel_op_404 + tmp_kernel_op_236*tmp_kernel_op_405);
                const real_t tmp_kernel_op_475 = tmp_kernel_op_107*(tmp_kernel_op_238*tmp_kernel_op_419 + tmp_kernel_op_239*tmp_kernel_op_420 + tmp_kernel_op_240*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_242*tmp_kernel_op_422 + tmp_kernel_op_243*tmp_kernel_op_423 + tmp_kernel_op_244*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_246*tmp_kernel_op_425 + tmp_kernel_op_247*tmp_kernel_op_426 + tmp_kernel_op_248*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_234*tmp_kernel_op_416 + tmp_kernel_op_235*tmp_kernel_op_417 + tmp_kernel_op_236*tmp_kernel_op_418);
                const real_t tmp_kernel_op_476 = tmp_kernel_op_430*0.11249999999999996;
                const real_t tmp_kernel_op_477 = tmp_kernel_op_433*0.012500000000000002;
                const real_t tmp_kernel_op_478 = tmp_kernel_op_436*0.012500000000000002;
                const real_t tmp_kernel_op_479 = tmp_kernel_op_439*0.012500000000000002;
                const real_t tmp_kernel_op_480 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_282 + tmp_kernel_op_256*tmp_kernel_op_285 + tmp_kernel_op_257*tmp_kernel_op_288) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_293 + tmp_kernel_op_260*tmp_kernel_op_296 + tmp_kernel_op_261*tmp_kernel_op_299) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_304 + tmp_kernel_op_264*tmp_kernel_op_307 + tmp_kernel_op_265*tmp_kernel_op_310) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_271 + tmp_kernel_op_252*tmp_kernel_op_274 + tmp_kernel_op_253*tmp_kernel_op_277);
                const real_t tmp_kernel_op_481 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_325 + tmp_kernel_op_256*tmp_kernel_op_328 + tmp_kernel_op_257*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_335 + tmp_kernel_op_260*tmp_kernel_op_338 + tmp_kernel_op_261*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_345 + tmp_kernel_op_264*tmp_kernel_op_348 + tmp_kernel_op_265*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_315 + tmp_kernel_op_252*tmp_kernel_op_318 + tmp_kernel_op_253*tmp_kernel_op_321);
                const real_t tmp_kernel_op_482 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_364 + tmp_kernel_op_256*tmp_kernel_op_367 + tmp_kernel_op_257*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_373 + tmp_kernel_op_260*tmp_kernel_op_376 + tmp_kernel_op_261*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_382 + tmp_kernel_op_264*tmp_kernel_op_385 + tmp_kernel_op_265*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_355 + tmp_kernel_op_252*tmp_kernel_op_358 + tmp_kernel_op_253*tmp_kernel_op_361);
                const real_t tmp_kernel_op_483 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_393 + tmp_kernel_op_256*tmp_kernel_op_394 + tmp_kernel_op_257*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_396 + tmp_kernel_op_260*tmp_kernel_op_397 + tmp_kernel_op_261*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_399 + tmp_kernel_op_264*tmp_kernel_op_400 + tmp_kernel_op_265*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_390 + tmp_kernel_op_252*tmp_kernel_op_391 + tmp_kernel_op_253*tmp_kernel_op_392);
                const real_t tmp_kernel_op_484 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_406 + tmp_kernel_op_256*tmp_kernel_op_407 + tmp_kernel_op_257*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_409 + tmp_kernel_op_260*tmp_kernel_op_410 + tmp_kernel_op_261*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_412 + tmp_kernel_op_264*tmp_kernel_op_413 + tmp_kernel_op_265*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_403 + tmp_kernel_op_252*tmp_kernel_op_404 + tmp_kernel_op_253*tmp_kernel_op_405);
                const real_t tmp_kernel_op_485 = tmp_kernel_op_107*(tmp_kernel_op_255*tmp_kernel_op_419 + tmp_kernel_op_256*tmp_kernel_op_420 + tmp_kernel_op_257*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_259*tmp_kernel_op_422 + tmp_kernel_op_260*tmp_kernel_op_423 + tmp_kernel_op_261*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_263*tmp_kernel_op_425 + tmp_kernel_op_264*tmp_kernel_op_426 + tmp_kernel_op_265*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_251*tmp_kernel_op_416 + tmp_kernel_op_252*tmp_kernel_op_417 + tmp_kernel_op_253*tmp_kernel_op_418);
                const real_t tmp_kernel_op_486 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_487 = tmp_kernel_op_24*tmp_kernel_op_486;
                const real_t tmp_kernel_op_488 = tmp_kernel_op_40*0.5854101966249684;
                const real_t tmp_kernel_op_489 = tmp_kernel_op_42*tmp_kernel_op_488;
                const real_t tmp_kernel_op_490 = tmp_kernel_op_45*tmp_kernel_op_486;
                const real_t tmp_kernel_op_491 = tmp_kernel_op_46*tmp_kernel_op_488;
                const real_t tmp_kernel_op_492 = tmp_kernel_op_486*tmp_kernel_op_49;
                const real_t tmp_kernel_op_493 = tmp_kernel_op_488*tmp_kernel_op_50;
                const real_t tmp_kernel_op_494 = tmp_kernel_op_94*0.5854101966249684;
                const real_t tmp_kernel_op_495 = tmp_kernel_op_494*tmp_kernel_op_78;
                const real_t tmp_kernel_op_496 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_497 = tmp_kernel_op_496*tmp_kernel_op_96;
                const real_t tmp_kernel_op_498 = tmp_kernel_op_494*tmp_kernel_op_99;
                const real_t tmp_kernel_op_499 = tmp_kernel_op_100*tmp_kernel_op_496;
                const real_t tmp_kernel_op_500 = tmp_kernel_op_103*tmp_kernel_op_494;
                const real_t tmp_kernel_op_501 = tmp_kernel_op_104*tmp_kernel_op_496;
                const real_t tmp_kernel_op_502 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_503 = tmp_kernel_op_132*tmp_kernel_op_502;
                const real_t tmp_kernel_op_504 = tmp_kernel_op_148*0.1381966011250105;
                const real_t tmp_kernel_op_505 = tmp_kernel_op_150*tmp_kernel_op_504;
                const real_t tmp_kernel_op_506 = tmp_kernel_op_153*tmp_kernel_op_502;
                const real_t tmp_kernel_op_507 = tmp_kernel_op_154*tmp_kernel_op_504;
                const real_t tmp_kernel_op_508 = tmp_kernel_op_157*tmp_kernel_op_502;
                const real_t tmp_kernel_op_509 = tmp_kernel_op_158*tmp_kernel_op_504;
                const real_t tmp_kernel_op_510 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_511 = tmp_kernel_op_186*tmp_kernel_op_510;
                const real_t tmp_kernel_op_512 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_513 = tmp_kernel_op_204*tmp_kernel_op_512;
                const real_t tmp_kernel_op_514 = tmp_kernel_op_207*tmp_kernel_op_510;
                const real_t tmp_kernel_op_515 = tmp_kernel_op_208*tmp_kernel_op_512;
                const real_t tmp_kernel_op_516 = tmp_kernel_op_211*tmp_kernel_op_510;
                const real_t tmp_kernel_op_517 = tmp_kernel_op_212*tmp_kernel_op_512;
                const real_t tmp_kernel_op_518 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_325 + tmp_kernel_op_285*tmp_kernel_op_328 + tmp_kernel_op_288*tmp_kernel_op_331) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_335 + tmp_kernel_op_296*tmp_kernel_op_338 + tmp_kernel_op_299*tmp_kernel_op_341) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_345 + tmp_kernel_op_307*tmp_kernel_op_348 + tmp_kernel_op_310*tmp_kernel_op_351) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_315 + tmp_kernel_op_274*tmp_kernel_op_318 + tmp_kernel_op_277*tmp_kernel_op_321);
                const real_t tmp_kernel_op_519 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_364 + tmp_kernel_op_285*tmp_kernel_op_367 + tmp_kernel_op_288*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_373 + tmp_kernel_op_296*tmp_kernel_op_376 + tmp_kernel_op_299*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_382 + tmp_kernel_op_307*tmp_kernel_op_385 + tmp_kernel_op_310*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_355 + tmp_kernel_op_274*tmp_kernel_op_358 + tmp_kernel_op_277*tmp_kernel_op_361);
                const real_t tmp_kernel_op_520 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_393 + tmp_kernel_op_285*tmp_kernel_op_394 + tmp_kernel_op_288*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_396 + tmp_kernel_op_296*tmp_kernel_op_397 + tmp_kernel_op_299*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_399 + tmp_kernel_op_307*tmp_kernel_op_400 + tmp_kernel_op_310*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_390 + tmp_kernel_op_274*tmp_kernel_op_391 + tmp_kernel_op_277*tmp_kernel_op_392);
                const real_t tmp_kernel_op_521 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_406 + tmp_kernel_op_285*tmp_kernel_op_407 + tmp_kernel_op_288*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_409 + tmp_kernel_op_296*tmp_kernel_op_410 + tmp_kernel_op_299*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_412 + tmp_kernel_op_307*tmp_kernel_op_413 + tmp_kernel_op_310*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_403 + tmp_kernel_op_274*tmp_kernel_op_404 + tmp_kernel_op_277*tmp_kernel_op_405);
                const real_t tmp_kernel_op_522 = tmp_kernel_op_107*(tmp_kernel_op_282*tmp_kernel_op_419 + tmp_kernel_op_285*tmp_kernel_op_420 + tmp_kernel_op_288*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_293*tmp_kernel_op_422 + tmp_kernel_op_296*tmp_kernel_op_423 + tmp_kernel_op_299*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_304*tmp_kernel_op_425 + tmp_kernel_op_307*tmp_kernel_op_426 + tmp_kernel_op_310*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_271*tmp_kernel_op_416 + tmp_kernel_op_274*tmp_kernel_op_417 + tmp_kernel_op_277*tmp_kernel_op_418);
                const real_t tmp_kernel_op_523 = tmp_kernel_op_40*0.1381966011250105;
                const real_t tmp_kernel_op_524 = tmp_kernel_op_24*tmp_kernel_op_523;
                const real_t tmp_kernel_op_525 = tmp_kernel_op_43*tmp_kernel_op_488;
                const real_t tmp_kernel_op_526 = tmp_kernel_op_45*tmp_kernel_op_523;
                const real_t tmp_kernel_op_527 = tmp_kernel_op_47*tmp_kernel_op_488;
                const real_t tmp_kernel_op_528 = tmp_kernel_op_49*tmp_kernel_op_523;
                const real_t tmp_kernel_op_529 = tmp_kernel_op_488*tmp_kernel_op_51;
                const real_t tmp_kernel_op_530 = tmp_kernel_op_94*0.1381966011250105;
                const real_t tmp_kernel_op_531 = tmp_kernel_op_530*tmp_kernel_op_78;
                const real_t tmp_kernel_op_532 = tmp_kernel_op_496*tmp_kernel_op_97;
                const real_t tmp_kernel_op_533 = tmp_kernel_op_530*tmp_kernel_op_99;
                const real_t tmp_kernel_op_534 = tmp_kernel_op_101*tmp_kernel_op_496;
                const real_t tmp_kernel_op_535 = tmp_kernel_op_103*tmp_kernel_op_530;
                const real_t tmp_kernel_op_536 = tmp_kernel_op_105*tmp_kernel_op_496;
                const real_t tmp_kernel_op_537 = tmp_kernel_op_148*0.5854101966249684;
                const real_t tmp_kernel_op_538 = tmp_kernel_op_132*tmp_kernel_op_537;
                const real_t tmp_kernel_op_539 = tmp_kernel_op_151*tmp_kernel_op_504;
                const real_t tmp_kernel_op_540 = tmp_kernel_op_153*tmp_kernel_op_537;
                const real_t tmp_kernel_op_541 = tmp_kernel_op_155*tmp_kernel_op_504;
                const real_t tmp_kernel_op_542 = tmp_kernel_op_157*tmp_kernel_op_537;
                const real_t tmp_kernel_op_543 = tmp_kernel_op_159*tmp_kernel_op_504;
                const real_t tmp_kernel_op_544 = tmp_kernel_op_202*0.1381966011250105;
                const real_t tmp_kernel_op_545 = tmp_kernel_op_186*tmp_kernel_op_544;
                const real_t tmp_kernel_op_546 = tmp_kernel_op_205*tmp_kernel_op_512;
                const real_t tmp_kernel_op_547 = tmp_kernel_op_207*tmp_kernel_op_544;
                const real_t tmp_kernel_op_548 = tmp_kernel_op_209*tmp_kernel_op_512;
                const real_t tmp_kernel_op_549 = tmp_kernel_op_211*tmp_kernel_op_544;
                const real_t tmp_kernel_op_550 = tmp_kernel_op_213*tmp_kernel_op_512;
                const real_t tmp_kernel_op_551 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_364 + tmp_kernel_op_328*tmp_kernel_op_367 + tmp_kernel_op_331*tmp_kernel_op_370) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_373 + tmp_kernel_op_338*tmp_kernel_op_376 + tmp_kernel_op_341*tmp_kernel_op_379) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_382 + tmp_kernel_op_348*tmp_kernel_op_385 + tmp_kernel_op_351*tmp_kernel_op_388) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_355 + tmp_kernel_op_318*tmp_kernel_op_358 + tmp_kernel_op_321*tmp_kernel_op_361);
                const real_t tmp_kernel_op_552 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_393 + tmp_kernel_op_328*tmp_kernel_op_394 + tmp_kernel_op_331*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_396 + tmp_kernel_op_338*tmp_kernel_op_397 + tmp_kernel_op_341*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_399 + tmp_kernel_op_348*tmp_kernel_op_400 + tmp_kernel_op_351*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_390 + tmp_kernel_op_318*tmp_kernel_op_391 + tmp_kernel_op_321*tmp_kernel_op_392);
                const real_t tmp_kernel_op_553 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_406 + tmp_kernel_op_328*tmp_kernel_op_407 + tmp_kernel_op_331*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_409 + tmp_kernel_op_338*tmp_kernel_op_410 + tmp_kernel_op_341*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_412 + tmp_kernel_op_348*tmp_kernel_op_413 + tmp_kernel_op_351*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_403 + tmp_kernel_op_318*tmp_kernel_op_404 + tmp_kernel_op_321*tmp_kernel_op_405);
                const real_t tmp_kernel_op_554 = tmp_kernel_op_107*(tmp_kernel_op_325*tmp_kernel_op_419 + tmp_kernel_op_328*tmp_kernel_op_420 + tmp_kernel_op_331*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_335*tmp_kernel_op_422 + tmp_kernel_op_338*tmp_kernel_op_423 + tmp_kernel_op_341*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_345*tmp_kernel_op_425 + tmp_kernel_op_348*tmp_kernel_op_426 + tmp_kernel_op_351*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_315*tmp_kernel_op_416 + tmp_kernel_op_318*tmp_kernel_op_417 + tmp_kernel_op_321*tmp_kernel_op_418);
                const real_t tmp_kernel_op_555 = tmp_kernel_op_42*tmp_kernel_op_523;
                const real_t tmp_kernel_op_556 = tmp_kernel_op_43*tmp_kernel_op_486;
                const real_t tmp_kernel_op_557 = tmp_kernel_op_46*tmp_kernel_op_523;
                const real_t tmp_kernel_op_558 = tmp_kernel_op_47*tmp_kernel_op_486;
                const real_t tmp_kernel_op_559 = tmp_kernel_op_50*tmp_kernel_op_523;
                const real_t tmp_kernel_op_560 = tmp_kernel_op_486*tmp_kernel_op_51;
                const real_t tmp_kernel_op_561 = tmp_kernel_op_530*tmp_kernel_op_96;
                const real_t tmp_kernel_op_562 = tmp_kernel_op_494*tmp_kernel_op_97;
                const real_t tmp_kernel_op_563 = tmp_kernel_op_100*tmp_kernel_op_530;
                const real_t tmp_kernel_op_564 = tmp_kernel_op_101*tmp_kernel_op_494;
                const real_t tmp_kernel_op_565 = tmp_kernel_op_104*tmp_kernel_op_530;
                const real_t tmp_kernel_op_566 = tmp_kernel_op_105*tmp_kernel_op_494;
                const real_t tmp_kernel_op_567 = tmp_kernel_op_150*tmp_kernel_op_537;
                const real_t tmp_kernel_op_568 = tmp_kernel_op_151*tmp_kernel_op_502;
                const real_t tmp_kernel_op_569 = tmp_kernel_op_154*tmp_kernel_op_537;
                const real_t tmp_kernel_op_570 = tmp_kernel_op_155*tmp_kernel_op_502;
                const real_t tmp_kernel_op_571 = tmp_kernel_op_158*tmp_kernel_op_537;
                const real_t tmp_kernel_op_572 = tmp_kernel_op_159*tmp_kernel_op_502;
                const real_t tmp_kernel_op_573 = tmp_kernel_op_204*tmp_kernel_op_544;
                const real_t tmp_kernel_op_574 = tmp_kernel_op_205*tmp_kernel_op_510;
                const real_t tmp_kernel_op_575 = tmp_kernel_op_208*tmp_kernel_op_544;
                const real_t tmp_kernel_op_576 = tmp_kernel_op_209*tmp_kernel_op_510;
                const real_t tmp_kernel_op_577 = tmp_kernel_op_212*tmp_kernel_op_544;
                const real_t tmp_kernel_op_578 = tmp_kernel_op_213*tmp_kernel_op_510;
                const real_t tmp_kernel_op_579 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_393 + tmp_kernel_op_367*tmp_kernel_op_394 + tmp_kernel_op_370*tmp_kernel_op_395) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_396 + tmp_kernel_op_376*tmp_kernel_op_397 + tmp_kernel_op_379*tmp_kernel_op_398) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_399 + tmp_kernel_op_385*tmp_kernel_op_400 + tmp_kernel_op_388*tmp_kernel_op_401) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_390 + tmp_kernel_op_358*tmp_kernel_op_391 + tmp_kernel_op_361*tmp_kernel_op_392);
                const real_t tmp_kernel_op_580 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_406 + tmp_kernel_op_367*tmp_kernel_op_407 + tmp_kernel_op_370*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_409 + tmp_kernel_op_376*tmp_kernel_op_410 + tmp_kernel_op_379*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_412 + tmp_kernel_op_385*tmp_kernel_op_413 + tmp_kernel_op_388*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_403 + tmp_kernel_op_358*tmp_kernel_op_404 + tmp_kernel_op_361*tmp_kernel_op_405);
                const real_t tmp_kernel_op_581 = tmp_kernel_op_107*(tmp_kernel_op_364*tmp_kernel_op_419 + tmp_kernel_op_367*tmp_kernel_op_420 + tmp_kernel_op_370*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_373*tmp_kernel_op_422 + tmp_kernel_op_376*tmp_kernel_op_423 + tmp_kernel_op_379*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_382*tmp_kernel_op_425 + tmp_kernel_op_385*tmp_kernel_op_426 + tmp_kernel_op_388*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_355*tmp_kernel_op_416 + tmp_kernel_op_358*tmp_kernel_op_417 + tmp_kernel_op_361*tmp_kernel_op_418);
                const real_t tmp_kernel_op_582 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_406 + tmp_kernel_op_394*tmp_kernel_op_407 + tmp_kernel_op_395*tmp_kernel_op_408) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_409 + tmp_kernel_op_397*tmp_kernel_op_410 + tmp_kernel_op_398*tmp_kernel_op_411) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_412 + tmp_kernel_op_400*tmp_kernel_op_413 + tmp_kernel_op_401*tmp_kernel_op_414) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_403 + tmp_kernel_op_391*tmp_kernel_op_404 + tmp_kernel_op_392*tmp_kernel_op_405);
                const real_t tmp_kernel_op_583 = tmp_kernel_op_107*(tmp_kernel_op_393*tmp_kernel_op_419 + tmp_kernel_op_394*tmp_kernel_op_420 + tmp_kernel_op_395*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_396*tmp_kernel_op_422 + tmp_kernel_op_397*tmp_kernel_op_423 + tmp_kernel_op_398*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_399*tmp_kernel_op_425 + tmp_kernel_op_400*tmp_kernel_op_426 + tmp_kernel_op_401*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_390*tmp_kernel_op_416 + tmp_kernel_op_391*tmp_kernel_op_417 + tmp_kernel_op_392*tmp_kernel_op_418);
                const real_t tmp_kernel_op_584 = tmp_kernel_op_107*(tmp_kernel_op_406*tmp_kernel_op_419 + tmp_kernel_op_407*tmp_kernel_op_420 + tmp_kernel_op_408*tmp_kernel_op_421) + tmp_kernel_op_161*(tmp_kernel_op_409*tmp_kernel_op_422 + tmp_kernel_op_410*tmp_kernel_op_423 + tmp_kernel_op_411*tmp_kernel_op_424) + tmp_kernel_op_215*(tmp_kernel_op_412*tmp_kernel_op_425 + tmp_kernel_op_413*tmp_kernel_op_426 + tmp_kernel_op_414*tmp_kernel_op_427) + tmp_kernel_op_53*(tmp_kernel_op_403*tmp_kernel_op_416 + tmp_kernel_op_404*tmp_kernel_op_417 + tmp_kernel_op_405*tmp_kernel_op_418);
                const real_t elMatVec_0 = src_dof_0*(tmp_kernel_op_107*((tmp_kernel_op_102*tmp_kernel_op_102) + (tmp_kernel_op_106*tmp_kernel_op_106) + (tmp_kernel_op_98*tmp_kernel_op_98)) + tmp_kernel_op_161*((tmp_kernel_op_152*tmp_kernel_op_152) + (tmp_kernel_op_156*tmp_kernel_op_156) + (tmp_kernel_op_160*tmp_kernel_op_160)) + tmp_kernel_op_215*((tmp_kernel_op_206*tmp_kernel_op_206) + (tmp_kernel_op_210*tmp_kernel_op_210) + (tmp_kernel_op_214*tmp_kernel_op_214)) + tmp_kernel_op_53*((tmp_kernel_op_44*tmp_kernel_op_44) + (tmp_kernel_op_48*tmp_kernel_op_48) + (tmp_kernel_op_52*tmp_kernel_op_52))) + src_dof_1*tmp_kernel_op_232 + src_dof_2*tmp_kernel_op_249 + src_dof_3*tmp_kernel_op_266 + src_dof_4*tmp_kernel_op_311 + src_dof_5*tmp_kernel_op_352 + src_dof_6*tmp_kernel_op_389 + src_dof_7*tmp_kernel_op_402 + src_dof_8*tmp_kernel_op_415 + src_dof_9*tmp_kernel_op_428;
                const real_t elMatVec_1 = src_dof_0*tmp_kernel_op_232 + src_dof_1*(tmp_kernel_op_107*((tmp_kernel_op_101*tmp_kernel_op_101)*tmp_kernel_op_434 + (tmp_kernel_op_105*tmp_kernel_op_105)*tmp_kernel_op_434 + tmp_kernel_op_434*(tmp_kernel_op_97*tmp_kernel_op_97)) + tmp_kernel_op_161*((tmp_kernel_op_151*tmp_kernel_op_151)*tmp_kernel_op_437 + (tmp_kernel_op_155*tmp_kernel_op_155)*tmp_kernel_op_437 + (tmp_kernel_op_159*tmp_kernel_op_159)*tmp_kernel_op_437) + tmp_kernel_op_215*((tmp_kernel_op_205*tmp_kernel_op_205)*tmp_kernel_op_440 + (tmp_kernel_op_209*tmp_kernel_op_209)*tmp_kernel_op_440 + (tmp_kernel_op_213*tmp_kernel_op_213)*tmp_kernel_op_440) + tmp_kernel_op_53*((tmp_kernel_op_43*tmp_kernel_op_43)*tmp_kernel_op_431 + tmp_kernel_op_431*(tmp_kernel_op_47*tmp_kernel_op_47) + tmp_kernel_op_431*(tmp_kernel_op_51*tmp_kernel_op_51))) + src_dof_2*tmp_kernel_op_449 + src_dof_3*tmp_kernel_op_454 + src_dof_4*tmp_kernel_op_455 + src_dof_5*tmp_kernel_op_456 + src_dof_6*tmp_kernel_op_457 + src_dof_7*tmp_kernel_op_458 + src_dof_8*tmp_kernel_op_459 + src_dof_9*tmp_kernel_op_460;
                const real_t elMatVec_2 = src_dof_0*tmp_kernel_op_249 + src_dof_1*tmp_kernel_op_449 + src_dof_2*(tmp_kernel_op_107*((tmp_kernel_op_100*tmp_kernel_op_100)*tmp_kernel_op_462 + (tmp_kernel_op_104*tmp_kernel_op_104)*tmp_kernel_op_462 + tmp_kernel_op_462*(tmp_kernel_op_96*tmp_kernel_op_96)) + tmp_kernel_op_161*((tmp_kernel_op_150*tmp_kernel_op_150)*tmp_kernel_op_463 + (tmp_kernel_op_154*tmp_kernel_op_154)*tmp_kernel_op_463 + (tmp_kernel_op_158*tmp_kernel_op_158)*tmp_kernel_op_463) + tmp_kernel_op_215*((tmp_kernel_op_204*tmp_kernel_op_204)*tmp_kernel_op_464 + (tmp_kernel_op_208*tmp_kernel_op_208)*tmp_kernel_op_464 + (tmp_kernel_op_212*tmp_kernel_op_212)*tmp_kernel_op_464) + tmp_kernel_op_53*((tmp_kernel_op_42*tmp_kernel_op_42)*tmp_kernel_op_461 + (tmp_kernel_op_46*tmp_kernel_op_46)*tmp_kernel_op_461 + tmp_kernel_op_461*(tmp_kernel_op_50*tmp_kernel_op_50))) + src_dof_3*tmp_kernel_op_469 + src_dof_4*tmp_kernel_op_470 + src_dof_5*tmp_kernel_op_471 + src_dof_6*tmp_kernel_op_472 + src_dof_7*tmp_kernel_op_473 + src_dof_8*tmp_kernel_op_474 + src_dof_9*tmp_kernel_op_475;
                const real_t elMatVec_3 = src_dof_0*tmp_kernel_op_266 + src_dof_1*tmp_kernel_op_454 + src_dof_2*tmp_kernel_op_469 + src_dof_3*(tmp_kernel_op_107*((tmp_kernel_op_103*tmp_kernel_op_103)*tmp_kernel_op_477 + tmp_kernel_op_477*(tmp_kernel_op_78*tmp_kernel_op_78) + tmp_kernel_op_477*(tmp_kernel_op_99*tmp_kernel_op_99)) + tmp_kernel_op_161*((tmp_kernel_op_132*tmp_kernel_op_132)*tmp_kernel_op_478 + (tmp_kernel_op_153*tmp_kernel_op_153)*tmp_kernel_op_478 + (tmp_kernel_op_157*tmp_kernel_op_157)*tmp_kernel_op_478) + tmp_kernel_op_215*((tmp_kernel_op_186*tmp_kernel_op_186)*tmp_kernel_op_479 + (tmp_kernel_op_207*tmp_kernel_op_207)*tmp_kernel_op_479 + (tmp_kernel_op_211*tmp_kernel_op_211)*tmp_kernel_op_479) + tmp_kernel_op_53*((tmp_kernel_op_24*tmp_kernel_op_24)*tmp_kernel_op_476 + (tmp_kernel_op_45*tmp_kernel_op_45)*tmp_kernel_op_476 + tmp_kernel_op_476*(tmp_kernel_op_49*tmp_kernel_op_49))) + src_dof_4*tmp_kernel_op_480 + src_dof_5*tmp_kernel_op_481 + src_dof_6*tmp_kernel_op_482 + src_dof_7*tmp_kernel_op_483 + src_dof_8*tmp_kernel_op_484 + src_dof_9*tmp_kernel_op_485;
                const real_t elMatVec_4 = src_dof_0*tmp_kernel_op_311 + src_dof_1*tmp_kernel_op_455 + src_dof_2*tmp_kernel_op_470 + src_dof_3*tmp_kernel_op_480 + src_dof_4*(tmp_kernel_op_107*(((tmp_kernel_op_495 + tmp_kernel_op_497)*(tmp_kernel_op_495 + tmp_kernel_op_497))*16.0 + ((tmp_kernel_op_498 + tmp_kernel_op_499)*(tmp_kernel_op_498 + tmp_kernel_op_499))*16.0 + ((tmp_kernel_op_500 + tmp_kernel_op_501)*(tmp_kernel_op_500 + tmp_kernel_op_501))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_503 + tmp_kernel_op_505)*(tmp_kernel_op_503 + tmp_kernel_op_505))*16.0 + ((tmp_kernel_op_506 + tmp_kernel_op_507)*(tmp_kernel_op_506 + tmp_kernel_op_507))*16.0 + ((tmp_kernel_op_508 + tmp_kernel_op_509)*(tmp_kernel_op_508 + tmp_kernel_op_509))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_511 + tmp_kernel_op_513)*(tmp_kernel_op_511 + tmp_kernel_op_513))*16.0 + ((tmp_kernel_op_514 + tmp_kernel_op_515)*(tmp_kernel_op_514 + tmp_kernel_op_515))*16.0 + ((tmp_kernel_op_516 + tmp_kernel_op_517)*(tmp_kernel_op_516 + tmp_kernel_op_517))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_487 + tmp_kernel_op_489)*(tmp_kernel_op_487 + tmp_kernel_op_489))*16.0 + ((tmp_kernel_op_490 + tmp_kernel_op_491)*(tmp_kernel_op_490 + tmp_kernel_op_491))*16.0 + ((tmp_kernel_op_492 + tmp_kernel_op_493)*(tmp_kernel_op_492 + tmp_kernel_op_493))*16.0)) + src_dof_5*tmp_kernel_op_518 + src_dof_6*tmp_kernel_op_519 + src_dof_7*tmp_kernel_op_520 + src_dof_8*tmp_kernel_op_521 + src_dof_9*tmp_kernel_op_522;
                const real_t elMatVec_5 = src_dof_0*tmp_kernel_op_352 + src_dof_1*tmp_kernel_op_456 + src_dof_2*tmp_kernel_op_471 + src_dof_3*tmp_kernel_op_481 + src_dof_4*tmp_kernel_op_518 + src_dof_5*(tmp_kernel_op_107*(((tmp_kernel_op_531 + tmp_kernel_op_532)*(tmp_kernel_op_531 + tmp_kernel_op_532))*16.0 + ((tmp_kernel_op_533 + tmp_kernel_op_534)*(tmp_kernel_op_533 + tmp_kernel_op_534))*16.0 + ((tmp_kernel_op_535 + tmp_kernel_op_536)*(tmp_kernel_op_535 + tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_538 + tmp_kernel_op_539)*(tmp_kernel_op_538 + tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_540 + tmp_kernel_op_541)*(tmp_kernel_op_540 + tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_542 + tmp_kernel_op_543)*(tmp_kernel_op_542 + tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_545 + tmp_kernel_op_546)*(tmp_kernel_op_545 + tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_547 + tmp_kernel_op_548)*(tmp_kernel_op_547 + tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_549 + tmp_kernel_op_550)*(tmp_kernel_op_549 + tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_524 + tmp_kernel_op_525)*(tmp_kernel_op_524 + tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_526 + tmp_kernel_op_527)*(tmp_kernel_op_526 + tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_528 + tmp_kernel_op_529)*(tmp_kernel_op_528 + tmp_kernel_op_529))*16.0)) + src_dof_6*tmp_kernel_op_551 + src_dof_7*tmp_kernel_op_552 + src_dof_8*tmp_kernel_op_553 + src_dof_9*tmp_kernel_op_554;
                const real_t elMatVec_6 = src_dof_0*tmp_kernel_op_389 + src_dof_1*tmp_kernel_op_457 + src_dof_2*tmp_kernel_op_472 + src_dof_3*tmp_kernel_op_482 + src_dof_4*tmp_kernel_op_519 + src_dof_5*tmp_kernel_op_551 + src_dof_6*(tmp_kernel_op_107*(((tmp_kernel_op_561 + tmp_kernel_op_562)*(tmp_kernel_op_561 + tmp_kernel_op_562))*16.0 + ((tmp_kernel_op_563 + tmp_kernel_op_564)*(tmp_kernel_op_563 + tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_565 + tmp_kernel_op_566)*(tmp_kernel_op_565 + tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_567 + tmp_kernel_op_568)*(tmp_kernel_op_567 + tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_569 + tmp_kernel_op_570)*(tmp_kernel_op_569 + tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_571 + tmp_kernel_op_572)*(tmp_kernel_op_571 + tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_573 + tmp_kernel_op_574)*(tmp_kernel_op_573 + tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_575 + tmp_kernel_op_576)*(tmp_kernel_op_575 + tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_577 + tmp_kernel_op_578)*(tmp_kernel_op_577 + tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_555 + tmp_kernel_op_556)*(tmp_kernel_op_555 + tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_557 + tmp_kernel_op_558)*(tmp_kernel_op_557 + tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_559 + tmp_kernel_op_560)*(tmp_kernel_op_559 + tmp_kernel_op_560))*16.0)) + src_dof_7*tmp_kernel_op_579 + src_dof_8*tmp_kernel_op_580 + src_dof_9*tmp_kernel_op_581;
                const real_t elMatVec_7 = src_dof_0*tmp_kernel_op_402 + src_dof_1*tmp_kernel_op_458 + src_dof_2*tmp_kernel_op_473 + src_dof_3*tmp_kernel_op_483 + src_dof_4*tmp_kernel_op_520 + src_dof_5*tmp_kernel_op_552 + src_dof_6*tmp_kernel_op_579 + src_dof_7*(tmp_kernel_op_107*(((-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25)*(-tmp_kernel_op_497 - tmp_kernel_op_532 + tmp_kernel_op_78*tmp_kernel_op_80*tmp_kernel_op_94*0.25))*16.0 + ((-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25)*(-tmp_kernel_op_499 - tmp_kernel_op_534 + tmp_kernel_op_80*tmp_kernel_op_94*tmp_kernel_op_99*0.25))*16.0 + ((tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536)*(tmp_kernel_op_103*tmp_kernel_op_80*tmp_kernel_op_94*0.25 - tmp_kernel_op_501 - tmp_kernel_op_536))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539)*(tmp_kernel_op_132*tmp_kernel_op_134*tmp_kernel_op_148*0.25 - tmp_kernel_op_505 - tmp_kernel_op_539))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_153*0.25 - tmp_kernel_op_507 - tmp_kernel_op_541))*16.0 + ((tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543)*(tmp_kernel_op_134*tmp_kernel_op_148*tmp_kernel_op_157*0.25 - tmp_kernel_op_509 - tmp_kernel_op_543))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546)*(tmp_kernel_op_186*tmp_kernel_op_188*tmp_kernel_op_202*0.25 - tmp_kernel_op_513 - tmp_kernel_op_546))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_207*0.25 - tmp_kernel_op_515 - tmp_kernel_op_548))*16.0 + ((tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550)*(tmp_kernel_op_188*tmp_kernel_op_202*tmp_kernel_op_211*0.25 - tmp_kernel_op_517 - tmp_kernel_op_550))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525)*(tmp_kernel_op_24*tmp_kernel_op_26*tmp_kernel_op_40*0.25 - tmp_kernel_op_489 - tmp_kernel_op_525))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_45*0.25 - tmp_kernel_op_491 - tmp_kernel_op_527))*16.0 + ((tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529)*(tmp_kernel_op_26*tmp_kernel_op_40*tmp_kernel_op_49*0.25 - tmp_kernel_op_493 - tmp_kernel_op_529))*16.0)) + src_dof_8*tmp_kernel_op_582 + src_dof_9*tmp_kernel_op_583;
                const real_t elMatVec_8 = src_dof_0*tmp_kernel_op_415 + src_dof_1*tmp_kernel_op_459 + src_dof_2*tmp_kernel_op_474 + src_dof_3*tmp_kernel_op_484 + src_dof_4*tmp_kernel_op_521 + src_dof_5*tmp_kernel_op_553 + src_dof_6*tmp_kernel_op_580 + src_dof_7*tmp_kernel_op_582 + src_dof_8*(tmp_kernel_op_107*(((-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25)*(-tmp_kernel_op_495 - tmp_kernel_op_562 + tmp_kernel_op_67*tmp_kernel_op_94*tmp_kernel_op_96*0.25))*16.0 + ((tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564)*(tmp_kernel_op_100*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_498 - tmp_kernel_op_564))*16.0 + ((tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566)*(tmp_kernel_op_104*tmp_kernel_op_67*tmp_kernel_op_94*0.25 - tmp_kernel_op_500 - tmp_kernel_op_566))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_150*0.25 - tmp_kernel_op_503 - tmp_kernel_op_568))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_154*0.25 - tmp_kernel_op_506 - tmp_kernel_op_570))*16.0 + ((tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572)*(tmp_kernel_op_121*tmp_kernel_op_148*tmp_kernel_op_158*0.25 - tmp_kernel_op_508 - tmp_kernel_op_572))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_204*0.25 - tmp_kernel_op_511 - tmp_kernel_op_574))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_208*0.25 - tmp_kernel_op_514 - tmp_kernel_op_576))*16.0 + ((tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578)*(tmp_kernel_op_175*tmp_kernel_op_202*tmp_kernel_op_212*0.25 - tmp_kernel_op_516 - tmp_kernel_op_578))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_42*0.25 - tmp_kernel_op_487 - tmp_kernel_op_556))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_46*0.25 - tmp_kernel_op_490 - tmp_kernel_op_558))*16.0 + ((tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560)*(tmp_kernel_op_13*tmp_kernel_op_40*tmp_kernel_op_50*0.25 - tmp_kernel_op_492 - tmp_kernel_op_560))*16.0)) + src_dof_9*tmp_kernel_op_584;
                const real_t elMatVec_9 = src_dof_0*tmp_kernel_op_428 + src_dof_1*tmp_kernel_op_460 + src_dof_2*tmp_kernel_op_475 + src_dof_3*tmp_kernel_op_485 + src_dof_4*tmp_kernel_op_522 + src_dof_5*tmp_kernel_op_554 + src_dof_6*tmp_kernel_op_581 + src_dof_7*tmp_kernel_op_583 + src_dof_8*tmp_kernel_op_584 + src_dof_9*(tmp_kernel_op_107*(((-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25)*(-tmp_kernel_op_531 - tmp_kernel_op_561 + tmp_kernel_op_59*tmp_kernel_op_94*tmp_kernel_op_97*0.25))*16.0 + ((tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563)*(tmp_kernel_op_101*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_533 - tmp_kernel_op_563))*16.0 + ((tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565)*(tmp_kernel_op_105*tmp_kernel_op_59*tmp_kernel_op_94*0.25 - tmp_kernel_op_535 - tmp_kernel_op_565))*16.0) + tmp_kernel_op_161*(((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_151*0.25 - tmp_kernel_op_538 - tmp_kernel_op_567))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_155*0.25 - tmp_kernel_op_540 - tmp_kernel_op_569))*16.0 + ((tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571)*(tmp_kernel_op_113*tmp_kernel_op_148*tmp_kernel_op_159*0.25 - tmp_kernel_op_542 - tmp_kernel_op_571))*16.0) + tmp_kernel_op_215*(((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_205*0.25 - tmp_kernel_op_545 - tmp_kernel_op_573))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_209*0.25 - tmp_kernel_op_547 - tmp_kernel_op_575))*16.0 + ((tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577)*(tmp_kernel_op_167*tmp_kernel_op_202*tmp_kernel_op_213*0.25 - tmp_kernel_op_549 - tmp_kernel_op_577))*16.0) + tmp_kernel_op_53*(((tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555)*(tmp_kernel_op_40*tmp_kernel_op_43*tmp_kernel_op_5*0.25 - tmp_kernel_op_524 - tmp_kernel_op_555))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557)*(tmp_kernel_op_40*tmp_kernel_op_47*tmp_kernel_op_5*0.25 - tmp_kernel_op_526 - tmp_kernel_op_557))*16.0 + ((tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559)*(tmp_kernel_op_40*tmp_kernel_op_5*tmp_kernel_op_51*0.25 - tmp_kernel_op_528 - tmp_kernel_op_559))*16.0));
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_4 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_5 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatVec_6 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_7 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatVec_8 + _data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatVec_9 + _data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
