/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../P2ElementwiseFullStokes_1_1.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseFullStokes_1_1::computeInverseDiagonalOperatorValues_P2ElementwiseFullStokes_1_1_macro_3D( real_t * RESTRICT  _data_invDiag_Edge, real_t * RESTRICT  _data_invDiag_Vertex, real_t * RESTRICT  _data_muEdge, real_t * RESTRICT  _data_muVertex, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float ) const
{
    {
       const real_t _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const real_t tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const real_t tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const real_t jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const real_t jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const real_t jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const real_t jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const real_t abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_UP [] = {((real_t)(jac_affine_inv_0_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_0_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_0_WHITE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_0_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_UP [] = {((real_t)(jac_affine_inv_0_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_1_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_1_WHITE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_1_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_UP [] = {((real_t)(jac_affine_inv_0_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995787 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995776 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_1_2_WHITE_UP*0.44721359549995765 + jac_affine_inv_2_2_WHITE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_UP*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_UP*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_UP*1.7888543819998317 + jac_affine_inv_1_2_WHITE_UP*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_WHITE_UP[2*q] + _data_tabulated_and_untitled_2_2_WHITE_UP[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_WHITE_UP[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_WHITE_UP[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_WHITE_UP[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_WHITE_UP[q] + 0.5*_data_tabulated_and_untitled_2_0_WHITE_UP[q])*(_data_tabulated_and_untitled_0_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_0_WHITE_UP[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_WHITE_UP[2*q]*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_WHITE_UP[q]*_data_tabulated_and_untitled_2_2_WHITE_UP[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_WHITE_UP[10*q] + mu_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 1])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 1])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 1] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 1])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 1]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 1]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 2])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 2])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 2] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 2])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 2]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 2]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 3])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 3])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 3] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 3])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 3]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 3]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 4])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 4])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 4] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 4])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 4]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 4]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 5])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 5])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 5] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 5])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 5]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 5]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 6])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 6])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 6] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 6])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 6]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 6]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 7])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 7])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 7] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 7])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 7]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 7]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 8])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 8])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 8] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 8])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 8]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 8]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 9])*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 9])*(_data_tabulated_and_untitled_0_1_WHITE_UP[10*q + 9] + _data_tabulated_and_untitled_1_0_WHITE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 9])*(_data_tabulated_and_untitled_1_2_WHITE_UP[q] + _data_tabulated_and_untitled_2_1_WHITE_UP[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 9]*_data_tabulated_and_untitled_1_1_WHITE_UP[10*q + 9]))*_data_tabulated_and_untitled_0_0_WHITE_UP[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const real_t tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const real_t tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const real_t jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const real_t jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const real_t jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const real_t jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const real_t jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_WHITE_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_WHITE_DOWN [] = {((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_WHITE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_WHITE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_WHITE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_WHITE_DOWN [] = {((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_WHITE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_WHITE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_WHITE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_WHITE_DOWN [] = {((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_WHITE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_WHITE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_WHITE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_WHITE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_WHITE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_WHITE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_WHITE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_WHITE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_WHITE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_WHITE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q] + _data_tabulated_and_untitled_2_2_WHITE_DOWN[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_WHITE_DOWN[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_WHITE_DOWN[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_WHITE_DOWN[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_WHITE_DOWN[q] + 0.5*_data_tabulated_and_untitled_2_0_WHITE_DOWN[q])*(_data_tabulated_and_untitled_0_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_0_WHITE_DOWN[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q]*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_WHITE_DOWN[q]*_data_tabulated_and_untitled_2_2_WHITE_DOWN[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 1])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 1])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 1] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 1])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 1]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 1]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 2])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 2])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 2] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 2])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 2]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 2]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 3])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 3])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 3] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 3])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 3]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 3]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 4])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 4])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 4] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 4])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 4]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 4]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 5])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 5])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 5] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 5])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 5]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 5]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 6])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 6])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 6] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 6])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 6]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 6]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 7])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 7])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 7] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 7])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 7]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 7]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 8])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 8])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 8] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 8])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 8]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 8]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 9])*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 9])*(_data_tabulated_and_untitled_0_1_WHITE_DOWN[10*q + 9] + _data_tabulated_and_untitled_1_0_WHITE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 9])*(_data_tabulated_and_untitled_1_2_WHITE_DOWN[q] + _data_tabulated_and_untitled_2_1_WHITE_DOWN[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 9]*_data_tabulated_and_untitled_1_1_WHITE_DOWN[10*q + 9]))*_data_tabulated_and_untitled_0_0_WHITE_DOWN[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const real_t tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const real_t tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const real_t jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const real_t jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const real_t jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const real_t jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const real_t jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const real_t abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_UP [] = {((real_t)(jac_affine_inv_0_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_0_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_0_BLUE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_0_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_UP [] = {((real_t)(jac_affine_inv_0_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_1_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_1_BLUE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_1_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_UP [] = {((real_t)(jac_affine_inv_0_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995787 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995776 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_1_2_BLUE_UP*0.44721359549995765 + jac_affine_inv_2_2_BLUE_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_UP*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_UP*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_UP*1.7888543819998317 + jac_affine_inv_1_2_BLUE_UP*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_BLUE_UP[2*q] + _data_tabulated_and_untitled_2_2_BLUE_UP[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_BLUE_UP[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_BLUE_UP[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_BLUE_UP[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_BLUE_UP[q] + 0.5*_data_tabulated_and_untitled_2_0_BLUE_UP[q])*(_data_tabulated_and_untitled_0_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_0_BLUE_UP[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_BLUE_UP[2*q]*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_BLUE_UP[q]*_data_tabulated_and_untitled_2_2_BLUE_UP[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_BLUE_UP[10*q] + mu_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 1])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 1])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 1] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 1])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 1]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 1]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 2])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 2])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 2] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 2])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 2]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 2]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 3])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 3])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 3] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 3])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 3]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 3]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 4])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 4])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 4] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 4])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 4]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 4]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 5])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 5])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 5] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 5])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 5]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 5]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 6])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 6])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 6] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 6])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 6]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 6]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 7])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 7])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 7] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 7])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 7]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 7]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 8])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 8])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 8] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 8])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 8]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 8]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 9])*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 9])*(_data_tabulated_and_untitled_0_1_BLUE_UP[10*q + 9] + _data_tabulated_and_untitled_1_0_BLUE_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 9])*(_data_tabulated_and_untitled_1_2_BLUE_UP[q] + _data_tabulated_and_untitled_2_1_BLUE_UP[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 9]*_data_tabulated_and_untitled_1_1_BLUE_UP[10*q + 9]))*_data_tabulated_and_untitled_0_0_BLUE_UP[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const real_t tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const real_t tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const real_t jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const real_t jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const real_t jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const real_t jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const real_t jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_BLUE_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_BLUE_DOWN [] = {((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_0_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_0_BLUE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_BLUE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_0_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_BLUE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_BLUE_DOWN [] = {((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_1_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_1_BLUE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_BLUE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_1_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_BLUE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_BLUE_DOWN [] = {((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995787 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995776 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_1_2_BLUE_DOWN*0.44721359549995765 + jac_affine_inv_2_2_BLUE_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_BLUE_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_BLUE_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_BLUE_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_BLUE_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_BLUE_DOWN*1.7888543819998317 + jac_affine_inv_1_2_BLUE_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_BLUE_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_BLUE_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q] + _data_tabulated_and_untitled_2_2_BLUE_DOWN[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_BLUE_DOWN[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_BLUE_DOWN[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_BLUE_DOWN[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_BLUE_DOWN[q] + 0.5*_data_tabulated_and_untitled_2_0_BLUE_DOWN[q])*(_data_tabulated_and_untitled_0_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_0_BLUE_DOWN[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q]*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_BLUE_DOWN[q]*_data_tabulated_and_untitled_2_2_BLUE_DOWN[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + mu_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 1])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 1])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 1] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 1])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 1]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 1]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 2])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 2])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 2] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 2])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 2]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 2]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 3])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 3])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 3] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 3])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 3]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 3]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 4])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 4])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 4] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 4])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 4]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 4]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 5])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 5])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 5] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 5])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 5]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 5]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 6])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 6])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 6] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 6])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 6]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 6]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 7])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 7])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 7] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 7])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 7]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 7]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 8])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 8])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 8] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 8])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 8]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 8]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 9])*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 9])*(_data_tabulated_and_untitled_0_1_BLUE_DOWN[10*q + 9] + _data_tabulated_and_untitled_1_0_BLUE_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 9])*(_data_tabulated_and_untitled_1_2_BLUE_DOWN[q] + _data_tabulated_and_untitled_2_1_BLUE_DOWN[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 9]*_data_tabulated_and_untitled_1_1_BLUE_DOWN[10*q + 9]))*_data_tabulated_and_untitled_0_0_BLUE_DOWN[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const real_t tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const real_t tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const real_t jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const real_t jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const real_t jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const real_t jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const real_t jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const real_t abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_UP))};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_UP [] = {((real_t)(jac_affine_inv_0_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_0_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_0_GREEN_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_0_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_UP [] = {((real_t)(jac_affine_inv_0_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_1_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_1_GREEN_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_1_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_UP [] = {((real_t)(jac_affine_inv_0_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995787 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995776 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_1_2_GREEN_UP*0.44721359549995765 + jac_affine_inv_2_2_GREEN_UP*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_UP*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_UP*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_UP*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_UP*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_UP*1.7888543819998317 + jac_affine_inv_1_2_GREEN_UP*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_UP*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_UP [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_GREEN_UP[2*q] + _data_tabulated_and_untitled_2_2_GREEN_UP[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_GREEN_UP[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_GREEN_UP[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_GREEN_UP[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_GREEN_UP[q] + 0.5*_data_tabulated_and_untitled_2_0_GREEN_UP[q])*(_data_tabulated_and_untitled_0_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_0_GREEN_UP[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_GREEN_UP[2*q]*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_GREEN_UP[q]*_data_tabulated_and_untitled_2_2_GREEN_UP[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_GREEN_UP[10*q] + mu_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 1])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 1])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 1] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 1])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 1]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 1]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 2])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 2])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 2] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 2])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 2]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 2]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 3])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 3])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 3] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 3])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 3]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 3]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 4])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 4])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 4] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 4])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 4]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 4]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 5])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 5])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 5] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 5])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 5]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 5]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 6])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 6])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 6] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 6])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 6]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 6]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 7])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 7])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 7] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 7])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 7]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 7]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 8])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 8])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 8] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 8])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 8]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 8]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 9])*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 9])*(_data_tabulated_and_untitled_0_1_GREEN_UP[10*q + 9] + _data_tabulated_and_untitled_1_0_GREEN_UP[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 9])*(_data_tabulated_and_untitled_1_2_GREEN_UP[q] + _data_tabulated_and_untitled_2_1_GREEN_UP[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 9]*_data_tabulated_and_untitled_1_1_GREEN_UP[10*q + 9]))*_data_tabulated_and_untitled_0_0_GREEN_UP[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const real_t tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const real_t tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const real_t jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const real_t jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const real_t jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const real_t jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const real_t jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.099999999999999978, 0.32360679774997891, 0.32360679774997891, 0.076393202250021025, 0.32360679774997902, 0.076393202250021108, 0.076393202250021108, -0.099999999999999978, -0.099999999999999992, 0.099999999999999978, -0.099999999999999992, 0.32360679774997891, 0.076393202250021025, 0.32360679774997891, 0.076393202250021108, 0.32360679774997902, 0.076393202250021081, -0.09999999999999995, 0.099999999999999978, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.32360679774997891, 0.32360679774997891, 0.076393202250021081, 0.076393202250021081, 0.32360679774997902, 0.10000000000000028, -0.099999999999999992, -0.099999999999999992, -0.099999999999999992, 0.076393202250021025, 0.076393202250021025, 0.076393202250021025, 0.32360679774997902, 0.32360679774997902, 0.32360679774997902};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN)), 0.0, ((real_t)(abs_det_jac_affine_GREEN_DOWN))};
      
          const real_t _data_tabulated_and_untitled_0_1_GREEN_DOWN [] = {((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_0_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_0_GREEN_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_0_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_0_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_0_GREEN_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_0_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_0_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_0_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_0_GREEN_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_0_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_1_1_GREEN_DOWN [] = {((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_1_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_1_GREEN_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_1_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_1_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_1_GREEN_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_1_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_1_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_1_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_1_GREEN_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_1_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_0_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          const real_t _data_tabulated_and_untitled_2_1_GREEN_DOWN [] = {((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995787 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995787)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.7888543819998315)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995776 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995776)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_1_2_GREEN_DOWN*0.44721359549995765 + jac_affine_inv_2_2_GREEN_DOWN*0.44721359549995765)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.3416407864998736)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*2.2204460492503131e-16)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*2.2204460492503131e-16 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.7888543819998315 + jac_affine_inv_1_2_GREEN_DOWN*-2.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-2.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_1_2_GREEN_DOWN*-1.3416407864998736 + jac_affine_inv_2_2_GREEN_DOWN*-1.3416407864998736)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_2_2_GREEN_DOWN*-0.44721359549995798)), ((real_t)(jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*1.7888543819998317)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_1_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202)), ((real_t)(jac_affine_inv_0_2_GREEN_DOWN*1.7888543819998317 + jac_affine_inv_1_2_GREEN_DOWN*-0.55278640450004202 + jac_affine_inv_2_2_GREEN_DOWN*-0.55278640450004202))};
      
          const real_t _data_tabulated_and_untitled_2_2_GREEN_DOWN [] = {0.0, 0.0, 0.0, 0.0};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t mu_dof_0 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_1 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_2 = _data_muVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t mu_dof_3 = _data_muVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t mu_dof_4 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_5 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_6 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t mu_dof_7 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t mu_dof_8 = _data_muEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t mu_dof_9 = _data_muEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_4_4 = 0.0;
             real_t q_acc_5_5 = 0.0;
             real_t q_acc_6_6 = 0.0;
             real_t q_acc_7_7 = 0.0;
             real_t q_acc_8_8 = 0.0;
             real_t q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const real_t tmp_qloop_0 = _data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q] + _data_tabulated_and_untitled_2_2_GREEN_DOWN[q];
                const real_t tmp_qloop_1 = 0.66666666666666663*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q] + 0.66666666666666663*_data_tabulated_and_untitled_2_2_GREEN_DOWN[q];
                const real_t tmp_qloop_2 = 0.5*_data_tabulated_and_untitled_1_0_GREEN_DOWN[q];
                const real_t tmp_qloop_3 = 0.5*_data_tabulated_and_untitled_1_2_GREEN_DOWN[q];
                const real_t tmp_qloop_4 = (0.5*_data_tabulated_and_untitled_0_2_GREEN_DOWN[q] + 0.5*_data_tabulated_and_untitled_2_0_GREEN_DOWN[q])*(_data_tabulated_and_untitled_0_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_0_GREEN_DOWN[q])*2.0 + 2.0*(_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q]*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q]) + 2.0*(_data_tabulated_and_untitled_2_2_GREEN_DOWN[q]*_data_tabulated_and_untitled_2_2_GREEN_DOWN[q]);
                const real_t tmp_qloop_5 = (mu_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + mu_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + mu_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + mu_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + mu_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + mu_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + mu_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + mu_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + mu_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + mu_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*_data_q_w[q];
                const real_t q_tmp_0_0 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_1_1 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 1])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 1])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 1])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 1] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 1])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 1])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 1]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 1]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_2_2 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 2])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 2])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 2])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 2] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 2])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 2])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 2]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 2]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_3_3 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 3])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 3])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 3])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 3] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 3])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 3])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 3]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 3]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_4_4 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 4])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 4])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 4])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 4] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 4])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 4])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 4]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 4]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_5_5 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 5])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 5])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 5])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 5] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 5])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 5])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 5]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 5]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_6_6 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 6])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 6])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 6])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 6] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 6])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 6])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 6]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 6]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_7_7 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 7])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 7])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 7])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 7] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 7])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 7])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 7]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 7]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_8_8 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 8])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 8])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 8])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 8] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 8])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 8])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 8]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 8]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                const real_t q_tmp_9_9 = tmp_qloop_5*(-(tmp_qloop_0 + _data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 9])*(tmp_qloop_1 + 0.66666666666666663*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 9])*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1] + (tmp_qloop_4 + (tmp_qloop_2 + 0.5*_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 9])*(_data_tabulated_and_untitled_0_1_GREEN_DOWN[10*q + 9] + _data_tabulated_and_untitled_1_0_GREEN_DOWN[q])*2.0 + (tmp_qloop_3 + 0.5*_data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 9])*(_data_tabulated_and_untitled_1_2_GREEN_DOWN[q] + _data_tabulated_and_untitled_2_1_GREEN_DOWN[10*q + 9])*2.0 + 2.0*(_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 9]*_data_tabulated_and_untitled_1_1_GREEN_DOWN[10*q + 9]))*_data_tabulated_and_untitled_0_0_GREEN_DOWN[2*q + 1]);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const real_t elMatDiag_0 = q_acc_0_0;
             const real_t elMatDiag_1 = q_acc_1_1;
             const real_t elMatDiag_2 = q_acc_2_2;
             const real_t elMatDiag_3 = q_acc_3_3;
             const real_t elMatDiag_4 = q_acc_4_4;
             const real_t elMatDiag_5 = q_acc_5_5;
             const real_t elMatDiag_6 = q_acc_6_6;
             const real_t elMatDiag_7 = q_acc_7_7;
             const real_t elMatDiag_8 = q_acc_8_8;
             const real_t elMatDiag_9 = q_acc_9_9;
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_0 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_1 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatDiag_2 + _data_invDiag_Vertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatDiag_3 + _data_invDiag_Vertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_4 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = elMatDiag_6 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_7 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = elMatDiag_8 + _data_invDiag_Edge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_9 + _data_invDiag_Edge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
