/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG Operator Generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/































#include "../P2ToP1ElementwiseKMassIcosahedralShellMap.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ToP1ElementwiseKMassIcosahedralShellMap::apply_P2ToP1ElementwiseKMassIcosahedralShellMap_macro_3D( real_t * RESTRICT  _data_dst, real_t * RESTRICT  _data_kEdge, real_t * RESTRICT  _data_kVertex, real_t * RESTRICT  _data_srcEdge, real_t * RESTRICT  _data_srcVertex, real_t forVertex_0, real_t forVertex_1, real_t forVertex_2, real_t macro_vertex_coord_id_0comp0, real_t macro_vertex_coord_id_0comp1, real_t macro_vertex_coord_id_0comp2, real_t macro_vertex_coord_id_1comp0, real_t macro_vertex_coord_id_1comp1, real_t macro_vertex_coord_id_1comp2, real_t macro_vertex_coord_id_2comp0, real_t macro_vertex_coord_id_2comp1, real_t macro_vertex_coord_id_2comp2, real_t macro_vertex_coord_id_3comp0, real_t macro_vertex_coord_id_3comp1, real_t macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, real_t micro_edges_per_macro_edge_float, real_t radRayVertex, real_t radRefVertex, real_t rayVertex_0, real_t rayVertex_1, real_t rayVertex_2, real_t refVertex_0, real_t refVertex_1, real_t refVertex_2, real_t thrVertex_0, real_t thrVertex_1, real_t thrVertex_2 ) const
{
    {
       const real_t _data_q_w [] = {0.02364442875776411, 0.0041220137385117907, 0.025486503738822306, 0.0091363578885896128, 0.0052827872295400091, 0.02526054964096567, 0.01949470769240411, 0.0094909452962763929, 0.019522077110586403, 0.018549261128954084, 0.0066770344442521412};
   
       const real_t _data_q_p_0 [] = {0.4881393122183349, 0.028620108024415062, 0.12011493111997025, 0.19015055018870972, 0.81934505243836264, 0.33721826230431567, 0.086557484679865959, 0.079692524193577793, 0.061206893331017434, 0.43957887847117094, 0.085226802665704912};
   
       const real_t _data_q_p_1 [] = {0.31081202744417918, 0.1144811451032984, 0.33248812467264544, 0.58529107547132619, 0.026719351714152292, 0.11264913310739497, 0.079391877387070833, 0.063296594113889035, 0.44299746808745322, 0.057741550565775693, 0.77428400209089154};
   
       const real_t _data_q_p_2 [] = {0.082320586256909412, 0.85148303380032098, 0.10040383353811888, 0.21187112908079075, 0.11113976289693195, 0.45821473775386756, 0.49383422023194623, 0.10603293862052354, 0.35074787972985066, 0.10858823393329198, 0.0088057690417862045};
   
       const real_t tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const real_t p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const real_t p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const real_t p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const real_t jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const real_t jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const real_t jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const real_t jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const real_t jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const real_t jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const real_t jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const real_t jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const real_t abs_det_jac_affine_WHITE_UP = abs(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const real_t tmp_qloop_0 = rayVertex_1 - refVertex_1;
       const real_t tmp_qloop_1 = -rayVertex_0;
       const real_t tmp_qloop_2 = -forVertex_0 - tmp_qloop_1;
       const real_t tmp_qloop_3 = rayVertex_2 - thrVertex_2;
       const real_t tmp_qloop_4 = tmp_qloop_2*tmp_qloop_3;
       const real_t tmp_qloop_5 = rayVertex_2 - refVertex_2;
       const real_t tmp_qloop_6 = rayVertex_1 - thrVertex_1;
       const real_t tmp_qloop_7 = tmp_qloop_2*tmp_qloop_6;
       const real_t tmp_qloop_8 = -rayVertex_1;
       const real_t tmp_qloop_9 = -forVertex_1 - tmp_qloop_8;
       const real_t tmp_qloop_10 = rayVertex_0 - thrVertex_0;
       const real_t tmp_qloop_11 = rayVertex_0 - refVertex_0;
       const real_t tmp_qloop_12 = -rayVertex_2;
       const real_t tmp_qloop_13 = -forVertex_2 - tmp_qloop_12;
       const real_t tmp_qloop_14 = tmp_qloop_3*tmp_qloop_9;
       const real_t tmp_qloop_15 = tmp_qloop_10*tmp_qloop_13;
       const real_t tmp_qloop_16 = -tmp_qloop_0*tmp_qloop_15 + tmp_qloop_0*tmp_qloop_4 + tmp_qloop_10*tmp_qloop_5*tmp_qloop_9 + tmp_qloop_11*tmp_qloop_13*tmp_qloop_6 - tmp_qloop_11*tmp_qloop_14 - tmp_qloop_5*tmp_qloop_7;
       const real_t tmp_qloop_17 = 1.0 / (tmp_qloop_16);
       const real_t tmp_qloop_20 = radRayVertex*tmp_qloop_16;
       const real_t tmp_qloop_21 = radRayVertex - radRefVertex;
       const real_t tmp_qloop_32 = -tmp_qloop_13*tmp_qloop_6 + tmp_qloop_14;
       const real_t tmp_qloop_33 = -tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_39 = tmp_qloop_10*tmp_qloop_13 - tmp_qloop_4;
       const real_t tmp_qloop_40 = tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_45 = -tmp_qloop_10*tmp_qloop_9 + tmp_qloop_7;
       const real_t tmp_qloop_46 = -tmp_qloop_21*tmp_qloop_45;
       const real_t tmp_qloop_53 = -tmp_qloop_21*tmp_qloop_39;
       const real_t tmp_qloop_68 = tmp_qloop_21*tmp_qloop_32;
       const real_t tmp_qloop_72 = tmp_qloop_21*tmp_qloop_45;
       {
          /* CellType.WHITE_UP */
          const real_t _data_phi_0_0_WHITE_UP [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_UP [] = {((real_t)(abs_det_jac_affine_WHITE_UP*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012151214443257608)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019083835042434261)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.072053489056043002)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017525267423213611)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.027523941260433657)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.049958575567593019)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.078461393265588306)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.29624114484395714)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.072053489056042974)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.11316209633188964)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.031810029988819218)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.18862506775555832)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012151214443257601)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.045878482755592566)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.07205348905604296)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013231853551815916)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012151214443257603)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_WHITE_UP*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_WHITE_UP*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017130957178208683)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011159409734644826)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_WHITE_UP*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.068524255492113287)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.044637916950180538)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.000283911881665389)), ((real_t)(abs_det_jac_affine_WHITE_UP*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.50966681808331993)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.33200601647520916)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.083000987173061064)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015706073884687172)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021562946853404222)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.071405876738584673)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.080243884747120436)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.26572828761452333)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.095997217930328324)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.016039226535213912)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019188018251946451)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021562946853404225)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025796145274243024)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.044397913749511943)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053114031247306501)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.19765740883375349)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013407157762204741)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018024424659562992)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.059688031245203853)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021562946853404232)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018984670973016902)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.094319450236798913)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.030642694050274453)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.084650020197820364)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058435584226493004)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.29031907828914638)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.26055618198886238)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017384857321768536)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.021153258143552994)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.10509340307518385)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034142957672569287)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.022395383667253931)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015588264867481133)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.42876947450525699)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.009732450635762396)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.29844418988237825)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.071749615697017544)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015588264867481126)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.1149198753205366)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013982439217157605)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058160280082415236)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.040482354049473784)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015588264867481138)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018978279386089755)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.056811998632973766)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01396686284573566)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015485631440181358)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01139648574059631)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.069625445155635055)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.20842567519062763)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.051240105769272605)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.056811998632973738)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013966862845735664)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.041810186095187066)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.023258663351751644)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.017116965895609845)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018978279386089748)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01396686284573564)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.094607584046545581)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.28321039153111127)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.077196575526473174)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018978279386089758)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.056811998632973676)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053354679030800815)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.22863973450271471)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.036757553494219546)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.040075149727639509)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.013574438423676774)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.014799615333023134)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058170268354931248)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.009351816102656051)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.010195875266786407)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012450687019346486)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053354679030800829)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.077445898974953548)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.084435869696849797)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.3318773554937019)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053354679030800836)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.2830869924348563)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020160825588817252)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025383152182066201)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.23919668259056145)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.14278898169094956)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.17977609281010931)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.030040718507945225)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.002139433116273644)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025383152182066195)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.019077538505445499)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.023860144794362503)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020160825588817249)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012035048833865587)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.01515252809081665)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.039969943152159265)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.033772932211040815)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020160825588817245)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.025383152182066191)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.090150328303510344)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.029517331411893867)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.037280633286332542)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.038041411821271319)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012455650259246798)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015731589118882314)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.27533253531028662)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.048046617223388682)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.090150328303510385)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.11386060898348732)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.21799741519439725)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.030119685775736597)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.07137746553252089)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.090150328303510371)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.067458477890573201)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.035870894765649017)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.27308043404340754)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.011024731463671476)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.083929839859876898)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.044629504659074608)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.30460043053460045)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.005862376301973493)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.020733009548559916)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.018587561536304909)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.055932196812816262)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.053705963564394235)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.036199865373541695)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.022496381554864123)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034759025419540221)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.32887513974352289)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.02111678772433076)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.20437923045390871)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.31578513412249021)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_WHITE_UP*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_WHITE_UP*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_WHITE_UP*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_WHITE_UP*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_WHITE_UP[10*q] + k_dof_1*_data_phi_0_0_WHITE_UP[10*q + 1] + k_dof_2*_data_phi_0_0_WHITE_UP[10*q + 2] + k_dof_3*_data_phi_0_0_WHITE_UP[10*q + 3] + k_dof_4*_data_phi_0_0_WHITE_UP[10*q + 4] + k_dof_5*_data_phi_0_0_WHITE_UP[10*q + 5] + k_dof_6*_data_phi_0_0_WHITE_UP[10*q + 6] + k_dof_7*_data_phi_0_0_WHITE_UP[10*q + 7] + k_dof_8*_data_phi_0_0_WHITE_UP[10*q + 8] + k_dof_9*_data_phi_0_0_WHITE_UP[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_UP[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const real_t p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const real_t p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const real_t p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const real_t p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const real_t p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const real_t p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const real_t p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const real_t p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const real_t p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const real_t jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const real_t jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const real_t jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const real_t jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const real_t jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const real_t jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const real_t jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const real_t jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const real_t jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const real_t abs_det_jac_affine_WHITE_DOWN = abs(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const real_t _data_phi_0_0_WHITE_DOWN [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_WHITE_DOWN [] = {((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012151214443257608)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019083835042434261)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.072053489056043002)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017525267423213611)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.027523941260433657)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.049958575567593019)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.078461393265588306)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.29624114484395714)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.072053489056042974)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.11316209633188964)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.031810029988819218)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.18862506775555832)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012151214443257601)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.045878482755592566)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.07205348905604296)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013231853551815916)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012151214443257603)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017130957178208683)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011159409734644826)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.068524255492113287)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.044637916950180538)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.000283911881665389)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.50966681808331993)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.33200601647520916)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.083000987173061064)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015706073884687172)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021562946853404222)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.071405876738584673)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.080243884747120436)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.26572828761452333)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.095997217930328324)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.016039226535213912)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019188018251946451)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021562946853404225)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025796145274243024)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.044397913749511943)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053114031247306501)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.19765740883375349)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013407157762204741)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018024424659562992)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.059688031245203853)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021562946853404232)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018984670973016902)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.094319450236798913)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.030642694050274453)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.084650020197820364)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058435584226493004)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.29031907828914638)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.26055618198886238)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017384857321768536)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.021153258143552994)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.10509340307518385)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034142957672569287)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.022395383667253931)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015588264867481133)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.42876947450525699)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.009732450635762396)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.29844418988237825)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.071749615697017544)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015588264867481126)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.1149198753205366)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013982439217157605)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058160280082415236)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.040482354049473784)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015588264867481138)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018978279386089755)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.056811998632973766)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01396686284573566)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015485631440181358)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01139648574059631)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.069625445155635055)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.20842567519062763)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.051240105769272605)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.056811998632973738)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013966862845735664)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.041810186095187066)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.023258663351751644)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.017116965895609845)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018978279386089748)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01396686284573564)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.094607584046545581)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.28321039153111127)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.077196575526473174)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018978279386089758)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.056811998632973676)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053354679030800815)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.22863973450271471)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.036757553494219546)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.040075149727639509)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.013574438423676774)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.014799615333023134)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058170268354931248)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.009351816102656051)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.010195875266786407)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012450687019346486)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053354679030800829)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.077445898974953548)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.084435869696849797)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.3318773554937019)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053354679030800836)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.2830869924348563)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020160825588817252)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025383152182066201)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.23919668259056145)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.14278898169094956)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.17977609281010931)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.030040718507945225)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.002139433116273644)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025383152182066195)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.019077538505445499)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.023860144794362503)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020160825588817249)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012035048833865587)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.01515252809081665)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.039969943152159265)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.033772932211040815)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020160825588817245)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.025383152182066191)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.090150328303510344)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.029517331411893867)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.037280633286332542)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.038041411821271319)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012455650259246798)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015731589118882314)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.27533253531028662)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.048046617223388682)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.090150328303510385)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.11386060898348732)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.21799741519439725)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.030119685775736597)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.07137746553252089)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.090150328303510371)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.067458477890573201)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.035870894765649017)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.27308043404340754)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.011024731463671476)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.083929839859876898)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.044629504659074608)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.30460043053460045)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.005862376301973493)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.020733009548559916)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.018587561536304909)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.055932196812816262)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.053705963564394235)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.036199865373541695)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.022496381554864123)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034759025419540221)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.32887513974352289)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.02111678772433076)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.20437923045390871)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.31578513412249021)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_WHITE_DOWN*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_WHITE_DOWN[10*q] + k_dof_1*_data_phi_0_0_WHITE_DOWN[10*q + 1] + k_dof_2*_data_phi_0_0_WHITE_DOWN[10*q + 2] + k_dof_3*_data_phi_0_0_WHITE_DOWN[10*q + 3] + k_dof_4*_data_phi_0_0_WHITE_DOWN[10*q + 4] + k_dof_5*_data_phi_0_0_WHITE_DOWN[10*q + 5] + k_dof_6*_data_phi_0_0_WHITE_DOWN[10*q + 6] + k_dof_7*_data_phi_0_0_WHITE_DOWN[10*q + 7] + k_dof_8*_data_phi_0_0_WHITE_DOWN[10*q + 8] + k_dof_9*_data_phi_0_0_WHITE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_WHITE_DOWN[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const real_t p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const real_t p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const real_t p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const real_t p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const real_t p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const real_t p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const real_t jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const real_t jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const real_t jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const real_t jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const real_t jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const real_t jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const real_t jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const real_t jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const real_t jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const real_t abs_det_jac_affine_BLUE_UP = abs(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const real_t _data_phi_0_0_BLUE_UP [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_UP [] = {((real_t)(abs_det_jac_affine_BLUE_UP*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012151214443257608)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019083835042434261)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.072053489056043002)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017525267423213611)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.027523941260433657)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.049958575567593019)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.078461393265588306)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.29624114484395714)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.072053489056042974)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.11316209633188964)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.031810029988819218)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.18862506775555832)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012151214443257601)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.045878482755592566)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.07205348905604296)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013231853551815916)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012151214443257603)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_BLUE_UP*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_BLUE_UP*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017130957178208683)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011159409734644826)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_BLUE_UP*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.068524255492113287)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.044637916950180538)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.000283911881665389)), ((real_t)(abs_det_jac_affine_BLUE_UP*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.50966681808331993)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.33200601647520916)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.083000987173061064)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015706073884687172)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021562946853404222)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.071405876738584673)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.080243884747120436)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.26572828761452333)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.095997217930328324)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.016039226535213912)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019188018251946451)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021562946853404225)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025796145274243024)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.044397913749511943)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053114031247306501)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.19765740883375349)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013407157762204741)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018024424659562992)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.059688031245203853)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021562946853404232)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018984670973016902)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.094319450236798913)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.030642694050274453)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.084650020197820364)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058435584226493004)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.29031907828914638)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.26055618198886238)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017384857321768536)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.021153258143552994)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.10509340307518385)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034142957672569287)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.022395383667253931)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015588264867481133)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.42876947450525699)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.009732450635762396)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.29844418988237825)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.071749615697017544)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015588264867481126)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.1149198753205366)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013982439217157605)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058160280082415236)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.040482354049473784)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015588264867481138)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018978279386089755)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.056811998632973766)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01396686284573566)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015485631440181358)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01139648574059631)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.069625445155635055)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.20842567519062763)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.051240105769272605)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.056811998632973738)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013966862845735664)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.041810186095187066)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.023258663351751644)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.017116965895609845)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018978279386089748)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01396686284573564)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.094607584046545581)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.28321039153111127)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.077196575526473174)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018978279386089758)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.056811998632973676)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053354679030800815)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.22863973450271471)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.036757553494219546)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.040075149727639509)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.013574438423676774)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.014799615333023134)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058170268354931248)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.009351816102656051)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.010195875266786407)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012450687019346486)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053354679030800829)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.077445898974953548)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.084435869696849797)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.3318773554937019)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053354679030800836)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.2830869924348563)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020160825588817252)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025383152182066201)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.23919668259056145)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.14278898169094956)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.17977609281010931)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.030040718507945225)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.002139433116273644)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025383152182066195)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.019077538505445499)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.023860144794362503)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020160825588817249)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012035048833865587)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.01515252809081665)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.039969943152159265)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.033772932211040815)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020160825588817245)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.025383152182066191)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.090150328303510344)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.029517331411893867)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.037280633286332542)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.038041411821271319)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012455650259246798)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015731589118882314)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.27533253531028662)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.048046617223388682)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.090150328303510385)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.11386060898348732)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.21799741519439725)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.030119685775736597)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.07137746553252089)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.090150328303510371)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.067458477890573201)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.035870894765649017)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.27308043404340754)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.011024731463671476)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.083929839859876898)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.044629504659074608)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.30460043053460045)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.005862376301973493)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.020733009548559916)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.018587561536304909)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.055932196812816262)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.053705963564394235)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.036199865373541695)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.022496381554864123)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034759025419540221)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.32887513974352289)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.02111678772433076)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.20437923045390871)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.31578513412249021)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_BLUE_UP*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_BLUE_UP*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_BLUE_UP*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_BLUE_UP*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_BLUE_UP[10*q] + k_dof_1*_data_phi_0_0_BLUE_UP[10*q + 1] + k_dof_2*_data_phi_0_0_BLUE_UP[10*q + 2] + k_dof_3*_data_phi_0_0_BLUE_UP[10*q + 3] + k_dof_4*_data_phi_0_0_BLUE_UP[10*q + 4] + k_dof_5*_data_phi_0_0_BLUE_UP[10*q + 5] + k_dof_6*_data_phi_0_0_BLUE_UP[10*q + 6] + k_dof_7*_data_phi_0_0_BLUE_UP[10*q + 7] + k_dof_8*_data_phi_0_0_BLUE_UP[10*q + 8] + k_dof_9*_data_phi_0_0_BLUE_UP[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_UP[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const real_t tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const real_t tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const real_t p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const real_t p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const real_t p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const real_t p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const real_t p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const real_t p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const real_t p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const real_t p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const real_t p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const real_t jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const real_t jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const real_t jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const real_t jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const real_t jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const real_t jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const real_t jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const real_t jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const real_t jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const real_t abs_det_jac_affine_BLUE_DOWN = abs(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const real_t _data_phi_0_0_BLUE_DOWN [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_BLUE_DOWN [] = {((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012151214443257608)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019083835042434261)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.072053489056043002)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017525267423213611)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.027523941260433657)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.049958575567593019)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.078461393265588306)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.29624114484395714)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.072053489056042974)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.11316209633188964)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.031810029988819218)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.18862506775555832)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012151214443257601)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.045878482755592566)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.07205348905604296)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013231853551815916)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012151214443257603)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017130957178208683)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011159409734644826)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.068524255492113287)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.044637916950180538)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.000283911881665389)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.50966681808331993)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.33200601647520916)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.083000987173061064)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015706073884687172)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021562946853404222)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.071405876738584673)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.080243884747120436)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.26572828761452333)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.095997217930328324)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.016039226535213912)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019188018251946451)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021562946853404225)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025796145274243024)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.044397913749511943)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053114031247306501)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.19765740883375349)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013407157762204741)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018024424659562992)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.059688031245203853)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021562946853404232)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018984670973016902)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.094319450236798913)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.030642694050274453)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.084650020197820364)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058435584226493004)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.29031907828914638)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.26055618198886238)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017384857321768536)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.021153258143552994)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.10509340307518385)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034142957672569287)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.022395383667253931)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015588264867481133)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.42876947450525699)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.009732450635762396)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.29844418988237825)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.071749615697017544)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015588264867481126)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.1149198753205366)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013982439217157605)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058160280082415236)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.040482354049473784)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015588264867481138)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018978279386089755)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.056811998632973766)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01396686284573566)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015485631440181358)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01139648574059631)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.069625445155635055)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.20842567519062763)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.051240105769272605)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.056811998632973738)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013966862845735664)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.041810186095187066)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.023258663351751644)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.017116965895609845)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018978279386089748)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01396686284573564)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.094607584046545581)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.28321039153111127)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.077196575526473174)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018978279386089758)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.056811998632973676)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053354679030800815)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.22863973450271471)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.036757553494219546)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.040075149727639509)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.013574438423676774)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.014799615333023134)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058170268354931248)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.009351816102656051)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.010195875266786407)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012450687019346486)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053354679030800829)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.077445898974953548)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.084435869696849797)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.3318773554937019)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053354679030800836)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.2830869924348563)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020160825588817252)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025383152182066201)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.23919668259056145)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.14278898169094956)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.17977609281010931)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.030040718507945225)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.002139433116273644)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025383152182066195)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.019077538505445499)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.023860144794362503)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020160825588817249)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012035048833865587)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.01515252809081665)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.039969943152159265)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.033772932211040815)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020160825588817245)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.025383152182066191)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.090150328303510344)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.029517331411893867)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.037280633286332542)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.038041411821271319)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012455650259246798)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015731589118882314)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.27533253531028662)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.048046617223388682)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.090150328303510385)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.11386060898348732)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.21799741519439725)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.030119685775736597)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.07137746553252089)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.090150328303510371)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.067458477890573201)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.035870894765649017)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.27308043404340754)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.011024731463671476)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.083929839859876898)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.044629504659074608)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.30460043053460045)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.005862376301973493)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.020733009548559916)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.018587561536304909)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.055932196812816262)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.053705963564394235)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.036199865373541695)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.022496381554864123)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034759025419540221)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.32887513974352289)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.02111678772433076)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.20437923045390871)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.31578513412249021)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_BLUE_DOWN*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_BLUE_DOWN[10*q] + k_dof_1*_data_phi_0_0_BLUE_DOWN[10*q + 1] + k_dof_2*_data_phi_0_0_BLUE_DOWN[10*q + 2] + k_dof_3*_data_phi_0_0_BLUE_DOWN[10*q + 3] + k_dof_4*_data_phi_0_0_BLUE_DOWN[10*q + 4] + k_dof_5*_data_phi_0_0_BLUE_DOWN[10*q + 5] + k_dof_6*_data_phi_0_0_BLUE_DOWN[10*q + 6] + k_dof_7*_data_phi_0_0_BLUE_DOWN[10*q + 7] + k_dof_8*_data_phi_0_0_BLUE_DOWN[10*q + 8] + k_dof_9*_data_phi_0_0_BLUE_DOWN[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_BLUE_DOWN[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const real_t p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const real_t p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const real_t p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const real_t p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const real_t p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const real_t p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const real_t jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const real_t jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const real_t jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const real_t jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const real_t jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const real_t jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const real_t jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const real_t jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const real_t jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const real_t abs_det_jac_affine_GREEN_UP = abs(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const real_t _data_phi_0_0_GREEN_UP [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_UP [] = {((real_t)(abs_det_jac_affine_GREEN_UP*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012151214443257608)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019083835042434261)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.072053489056043002)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017525267423213611)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.027523941260433657)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.049958575567593019)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.078461393265588306)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.29624114484395714)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.072053489056042974)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.11316209633188964)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.031810029988819218)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.18862506775555832)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012151214443257601)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.045878482755592566)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.07205348905604296)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013231853551815916)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012151214443257603)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019083835042434251)), ((real_t)(abs_det_jac_affine_GREEN_UP*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_GREEN_UP*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017130957178208683)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011159409734644826)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_GREEN_UP*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.068524255492113287)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.044637916950180538)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.000283911881665389)), ((real_t)(abs_det_jac_affine_GREEN_UP*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.50966681808331993)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.33200601647520916)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.083000987173061064)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015706073884687172)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021562946853404222)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.071405876738584673)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.080243884747120436)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.26572828761452333)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.095997217930328324)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.016039226535213912)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019188018251946451)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021562946853404225)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025796145274243024)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.044397913749511943)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053114031247306501)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.059688031245203839)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.19765740883375349)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0714058767385847)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013407157762204741)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018024424659562992)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.059688031245203853)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021562946853404232)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018984670973016902)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.094319450236798913)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.030642694050274453)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.084650020197820364)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058435584226493004)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.29031907828914638)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.26055618198886238)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017384857321768536)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.021153258143552994)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.10509340307518385)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034142957672569287)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.022395383667253931)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015588264867481133)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.42876947450525699)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.009732450635762396)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.29844418988237825)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.071749615697017544)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015588264867481126)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.1149198753205366)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013982439217157605)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058160280082415236)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.040482354049473784)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015588264867481138)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018978279386089755)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.056811998632973766)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01396686284573566)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015485631440181358)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01139648574059631)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.069625445155635055)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.20842567519062763)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.051240105769272605)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.056811998632973738)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013966862845735664)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.041810186095187066)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.023258663351751644)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.017116965895609845)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018978279386089748)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01396686284573564)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.094607584046545581)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.28321039153111127)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.077196575526473174)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018978279386089758)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.056811998632973676)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053354679030800815)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.22863973450271471)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.036757553494219546)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.040075149727639509)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.013574438423676774)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.014799615333023134)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058170268354931248)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.009351816102656051)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.010195875266786407)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012450687019346486)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053354679030800829)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.077445898974953548)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.084435869696849797)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.3318773554937019)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053354679030800836)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.058170268354931241)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.2830869924348563)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020160825588817252)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025383152182066201)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.23919668259056145)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.14278898169094956)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.17977609281010931)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.030040718507945225)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.002139433116273644)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025383152182066195)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015152528090816651)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.019077538505445499)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.023860144794362503)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020160825588817249)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012035048833865587)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.01515252809081665)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.039969943152159265)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.033772932211040815)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020160825588817245)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.025383152182066191)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.090150328303510344)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.029517331411893867)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.037280633286332542)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.038041411821271319)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012455650259246798)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015731589118882314)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.27533253531028662)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.048046617223388682)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.090150328303510385)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.11386060898348732)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.015731589118882311)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.21799741519439725)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.030119685775736597)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.07137746553252089)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.090150328303510371)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.012455650259246793)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.067458477890573201)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.035870894765649017)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.27308043404340754)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.011024731463671476)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.083929839859876898)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.044629504659074608)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.30460043053460045)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.005862376301973493)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.020733009548559916)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.018587561536304909)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.055932196812816262)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.053705963564394235)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.036199865373541695)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.022496381554864123)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034759025419540221)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.32887513974352289)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.02111678772433076)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.20437923045390871)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.31578513412249021)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.034759025419540214)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_GREEN_UP*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_GREEN_UP*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_GREEN_UP*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_GREEN_UP*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_GREEN_UP[10*q] + k_dof_1*_data_phi_0_0_GREEN_UP[10*q + 1] + k_dof_2*_data_phi_0_0_GREEN_UP[10*q + 2] + k_dof_3*_data_phi_0_0_GREEN_UP[10*q + 3] + k_dof_4*_data_phi_0_0_GREEN_UP[10*q + 4] + k_dof_5*_data_phi_0_0_GREEN_UP[10*q + 5] + k_dof_6*_data_phi_0_0_GREEN_UP[10*q + 6] + k_dof_7*_data_phi_0_0_GREEN_UP[10*q + 7] + k_dof_8*_data_phi_0_0_GREEN_UP[10*q + 8] + k_dof_9*_data_phi_0_0_GREEN_UP[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_UP[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_0 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_3 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
          }
       }
       const real_t tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const real_t tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const real_t tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const real_t tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const real_t tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const real_t tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const real_t tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const real_t tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const real_t tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const real_t tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const real_t p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const real_t p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const real_t p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const real_t p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const real_t p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const real_t p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const real_t p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const real_t p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const real_t p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const real_t jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const real_t jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const real_t jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const real_t jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const real_t jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const real_t jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const real_t jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const real_t jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const real_t jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const real_t abs_det_jac_affine_GREEN_DOWN = abs(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const real_t _data_phi_0_0_GREEN_DOWN [] = {-0.090535362930810992, -0.011579335952356828, -0.11760379463625681, -0.068767228413546891, 0.10234491325961378, 0.16073565742743148, 0.60687827722315146, 0.039095058653867309, 0.14760845367810674, 0.23182336169080051, -0.0053570531758102002, -0.026981886857756689, -0.08826927993497348, 0.59856367989927617, 0.38991501098196513, 0.097478145633287397, 0.013105850958460542, 0.018445551186837106, 0.0024799881361180498, 0.0006199931725955482, -0.047387428697692885, -0.091259737764059851, -0.1113914185759802, -0.080241973959818302, 0.13353232929213443, 0.048239998198448431, 0.15974715277305154, 0.1795192875052915, 0.59447960443206538, 0.21476218679656028, -0.012365312874640544, -0.11783608671457169, 0.099840210581437105, -0.12209237840485256, 0.49602512400408078, 0.161149647055262, 0.44517368008565716, 0.010752243911943793, 0.029702925690040238, 0.0096499466656436994, -0.039132866314689811, 0.52330757747208378, -0.025291504202103146, -0.086435669103359453, 0.011878329657082472, 0.36424725943509562, 0.087569474525404659, 0.019025274908404714, 0.0045739076500237383, 0.14025821597205745, -0.075020078347640823, -0.10978594944123118, -0.087269478727699787, -0.038293245964176326, 0.20646997194002201, 0.61807351051034776, 0.15194937966625316, 0.16847248498571801, 0.041417872063914368, 0.12398553331449269, -0.10872199595435525, -0.071573088371655491, -0.066785736996983452, -0.0060897460877574749, 0.15682570344877764, 0.17098019180848095, 0.027487844842548723, 0.67204203738214874, 0.10804168047678223, 0.11779310945201321, 0.37695779888932324, -0.066990727368889835, -0.055283676461052214, -0.083546970475516125, 0.026846095514264753, 0.033800130105328889, 0.020177061431168701, 0.31851359257248568, 0.19013738420444903, 0.23938931158843763, -0.10297005415588911, -0.053714325748548342, -0.050503954623664971, -0.1046997294598791, 0.62152169062946561, 0.085872752242822009, 0.1084579951005582, 0.20350077550717194, 0.25702315969221257, 0.03551169081575134, -0.083475373185951274, -0.053119697675226007, -0.051073377242295631, -0.085005424835789295, 0.025080212002029836, 0.19093237635024654, 0.10152786415556034, 0.17117472918588617, 0.091021779458552471, 0.69293691178698702, -0.097002376729223169, -0.070699586880466903, 0.42474742969688395, -0.0086506859049516431, 0.027272664380649191, 0.0030019501617763451, 0.26395899941365064, 0.0046382953510501583, 0.40784148099371537, 0.044891829516916615};
      
          const real_t _data_tabulated_and_untitled_0_0_GREEN_DOWN [] = {((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010749089276961213)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0013747922567553051)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.01396287204173041)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.008164600589399525)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012151214443257608)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019083835042434261)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.072053489056043002)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0046416810200408439)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017525267423213611)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.027523941260433657)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.044193869792483409)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0056523290877285)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0574070354280087)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.033567987580949914)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.049958575567593019)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.078461393265588306)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.29624114484395714)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.072053489056042974)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.11316209633188964)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.02813947970791995)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035989968838093011)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036552673846023863)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.021373681684931475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.031810029988819218)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.18862506775555832)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012151214443257601)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.045878482755592566)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.07205348905604296)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0074529241534464254)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00095321772406372263)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0096812133204938391)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0056609585582659784)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0084250932599439499)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013231853551815916)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0032183281481346165)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012151214443257603)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019083835042434251)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-2.9012262911449775e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00014612615736184792)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00047804109319682082)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0032416491456343029)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021116678219306132)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00052791366753715454)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*7.0977528354966774e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*9.9895812682163066e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*1.3430904167093961e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*3.3577051293550935e-6)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00015331944058422371)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00077222451657154147)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0025262763269762738)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017130957178208683)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011159409734644826)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0027898350580443485)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00037509087018302439)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00052791366753715541)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*7.0977528354966354e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*1.7744271574084403e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00061328158194601311)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0030889173045236238)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010105168244399365)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.068524255492113287)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.044637916950180538)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0015003728252777238)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021116678219306167)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.000283911881665389)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*7.0977528354965283e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0045614398903685138)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022974618879299673)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.075159794270401023)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.50966681808331993)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.33200601647520916)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.083000987173061064)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015706073884687172)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021116678219306002)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00052791366753714337)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.02118185416019976)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.040792474062018545)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.049791196691139579)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.035867609546541376)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021562946853404222)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.071405876738584673)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.080243884747120436)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.26572828761452333)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.095997217930328324)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.005691937733975882)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010961657115556597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.013379772569609637)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.009638259175114022)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.016039226535213912)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0057943440608341223)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019188018251946451)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021562946853404225)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025796145274243024)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.015755757300754607)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.03034277906728966)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.037036323866953338)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.026679503441931235)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.044397913749511943)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053114031247306501)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.059688031245203839)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.19765740883375349)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0714058767385847)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0047578795027626341)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0091628275191950465)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.011184125448277639)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0080566017962316674)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013407157762204741)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0048434807489961713)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018024424659562992)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.059688031245203853)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021562946853404232)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00015688175714697789)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0014950153325289843)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012666972383742025)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0015490159490981592)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062931924029516256)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0020445450956193246)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0056480276621754888)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00013641635559728395)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00037684830314454006)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0001224312400849633)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.002351271046368435)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022406596720860313)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018984670973016902)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.023215932927530856)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.094319450236798913)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.030642694050274453)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.084650020197820364)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0020445450956193168)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0056480276621755114)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0018349426677638542)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0072373072709378001)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.068968409922504109)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058435584226493004)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.071459579463428277)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.29031907828914638)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.26055618198886238)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062931924029516022)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017384857321768536)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0056480276621755391)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0026198528001873307)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.024966064738678271)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.021153258143552994)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.025867850064795264)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.10509340307518385)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034142957672569287)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0022780900577755898)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0062931924029516507)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0020445450956193428)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0016747236096797923)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.022395383667253931)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0010823709889014185)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0036990864559166563)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00050834301173610229)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015588264867481133)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0037476086033569342)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00081420248681843786)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00019574418772167287)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0060024671806827717)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.032063320402672957)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.42876947450525699)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020722468836717273)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.070820637834037012)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.009732450635762396)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.29844418988237825)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.071749615697017544)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015588264867481126)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0037476086033569277)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.1149198753205366)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0010456048186450997)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013982439217157605)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00067577259615595462)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0023095050434207478)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00031738126788423253)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023397995892677865)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00050834301173610208)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00012221184720903605)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0037476086033569355)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0043492174836919605)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058160280082415236)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0028108917803285017)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0096064397699850354)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0013201547416997409)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.040482354049473784)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021144645423690485)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00050834301173610142)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015588264867481138)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0068956855714663416)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.010091290281029655)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0080216243244021178)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0035198334831929206)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018978279386089755)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.056811998632973766)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01396686284573566)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015485631440181358)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0038070424489360009)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01139648574059631)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.025298140458325055)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.037021827096001436)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.029428861968758362)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012913181862031289)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.069625445155635055)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.20842567519062763)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.051240105769272605)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.056811998632973738)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013966862845735664)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.041810186095187066)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0084509467915105906)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012367292031926986)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0098308311254096271)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0043137009617327136)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.023258663351751644)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.017116965895609845)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018978279386089748)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0046656873831529451)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01396686284573564)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.034375305526338835)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.050305540032273111)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.039988161309129681)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017546529657219402)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.094607584046545581)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.28321039153111127)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.077196575526473174)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018978279386089758)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.056811998632973676)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036989007988906066)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.024350339729610097)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022721604194642659)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0020718315986862396)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053354679030800815)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.22863973450271471)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.036757553494219546)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.040075149727639509)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0094107024991835538)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0061951865002202629)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.005780805406949952)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00052711310369534133)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.013574438423676774)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.014799615333023134)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023792787088414437)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058170268354931248)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.009351816102656051)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.010195875266786407)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0086316433720857837)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0056823218562164577)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0053022450428696702)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00048347637471763576)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012450687019346486)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021823116073744556)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053354679030800829)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0085776318491057792)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0093518161026560475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.053690642094179834)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.035345240285608669)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.032981082352521167)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0030073250106582576)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.077445898974953548)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.084435869696849797)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.3318773554937019)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053354679030800836)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.058170268354931241)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.2830869924348563)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.050308558644386672)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.041516821634179475)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.06274193203760102)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020160825588817252)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025383152182066201)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.23919668259056145)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.14278898169094956)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.17977609281010931)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.030040718507945225)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0053386601615906274)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0044056957238823311)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0066580689659201985)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.002139433116273644)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0026936176861649991)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0016079609562587173)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025383152182066195)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015152528090816651)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.019077538505445499)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.023860144794362503)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0042402848796628178)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0034992684300787832)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0052882386796338152)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0016992664113091131)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0012771392678196903)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020160825588817249)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012035048833865587)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.01515252809081665)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.039969943152159265)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0071032236832497221)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0058618906729116316)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0088587307923610938)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0028465703978647464)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0035839271208240476)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.033772932211040815)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020160825588817245)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.025383152182066191)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.014935575584147695)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.007791142568055953)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0073254854313094774)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.015186461110532538)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.090150328303510344)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.029517331411893867)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.037280633286332542)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0051508911658584714)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0063024771210085937)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0032876870064389215)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0030911901634452068)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0064083451728372039)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.038041411821271319)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0052560043865672946)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0066383769370158769)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012455650259246798)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015731589118882314)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0021735602717637636)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.045615473279886819)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.023795310306631609)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022373124026687209)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.046381715060167777)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.27533253531028662)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.048046617223388682)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.090150328303510385)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.11386060898348732)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.015731589118882311)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036116528170846006)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.018840185867421855)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.017714155002223078)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036723208116341576)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.21799741519439725)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.030119685775736597)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.07137746553252089)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.090150328303510371)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.012455650259246793)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.032896921427909828)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020934012679446525)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.020127575524041673)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.033499901528319088)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0098838942808698073)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.067458477890573201)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.035870894765649017)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.27308043404340754)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.036694010925042916)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.023350297128803515)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.022450777887903339)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.037366589313281677)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.011024731463671476)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.083929839859876898)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.044629504659074608)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.30460043053460045)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0048199974818136015)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0030672137093527801)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0029490559946009505)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0049083450365209726)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0014481703295155801)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.005862376301973493)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0052557386811928905)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.040011251730840761)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.009064443351184925)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.005768174157623188)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0055459678357496689)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.009230588957667556)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0027234159279729726)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.020733009548559916)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.018587561536304909)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0098838942808698056)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.075244795478138254)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.012773605317404142)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0093099638314587951)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.055932196812816262)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0011391519589580709)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0035913578872906952)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00039530708258920854)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00061078662356131824)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.053705963564394235)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0059115099192464755)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0082672024196058687)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.0060254997396084128)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.036199865373541695)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00073727030054430856)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0023243619853375876)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00025584661404999347)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.022496381554864123)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00039530708258920833)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034759025419540221)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0038259870955407193)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.075107388466231287)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.054741559075980606)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.32887513974352289)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.006698087703317224)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.02111678772433076)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.20437923045390871)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0035913578872906935)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.31578513412249021)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.034759025419540214)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00085418052598187596)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-0.00062256423341908954)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0037402277670030831)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*-7.6175942132039452e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00024015678369014598)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*2.6434479799555231e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*4.0843757608938361e-5)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.0035913578872906957)), ((real_t)(abs_det_jac_affine_GREEN_DOWN*0.00039530708258920849))};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
         
             const int64_t phantom_ctr_0 = ctr_0;
             real_t _data_float_loop_ctr_array_dim_0[4];
             _data_float_loop_ctr_array_dim_0[0] = (real_t) ctr_0+ 0;
             _data_float_loop_ctr_array_dim_0[1] = (real_t) ctr_0+ 1;
             _data_float_loop_ctr_array_dim_0[2] = (real_t) ctr_0+ 2;
             _data_float_loop_ctr_array_dim_0[3] = (real_t) ctr_0+ 3;
             real_t _data_float_loop_ctr_array_dim_1[4];
             _data_float_loop_ctr_array_dim_1[0] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[1] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[2] = (real_t) ctr_1;
             _data_float_loop_ctr_array_dim_1[3] = (real_t) ctr_1;
             real_t _data_float_loop_ctr_array_dim_2[4];
             _data_float_loop_ctr_array_dim_2[0] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[1] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[2] = (real_t) ctr_2;
             _data_float_loop_ctr_array_dim_2[3] = (real_t) ctr_2;
         
             const real_t p_affine_0_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_0_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_1_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*1.0*_data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0];
             const real_t p_affine_2_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_2_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*(1.0 + _data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*1.0*_data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_0 = macro_vertex_coord_id_0comp0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_1 = macro_vertex_coord_id_0comp1 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t p_affine_3_2 = macro_vertex_coord_id_0comp2 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2)*1.0*_data_float_loop_ctr_array_dim_0[ctr_0 - phantom_ctr_0] + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2)*(1.0 + _data_float_loop_ctr_array_dim_1[ctr_0 - phantom_ctr_0])*1.0 + 1.0 / (micro_edges_per_macro_edge_float)*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2)*(1.0 + _data_float_loop_ctr_array_dim_2[ctr_0 - phantom_ctr_0])*1.0;
             const real_t src_dof_0 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_1 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_2 = _data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t src_dof_3 = _data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t src_dof_4 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_5 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_6 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t src_dof_7 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t src_dof_8 = _data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t src_dof_9 = _data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const real_t k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const real_t k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_5 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const real_t k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const real_t k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const real_t k_dof_9 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             real_t q_acc_0_0 = 0.0;
             real_t q_acc_0_1 = 0.0;
             real_t q_acc_0_2 = 0.0;
             real_t q_acc_0_3 = 0.0;
             real_t q_acc_0_4 = 0.0;
             real_t q_acc_0_5 = 0.0;
             real_t q_acc_0_6 = 0.0;
             real_t q_acc_0_7 = 0.0;
             real_t q_acc_0_8 = 0.0;
             real_t q_acc_0_9 = 0.0;
             real_t q_acc_1_0 = 0.0;
             real_t q_acc_1_1 = 0.0;
             real_t q_acc_1_2 = 0.0;
             real_t q_acc_1_3 = 0.0;
             real_t q_acc_1_4 = 0.0;
             real_t q_acc_1_5 = 0.0;
             real_t q_acc_1_6 = 0.0;
             real_t q_acc_1_7 = 0.0;
             real_t q_acc_1_8 = 0.0;
             real_t q_acc_1_9 = 0.0;
             real_t q_acc_2_0 = 0.0;
             real_t q_acc_2_1 = 0.0;
             real_t q_acc_2_2 = 0.0;
             real_t q_acc_2_3 = 0.0;
             real_t q_acc_2_4 = 0.0;
             real_t q_acc_2_5 = 0.0;
             real_t q_acc_2_6 = 0.0;
             real_t q_acc_2_7 = 0.0;
             real_t q_acc_2_8 = 0.0;
             real_t q_acc_2_9 = 0.0;
             real_t q_acc_3_0 = 0.0;
             real_t q_acc_3_1 = 0.0;
             real_t q_acc_3_2 = 0.0;
             real_t q_acc_3_3 = 0.0;
             real_t q_acc_3_4 = 0.0;
             real_t q_acc_3_5 = 0.0;
             real_t q_acc_3_6 = 0.0;
             real_t q_acc_3_7 = 0.0;
             real_t q_acc_3_8 = 0.0;
             real_t q_acc_3_9 = 0.0;
             for (int64_t q = 0; q < 11; q += 1)
             {
                const real_t tmp_qloop_18 = p_affine_0_0 + (-p_affine_0_0 + p_affine_1_0)*_data_q_p_0[q] + (-p_affine_0_0 + p_affine_2_0)*_data_q_p_1[q] + (-p_affine_0_0 + p_affine_3_0)*_data_q_p_2[q];
                const real_t tmp_qloop_19 = (tmp_qloop_18*tmp_qloop_18);
                const real_t tmp_qloop_22 = p_affine_0_2 + (-p_affine_0_2 + p_affine_1_2)*_data_q_p_0[q] + (-p_affine_0_2 + p_affine_2_2)*_data_q_p_1[q] + (-p_affine_0_2 + p_affine_3_2)*_data_q_p_2[q];
                const real_t tmp_qloop_23 = -tmp_qloop_12 - tmp_qloop_22;
                const real_t tmp_qloop_24 = -tmp_qloop_1 - tmp_qloop_18;
                const real_t tmp_qloop_25 = p_affine_0_1 + (-p_affine_0_1 + p_affine_1_1)*_data_q_p_0[q] + (-p_affine_0_1 + p_affine_2_1)*_data_q_p_1[q] + (-p_affine_0_1 + p_affine_3_1)*_data_q_p_2[q];
                const real_t tmp_qloop_26 = -tmp_qloop_25 - tmp_qloop_8;
                const real_t tmp_qloop_27 = tmp_qloop_21*(tmp_qloop_10*tmp_qloop_23*tmp_qloop_9 + tmp_qloop_13*tmp_qloop_24*tmp_qloop_6 - tmp_qloop_14*tmp_qloop_24 - tmp_qloop_15*tmp_qloop_26 + tmp_qloop_2*tmp_qloop_26*tmp_qloop_3 - tmp_qloop_23*tmp_qloop_7);
                const real_t tmp_qloop_28 = tmp_qloop_20 - tmp_qloop_27;
                const real_t tmp_qloop_29 = (tmp_qloop_25*tmp_qloop_25);
                const real_t tmp_qloop_30 = (tmp_qloop_22*tmp_qloop_22);
                const real_t tmp_qloop_31 = tmp_qloop_19 + tmp_qloop_29 + tmp_qloop_30;
                const real_t tmp_qloop_34 = tmp_qloop_18*tmp_qloop_33;
                const real_t tmp_qloop_35 = tmp_qloop_28 + tmp_qloop_34;
                const real_t tmp_qloop_36 = tmp_qloop_17*(-tmp_qloop_19*tmp_qloop_28 + tmp_qloop_31*tmp_qloop_35);
                const real_t tmp_qloop_37 = pow(tmp_qloop_31, -1.5000000000000000);
                const real_t tmp_qloop_38 = tmp_qloop_37*1.0;
                const real_t tmp_qloop_41 = tmp_qloop_31*tmp_qloop_40;
                const real_t tmp_qloop_42 = -tmp_qloop_25*tmp_qloop_28 - tmp_qloop_41;
                const real_t tmp_qloop_43 = tmp_qloop_17*tmp_qloop_38;
                const real_t tmp_qloop_44 = tmp_qloop_42*tmp_qloop_43;
                const real_t tmp_qloop_47 = -tmp_qloop_28;
                const real_t tmp_qloop_48 = tmp_qloop_22*tmp_qloop_47;
                const real_t tmp_qloop_49 = tmp_qloop_31*tmp_qloop_46 + tmp_qloop_48;
                const real_t tmp_qloop_50 = tmp_qloop_43*tmp_qloop_49;
                const real_t tmp_qloop_51 = tmp_qloop_18*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_33;
                const real_t tmp_qloop_52 = tmp_qloop_43*tmp_qloop_51;
                const real_t tmp_qloop_54 = tmp_qloop_25*tmp_qloop_53 + tmp_qloop_28;
                const real_t tmp_qloop_55 = tmp_qloop_29*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_54;
                const real_t tmp_qloop_56 = tmp_qloop_22*tmp_qloop_46;
                const real_t tmp_qloop_57 = tmp_qloop_28 + tmp_qloop_56;
                const real_t tmp_qloop_58 = tmp_qloop_30*tmp_qloop_47 + tmp_qloop_31*tmp_qloop_57;
                const real_t tmp_qloop_66 = pow(tmp_qloop_31, -2.5000000000000000)*3.0;
                const real_t tmp_qloop_67 = tmp_qloop_36*tmp_qloop_66;
                const real_t tmp_qloop_69 = tmp_qloop_18*2.0;
                const real_t tmp_qloop_70 = -tmp_qloop_41;
                const real_t tmp_qloop_71 = tmp_qloop_35*2.0;
                const real_t tmp_qloop_73 = -tmp_qloop_31*tmp_qloop_72;
                const real_t tmp_qloop_74 = -tmp_qloop_20 + tmp_qloop_27;
                const real_t tmp_qloop_75 = tmp_qloop_18*tmp_qloop_68 + tmp_qloop_34*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_76 = tmp_qloop_17*tmp_qloop_66;
                const real_t tmp_qloop_77 = tmp_qloop_51*tmp_qloop_76;
                const real_t tmp_qloop_78 = tmp_qloop_25*tmp_qloop_77;
                const real_t tmp_qloop_79 = tmp_qloop_25*2.0;
                const real_t tmp_qloop_80 = tmp_qloop_18*tmp_qloop_40 + tmp_qloop_33*tmp_qloop_79;
                const real_t tmp_qloop_81 = tmp_qloop_25*tmp_qloop_43;
                const real_t tmp_qloop_82 = tmp_qloop_22*2.0;
                const real_t tmp_qloop_83 = tmp_qloop_18*tmp_qloop_72 + tmp_qloop_33*tmp_qloop_82;
                const real_t tmp_qloop_84 = -tmp_qloop_22*tmp_qloop_78;
                const real_t tmp_qloop_85 = tmp_qloop_18*tmp_qloop_22;
                const real_t tmp_qloop_86 = tmp_qloop_22*tmp_qloop_43;
                const real_t tmp_qloop_87 = tmp_qloop_21*tmp_qloop_25*tmp_qloop_32 - tmp_qloop_40*tmp_qloop_69;
                const real_t tmp_qloop_88 = tmp_qloop_18*tmp_qloop_43;
                const real_t tmp_qloop_89 = tmp_qloop_42*tmp_qloop_76;
                const real_t tmp_qloop_90 = -tmp_qloop_25*tmp_qloop_40 - tmp_qloop_28;
                const real_t tmp_qloop_91 = tmp_qloop_25*tmp_qloop_89;
                const real_t tmp_qloop_92 = tmp_qloop_25*tmp_qloop_72 - tmp_qloop_40*tmp_qloop_82;
                const real_t tmp_qloop_93 = tmp_qloop_85*tmp_qloop_89;
                const real_t tmp_qloop_94 = -tmp_qloop_31*tmp_qloop_68;
                const real_t tmp_qloop_95 = tmp_qloop_55*tmp_qloop_76;
                const real_t tmp_qloop_96 = tmp_qloop_22*tmp_qloop_68 + tmp_qloop_46*tmp_qloop_69;
                const real_t tmp_qloop_97 = tmp_qloop_49*tmp_qloop_76;
                const real_t tmp_qloop_98 = tmp_qloop_22*tmp_qloop_40 + tmp_qloop_46*tmp_qloop_79;
                const real_t tmp_qloop_99 = tmp_qloop_25*tmp_qloop_97;
                const real_t tmp_qloop_100 = tmp_qloop_18*tmp_qloop_99;
                const real_t tmp_qloop_101 = tmp_qloop_22*tmp_qloop_72 + tmp_qloop_56*2.0 + tmp_qloop_74;
                const real_t tmp_qloop_102 = tmp_qloop_58*tmp_qloop_76;
                const real_t jac_blending_0_0 = tmp_qloop_36*tmp_qloop_38;
                const real_t jac_blending_0_1 = tmp_qloop_18*tmp_qloop_44;
                const real_t jac_blending_0_2 = tmp_qloop_18*tmp_qloop_50;
                const real_t jac_blending_1_0 = tmp_qloop_25*tmp_qloop_52;
                const real_t jac_blending_1_1 = tmp_qloop_43*tmp_qloop_55;
                const real_t tmp_qloop_63 = jac_blending_0_2*jac_blending_1_1;
                const real_t jac_blending_1_2 = tmp_qloop_25*tmp_qloop_50;
                const real_t tmp_qloop_60 = jac_blending_0_1*jac_blending_1_2;
                const real_t jac_blending_2_0 = tmp_qloop_22*tmp_qloop_52;
                const real_t jac_blending_2_1 = tmp_qloop_22*tmp_qloop_44;
                const real_t tmp_qloop_61 = jac_blending_1_2*jac_blending_2_1;
                const real_t jac_blending_2_2 = tmp_qloop_43*tmp_qloop_58;
                const real_t tmp_qloop_59 = jac_blending_1_1*jac_blending_2_2;
                const real_t tmp_qloop_62 = jac_blending_0_1*jac_blending_2_2;
                const real_t tmp_qloop_64 = jac_blending_0_0*tmp_qloop_59 - jac_blending_0_0*tmp_qloop_61 + jac_blending_0_2*jac_blending_1_0*jac_blending_2_1 - jac_blending_1_0*tmp_qloop_62 + jac_blending_2_0*tmp_qloop_60 - jac_blending_2_0*tmp_qloop_63;
                const real_t tmp_qloop_65 = 1.0 / (tmp_qloop_64);
                const real_t abs_det_jac_blending = tmp_qloop_64;
                const real_t tmp_qloop_103 = abs_det_jac_blending*(k_dof_0*_data_phi_0_0_GREEN_DOWN[10*q] + k_dof_1*_data_phi_0_0_GREEN_DOWN[10*q + 1] + k_dof_2*_data_phi_0_0_GREEN_DOWN[10*q + 2] + k_dof_3*_data_phi_0_0_GREEN_DOWN[10*q + 3] + k_dof_4*_data_phi_0_0_GREEN_DOWN[10*q + 4] + k_dof_5*_data_phi_0_0_GREEN_DOWN[10*q + 5] + k_dof_6*_data_phi_0_0_GREEN_DOWN[10*q + 6] + k_dof_7*_data_phi_0_0_GREEN_DOWN[10*q + 7] + k_dof_8*_data_phi_0_0_GREEN_DOWN[10*q + 8] + k_dof_9*_data_phi_0_0_GREEN_DOWN[10*q + 9])*_data_q_w[q];
                const real_t tmp_qloop_104 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 14];
                const real_t jac_blending_inv_0_0 = tmp_qloop_65*(tmp_qloop_59 - tmp_qloop_61);
                const real_t jac_blending_inv_0_1 = tmp_qloop_65*(jac_blending_0_2*jac_blending_2_1 - tmp_qloop_62);
                const real_t jac_blending_inv_0_2 = tmp_qloop_65*(tmp_qloop_60 - tmp_qloop_63);
                const real_t jac_blending_inv_1_0 = tmp_qloop_65*(-jac_blending_1_0*jac_blending_2_2 + jac_blending_1_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_1 = tmp_qloop_65*(jac_blending_0_0*jac_blending_2_2 - jac_blending_0_2*jac_blending_2_0);
                const real_t jac_blending_inv_1_2 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_1_2 + jac_blending_0_2*jac_blending_1_0);
                const real_t jac_blending_inv_2_0 = tmp_qloop_65*(jac_blending_1_0*jac_blending_2_1 - jac_blending_1_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_1 = tmp_qloop_65*(-jac_blending_0_0*jac_blending_2_1 + jac_blending_0_1*jac_blending_2_0);
                const real_t jac_blending_inv_2_2 = tmp_qloop_65*(jac_blending_0_0*jac_blending_1_1 - jac_blending_0_1*jac_blending_1_0);
                const real_t hessian_blending_0_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_68 - tmp_qloop_28*tmp_qloop_69 + tmp_qloop_31*(tmp_qloop_33 - tmp_qloop_68) + tmp_qloop_35*tmp_qloop_69)*1.0 - tmp_qloop_18*tmp_qloop_67;
                const real_t hessian_blending_1_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_40 + tmp_qloop_25*tmp_qloop_71 + tmp_qloop_70)*1.0 - tmp_qloop_25*tmp_qloop_67;
                const real_t hessian_blending_2_0_0 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_19*tmp_qloop_72 + tmp_qloop_22*tmp_qloop_71 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_67;
                const real_t hessian_blending_0_0_1 = tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_18*tmp_qloop_78;
                const real_t hessian_blending_1_0_1 = -tmp_qloop_29*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_80*tmp_qloop_81;
                const real_t hessian_blending_2_0_1 = tmp_qloop_81*tmp_qloop_83 + tmp_qloop_84;
                const real_t hessian_blending_0_0_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_75*1.0 - tmp_qloop_77*tmp_qloop_85;
                const real_t hessian_blending_1_0_2 = tmp_qloop_80*tmp_qloop_86 + tmp_qloop_84;
                const real_t hessian_blending_2_0_2 = -tmp_qloop_30*tmp_qloop_77 + tmp_qloop_52 + tmp_qloop_83*tmp_qloop_86;
                const real_t hessian_blending_0_1_0 = -tmp_qloop_19*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_87*tmp_qloop_88;
                const real_t hessian_blending_1_1_0 = tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_18*tmp_qloop_91;
                const real_t hessian_blending_2_1_0 = tmp_qloop_88*tmp_qloop_92 - tmp_qloop_93;
                const real_t hessian_blending_0_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_94)*1.0 - tmp_qloop_18*tmp_qloop_95;
                const real_t hessian_blending_1_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_40 + tmp_qloop_31*(-tmp_qloop_40 + tmp_qloop_53) + tmp_qloop_47*tmp_qloop_79 + tmp_qloop_54*tmp_qloop_79)*1.0 - tmp_qloop_25*tmp_qloop_95;
                const real_t hessian_blending_2_1_1 = tmp_qloop_17*tmp_qloop_37*(tmp_qloop_29*tmp_qloop_72 + tmp_qloop_54*tmp_qloop_82 + tmp_qloop_73)*1.0 - tmp_qloop_22*tmp_qloop_95;
                const real_t hessian_blending_0_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_87*1.0 - tmp_qloop_93;
                const real_t hessian_blending_1_1_2 = tmp_qloop_17*tmp_qloop_22*tmp_qloop_37*tmp_qloop_90*1.0 - tmp_qloop_22*tmp_qloop_91;
                const real_t hessian_blending_2_1_2 = -tmp_qloop_30*tmp_qloop_89 + tmp_qloop_44 + tmp_qloop_86*tmp_qloop_92;
                const real_t hessian_blending_0_2_0 = -tmp_qloop_19*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_88*tmp_qloop_96;
                const real_t hessian_blending_1_2_0 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*tmp_qloop_98*1.0;
                const real_t hessian_blending_2_2_0 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_18*tmp_qloop_37*1.0 - tmp_qloop_85*tmp_qloop_97;
                const real_t hessian_blending_0_2_1 = -tmp_qloop_100 + tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*tmp_qloop_96*1.0;
                const real_t hessian_blending_1_2_1 = -tmp_qloop_29*tmp_qloop_97 + tmp_qloop_50 + tmp_qloop_81*tmp_qloop_98;
                const real_t hessian_blending_2_2_1 = tmp_qloop_101*tmp_qloop_17*tmp_qloop_25*tmp_qloop_37*1.0 - tmp_qloop_22*tmp_qloop_99;
                const real_t hessian_blending_0_2_2 = -tmp_qloop_102*tmp_qloop_18 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_68 + tmp_qloop_57*tmp_qloop_69 + tmp_qloop_94)*1.0;
                const real_t hessian_blending_1_2_2 = -tmp_qloop_102*tmp_qloop_25 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_40 + tmp_qloop_57*tmp_qloop_79 + tmp_qloop_70)*1.0;
                const real_t hessian_blending_2_2_2 = -tmp_qloop_102*tmp_qloop_22 + tmp_qloop_17*tmp_qloop_37*(tmp_qloop_30*tmp_qloop_72 + tmp_qloop_31*(tmp_qloop_46 - tmp_qloop_72) + tmp_qloop_48*2.0 + tmp_qloop_57*tmp_qloop_82)*1.0;
                const real_t q_tmp_0_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q];
                const real_t q_tmp_0_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 1];
                const real_t q_tmp_0_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 2];
                const real_t q_tmp_0_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 3];
                const real_t q_tmp_0_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 4];
                const real_t q_tmp_0_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 5];
                const real_t q_tmp_0_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 6];
                const real_t q_tmp_0_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 7];
                const real_t q_tmp_0_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 8];
                const real_t q_tmp_0_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 9];
                const real_t q_tmp_1_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 10];
                const real_t q_tmp_1_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 11];
                const real_t q_tmp_1_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 12];
                const real_t q_tmp_1_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 13];
                const real_t q_tmp_1_4 = tmp_qloop_104;
                const real_t q_tmp_1_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 15];
                const real_t q_tmp_1_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 16];
                const real_t q_tmp_1_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 17];
                const real_t q_tmp_1_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 18];
                const real_t q_tmp_1_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 19];
                const real_t q_tmp_2_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 20];
                const real_t q_tmp_2_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 21];
                const real_t q_tmp_2_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 22];
                const real_t q_tmp_2_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 23];
                const real_t q_tmp_2_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 24];
                const real_t q_tmp_2_5 = tmp_qloop_104;
                const real_t q_tmp_2_6 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 25];
                const real_t q_tmp_2_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 26];
                const real_t q_tmp_2_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 27];
                const real_t q_tmp_2_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 28];
                const real_t q_tmp_3_0 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 29];
                const real_t q_tmp_3_1 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 30];
                const real_t q_tmp_3_2 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 31];
                const real_t q_tmp_3_3 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 32];
                const real_t q_tmp_3_4 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 33];
                const real_t q_tmp_3_5 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 34];
                const real_t q_tmp_3_6 = tmp_qloop_104;
                const real_t q_tmp_3_7 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 35];
                const real_t q_tmp_3_8 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 36];
                const real_t q_tmp_3_9 = tmp_qloop_103*_data_tabulated_and_untitled_0_0_GREEN_DOWN[38*q + 37];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_0 = q_acc_1_0 + q_tmp_1_0;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_0 = q_acc_2_0 + q_tmp_2_0;
                q_acc_2_1 = q_acc_2_1 + q_tmp_2_1;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_0 = q_acc_3_0 + q_tmp_3_0;
                q_acc_3_1 = q_acc_3_1 + q_tmp_3_1;
                q_acc_3_2 = q_acc_3_2 + q_tmp_3_2;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
             }
             const real_t elMatVec_0 = q_acc_0_0*src_dof_0 + q_acc_0_1*src_dof_1 + q_acc_0_2*src_dof_2 + q_acc_0_3*src_dof_3 + q_acc_0_4*src_dof_4 + q_acc_0_5*src_dof_5 + q_acc_0_6*src_dof_6 + q_acc_0_7*src_dof_7 + q_acc_0_8*src_dof_8 + q_acc_0_9*src_dof_9;
             const real_t elMatVec_1 = q_acc_1_0*src_dof_0 + q_acc_1_1*src_dof_1 + q_acc_1_2*src_dof_2 + q_acc_1_3*src_dof_3 + q_acc_1_4*src_dof_4 + q_acc_1_5*src_dof_5 + q_acc_1_6*src_dof_6 + q_acc_1_7*src_dof_7 + q_acc_1_8*src_dof_8 + q_acc_1_9*src_dof_9;
             const real_t elMatVec_2 = q_acc_2_0*src_dof_0 + q_acc_2_1*src_dof_1 + q_acc_2_2*src_dof_2 + q_acc_2_3*src_dof_3 + q_acc_2_4*src_dof_4 + q_acc_2_5*src_dof_5 + q_acc_2_6*src_dof_6 + q_acc_2_7*src_dof_7 + q_acc_2_8*src_dof_8 + q_acc_2_9*src_dof_9;
             const real_t elMatVec_3 = q_acc_3_0*src_dof_0 + q_acc_3_1*src_dof_1 + q_acc_3_2*src_dof_2 + q_acc_3_3*src_dof_3 + q_acc_3_4*src_dof_4 + q_acc_3_5*src_dof_5 + q_acc_3_6*src_dof_6 + q_acc_3_7*src_dof_7 + q_acc_3_8*src_dof_8 + q_acc_3_9*src_dof_9;
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_0 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_1 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1] = elMatVec_2 + _data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))] = elMatVec_3 + _data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
